// Datei AM.java
/* ------------------------------------------------------------------------
Diese Klasse AM enthaelt Klassenmethoden namens p, pln, pad und printf,
mit denen man Werte beliebiger Typen formattieren und ausgeben kann.

1. Einige dieser Methoden sind nur "Abkuerzungen" fuer Methoden aus der
Java-Standardbibliothek, deren Namen unhandlich lang sind.

Methode mit langem Namen | Gleichwertige Methode mit kurzem Namen
-------------------------+---------------------------------------
System.out.print         | AM.p
System.out.println       | AM.pln
System.out.printf        | AM.printf

2. Mit Prozeduren namens AM.p und AM.pln kann man ausserdem z.B. int-Werte
n1, n2, .... "spaltengerecht" untereinander schreiben, indem man sie unab-
haengig von ihrer Groesse "in einer bestimmten Laenge" ausgeben laesst,
z.B. so:

Prozeduraufruf           | Ergebnis auf dem Bildschirm | Kommentar
-------------------------+-----------------------------+-----------
AM.pln(   123, 10);      |"       123"                 | Laenge 10
AM.pln(-12345, 10);      |"    -12345"                 | Laenge 10
AM.pln(n1,     10);      |Wert von n1 als String       | Laenge 10

3. Mit Funktionen namens AM.pad (wie "polstern") kann man z.B. int-Werte
n1, n2, ... in Strings einer bestimmten Laenge umwandeln. Falls noetig
werden die Werte dabei mit einem bestimmten "Polsterzeichen" verlaengert,
z.B. so:

Funktionsaufruf          | Ergebnis der Funktion       | Kommentar
-------------------------+-----------------------------+-----------
AM.pad(   123, 10)       |"       123"                 | Laenge 10
AM.pad(-12345, 10)       |"    -12345"                 | Laenge 10
AM.pad(n1,     10)       |Wert von n1 als String       | Laenge 10

4. Mit Prozeduren namens AM.p und AM.pln kann man float- und double-
Werte z.B. mit 7 Stellen vor und 3 Stellen nach dem Punkt ausgeben,
etwa so:

Prozeduraufruf           | Ergebnis auf dem Bildschirm | Kommentar
-------------------------+-----------------------------+-----------
AM.pln(12345.6, 7, 3);   |"  12345.600"                | Laenge 11
AM.pln(1.2,     7, 3);   |"      1.200"                | Laenge 11


5. Ein paar interessantere Aufrufe der Funktionen namens pad:

Funktionsaufruf:         |  Ergebnis:   |  Kommentar:
-------------------------+--------------+----------------------------------
AM.pad(123,   7)         |  "    123"   |  Zahlen   rechtsbuendig
AM.pad(12.3F, 7)         |  "   12.3"   |  Zahlen   rechtsbuendig
AM.pad(true,  7)         |  " true  "   |  Booleans zentriert
AM.pad("ab",  7)         |  "ab     "   |  Strings  linksbuendig
AM.pad(123,   7, AM.LB)  |  "123    "   |  linksbuendig
AM.pad(12.3F, 7, AM.LB)  |  "12.3   "   |  linksbuendig
AM.pad(true,  7, AM.RB)  |  "   true"   |  rechtsbuendig
AM.pad("ab",  7, AM.RB)  |  "     ab"   |  rechtsbuendig
AM.pad(123,   7, AM.ZB)  |  "  123  "   |  zentriert
AM.pad(12.3F, 7, AM.ZB)  |  " 12.3  "   |  zentriert
AM.pad(false, 7, AM.ZB)  |  " false "   |  zentriert
AM.pad("ab",  7, AM.ZB)  |  "  ab   "   |  zentriert
AM.pad(123)              |  "123"       |  nur Umwandlung in String
AM.pad(true)             |  "true"      |  nur Umwandlung in String
AM.pad("ab")             |  "ab"        |  nur Umwandlung in String
AM.pad(12.3F)            |  "12.3"      |  nur Umwandlung in String
AM.pad(12.3F, 4, 2)      |  "  12.3 "   |  4 Vor und 2 Nachpunktstellen
AM.pad(12.3F, 0, 4)      |  "12.3   "   |  0 Vor und 4 Nachpunktstellen


6. Die Methoden AM.p und AM.pln rufen die Methoden AM.pad auf

Der Befehl               |  hat die gleiche Wirkung wie der Befehl:
-------------------------+-------------------------------------------------
AM.p(otto);              |  System.out.print(otto);
AM.p(otto, 7);           |  System.out.print(AM.pad(otto, 7));
AM.p(otto, 7, ZB);       |  System.out.print(AM.pad(otto, 7, ZB));
AM.p(otto, 4,  2);       |  System.out.print(AM.pad(otto, 4,  2));
                         |
AM.pln(otto);            |  System.out.println(otto)
AM.pln(otto, 7);         |  System.out.println(AM.pad(otto, 7));
AM.pln(otto, 7, ZB);     |  System.out.println(AM.pad(otto, 7, ZB));
AM.pln();                |  System.out.println();


7. Eine Liste mit den Namen der Funktionen (F) und Prozeduren (P)
dieser Klasse und einer kurzen Beschreibung, was sie machen:

Namen              | F/P |  Was macht diese Funktion/Prozedur
-------------------+-----+-------------------------------------------------
pad                |  F  | Werte in Strings umwandeln und dabei mit einem
                   |     | Polsterzeichen (standardmaessig mit einem Blank)
                   |     | auf eine bestimmte Laenge bringen
p, pln             |  P  | Werte (gepolstert oder ungepolstert) ausgeben
                   |     | (standardmaessig zur Standardausgabe)
setOut             |  P  | Ausgabe zu einem anderen PrintStream-Objekt
                   |     | umlenken
setPolsterzeichen  |  P  | Ein anderes Polsterzeichen festlegen


8. Allgemeine Erlaeuterungen

Die meisten pad-Methoden haben 1, 2 oder 3 Parameter:
Einen Wert x         (der gepolster werden soll),
eine Laenge len      (bis zu der gepolster werden soll) und
eine Ausrichtung wie (linksbuendig bzw. rechtsbuendig).
Sie wandeln x in einen String s um und liefern einen Ergebnis-String
erg, der s und eventuell zusaetliche Polsterzeichen enthaelt.

Als Ausrichtungs-Parameter wie kann man wahlweise die "sprechenden"
Konstanten AM.RECHTSBUENDIG, AM.LINKSBUENDIG, AM.ZENTRIERT oder die kurzen
Konstanten AM.RB,            AM.LB,           AM.ZB angeben.

Sonderfall 1: Ist der Parameter x gleich null, wird als Ergebnis der String
   "null" (gepolstert und ausgerichtet wie angegeben) geliefert.
Sonderfall 2: Ist len kleiner als s.length(), wird s unveraendert als
   Ergebnis geliefert (d.h. eine "zu kleine" Laengenangabe fuehrt *nicht*
   dazu, dass Zeichen von s abgeschnitten werden).
Sonderfall 3: Ist len groesser als MAXL (siehe unten), wird len durch
   MAXL ersetzt.

Zwei spezielle pad-Methoden fuer Gleitpunktzahlen (float und double) haben
drei Parameter: Die Zahl z, die Anzahl der gewuenschten Vorpunktstellen
vorSoll und die Anzahl der gewuenschten Nachpunktstellen nachSoll. Der
Ergebnis-String ist dann mindestens vorSoll+1+nachSoll Zeichen lang
(1 Zeichen fuer den Punkt). Ein Minuszeichen (falls angebracht) und alle
Ziffern vor dem Dezimalpunkt (mindestens eine) werden auf jeden Fall
dargestellt (auch wenn das mehr als vorSoll viele Zeichen sind). Nach dem
Punkt werden genau nachSoll viele Ziffern dargestellt.
---------------------------------------------------------------------------
WICHTIGER HINWEIS: Dieser Ausgabemodul AM funktioniert auch mit aelteren
Java-Versionen, wenn man die Vereinbarungen von zwei Methoden namens
printf auskommentiert. Die anderen Methoden sind NICHT von den printf-
Methoden abhaengig und verwenden kein Autohuellen (engl. auto boxing).
------------------------------------------------------------------------ */
import java.io  .PrintStream;
import java.text.NumberFormat;
import java.util.Arrays;    // fuer fill
import java.util.Locale;

class AM {
   // ---------------------------------------------------------------------
   // Zwei Methoden mit kurzen Namen (sollten auskommentiert werden,
   // wenn man mit Java 1.3 oder 1.4 arbeiten will):
   static
   void printf(            String f, Object... v) {System.out.printf(f, v);}
   static
   void printf(Locale loc, String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
   /* Die Prozeduren p und pln geben zum PrintStream-Objekt out aus.
      Anfangs ist out gleich der Standardausgabe System.out, kann aber
      jederzeit mit der Methode setOut veraendert werden */
   static private PrintStream out = System.out;
   static public  void setOut(PrintStream out) {AM.out = out;}
   // ---------------------------------------------------------------------
   /* Die Prozeduren pad, p und pln "polstern" Strings, indem sie
      polsterZeichen vorn und/oder hinten anhaengen. Das polsterZeichen
      ist anfangs ein Blank, kann aber jederzeit mit der Methode
      setPolsterZeichen veraendert werden. */
   static private char polsterZeichen = ' ';
   static public  void setPolsterZeichen(char z) {
      // Bringt z nach polsterZeichen und macht polster zu einem String,
      // der aus MAXL vielen polsterZeichen besteht:
      polsterZeichen = z;
      final char[] charR = new char[maxl];
      Arrays.fill(charR, polsterZeichen);
      polster = new String(charR);
   } // setPolsterZeichen
   // ---------------------------------------------------------------------
   /* Das Ergebnis einer pad-Funktion bzw. die Ausgabe einer p- oder pln-
      Prozedur kann hoechstens maxl viele Zeichen lang sein. Die Variable
      maxl hat anfangs den Wert 79 ("fast eine Bildschirmzeile"), kann
      aber jederzeit mit der Methode setMaxl veraendert werden. */
   static private int  maxl = 79;
   static public  void setMaxl(int n) {
      if (n < 10 || 10000 < n) {
         pln("AM: Unplausibler Wert fuer maxl: " + n);
         pln("    maxl bleibt unveraendert gleich " + maxl);
      } else {
         maxl = n;
      }
   } // setMaxl
   // ---------------------------------------------------------------------
   /** Aus Effizienzgruenden werden beim Polstern nicht einzelne Zeichen,
       sondern ganze Teilstrings des Strings polster angehaengt. */
   static public String polster;

   static { // Zum Initialisieren von polster mit maxl vielen Blanks:
      setPolsterZeichen(' ');
   } // Ende des statischen Initialisierers fuer polster
   // ---------------------------------------------------------------------
   /** Eine Klasse von Aufzaehlungswerten */
   static public final class Ausrichtung {
      // Ein privater Konstruktor, damit ausserhalb der Klasse AM
      // niemand mit dem "geschenkten" oeffentlichen Standardkonstruktor
      // neue Ausrichtung-Objekte erzeugen kann:
      private Ausrichtung() {}
   };

   /* Konstanten, die als dritter Parameter der Methoden pad, p und pln
      angegeben werden koennen, mit langen Namen */
   static public final Ausrichtung RECHTSBUENDIG = new Ausrichtung();
   static public final Ausrichtung LINKSBUENDIG  = new Ausrichtung();
   static public final Ausrichtung ZENTRIERT     = new Ausrichtung();
   /* Konstanten, die als dritter Parameter der Methoden pad, p und pln
      angegeben werden koennen, mit kurzen Namen */
   static public final Ausrichtung RB            = RECHTSBUENDIG;
   static public final Ausrichtung LB            = LINKSBUENDIG;
   static public final Ausrichtung ZB            = ZENTRIERT;

   /* Fuer jeden Typ T gibt es eine Variable namens aT. Deren Wert legt
      die Standardausrichtung fuer Werte des Typs T fest. Der Wert der
      Variablen aT kann jederzeit mit der Methode namens setAusrichtungT
      veraendert werden */
   static private      Ausrichtung aByte         = RECHTSBUENDIG;
   static private      Ausrichtung aChar         = ZENTRIERT;
   static private      Ausrichtung aShort        = RECHTSBUENDIG;
   static private      Ausrichtung aInt          = RECHTSBUENDIG;
   static private      Ausrichtung aLong         = RECHTSBUENDIG;
   static private      Ausrichtung aFloat        = RECHTSBUENDIG;
   static private      Ausrichtung aDouble       = RECHTSBUENDIG;
   static private      Ausrichtung aBoolean      = ZENTRIERT;
   static private      Ausrichtung aObject       = LINKSBUENDIG;

   static public void setAusrichtungByte   (Ausrichtung a) {aByte    = a;}
   static public void setAusrichtungChar   (Ausrichtung a) {aChar    = a;}
   static public void setAusrichtungShort  (Ausrichtung a) {aShort   = a;}
   static public void setAusrichtungInt    (Ausrichtung a) {aInt     = a;}
   static public void setAusrichtungLong   (Ausrichtung a) {aLong    = a;}
   static public void setAusrichtungFloat  (Ausrichtung a) {aFloat   = a;}
   static public void setAusrichtungDouble (Ausrichtung a) {aDouble  = a;}
   static public void setAusrichtungBoolean(Ausrichtung a) {aBoolean = a;}
   static public void setAusrichtungObject (Ausrichtung a) {aObject  = a;}


   /* ---------------------------------------------------------------------
   Die "grundlegende pad-Methode fuer Strings": Liefert einen String, in
   dem der String s enthalten ist (linksbuendig, rechtsbuendig bzw. zen-
   triert, je nach dem Ausrichtungsparameter wie) und dessen uebrige
   Zeichen Blanks (spaces) sind.
   Sonderfall 1: Falls s eine null-Referenz ist, wird der String "null"
      (in der angegebenen Laenge und Ausrichtung) geliefert.
   Sonderfall 2: Falls s.length() groesser ist als len wird s unveraendert
      als Ergebnis geliefert. Dies passiert insbesondere dann, wenn len
      gleich 0 oder negativ ist.
   Sonderfall 3: Falls len groesser als maxl ist, wird maxl anstelle von
      len genommen.
   --------------------------------------------------------------------- */
   static public String pad(String s, int len, Ausrichtung wie) {
      if (s == null)         return pad("null", len, wie); // Sonderfall 1
      if (s.length() >= len) return s;                     // Sonderfall 2

      len = Math.min(len, maxl);                           // Sonderfall 3

      // Um wieviel Blanks muss s verlaengert werden?
      String blanks = polster.substring(0, len - s.length());

           if (wie == RECHTSBUENDIG) return blanks + s;
      else if (wie ==  LINKSBUENDIG) return          s + blanks;
      else if (wie == ZENTRIERT    ) {
         // Falls blanks.length ungerade ist, wird *rechts* von s ein
         // Blank mehr angefuegt als links:
         String blanksL = blanks.substring(0, (blanks.length()+0) / 2);
         String blanksR = blanks.substring(0, (blanks.length()+1) / 2);
         return blanksL + s + blanksR;
      } // if

      return "Schwerer Fehler in Methode AM.pad, falsches Ergebnis!";

   } // pad
   /* ---------------------------------------------------------------------
   Es folgend Gruppen von pad-Methoden. Die Methoden innerhalb einer Gruppe
   haben gleich viele Parameter und unterscheiden sich nur durch den Typ
   ihres ersten Parameters.
   ---------------------------------------------------------------------
   Gruppe 1: pad-Methoden mit *drei* Parametern. Der erste Parameter wird
   in einen String umgewandelt und die "grundlegende pad-Methode fuer
   Strings" (siehe oben) wird aufgerufen:
   --------------------------------------------------------------------- */
   static public String pad(byte    x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(char    x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(short   x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(int     x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(long    x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(float   x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(double  x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(boolean x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   static public String pad(Object  x, int len, Ausrichtung wie) {return pad(""+x, len, wie);}
   /* ---------------------------------------------------------------------
   Gruppe 2: pad-Methoden mit *zwei* Parametern (mit Laenge, ohne Aus-
   richtung). In Abhaengigkeit vom Typ des ersten Parameters x wird eine
   Standardausrichtung festgelegt (fuer Zahlen RECHTSBUENDIG, fuer char- und
   fuer boolean-Werte ZENTRIERT und fuer andere Werte LINKSBUENDIG) und
   eine entsprechende pad-Methode mit 3 Parametern wird aufgerufen:
   --------------------------------------------------------------------- */
   static public String pad(byte    x, int len) {return pad(x, len, aByte)   ;}
   static public String pad(char    x, int len) {return pad(x, len, aChar)   ;}
   static public String pad(short   x, int len) {return pad(x, len, aShort)  ;}
   static public String pad(int     x, int len) {return pad(x, len, aInt)    ;}
   static public String pad(long    x, int len) {return pad(x, len, aLong)   ;}
   static public String pad(float   x, int len) {return pad(x, len, aFloat)  ;}
   static public String pad(double  x, int len) {return pad(x, len, aDouble) ;}
   static public String pad(boolean x, int len) {return pad(x, len, aBoolean);}
   static public String pad(Object  x, int len) {return pad(x, len, aObject) ;}
   /* ---------------------------------------------------------------------
   Gruppe 3: pad-Methoden mit *einem* Parameter (ohne Laenge und ohne
   Ausrichtung). Der Parameter wird als String zurueckgeliefert:
   --------------------------------------------------------------------- */
   static public String pad(byte    x) {return ""+x;}
   static public String pad(char    x) {return ""+x;}
   static public String pad(short   x) {return ""+x;}
   static public String pad(int     x) {return ""+x;}
   static public String pad(long    x) {return ""+x;}
   static public String pad(float   x) {return ""+x;}
   static public String pad(double  x) {return ""+x;}
   static public String pad(boolean x) {return ""+x;}
   static public String pad(Object  x) {return ""+x;}
   /* ---------------------------------------------------------------------
   Gruppe G: pad-Methoden fuer Gleitpunktzahlen (mit 3 Parametern)
   --------------------------------------------------------------------- */
   static public String pad(float  f, int vorSoll, int nachSoll) {
      return pad((double) f, vorSoll, nachSoll);
   } // pad float
   // -------------------------------------------
   static public String pad(double d, int vorSoll, int nachSoll) {
      // Liefert d als String, mit mindestens vorSoll vielen Dezimalziffern
      // vor und genau nachSoll vielen Dezimalziffern nach dem Dezimalpunkt
      // (aber mit mindestens einer Ziffer vor und einer Ziffer nach dem
      // Dezimalpunkt). Unnoetige fuehrende Nullen sind durch Blanks er-
      // setzt. Normalerweise hat des Ergebnis eine Laenge von
      // vorSoll + 1 + nachSoll vielen Zeichen, kann aber auch laenger
      // sein, da Ziffern vor dem Dezimalpunkt auf keinen Fall "abge-
      // schnitten" werden.

      if (vorSoll  < 1)  vorSoll = 1;
      if (nachSoll < 1) nachSoll = 1;

      // Die Zahl d muss nicht-negativ gemacht werden, damit das Entfernen
      // von fuehrenden Nullen nicht durch ein Minuszeichen verhindert wird:
      String vorZeichen = "";
      if (d < 0) {
         vorZeichen = "-";
         d = -d;
      }

      // Ein NumberFormat-Objekt aus dem United Kingdom holen (mit einem
      // Dezimal-PUNKT statt einem Dezimal-KOMMA):
      NumberFormat nf = NumberFormat.getInstance(Locale.UK);

      // Keine Gruppierung der Vorpunktziffern durch Kommas:
      nf.setGroupingUsed(false);

      // Mindestens vorSoll viele Ziffern vor dem Dezimalpunkt
      // und genau nachSoll viele Ziffern nach dem Dezimalpunkt:
      nf.setMinimumIntegerDigits(vorSoll);
      nf.setMinimumFractionDigits(nachSoll);
      nf.setMaximumFractionDigits(nachSoll);

      StringBuffer erg = new StringBuffer(nf.format(d));

      // Unnoetige fuehrende Nullen durch Blanks ersetzen (aber mindestens
      // eine Null vor dem Dezimalpunkt stehen lassen):
      int i;
      for (i=0; erg.charAt(i) == '0' && erg.charAt(i+1) != '.'; i++) {
         erg.replace(i, i+1, polsterZeichen+"");
      }

      // Das "gemerkte Vorzeichen" (nichts oder "-") vor die erste
      // Ziffer bringen:
      if (vorZeichen.length() == 0) {
         ;
      } else if (i==0) {
         erg.insert(0, vorZeichen);
      } else {
         erg.replace(i-1, i, vorZeichen);
      } // if

      return erg.toString();
   } // pad double
   /* ---------------------------------------------------------------------
   Jetzt kommen die p- und pln-Methoden.
   Die "grundlegende p-Methode" hat drei Parameter, von denen der erste vom
   Typ String ist. Diese p-Methode wird von anderen p-Methoden aufgerufen.
   --------------------------------------------------------------------- */
   // Die "grundlegende p-Methode" (die von den anderen aufgerufen wird):
   static public void p(String s, int len, Ausrichtung wie) {
     p(pad(s, len, wie));
   } // p
   /* ---------------------------------------------------------------------
   Es folgen Gruppen von p- und pln-Methoden. Die Methoden innerhalb einer
   Gruppe unterscheiden sich nur durch den Typ ihres ersten Parameters.
   Ansonsten haben sie den gleichen Namen ("p" bzw. "pln") und die gleiche
   Anzahl von Parametern (0, 1, 2 oder 3).
   ---------------------------------------------------------------------
   Gruppe 1: p-Methoden mit *drei* Parametern. Der erste Parameter wird
   in einen String umgewandelt und die "grundlegende p-Methode" (siehe
   oben) wird aufgerufen:
   --------------------------------------------------------------------- */
   static public void p(byte    x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(char    x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(short   x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(int     x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(long    x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(float   x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(double  x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(boolean x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   static public void p(Object  x, int len, Ausrichtung wie) {p(""+x, len, wie);}
   /* ---------------------------------------------------------------------
   Gruppe 2: p-Methoden mit *zwei* Parametern (mit Laenge, ohne Ausrichtung).
   In Abhaengigkeit vom Typ des ersten Parameters x wird eine Standard-Aus-
   richtung festgelegt (fuer Zahlen RECHTSBUENDIG, fuer char- und fuer
   boolean-Werte ZENTRIERT und fuer andere Werte LINKSBUENDIG) und
   eine entsprechende p-Methode mit 3 Parametern wird aufgerufen:
   --------------------------------------------------------------------- */
   static public void p(byte    x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(char    x, int len) {p(x, len, ZENTRIERT    );}
   static public void p(short   x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(int     x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(long    x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(float   x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(double  x, int len) {p(x, len, RECHTSBUENDIG);}
   static public void p(boolean x, int len) {p(x, len, ZENTRIERT    );}
   static public void p(Object  x, int len) {p(x, len, LINKSBUENDIG );}
   /* ---------------------------------------------------------------------
   Gruppe 3: p-Methoden mit *einem* Parameter (ohne Laenge und ohne
   Ausrichtung). Die entsprechende Methode print wird aufgerufen:
   --------------------------------------------------------------------- */
   static public void p(byte    x) {out.print(x);}
   static public void p(char    x) {out.print(x);}
   static public void p(short   x) {out.print(x);}
   static public void p(int     x) {out.print(x);}
   static public void p(long    x) {out.print(x);}
   static public void p(float   x) {out.print(x);}
   static public void p(double  x) {out.print(x);}
   static public void p(boolean x) {out.print(x);}
   static public void p(Object  x) {out.print(x);}
   /* ---------------------------------------------------------------------
   Gruppe 4: Die pln-Methode *ohne* Parameter (nur Zeilenvorschub):
   --------------------------------------------------------------------- */
   static public void pln()        {out.println();}
   /* ---------------------------------------------------------------------
   Gruppe 5: pln-Methoden mit *drei* Parametern. Diese Methoden rufen
   direkt die "grundlegende p-Methode fuer Strings" auf (siehe oben),
   und nicht die entsprechende p-Methode mit drei Parametern (um Zeit zu
   sparen). Danach wird die Methode pln() aufgerufen:
   --------------------------------------------------------------------- */
   static public void pln(byte    x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(char    x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(short   x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(int     x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(long    x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(float   x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(double  x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(boolean x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   static public void pln(Object  x, int len, Ausrichtung wie) {p(""+x, len, wie); pln();}
   /* ---------------------------------------------------------------------
   Gruppe 6: pln-Methoden mit *zwei* Parametern (ohne Ausrichtung). Die
   entsprechende p-Methode mit zwei Parametern wird aufgerufen und
   anschliessend die Methode pln():
   --------------------------------------------------------------------- */
   static public void pln(byte    x, int len) {p(x, len);  pln();}
   static public void pln(char    x, int len) {p(x, len);  pln();}
   static public void pln(short   x, int len) {p(x, len);  pln();}
   static public void pln(int     x, int len) {p(x, len);  pln();}
   static public void pln(long    x, int len) {p(x, len);  pln();}
   static public void pln(float   x, int len) {p(x, len);  pln();}
   static public void pln(double  x, int len) {p(x, len);  pln();}
   static public void pln(boolean x, int len) {p(x, len);  pln();}
   static public void pln(Object  x, int len) {p(x, len);  pln();}
   /* ---------------------------------------------------------------------
   Gruppe 7: pln-Methoden mit *einem* Parameter (ohne Laenge und ohne
   Ausrichtung). Die entsprechende Methode println wird aufgerufen:
   --------------------------------------------------------------------- */
   static public void pln(byte    x) {out.println(x);}
   static public void pln(char    x) {out.println(x);}
   static public void pln(short   x) {out.println(x);}
   static public void pln(int     x) {out.println(x);}
   static public void pln(long    x) {out.println(x);}
   static public void pln(float   x) {out.println(x);}
   static public void pln(double  x) {out.println(x);}
   static public void pln(boolean x) {out.println(x);}
   static public void pln(Object  x) {out.println(x);}
   /* ---------------------------------------------------------------------
   Gruppe G: p und pln-Methoden fuer Gleitpunktzahlen (mit 3 Parametern)
   vS: Anzahl Vorpunktstellen, nS: Anzahl Nachpunktstellen:
   --------------------------------------------------------------------- */
   static public void p  (float  x, int vS, int nS) {p  (pad(x, vS, nS));}
   static public void p  (double x, int vS, int nS) {p  (pad(x, vS, nS));}
   static public void pln(float  x, int vS, int nS) {pln(pad(x, vS, nS));}
   static public void pln(double x, int vS, int nS) {pln(pad(x, vS, nS));}
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("AM: Die Klasse AM ist nur ein Modul, aber kein Programm!");
      pln("    Der Ausgabe-Modul AM enthaelt Methoden namens pad, pln");
      pln("    und p mit denen man beliebige Werte in Strings einer");
      pln("    bestimmten Laenge umwandeln und ausgeben lassen kann.");
      pln("    Mit dem Programm AMTst kann man den Modul AM testen!");
   } // main
   // ---------------------------------------------------------------------
} // class AM
// ------------------------------------------------------------------------