// Datei AMTst.java
/* ------------------------------------------------------------------------
Ein Programm zum Testen des Ausgabe-Moduls AM.
Die zahlreichen Methoden namens pln im Modul AM werden mehrmals mit unter-
schiedlichen Parametern aufgerufen. Die Ausgabe zur Standardausgabe (Bild-
schirm) muss dann aber manuell ueberprueft werden. Das ist viel Arbeit!.
------------------------------------------------------------------------ */
class AMTst {
   static public void main(String[] susi) {
      AM.setPolsterZeichen('.');
      AM.setMaxl(9);
      AM.setMaxl(10001);
      AM.setMaxl(79);

      // Spalten-Nrn, damit man die anderen Ausgaben "daren messen kann":
      AM.pln("AMTst: Spalten             : 12345678901234567890");

      // Einfache Testfaelle mit int-Werten:
      AM.p  ("AM.pln(     123, 10)       : "); AM.pln( 123,  10);
      AM.p  ("AM.pln(      12, 10, AM.LB): "); AM.pln(  12,  10, AM.LB);
      AM.p  ("AM.pln(     321, 10, AM.ZB): "); AM.pln( 321,  10, AM.ZB);
      AM.p  ("AM.pln(      21, 10, AM.ZB): "); AM.pln(  21,  10, AM.ZB);

      // Einfache Testfaelle mit String-Werten:
      AM.p("AM.pln(   \"123\", 10, AM.RB): "); AM.pln("123", 10, AM.RB);
      AM.p("AM.pln(    \"12\", 10)       : "); AM.pln( "12", 10);
      AM.p("AM.pln(   \"321\", 10, AM.ZB): "); AM.pln("321", 10, AM.ZB);
      AM.p("AM.pln(    \"21\", 10, AM.ZB): "); AM.pln( "21", 10, AM.ZB);

      // Ungerade und gerade Anzahl von Blanks werden hinzugefuegt:
      AM.p  ("AM.pln( 1234567, 10, AM.ZB): "); AM.pln( 1234567, 10, AM.ZB);
      AM.p  ("AM.pln(12345678, 10, AM.ZB): "); AM.pln(12345678, 10, AM.ZB);

      // Zwei Spalten von Zahlen nebeneinander:
      AM.p  (  1,  5, AM.RB);    AM.pln(     11, 10);
      AM.p  (123,  5, AM.RB);    AM.pln(   2222, 10);
      AM.p  ( 22,  5, AM.RB);    AM.pln(3333333, 10);

      // Ausgabelaenge kurz unter, gleich und kurz ueber MAXL:
      AM.pln("AM.pln(666, 78)            : "); AM.pln(666, 78);
      AM.pln("AM.pln(777, 79)            : "); AM.pln(777, 79);
      AM.pln("AM.pln(888, 80)            : "); AM.pln(888, 80);
      AM.pln("AM.pln(111, 81)            : "); AM.pln(111, 81);

      // Grosse Ausgabelaengen und zentrierte Ausgabe:
      AM.pln("AM.pln(111, 90, AM.ZB)     : "); AM.pln(111, 90, AM.ZB);
      AM.pln("AM.pln(  1, 90, AM.ZB)     : "); AM.pln(  1, 90, AM.ZB);

      // Ausgabelaenge negativ oder 0:
      AM.pln("AM.pln(123,  0)            : "); AM.pln(123,  0);
      AM.pln("AM.pln(456, -3)            : "); AM.pln(456, -3);

      // Werden null-Referenzen richtig verarbeitet?
      Object nullOb = null; // null vom Typ Short
      AM.p  ("AM.pln(nullOb)             : "); AM.pln(nullOb);
      AM.p  ("AM.pln(nullOb, 10)         : "); AM.pln(nullOb, 10);
      AM.p  ("AM.pln(nullOb, 10, AM.RB)  : "); AM.pln(nullOb, 10, AM.RB);
      AM.p  ("AM.pln(nullOb, 10, AM.ZB)  : "); AM.pln(nullOb, 10, AM.ZB);

      // Werden boolean-Werte richtig verarbeitet?
      final boolean bf = false;
      final boolean bt = true;
      AM.p  ("AM.pln(bf)                 : "); AM.pln(bf);
      AM.p  ("AM.pln(bt, 10)             : "); AM.pln(bt, 10);
      AM.p  ("AM.pln(bf, 10)             : "); AM.pln(bf, 10);
      AM.p  ("AM.pln(bf, 10, AM.RB)      : "); AM.pln(bf, 10, AM.RB);
      AM.p  ("AM.pln(bt, 10, AM.LB)      : "); AM.pln(bt, 10, AM.LB);

      AM.pln("AMTst: Spalten             : 12345678901234567890");
      AM.pln("------------------------------------------------------");
      AM.pln("Jetzt wird pad fuer double-Werte getestet:");

      // Verschiedene double-Werte zum Testen:
      double dr[] = {0.12345, 12345678.0, -987.654};

      // Jeder double-Wert wird 12 * 12 Mal verschieden formatiert:
      for (int i=0; i<dr.length; i++) {
         for (int vor=0; vor<12; vor++) {
            for (int nach=0; nach<12; nach++) {
               double dd = dr[i];
               StringBuffer sb = new StringBuffer();
               sb.append("(");
               sb.append(dd);
               sb.append(", vor:");
               sb.append(AM.pad(vor, 2));
               sb.append(", nach:");
               sb.append(AM.pad(nach, 2));
               sb.append(")  -->");
               sb.append(AM.pad(dd, vor, nach));
               sb.append("<--");
               AM.pln(sb);
            } // for nach
         } // for vor
         AM.pln("-----------------------------------------------------");
      } // for i

   } // main
} // class AMTst
/* ------------------------------------------------------------------------
Ausgabe des Programms AMTst:

AM: Unplausibler Wert fuer maxl: 9
    maxl bleibt unveraendert gleich 79
AM: Unplausibler Wert fuer maxl: 10001
    maxl bleibt unveraendert gleich 79
AMTst: Spalten             : 12345678901234567890
AM.pln(     123, 10)       : .......123
AM.pln(      12, 10, AM.LB): 12........
AM.pln(     321, 10, AM.ZB): ...321....
AM.pln(      21, 10, AM.ZB): ....21....
AM.pln(   "123", 10, AM.RB): .......123
AM.pln(    "12", 10)       : 12........
AM.pln(   "321", 10, AM.ZB): ...321....
AM.pln(    "21", 10, AM.ZB): ....21....
AM.pln( 1234567, 10, AM.ZB): .1234567..
AM.pln(12345678, 10, AM.ZB): .12345678.
....1........11
..123......2222
...22...3333333
AM.pln(666, 78)            :
...........................................................................666
AM.pln(777, 79)            :
............................................................................777
AM.pln(888, 80)            :
............................................................................888
AM.pln(111, 81)            :
............................................................................111
AM.pln(111, 90, AM.ZB)     :
......................................111......................................
AM.pln(  1, 90, AM.ZB)     :
.......................................1.......................................
AM.pln(123,  0)            :
123
AM.pln(456, -3)            :
456
AM.pln(nullOb)             : null
AM.pln(nullOb, 10)         : null......
AM.pln(nullOb, 10, AM.RB)  : ......null
AM.pln(nullOb, 10, AM.ZB)  : ...null...
AM.pln(bf)                 : false
AM.pln(bt, 10)             : ...true...
AM.pln(bf, 10)             : ..false...
AM.pln(bf, 10, AM.RB)      : .....false
AM.pln(bt, 10, AM.LB)      : true......
AMTst: Spalten             : 12345678901234567890
------------------------------------------------------
Jetzt wird pad fuer double-Werte getestet:
(0.12345, vor:.0, nach:.0)  -->0.1<--
(0.12345, vor:.0, nach:.1)  -->0.1<--
(0.12345, vor:.0, nach:.2)  -->0.12<--
(0.12345, vor:.0, nach:.3)  -->0.123<--
(0.12345, vor:.0, nach:.4)  -->0.1234<--
(0.12345, vor:.0, nach:.5)  -->0.12345<--
(0.12345, vor:.0, nach:.6)  -->0.123450<--
(0.12345, vor:.0, nach:.7)  -->0.1234500<--
(0.12345, vor:.0, nach:.8)  -->0.12345000<--
(0.12345, vor:.0, nach:.9)  -->0.123450000<--
(0.12345, vor:.0, nach:10)  -->0.1234500000<--
(0.12345, vor:.0, nach:11)  -->0.12345000000<--
(0.12345, vor:.1, nach:.0)  -->0.1<--
(0.12345, vor:.1, nach:.1)  -->0.1<--
(0.12345, vor:.1, nach:.2)  -->0.12<--
(0.12345, vor:.1, nach:.3)  -->0.123<--
(0.12345, vor:.1, nach:.4)  -->0.1234<--
(0.12345, vor:.1, nach:.5)  -->0.12345<--
(0.12345, vor:.1, nach:.6)  -->0.123450<--
(0.12345, vor:.1, nach:.7)  -->0.1234500<--
(0.12345, vor:.1, nach:.8)  -->0.12345000<--
(0.12345, vor:.1, nach:.9)  -->0.123450000<--
(0.12345, vor:.1, nach:10)  -->0.1234500000<--
(0.12345, vor:.1, nach:11)  -->0.12345000000<--
(0.12345, vor:.2, nach:.0)  -->.0.1<--
(0.12345, vor:.2, nach:.1)  -->.0.1<--
(0.12345, vor:.2, nach:.2)  -->.0.12<--
(0.12345, vor:.2, nach:.3)  -->.0.123<--
(0.12345, vor:.2, nach:.4)  -->.0.1234<--
(0.12345, vor:.2, nach:.5)  -->.0.12345<--
(0.12345, vor:.2, nach:.6)  -->.0.123450<--
(0.12345, vor:.2, nach:.7)  -->.0.1234500<--
(0.12345, vor:.2, nach:.8)  -->.0.12345000<--
(0.12345, vor:.2, nach:.9)  -->.0.123450000<--
(0.12345, vor:.2, nach:10)  -->.0.1234500000<--
(0.12345, vor:.2, nach:11)  -->.0.12345000000<--
(0.12345, vor:.3, nach:.0)  -->..0.1<--
(0.12345, vor:.3, nach:.1)  -->..0.1<--
(0.12345, vor:.3, nach:.2)  -->..0.12<--
(0.12345, vor:.3, nach:.3)  -->..0.123<--
(0.12345, vor:.3, nach:.4)  -->..0.1234<--
(0.12345, vor:.3, nach:.5)  -->..0.12345<--
(0.12345, vor:.3, nach:.6)  -->..0.123450<--
(0.12345, vor:.3, nach:.7)  -->..0.1234500<--
(0.12345, vor:.3, nach:.8)  -->..0.12345000<--
(0.12345, vor:.3, nach:.9)  -->..0.123450000<--
(0.12345, vor:.3, nach:10)  -->..0.1234500000<--
(0.12345, vor:.3, nach:11)  -->..0.12345000000<--
(0.12345, vor:.4, nach:.0)  -->...0.1<--
(0.12345, vor:.4, nach:.1)  -->...0.1<--
(0.12345, vor:.4, nach:.2)  -->...0.12<--
(0.12345, vor:.4, nach:.3)  -->...0.123<--
(0.12345, vor:.4, nach:.4)  -->...0.1234<--
(0.12345, vor:.4, nach:.5)  -->...0.12345<--
(0.12345, vor:.4, nach:.6)  -->...0.123450<--
(0.12345, vor:.4, nach:.7)  -->...0.1234500<--
(0.12345, vor:.4, nach:.8)  -->...0.12345000<--
(0.12345, vor:.4, nach:.9)  -->...0.123450000<--
(0.12345, vor:.4, nach:10)  -->...0.1234500000<--
(0.12345, vor:.4, nach:11)  -->...0.12345000000<--
(0.12345, vor:.5, nach:.0)  -->....0.1<--
(0.12345, vor:.5, nach:.1)  -->....0.1<--
(0.12345, vor:.5, nach:.2)  -->....0.12<--
(0.12345, vor:.5, nach:.3)  -->....0.123<--
(0.12345, vor:.5, nach:.4)  -->....0.1234<--
(0.12345, vor:.5, nach:.5)  -->....0.12345<--
(0.12345, vor:.5, nach:.6)  -->....0.123450<--
(0.12345, vor:.5, nach:.7)  -->....0.1234500<--
(0.12345, vor:.5, nach:.8)  -->....0.12345000<--
(0.12345, vor:.5, nach:.9)  -->....0.123450000<--
(0.12345, vor:.5, nach:10)  -->....0.1234500000<--
(0.12345, vor:.5, nach:11)  -->....0.12345000000<--
(0.12345, vor:.6, nach:.0)  -->.....0.1<--
(0.12345, vor:.6, nach:.1)  -->.....0.1<--
(0.12345, vor:.6, nach:.2)  -->.....0.12<--
(0.12345, vor:.6, nach:.3)  -->.....0.123<--
(0.12345, vor:.6, nach:.4)  -->.....0.1234<--
(0.12345, vor:.6, nach:.5)  -->.....0.12345<--
(0.12345, vor:.6, nach:.6)  -->.....0.123450<--
(0.12345, vor:.6, nach:.7)  -->.....0.1234500<--
(0.12345, vor:.6, nach:.8)  -->.....0.12345000<--
(0.12345, vor:.6, nach:.9)  -->.....0.123450000<--
(0.12345, vor:.6, nach:10)  -->.....0.1234500000<--
(0.12345, vor:.6, nach:11)  -->.....0.12345000000<--
(0.12345, vor:.7, nach:.0)  -->......0.1<--
(0.12345, vor:.7, nach:.1)  -->......0.1<--
(0.12345, vor:.7, nach:.2)  -->......0.12<--
(0.12345, vor:.7, nach:.3)  -->......0.123<--
(0.12345, vor:.7, nach:.4)  -->......0.1234<--
(0.12345, vor:.7, nach:.5)  -->......0.12345<--
(0.12345, vor:.7, nach:.6)  -->......0.123450<--
(0.12345, vor:.7, nach:.7)  -->......0.1234500<--
(0.12345, vor:.7, nach:.8)  -->......0.12345000<--
(0.12345, vor:.7, nach:.9)  -->......0.123450000<--
(0.12345, vor:.7, nach:10)  -->......0.1234500000<--
(0.12345, vor:.7, nach:11)  -->......0.12345000000<--
(0.12345, vor:.8, nach:.0)  -->.......0.1<--
(0.12345, vor:.8, nach:.1)  -->.......0.1<--
(0.12345, vor:.8, nach:.2)  -->.......0.12<--
(0.12345, vor:.8, nach:.3)  -->.......0.123<--
(0.12345, vor:.8, nach:.4)  -->.......0.1234<--
(0.12345, vor:.8, nach:.5)  -->.......0.12345<--
(0.12345, vor:.8, nach:.6)  -->.......0.123450<--
(0.12345, vor:.8, nach:.7)  -->.......0.1234500<--
(0.12345, vor:.8, nach:.8)  -->.......0.12345000<--
(0.12345, vor:.8, nach:.9)  -->.......0.123450000<--
(0.12345, vor:.8, nach:10)  -->.......0.1234500000<--
(0.12345, vor:.8, nach:11)  -->.......0.12345000000<--
(0.12345, vor:.9, nach:.0)  -->........0.1<--
(0.12345, vor:.9, nach:.1)  -->........0.1<--
(0.12345, vor:.9, nach:.2)  -->........0.12<--
(0.12345, vor:.9, nach:.3)  -->........0.123<--
(0.12345, vor:.9, nach:.4)  -->........0.1234<--
(0.12345, vor:.9, nach:.5)  -->........0.12345<--
(0.12345, vor:.9, nach:.6)  -->........0.123450<--
(0.12345, vor:.9, nach:.7)  -->........0.1234500<--
(0.12345, vor:.9, nach:.8)  -->........0.12345000<--
(0.12345, vor:.9, nach:.9)  -->........0.123450000<--
(0.12345, vor:.9, nach:10)  -->........0.1234500000<--
(0.12345, vor:.9, nach:11)  -->........0.12345000000<--
(0.12345, vor:10, nach:.0)  -->.........0.1<--
(0.12345, vor:10, nach:.1)  -->.........0.1<--
(0.12345, vor:10, nach:.2)  -->.........0.12<--
(0.12345, vor:10, nach:.3)  -->.........0.123<--
(0.12345, vor:10, nach:.4)  -->.........0.1234<--
(0.12345, vor:10, nach:.5)  -->.........0.12345<--
(0.12345, vor:10, nach:.6)  -->.........0.123450<--
(0.12345, vor:10, nach:.7)  -->.........0.1234500<--
(0.12345, vor:10, nach:.8)  -->.........0.12345000<--
(0.12345, vor:10, nach:.9)  -->.........0.123450000<--
(0.12345, vor:10, nach:10)  -->.........0.1234500000<--
(0.12345, vor:10, nach:11)  -->.........0.12345000000<--
(0.12345, vor:11, nach:.0)  -->..........0.1<--
(0.12345, vor:11, nach:.1)  -->..........0.1<--
(0.12345, vor:11, nach:.2)  -->..........0.12<--
(0.12345, vor:11, nach:.3)  -->..........0.123<--
(0.12345, vor:11, nach:.4)  -->..........0.1234<--
(0.12345, vor:11, nach:.5)  -->..........0.12345<--
(0.12345, vor:11, nach:.6)  -->..........0.123450<--
(0.12345, vor:11, nach:.7)  -->..........0.1234500<--
(0.12345, vor:11, nach:.8)  -->..........0.12345000<--
(0.12345, vor:11, nach:.9)  -->..........0.123450000<--
(0.12345, vor:11, nach:10)  -->..........0.1234500000<--
(0.12345, vor:11, nach:11)  -->..........0.12345000000<--
-----------------------------------------------------
(1.2345678E7, vor:.0, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.0, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.0, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.0, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.0, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.0, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.0, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.0, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.0, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.0, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.0, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.0, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.1, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.1, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.1, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.1, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.1, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.1, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.1, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.1, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.1, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.1, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.1, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.1, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.2, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.2, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.2, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.2, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.2, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.2, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.2, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.2, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.2, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.2, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.2, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.2, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.3, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.3, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.3, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.3, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.3, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.3, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.3, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.3, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.3, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.3, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.3, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.3, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.4, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.4, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.4, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.4, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.4, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.4, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.4, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.4, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.4, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.4, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.4, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.4, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.5, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.5, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.5, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.5, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.5, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.5, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.5, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.5, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.5, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.5, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.5, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.5, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.6, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.6, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.6, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.6, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.6, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.6, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.6, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.6, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.6, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.6, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.6, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.6, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.7, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.7, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.7, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.7, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.7, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.7, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.7, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.7, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.7, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.7, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.7, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.7, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.8, nach:.0)  -->12345678.0<--
(1.2345678E7, vor:.8, nach:.1)  -->12345678.0<--
(1.2345678E7, vor:.8, nach:.2)  -->12345678.00<--
(1.2345678E7, vor:.8, nach:.3)  -->12345678.000<--
(1.2345678E7, vor:.8, nach:.4)  -->12345678.0000<--
(1.2345678E7, vor:.8, nach:.5)  -->12345678.00000<--
(1.2345678E7, vor:.8, nach:.6)  -->12345678.000000<--
(1.2345678E7, vor:.8, nach:.7)  -->12345678.0000000<--
(1.2345678E7, vor:.8, nach:.8)  -->12345678.00000000<--
(1.2345678E7, vor:.8, nach:.9)  -->12345678.000000000<--
(1.2345678E7, vor:.8, nach:10)  -->12345678.0000000000<--
(1.2345678E7, vor:.8, nach:11)  -->12345678.00000000000<--
(1.2345678E7, vor:.9, nach:.0)  -->.12345678.0<--
(1.2345678E7, vor:.9, nach:.1)  -->.12345678.0<--
(1.2345678E7, vor:.9, nach:.2)  -->.12345678.00<--
(1.2345678E7, vor:.9, nach:.3)  -->.12345678.000<--
(1.2345678E7, vor:.9, nach:.4)  -->.12345678.0000<--
(1.2345678E7, vor:.9, nach:.5)  -->.12345678.00000<--
(1.2345678E7, vor:.9, nach:.6)  -->.12345678.000000<--
(1.2345678E7, vor:.9, nach:.7)  -->.12345678.0000000<--
(1.2345678E7, vor:.9, nach:.8)  -->.12345678.00000000<--
(1.2345678E7, vor:.9, nach:.9)  -->.12345678.000000000<--
(1.2345678E7, vor:.9, nach:10)  -->.12345678.0000000000<--
(1.2345678E7, vor:.9, nach:11)  -->.12345678.00000000000<--
(1.2345678E7, vor:10, nach:.0)  -->..12345678.0<--
(1.2345678E7, vor:10, nach:.1)  -->..12345678.0<--
(1.2345678E7, vor:10, nach:.2)  -->..12345678.00<--
(1.2345678E7, vor:10, nach:.3)  -->..12345678.000<--
(1.2345678E7, vor:10, nach:.4)  -->..12345678.0000<--
(1.2345678E7, vor:10, nach:.5)  -->..12345678.00000<--
(1.2345678E7, vor:10, nach:.6)  -->..12345678.000000<--
(1.2345678E7, vor:10, nach:.7)  -->..12345678.0000000<--
(1.2345678E7, vor:10, nach:.8)  -->..12345678.00000000<--
(1.2345678E7, vor:10, nach:.9)  -->..12345678.000000000<--
(1.2345678E7, vor:10, nach:10)  -->..12345678.0000000000<--
(1.2345678E7, vor:10, nach:11)  -->..12345678.00000000000<--
(1.2345678E7, vor:11, nach:.0)  -->...12345678.0<--
(1.2345678E7, vor:11, nach:.1)  -->...12345678.0<--
(1.2345678E7, vor:11, nach:.2)  -->...12345678.00<--
(1.2345678E7, vor:11, nach:.3)  -->...12345678.000<--
(1.2345678E7, vor:11, nach:.4)  -->...12345678.0000<--
(1.2345678E7, vor:11, nach:.5)  -->...12345678.00000<--
(1.2345678E7, vor:11, nach:.6)  -->...12345678.000000<--
(1.2345678E7, vor:11, nach:.7)  -->...12345678.0000000<--
(1.2345678E7, vor:11, nach:.8)  -->...12345678.00000000<--
(1.2345678E7, vor:11, nach:.9)  -->...12345678.000000000<--
(1.2345678E7, vor:11, nach:10)  -->...12345678.0000000000<--
(1.2345678E7, vor:11, nach:11)  -->...12345678.00000000000<--
-----------------------------------------------------
(-987.654, vor:.0, nach:.0)  -->-987.7<--
(-987.654, vor:.0, nach:.1)  -->-987.7<--
(-987.654, vor:.0, nach:.2)  -->-987.65<--
(-987.654, vor:.0, nach:.3)  -->-987.654<--
(-987.654, vor:.0, nach:.4)  -->-987.6540<--
(-987.654, vor:.0, nach:.5)  -->-987.65400<--
(-987.654, vor:.0, nach:.6)  -->-987.654000<--
(-987.654, vor:.0, nach:.7)  -->-987.6540000<--
(-987.654, vor:.0, nach:.8)  -->-987.65400000<--
(-987.654, vor:.0, nach:.9)  -->-987.654000000<--
(-987.654, vor:.0, nach:10)  -->-987.6540000000<--
(-987.654, vor:.0, nach:11)  -->-987.65400000000<--
(-987.654, vor:.1, nach:.0)  -->-987.7<--
(-987.654, vor:.1, nach:.1)  -->-987.7<--
(-987.654, vor:.1, nach:.2)  -->-987.65<--
(-987.654, vor:.1, nach:.3)  -->-987.654<--
(-987.654, vor:.1, nach:.4)  -->-987.6540<--
(-987.654, vor:.1, nach:.5)  -->-987.65400<--
(-987.654, vor:.1, nach:.6)  -->-987.654000<--
(-987.654, vor:.1, nach:.7)  -->-987.6540000<--
(-987.654, vor:.1, nach:.8)  -->-987.65400000<--
(-987.654, vor:.1, nach:.9)  -->-987.654000000<--
(-987.654, vor:.1, nach:10)  -->-987.6540000000<--
(-987.654, vor:.1, nach:11)  -->-987.65400000000<--
(-987.654, vor:.2, nach:.0)  -->-987.7<--
(-987.654, vor:.2, nach:.1)  -->-987.7<--
(-987.654, vor:.2, nach:.2)  -->-987.65<--
(-987.654, vor:.2, nach:.3)  -->-987.654<--
(-987.654, vor:.2, nach:.4)  -->-987.6540<--
(-987.654, vor:.2, nach:.5)  -->-987.65400<--
(-987.654, vor:.2, nach:.6)  -->-987.654000<--
(-987.654, vor:.2, nach:.7)  -->-987.6540000<--
(-987.654, vor:.2, nach:.8)  -->-987.65400000<--
(-987.654, vor:.2, nach:.9)  -->-987.654000000<--
(-987.654, vor:.2, nach:10)  -->-987.6540000000<--
(-987.654, vor:.2, nach:11)  -->-987.65400000000<--
(-987.654, vor:.3, nach:.0)  -->-987.7<--
(-987.654, vor:.3, nach:.1)  -->-987.7<--
(-987.654, vor:.3, nach:.2)  -->-987.65<--
(-987.654, vor:.3, nach:.3)  -->-987.654<--
(-987.654, vor:.3, nach:.4)  -->-987.6540<--
(-987.654, vor:.3, nach:.5)  -->-987.65400<--
(-987.654, vor:.3, nach:.6)  -->-987.654000<--
(-987.654, vor:.3, nach:.7)  -->-987.6540000<--
(-987.654, vor:.3, nach:.8)  -->-987.65400000<--
(-987.654, vor:.3, nach:.9)  -->-987.654000000<--
(-987.654, vor:.3, nach:10)  -->-987.6540000000<--
(-987.654, vor:.3, nach:11)  -->-987.65400000000<--
(-987.654, vor:.4, nach:.0)  -->-987.7<--
(-987.654, vor:.4, nach:.1)  -->-987.7<--
(-987.654, vor:.4, nach:.2)  -->-987.65<--
(-987.654, vor:.4, nach:.3)  -->-987.654<--
(-987.654, vor:.4, nach:.4)  -->-987.6540<--
(-987.654, vor:.4, nach:.5)  -->-987.65400<--
(-987.654, vor:.4, nach:.6)  -->-987.654000<--
(-987.654, vor:.4, nach:.7)  -->-987.6540000<--
(-987.654, vor:.4, nach:.8)  -->-987.65400000<--
(-987.654, vor:.4, nach:.9)  -->-987.654000000<--
(-987.654, vor:.4, nach:10)  -->-987.6540000000<--
(-987.654, vor:.4, nach:11)  -->-987.65400000000<--
(-987.654, vor:.5, nach:.0)  -->.-987.7<--
(-987.654, vor:.5, nach:.1)  -->.-987.7<--
(-987.654, vor:.5, nach:.2)  -->.-987.65<--
(-987.654, vor:.5, nach:.3)  -->.-987.654<--
(-987.654, vor:.5, nach:.4)  -->.-987.6540<--
(-987.654, vor:.5, nach:.5)  -->.-987.65400<--
(-987.654, vor:.5, nach:.6)  -->.-987.654000<--
(-987.654, vor:.5, nach:.7)  -->.-987.6540000<--
(-987.654, vor:.5, nach:.8)  -->.-987.65400000<--
(-987.654, vor:.5, nach:.9)  -->.-987.654000000<--
(-987.654, vor:.5, nach:10)  -->.-987.6540000000<--
(-987.654, vor:.5, nach:11)  -->.-987.65400000000<--
(-987.654, vor:.6, nach:.0)  -->..-987.7<--
(-987.654, vor:.6, nach:.1)  -->..-987.7<--
(-987.654, vor:.6, nach:.2)  -->..-987.65<--
(-987.654, vor:.6, nach:.3)  -->..-987.654<--
(-987.654, vor:.6, nach:.4)  -->..-987.6540<--
(-987.654, vor:.6, nach:.5)  -->..-987.65400<--
(-987.654, vor:.6, nach:.6)  -->..-987.654000<--
(-987.654, vor:.6, nach:.7)  -->..-987.6540000<--
(-987.654, vor:.6, nach:.8)  -->..-987.65400000<--
(-987.654, vor:.6, nach:.9)  -->..-987.654000000<--
(-987.654, vor:.6, nach:10)  -->..-987.6540000000<--
(-987.654, vor:.6, nach:11)  -->..-987.65400000000<--
(-987.654, vor:.7, nach:.0)  -->...-987.7<--
(-987.654, vor:.7, nach:.1)  -->...-987.7<--
(-987.654, vor:.7, nach:.2)  -->...-987.65<--
(-987.654, vor:.7, nach:.3)  -->...-987.654<--
(-987.654, vor:.7, nach:.4)  -->...-987.6540<--
(-987.654, vor:.7, nach:.5)  -->...-987.65400<--
(-987.654, vor:.7, nach:.6)  -->...-987.654000<--
(-987.654, vor:.7, nach:.7)  -->...-987.6540000<--
(-987.654, vor:.7, nach:.8)  -->...-987.65400000<--
(-987.654, vor:.7, nach:.9)  -->...-987.654000000<--
(-987.654, vor:.7, nach:10)  -->...-987.6540000000<--
(-987.654, vor:.7, nach:11)  -->...-987.65400000000<--
(-987.654, vor:.8, nach:.0)  -->....-987.7<--
(-987.654, vor:.8, nach:.1)  -->....-987.7<--
(-987.654, vor:.8, nach:.2)  -->....-987.65<--
(-987.654, vor:.8, nach:.3)  -->....-987.654<--
(-987.654, vor:.8, nach:.4)  -->....-987.6540<--
(-987.654, vor:.8, nach:.5)  -->....-987.65400<--
(-987.654, vor:.8, nach:.6)  -->....-987.654000<--
(-987.654, vor:.8, nach:.7)  -->....-987.6540000<--
(-987.654, vor:.8, nach:.8)  -->....-987.65400000<--
(-987.654, vor:.8, nach:.9)  -->....-987.654000000<--
(-987.654, vor:.8, nach:10)  -->....-987.6540000000<--
(-987.654, vor:.8, nach:11)  -->....-987.65400000000<--
(-987.654, vor:.9, nach:.0)  -->.....-987.7<--
(-987.654, vor:.9, nach:.1)  -->.....-987.7<--
(-987.654, vor:.9, nach:.2)  -->.....-987.65<--
(-987.654, vor:.9, nach:.3)  -->.....-987.654<--
(-987.654, vor:.9, nach:.4)  -->.....-987.6540<--
(-987.654, vor:.9, nach:.5)  -->.....-987.65400<--
(-987.654, vor:.9, nach:.6)  -->.....-987.654000<--
(-987.654, vor:.9, nach:.7)  -->.....-987.6540000<--
(-987.654, vor:.9, nach:.8)  -->.....-987.65400000<--
(-987.654, vor:.9, nach:.9)  -->.....-987.654000000<--
(-987.654, vor:.9, nach:10)  -->.....-987.6540000000<--
(-987.654, vor:.9, nach:11)  -->.....-987.65400000000<--
(-987.654, vor:10, nach:.0)  -->......-987.7<--
(-987.654, vor:10, nach:.1)  -->......-987.7<--
(-987.654, vor:10, nach:.2)  -->......-987.65<--
(-987.654, vor:10, nach:.3)  -->......-987.654<--
(-987.654, vor:10, nach:.4)  -->......-987.6540<--
(-987.654, vor:10, nach:.5)  -->......-987.65400<--
(-987.654, vor:10, nach:.6)  -->......-987.654000<--
(-987.654, vor:10, nach:.7)  -->......-987.6540000<--
(-987.654, vor:10, nach:.8)  -->......-987.65400000<--
(-987.654, vor:10, nach:.9)  -->......-987.654000000<--
(-987.654, vor:10, nach:10)  -->......-987.6540000000<--
(-987.654, vor:10, nach:11)  -->......-987.65400000000<--
(-987.654, vor:11, nach:.0)  -->.......-987.7<--
(-987.654, vor:11, nach:.1)  -->.......-987.7<--
(-987.654, vor:11, nach:.2)  -->.......-987.65<--
(-987.654, vor:11, nach:.3)  -->.......-987.654<--
(-987.654, vor:11, nach:.4)  -->.......-987.6540<--
(-987.654, vor:11, nach:.5)  -->.......-987.65400<--
(-987.654, vor:11, nach:.6)  -->.......-987.654000<--
(-987.654, vor:11, nach:.7)  -->.......-987.6540000<--
(-987.654, vor:11, nach:.8)  -->.......-987.65400000<--
(-987.654, vor:11, nach:.9)  -->.......-987.654000000<--
(-987.654, vor:11, nach:10)  -->.......-987.6540000000<--
(-987.654, vor:11, nach:11)  -->.......-987.65400000000<--
-----------------------------------------------------
------------------------------------------------------------------------ */