// Datei Abbildungen03.java
/* ------------------------------------------------------------------------
Ist a01 eine Abbildung des Typs Map<String, Number>, so gehoeren
die Eintraege von a01 zum Typ Map.Entry<String, Number>.

Der Ausdruck a01.entrySet() liefert ein Set-Objekt, welches alle
Eintraege der Abbildung a01 enthaelt.

Die Eintraege einer Abbildung a01 werden in einzelne Variablen
e01, e02 und e03 gebracht und mit verschiedenen Methoden
(getKey, getValue, setValue, equals und hashCode) bearbeitet.
Die Eintraege und die Ergebnisse der Methoden werden ausgegeben.
------------------------------------------------------------------------ */
import java.util.Map;       // Eine Schnittstelle
import java.util.HashMap;   // Eine Map-Klasse
import java.util.Set;       // Eine Schnittstelle
import java.util.Iterator;  // Eine Schnittstelle

class Abbildungen03 {
   static public void main(String[] sonja) {

      // Drei Schluessel-Objekte des Typs String:
      String  key01 = new String("Hoehe");
      String  key02 = new String("Breite");
      String  key03 = new String("Anzahl");

      // Drei Wert-Objekte verschiedener Typen:
      Double  val01 = new Double (21.0);
      Double  val02 = new Double (29.7);
      Integer val03 = new Integer(5);

      // Ein Abbildungs-Objekt namens ab01 wird vereinbart
      // (Number ist eine Obertyp von Double und von Integer):
      Map<String, Number>  a01  = new HashMap<String, Number>();

      // In die Abbildung ab01 werden 3 Eintraege eingetragen:
      a01.put(key01, val01);
      a01.put(key02, val02);
      a01.put(key03, val03);

      // Eine Menge m01, die alle Eintraege der Abbildung a01 enthaelt.
      // Ein Iterator i01 zum "Durchschreiten" der Menge m01.
      // Drei Eintraege e01, e02 und e03 der Abbildung a01.
           Set<Map.Entry<String, Number>> m01 =  a01.entrySet();
      Iterator<Map.Entry<String, Number>> i01 =  m01.iterator();

               Map.Entry<String, Number>  e01 =  i01.next();
               Map.Entry<String, Number>  e02 =  i01.next();
               Map.Entry<String, Number>  e03 =  i01.next();

      pln("Abbildungen03: Jetzt geht es los!");
      pln("----------------------------------------");
      pln("a01: " + a01);
      pln("----------------------------------------");
      pln("e01               : " + e01);
      pln("e02               : " + e02);
      pln("----------------------------------------");
      pln("e03               : " + e03);
      pln("e03.getKey()      : " + e03.getKey  ());
      pln("e03.getValue()    : " + e03.getValue());
      pln("e03.setValue(33.3): " + e03.setValue(33.3));
      pln("e03               : " + e03);
      pln("----------------------------------------");
      pln("e03.equals(e03)   : " + e03.equals(e03));
      pln("e03.equals(e02)   : " + e03.equals(e02));
      pln("----------------------------------------");
      pln("e01.hashCode()    : " + e01.hashCode());
      pln("e02.hashCode()    : " + e02.hashCode());
      pln("e03.hashCode()    : " + e03.hashCode());
      pln("----------------------------------------");

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Abbildungen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Abbildungen03:

Abbildungen03: Jetzt geht es los!
----------------------------------------
a01: {Breite=29.7, Anzahl=5, Hoehe=21.0}
----------------------------------------
e01               : Breite=29.7
e02               : Anzahl=5
----------------------------------------
e03               : Hoehe=21.0
e03.getKey()      : Hoehe
e03.getValue()    : 21.0
e03.setValue(33.3): 21.0
e03               : Hoehe=33.3
----------------------------------------
e03.equals(e03)   : true
e03.equals(e02)   : false
----------------------------------------
e01.hashCode()    : 68899461
e02.hashCode()    : 1966213181
e03.hashCode()    : 571234715
----------------------------------------
------------------------------------------------------------------------ */