// Datei ArrayList02.java
/* ------------------------------------------------------------------------
Demonstriert die Benutzung eines Sammlungsobjekts namens sam02 vom Typ
ArrayList<String>. Komponenten des Typs String werden
- hinten an die Sammlung sam02 angehaengt  (mit add    ohne Index),
- an speziellen Indexpositionen eingefuegt (mit add    mit  Index),
- aus der Sammlung sam02 entfernt          (mit remove mit  Index),
- durch andere String-Objekte ersetzt      (mit set    mit  Index),
- alle aus der Sammlung sam02 entfernt     (mit clear  ohne Index).

In einer Sammlung des Typs ArrayList<String> kann man nur String-
Objekte sammeln (d.h. anhaengen, einfuegen, entfernen etc.).

Nach der "Abkuerzungsvereinbarung"   import java.util.ArrayList;
duerfen wir die Klasse ArrayList mit ihrem einfachen Namen "ArrayList"
(statt mit ihrem vollen Namen "java.util.ArrayList") bezeichnen (siehe
dazu auch das Programm ArrayList01).
------------------------------------------------------------------------ */
import java.util.ArrayList; // Eine "Abkuerzungsvereinbarung"

class ArrayList02 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {

      // Ein (anfangs leeres) Objekt des Sammlungstyps ArrayList<String>
      // wird vereinbart:
      ArrayList<String> sam02 = new ArrayList<String>();

      // Stringvariablen zum Einfuegen:
      String sa1 = "aaa";
      String sb1 = "bb";
      String sc1 = "ccccc";
      String sd1 = "d";
      String se1 = "eeee";

      // Das noch leere Sammlungsbjekt sam02 ausgeben:
      pln("----------------------------------");
      pln("A sam02: " + sam02);
      pln("----------------------------------");

      // Mit add (ohne Index) Komponenten hintereinander einfuegen
      // ("hinten anhaengen", ist schnell):
      sam02.add(sa1);
      sam02.add(sc1);
      sam02.add(se1);
      pln("B sam02: " + sam02);

      // Mit add (mit Index) Komponenten an bestimmten Indexpositionen
      // einfuegen, schon vorhandene Komponenten werden automatisch nach
      // rechts verschoben (ist wegen der "Verschiebearbeit" langsamer):
      sam02.add(2, sd1);
      sam02.add(1, sb1);
      pln("C sam02: " + sam02);
      pln("----------------------------------");

      // Mit get einzelne Komponenten aus der Sammlung herausholen:
      String sc2 = sam02.get(2);
      String sa2 = sam02.get(0);
      String se2 = sam02.get(4);
      String sb2 = sam02.get(1);
      String sd2 = sam02.get(3);

      // Die fuenf String-Variablen ausgeben:
      pln("D sa2  : " + sa2);
      pln("E sb2  : " + sb2);
      pln("F sc2  : " + sc2);
      pln("G sd2  : " + sd2);
      pln("H se2  : " + se2);
      pln("----------------------------------");

      // sam02 vor dem Entfernen und Ersetzen noch mal ausgeben:
      pln("I sam02: " + sam02);

      // Mit remove Komponenten an bestimmten Indexpositionen entfernen:
      sam02.remove(1);
      sam02.remove(2);
      pln("J sam02: " + sam02);

      // Mit set Komponenten an bestimmten Indexpositionen ersetzen:
      sam02.set(0, se1);
      sam02.set(2, sd1);
      pln("K sam02: " + sam02);
      pln("----------------------------------");

      // Alle noch vorhandenen Komponenten aus sam02 entfernen:
      sam02.clear();
      pln("L sam02: " + sam02);
      pln("----------------------------------");
      pln("M ArrayList02: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class ArrayList02
/* ------------------------------------------------------------------------
Ausgabe des Programms ArrayList02:

----------------------------------
A sam02: []
----------------------------------
B sam02: [aaa, ccccc, eeee]
C sam02: [aaa, bb, ccccc, d, eeee]
----------------------------------
D sa2  : aaa
E sb2  : bb
F sc2  : ccccc
G sd2  : d
H se2  : eeee
----------------------------------
I sam02: [aaa, bb, ccccc, d, eeee]
J sam02: [aaa, ccccc, eeee]
K sam02: [eeee, ccccc, d]
----------------------------------
L sam02: []
----------------------------------
M ArrayList02: Das war's erstmal!
------------------------------------------------------------------------ */