// Datei ArrayList03.java
/* ------------------------------------------------------------------------
Wenn man in einer Sammlung sam nach einem Objekt ob sucht (z.B. mit der
Methode contains) wird ob der Reihe nach mit jeder Komponenten in der
Sammlung verglichen, und zwar mit der equals-Methode (der Komponenten).
Wie die equals-Methode eines Komponenten-Objekts vergleicht haengt von
seiner Klasse ab.

Die equals-Methode in einem String-Objekt vergleicht Zielwerte (d.h. die
eigentlichen Zeichenketten, keine Referenzwerte).
Die equals-Methode in einem StringBuffer-Objekt vergleicht Werte (d.h.
Referenzwerte, keine Zeichenketten).
------------------------------------------------------------------------ */
import java.util.ArrayList;

class ArrayList03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {

      // Zwei String-Objekte, die gleiche
      // Zeichenketten repraesentieren:
      String                  s01  = new String("Hallo!");
      String                  s02  = new String("Hallo!");

      // Zwei StringBuffer-Objekte, die gleiche
      // Zeichenketten repraesentieren:
      StringBuffer            b01  = new StringBuffer("Hallo!");
      StringBuffer            b02  = new StringBuffer("Hallo!");

      // Zwei Sammlungsobjekte:
      ArrayList<String>       samS = new ArrayList<String>();
      ArrayList<StringBuffer> samB = new ArrayList<StringBuffer>();

      // In jede der beiden Sammlungen wird nur ein einziges
      // Objekt eingefuegt:
      samS.add(s01);                       // Ein String
      samB.add(b01);                       // Ein StringBuffer

      // Die String- und StringBuffer-Objekte werden mit equals
      // verglichen und in den Sammlungen mit contains gesucht:
      pln("-------------------------------------------");
      pln("A  s01.equals  (s01): " +  s01.equals  (s01));
      pln("B  s01.equals  (s02): " +  s01.equals  (s01));
      pln("C samS.contains(s01): " + samS.contains(s01));
      pln("D samS.contains(s02): " + samS.contains(s02));
      pln("-------------------------------------------");
      pln("E  b01.equals  (b01): " +  b01.equals  (b01));
      pln("F  b01.equals  (b02): " +  b01.equals  (b02));
      pln("G samB.contains(b01): " + samB.contains(b01));
      pln("H samB.contains(b02): " + samB.contains(b02));
      pln("-------------------------------------------");
      pln("I ArrayList03: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class ArrayList03
/* ------------------------------------------------------------------------
Ausgabe des Programms ArrayList03:

-------------------------------------------
A  s01.equals  (s01): true
B  s01.equals  (s02): true
C samS.contains(s01): true
D samS.contains(s02): true
-------------------------------------------
E  b01.equals  (b01): true
F  b01.equals  (b02): false
G samB.contains(b01): true
H samB.contains(b02): false
-------------------------------------------
I ArrayList03: Das war's erstmal!
------------------------------------------------------------------------ */