// Datei ArrayList04.java
/* ------------------------------------------------------------------------
In eine Sammlung des Typs ArrayList<StringBuffer> werden 10 Objekte
eingefuegt. Dann werden verschiedene Objekte in der Sammlung gesucht
(mit den Methoden contains, indexOf und lastIndexOf). Die Ergebnisse
der Suche werden ausgegeben.
------------------------------------------------------------------------ */
import java.util.ArrayList;
import java.util.Arrays;    // fuer asList

class ArrayList04 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // ------------------------------------------------------------------
      // Drei StringBuffer-Objekte. Zwei davon repraesentieren gleiche
      // Zeichenketten ("aaa"):
      StringBuffer sb01 = new StringBuffer("aaa");
      StringBuffer sb02 = new StringBuffer("bbb");
      StringBuffer sb03 = new StringBuffer("aaa");
      // ------------------------------------------------------------------
      // Die Reihung sbr enthaelt zweimal das Objekt sb01 und zweimal
      // das Objekt sb02:
      StringBuffer[]  sbr           = {sb01, sb02, sb01, sb02};

      // Das Sammlungsobjekt sam04 wird mit der Reihung sr initialisiert:
      ArrayList<StringBuffer> sam04 =
         new ArrayList<StringBuffer>(Arrays.asList(sbr));
      // Jetzt enthaelt auch die Sammlung sam04 zweimal das Objekt sb01
      // und zweimal das Objekt sb02.

      pln("------------------------------------------------------");
      // Die Groesse (size) der Sammlung sam04 und die Sammlung selbst
      // ausgeben:
      pln("A sam04.size()            : " + sam04.size());
      pln("B sam04                   : " + sam04);

      pln("------------------------------------------------------");
      // Die drei StringBuffer-Objekte ausgeben:
      pln("C sb01                    : " + sb01);
      pln("D sb02                    : " + sb02);
      pln("E sb03                    : " + sb03);

      pln("------------------------------------------------------");
      // Mit contains pruefen, ob die Sammlung sam04 die Objekte
      // sb01, sb02 bzw. sb03 enthaelt. Die contains-Methode ver-
      // gleicht das jeweils gesuchte Objekt und die Objekte in
      // sam04 mit equals (bei StringBuffer-Objekten liefert equals
      // nur dann true, wenn die beiden Objekte identisch sind,
      // gleiche Inhalte reichen nicht aus):
      pln("F sam04.contains   (sb01) : " + sam04.contains   (sb01));
      pln("G sam04.contains   (sb02) : " + sam04.contains   (sb02));
      pln("H sam04.contains   (sb03) : " + sam04.contains   (sb03));

      pln("------------------------------------------------------");
      // Mit indexOf den ersten Index eines Objekts in sam04
      // ermitteln (das Ergebnis ist gleich -1 wenn das Objekt
      // nicht in sam04 enthalten ist).
      // Auch die Methode indexOf vergleicht das gesuchte Objekt
      // und die Objekte in sam04 mit equals.
      pln("I sam04.indexOf    (sb01) : " + sam04.indexOf    (sb01));
      pln("J sam04.indexOf    (sb02) : " + sam04.indexOf    (sb02));
      pln("K sam04.indexOf    (sb03) : " + sam04.indexOf    (sb03));

      // Mit LastIndexOf den letzten Index eines Objekts in sam04
      // ermitteln (das Ergebnis ist gleich -1 wenn das Objekt nicht
      // in sam04 enthalten ist).
      // Auch die Methode lastIndexOf vergleicht das gesuchte Objekt
      // und die Objekte in sam04 mit equals.
      pln("------------------------------------------------------");
      pln("L sam04.lastIndexOf(sb01) : " + sam04.lastIndexOf(sb01));
      pln("M sam04.lastIndexOf(sb02) : " + sam04.lastIndexOf(sb02));
      pln("N sam04.lastIndexOf(sb03) : " + sam04.lastIndexOf(sb03));

      pln("------------------------------------------------------");
      pln("O ArrayList04: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class ArrayList04
/* ------------------------------------------------------------------------
Ausgabe des Programms ArrayList04:

------------------------------------------------------
A sam04.size()            : 4
B sam04                   : [aaa, bbb, aaa, bbb]
------------------------------------------------------
C sb01                    : aaa
D sb02                    : bbb
E sb03                    : aaa
------------------------------------------------------
F sam04.contains   (sb01) : true
G sam04.contains   (sb02) : true
H sam04.contains   (sb03) : false
------------------------------------------------------
I sam04.indexOf    (sb01) : 0
J sam04.indexOf    (sb02) : 1
K sam04.indexOf    (sb03) : -1
------------------------------------------------------
L sam04.lastIndexOf(sb01) : 2
M sam04.lastIndexOf(sb02) : 3
N sam04.lastIndexOf(sb03) : -1
------------------------------------------------------
O ArrayList04: Das war's erstmal!
------------------------------------------------------------------------ */