// Datei ArrayList07MitCompilerFehler.java
/* ------------------------------------------------------------------------
Der Ausfuehrer taeuscht dem Programmierer vor, dass man in einer Sammlung
des Typs ArrayList<Long> nicht nur Objekte der Huellklasse Long sondern
auch Werte des primitiven Typs long sammeln kann.
Tatsaechlich werden beim Einfuegen (mit add) long-Werte automatisch in
Long-Objekte umgewandelt. Beim Herausholen (mit get) werden Long-Objekte
in long-Werte umgewandelt, wenn das sinnvoll ist.
------------------------------------------------------------------------ */
import java.util.ArrayList;

class ArrayList07 {
   // ---------------------------------------------------------------------
   // Eine Sammlung von Objekten der Huellklasse Long:
   static ArrayList<Long> samL = new ArrayList<Long>();

   static Long LA = new Long(11); // Ein Long-Objekt
   static Long LB = new Long(22); // Ein Long-Objekt
   static long la =          33;  // Ein primitiver long-Wert
   static long lb =          44;  // Ein primitiver long-Wert
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Objekt bzw. primitive Werte in die Sammlung samL einfuegen:
      samL.add(LA);               // Keine Umwandlung
      samL.add(LB);               // Keine Umwandlung
      samL.add(la);               // Umwandlung long nach Long
      samL.add(lb);               // Umwandlung long nach Long
      pln("samL: " + samL);
      pln("-------------------------------");
      gibAus();

      // Objekte bzw. primitive Werte aus der Sammlung samL herausholen:
      LA = samL.get(0);           // Keine Umwandlung
      LB = samL.get(2);           // Keine Umwandlung
      la = samL.get(1);           // Umwandlung Long nach long
      lb = samL.get(3);           // Umwandlung Long nach long
      gibAus();
      pln("-------------------------------");
      pln("ArrayList07: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   static void gibAus() {
      // Gibt die vier Variablen LA, LB, la und lb aus:
      p  (  "LA: " + LA + ", LB: " + LB);
      pln(", la: " + la + ", lb: " + lb);
   } // gibAus
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
// static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class ArrayList07
/* ------------------------------------------------------------------------
Ausgabe des Programms ArrayList07:

samL: [11, 22, 33, 44]
-------------------------------
LA: 11, LB: 22, la: 33, lb: 44
LA: 11, LB: 33, la: 22, lb: 44
-------------------------------
ArrayList07: Das war's erstmal!
------------------------------------------------------------------------ */