// Datei ArraysPAnw01.java
/* ------------------------------------------------------------------------
Eine Anwendung der  Schnittstelle ArraysP.DoubleList und einer Methode
ArraysP.asList. Die Schnittstelle ArraysP.DoubleList ist eine Erweiterung
der Schnittstelle java.util.List.

Die Reihung dRei enthaelt Komponenten des primitiven Typs double.
Das Objekt  dLst bietet eine Sammlungs-Sicht auf die Reihung dRei.
Jede Veraenderung an dRei (bzw. an dLst) ist auch eine Veraenderung
an dLst (bzw. dRei).

Die Sammlung dLst bietet eigentlich zwei Sichten auf die Reihung dRei:
eine Sicht auf eine Sammlung von Double-Objekten und
eine Sicht auf eine Sammlung von double-Werten.
Methoden wie get,  set,  contains  beziehen sich auf die Double-Sammlung.
Methoden wie getP, setP, containsP beziehen sich auf die double-Sammlung.

Methoden, die die Laenge der Sammlung dLst veraendern wuerden, funktio-
nieren nicht richtig sondern werfen eine Ausnahme des Typs UnsupportedOpe-
rationException.
------------------------------------------------------------------------ */
import java.util.Arrays;      // fuer sort
import java.util.Collections; // fuer sort und shuffle

class ArraysPAnw01 {
   static public void main(String[] sonja) {

      double[]           dRei  = {31.5, 11.5, 21.5, 41.5};
      ArraysP.DoubleList dLst  = ArraysP.asList(dRei);

      pln("ArraysPAnw01: Jetzt geht es los!");
      pln("-------------------------------------------------------------");
      pln("  Eine Reihung dRei mit primitiven Komponenten und");
      pln("  eine List-Ansicht dLstdarauf:");
      pln("A double[]            dRei  = {31.5, 11.5, 21.5, 41.5};");
      pln("B ArraysP.DoubleList  dLst  = ArraysP.asList(dRei);");
      pln("-------------------------------------------------------------");
      pln("         Indizes der Sammlung dLst:   0     1     2     3");
      pln("C dLst am Anfang                  : " + dLst);
                       dRei[3] = 42.5;
      pln("D nach      dRei[3] = 42.5;       : " + dLst);
                  dLst.setP(3,   43.5);
      pln("E nach dLst.setP(3,   43.5);      : " + dLst);
                  dLst.set (3,   44.5);
      pln("F nach dLst.set (3,   44.5);      : " + dLst);
                  Arrays.sort        (dRei);
      pln("G nach Arrays.sort        (dRei); : " + dLst);
                  Collections.shuffle(dLst);
      pln("H nach Collections.shuffle(dLst); : " + dLst);
                  Collections.shuffle(dLst);
      pln("I nach Collections.shuffle(dLst); : " + dLst);
                  Collections.sort   (dLst);
      pln("J nach Collections.sort   (dLst); : " + dLst);
      pln("-------------------------------------------------------------");
      pln("K dLst.containsP(44.5)            : " + dLst.containsP(44.5));
      pln("L dLst.contains (44.5)            : " + dLst.contains (44.5));
      pln("M dLst.containsP(99.5)            : " + dLst.containsP(99.5));
      pln("N dLst.contains (99.5)            : " + dLst.contains (99.5));
      pln("-------------------------------------------------------------");

      // Welche Methodenaufrufe loesen eine Ausnahme des Typs
      // UnsupportedOperation aus und welche nicht?
      for (int i=1; i<=4; i++) {
         try {
            switch(i) {
               case 1: p("O dLst.add   (99.5); "); dLst.add   (99.5); break;
               case 2: p("P dLst.add   (44.5); "); dLst.add   (44.5); break;
               case 3: p("Q dLst.remove(99.5); "); dLst.remove(99.5); break;
               case 4: p("R dLst.remove(44.5); "); dLst.remove(44.5); break;
            } // switch
            pln("Keine Ausnahme!");
         } catch (Exception ex) {
            pln(ex);
         } // try-catch
      } // for
      pln("-------------------------------------------------------------");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class ArraysPAnw01
/* ------------------------------------------------------------------------
Ausgabe des Programms ArraysPAnw01:

ArraysPAnw01: Jetzt geht es los!
-------------------------------------------------------------
  Eine Reihung dRei mit primitiven Komponenten und
  eine List-Ansicht dLstdarauf:
A double[]            dRei  = {31.5, 11.5, 21.5, 41.5};
B ArraysP.DoubleList  dLst  = ArraysP.asList(dRei);
-------------------------------------------------------------
  Indizes der Sammlung dLst       :   0     1     2     3
C dLst am Anfang                  : [31.5, 11.5, 21.5, 41.5]
D nach      dRei[3] = 42.5;       : [31.5, 11.5, 21.5, 42.5]
E nach dLst.setP(3,   43.5);      : [31.5, 11.5, 21.5, 43.5]
F nach dLst.set (3,   44.5);      : [31.5, 11.5, 21.5, 44.5]
G nach Arrays.sort        (dRei); : [11.5, 21.5, 31.5, 44.5]
H nach Collections.shuffle(dLst); : [31.5, 11.5, 44.5, 21.5]
I nach Collections.shuffle(dLst); : [21.5, 31.5, 44.5, 11.5]
J nach Collections.sort   (dLst); : [11.5, 21.5, 31.5, 44.5]
-------------------------------------------------------------
K dLst.containsP(44.5)            : true
L dLst.contains (44.5)            : true
M dLst.containsP(99.5)            : false
N dLst.contains (99.5)            : false
-------------------------------------------------------------
O dLst.add   (99.5); java.lang.UnsupportedOperationException
P dLst.add   (44.5); java.lang.UnsupportedOperationException
Q dLst.remove(99.5); Keine Ausnahme!
R dLst.remove(44.5); java.lang.UnsupportedOperationException
-------------------------------------------------------------
------------------------------------------------------------------------ */