// Datei ArraysPTst.java
/* ------------------------------------------------------------------------
Programm zum Testen der Klasse ArraysP.
Die Standardklasse java.util.Arrays verbindet Reihungen von Objekten
(Reihungen von Typen wie String[], Double[], Object[], ...) mit
Sammlungen, genauer mit List-Objekten.
Die (nicht-Standard-) Klasse ArraysP soll ganz entsprechend Reihungen
mit primitiven Komponenten (Reihungen der 8 Typen byte[], char[], ...
int[], ..., boolean[]) mit Sammlungen verbinden.

Die Klasse ArraysP ("P" wie "primitiv") enthaelt
8 Schnittstellen  ByteList,   CharList,   ..., BooleanList,
8 private Klassen ListOfByte, ListOfChar, ..., ListOfBoolean und
8 Methoden names asList.
------------------------------------------------------------------------ */
import java.util.Iterator;

class ArraysPTst {
   static public void main(String[] sonja) {
      // Die 8 Schnittstellen   ByteList,   CharList,   ..., BooleanList   und
      // die 8 privaten Klassen ListOfByte, ListOfChar, ..., ListOfBoolean und
      // die 8 Methoden namens asList werden jetzt ein bisschen getestet.

      // Reihungen mit Testdaten (byte-Reihung, char-Reihung, ...):
      // Die byteRei wird spaeter veraendert. Die veraenderte byteRei
      // sollte ungleich der byteReiA und gleich der byteReiB sei
      // Fuer die anderen Reihungen entsprechend:
         byte[]    byteRei = {55, 56, 57};
         char[]    charRei = {65, 66, 67};
        short[]   shortRei = {75, 76, 77};
          int[]     intRei = {85, 86, 87};
         long[]    longRei = {95, 96, 97};
        float[]   floatRei = {15, 16, 17};
       double[]  doubleRei = {25, 26, 27};
      boolean[] booleanRei = {true, false, true};

         byte[]    byteReiA = {55, 56, 57};
         char[]    charReiA = {65, 66, 67};
        short[]   shortReiA = {75, 76, 77};
          int[]     intReiA = {85, 86, 87};
         long[]    longReiA = {95, 96, 97};
        float[]   floatReiA = {15, 16, 17};
       double[]  doubleReiA = {25, 26, 27};
      boolean[] booleanReiA = {true, false, true};

         byte[]    byteReiB = {58, 57, 56};
         char[]    charReiB = {68, 67, 66};
        short[]   shortReiB = {78, 77, 76};
          int[]     intReiB = {88, 87, 86};
         long[]    longReiB = {98, 97, 96};
        float[]   floatReiB = {18, 17, 16};
       double[]  doubleReiB = {28, 27, 26};
      boolean[] booleanReiB = {true, false, true};

      // Sammlungen mit Testdaten (byte-Sammlung, char-Sammlung, ...):
      ArraysP.   ByteList    byteSam  = ArraysP.asList(   byteRei);
      ArraysP.   CharList    charSam  = ArraysP.asList(   charRei);
      ArraysP.  ShortList   shortSam  = ArraysP.asList(  shortRei);
      ArraysP.    IntList     intSam  = ArraysP.asList(    intRei);
      ArraysP.   LongList    longSam  = ArraysP.asList(   longRei);
      ArraysP.  FloatList   floatSam  = ArraysP.asList(  floatRei);
      ArraysP. DoubleList  doubleSam  = ArraysP.asList( doubleRei);
      ArraysP.BooleanList booleanSam  = ArraysP.asList(booleanRei);

      ArraysP.   ByteList    byteSamA = ArraysP.asList(   byteReiA);
      ArraysP.   CharList    charSamA = ArraysP.asList(   charReiA);
      ArraysP.  ShortList   shortSamA = ArraysP.asList(  shortReiA);
      ArraysP.    IntList     intSamA = ArraysP.asList(    intReiA);
      ArraysP.   LongList    longSamA = ArraysP.asList(   longReiA);
      ArraysP.  FloatList   floatSamA = ArraysP.asList(  floatReiA);
      ArraysP. DoubleList  doubleSamA = ArraysP.asList( doubleReiA);
      ArraysP.BooleanList booleanSamA = ArraysP.asList(booleanReiA);

      ArraysP.   ByteList    byteSamB = ArraysP.asList(   byteReiB);
      ArraysP.   CharList    charSamB = ArraysP.asList(   charReiB);
      ArraysP.  ShortList   shortSamB = ArraysP.asList(  shortReiB);
      ArraysP.    IntList     intSamB = ArraysP.asList(    intReiB);
      ArraysP.   LongList    longSamB = ArraysP.asList(   longReiB);
      ArraysP.  FloatList   floatSamB = ArraysP.asList(  floatReiB);
      ArraysP. DoubleList  doubleSamB = ArraysP.asList( doubleReiB);
      ArraysP.BooleanList booleanSamB = ArraysP.asList(booleanReiB);


      // Jetzt kommen 8 Gruppen von Testbefehlen, fuer jeden primitiven
      // Typ eine. Reihenfolge:
      // (byte, char, short, int, long, float, double, boolean)
      pln("ArraysPTst: Jetzt geht es los!");
      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ byte:");
      pln("byteSam:   " + byteSam);
      byteRei[0] = (byte) 56;
      byteSam.set    (1, new Byte((byte)57));
      byteSam.setP   (2, (byte)58);
      pln("byteSam:   " + byteSam);
      pln("byteSam.getP   (0): " + byteSam.getP   (0));
      pln("byteSam.getP   (1): " + byteSam.getP   (1));
      pln("byteSam.getP   (2): " + byteSam.getP   (2));
      pln("byteSam.get    (0): " + byteSam.get    (0));
      pln("byteSam.get    (1): " + byteSam.get    (1));
      pln("byteSam.get    (2): " + byteSam.get    (2));
      pln(Objects.toString(byteSam.toArrayP()));

      p("     ");
/*
      for (Iterator it = byteSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
*/
      for (Byte b: byteSam) {
         p(b + "  ");
      }

      pln();

      pln("byteSam.contains (new Byte((byte)57)): " +
           byteSam.contains (new Byte((byte)57)));
      pln("byteSam.contains (new Byte((byte)99)): " +
           byteSam.contains (new Byte((byte)99)));
      pln("byteSam.containsP(         (byte)57)): " +
           byteSam.containsP(         (byte)57));
      pln("byteSam.containsP(         (byte)99)): " +
           byteSam.containsP(         (byte)99));

      pln("byteSam.containsAll (byteSamA):        " +
           byteSam.containsAll (byteSamA));
      pln("byteSam.containsAll (byteSamB):        " +
           byteSam.containsAll (byteSamB));
      pln("byteSam.containsAllP(byteReiA):        " +
           byteSam.containsAllP(byteReiA));
      pln("byteSam.containsAllP(byteReiB):        " +
           byteSam.containsAllP(byteReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ char:");
      pln("charSam:   " + charSam);
      charRei[0] = (char) 66;
      charSam.set    (1, new Character((char)67));
      charSam.setP   (2, (char)68);
      pln("charSam:   " + charSam);
      pln("charSam.getP   (0): " + charSam.getP   (0));
      pln("charSam.getP   (1): " + charSam.getP   (1));
      pln("charSam.getP   (2): " + charSam.getP   (2));
      pln("charSam.get    (0): " + charSam.get    (0));
      pln("charSam.get    (1): " + charSam.get    (1));
      pln("charSam.get    (2): " + charSam.get    (2));
      pln(Objects.toString(charSam.toArrayP()));

      p("     ");
      for (Iterator it = charSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("charSam.contains (new Character((char)67)): " +
           charSam.contains (new Character((char)67)));
      pln("charSam.contains (new Character((char)99)): " +
           charSam.contains (new Character((char)99)));
      pln("charSam.containsP(              (char)67)): " +
           charSam.containsP(              (char)67));
      pln("charSam.containsP(              (char)99)): " +
           charSam.containsP(              (char)99));

      pln("charSam.containsAll (charSamA):             " +
           charSam.containsAll (charSamA));
      pln("charSam.containsAll (charSamB):             " +
           charSam.containsAll (charSamB));
      pln("charSam.containsAllP(charReiA):             " +
           charSam.containsAllP(charReiA));
      pln("charSam.containsAllP(charReiB):             " +
           charSam.containsAllP(charReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ short:");
      pln("shortSam:   " + shortSam);
      shortRei[0] = (short) 76;
      shortSam.set    (1, new Short((short)77));
      shortSam.setP   (2, (short)78);
      pln("shortSam:   " + shortSam);
      pln("shortSam.getP   (0): " + shortSam.getP   (0));
      pln("shortSam.getP   (1): " + shortSam.getP   (1));
      pln("shortSam.getP   (2): " + shortSam.getP   (2));
      pln("shortSam.get    (0): " + shortSam.get    (0));
      pln("shortSam.get    (1): " + shortSam.get    (1));
      pln("shortSam.get    (2): " + shortSam.get    (2));
      pln(Objects.toString(shortSam.toArrayP()));

      p("     ");
      for (Iterator it = shortSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("shortSam.contains (new Short((short)77)): " +
           shortSam.contains (new Short((short)77)));
      pln("shortSam.contains (new Short((short)99)): " +
           shortSam.contains (new Short((short)99)));
      pln("shortSam.containsP(          (short)77)): " +
           shortSam.containsP(          (short)77));
      pln("shortSam.containsP(          (short)99)): " +
           shortSam.containsP(          (short)99));

      pln("shortSam.containsAll (shortSamA):         " +
           shortSam.containsAll (shortSamA));
      pln("shortSam.containsAll (shortSamB):         " +
           shortSam.containsAll (shortSamB));
      pln("shortSam.containsAllP(shortReiA):         " +
           shortSam.containsAllP(shortReiA));
      pln("shortSam.containsAllP(shortReiB):         " +
           shortSam.containsAllP(shortReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ int:");
      pln("intSam:   " + intSam);
      intRei[0] = 86;
      intSam.set(1, new Integer(87));
      intSam.setP   (2, 88);
      pln("intSam:   " + intSam);
      pln("intSam.getP   (0): " + intSam.getP   (0));
      pln("intSam.getP   (1): " + intSam.getP   (1));
      pln("intSam.getP   (2): " + intSam.getP   (2));
      pln("intSam.get    (0): " + intSam.get    (0));
      pln("intSam.get    (1): " + intSam.get    (1));
      pln("intSam.get    (2): " + intSam.get    (2));
      pln(Objects.toString(intSam.toArrayP()));

      p("     ");
      for (Iterator it = intSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("intSam.contains (new Integer((int)87)): " +
           intSam.contains (new Integer((int)87)));
      pln("intSam.contains (new Integer((int)99)): " +
           intSam.contains (new Integer((int)99)));
      pln("intSam.containsP(            (int)87)): " +
           intSam.containsP(            (int)87));
      pln("intSam.containsP(            (int)99)): " +
           intSam.containsP(            (int)99));

      pln("intSam.containsAll (intSamA):           " +
           intSam.containsAll (intSamA));
      pln("intSam.containsAll (intSamB):           " +
           intSam.containsAll (intSamB));
      pln("intSam.containsAllP(intReiA):           " +
           intSam.containsAllP(intReiA));
      pln("intSam.containsAllP(intReiB):           " +
           intSam.containsAllP(intReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ long:");
      pln("longSam:   " + longSam);
      longRei[0] = (long) 96;
      longSam.set    (1, new Long((long)97));
      longSam.setP   (2, (long)98);
      pln("longSam:   " + longSam);
      pln("longSam.getP   (0): " + longSam.getP   (0));
      pln("longSam.getP   (1): " + longSam.getP   (1));
      pln("longSam.getP   (2): " + longSam.getP   (2));
      pln("longSam.get    (0): " + longSam.get    (0));
      pln("longSam.get    (1): " + longSam.get    (1));
      pln("longSam.get    (2): " + longSam.get    (2));
      pln(Objects.toString(longSam.toArrayP()));

      p("     ");
      for (Iterator it = longSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("longSam.contains (new Long((long)97)): " +
           longSam.contains (new Long((long)97)));
      pln("longSam.contains (new Long((long)99)): " +
           longSam.contains (new Long((long)99)));
      pln("longSam.containsP(         (long)97)): " +
           longSam.containsP(         (long)97));
      pln("longSam.containsP(         (long)99)): " +
           longSam.containsP(         (long)99));

      pln("longSam.containsAll (longSamA):        " +
           longSam.containsAll (longSamA));
      pln("longSam.containsAll (longSamB):        " +
           longSam.containsAll (longSamB));
      pln("longSam.containsAllP(longReiA):        " +
           longSam.containsAllP(longReiA));
      pln("longSam.containsAllP(longReiB):        " +
           longSam.containsAllP(longReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ float:");
      pln("floatSam:   " + floatSam);
      floatRei[0] = (float) 16;
      floatSam.set    (1, new Float((float)17));
      floatSam.setP   (2, (float)18);
      pln("floatSam:   " + floatSam);
      pln("floatSam.getP   (0): " + floatSam.getP   (0));
      pln("floatSam.getP   (1): " + floatSam.getP   (1));
      pln("floatSam.getP   (2): " + floatSam.getP   (2));
      pln("floatSam.get    (0): " + floatSam.get    (0));
      pln("floatSam.get    (1): " + floatSam.get    (1));
      pln("floatSam.get    (2): " + floatSam.get    (2));
      pln(Objects.toString(floatSam.toArrayP()));

      p("     ");
      for (Iterator it = floatSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("floatSam.contains (new Float((float)17)): " +
           floatSam.contains (new Float((float)17)));
      pln("floatSam.contains (new Float((float)99)): " +
           floatSam.contains (new Float((float)99)));
      pln("floatSam.containsP(          (float)17)): " +
           floatSam.containsP(          (float)17));
      pln("floatSam.containsP(          (float)99)): " +
           floatSam.containsP(          (float)99));

      pln("floatSam.containsAll (floatSamA):         " +
           floatSam.containsAll (floatSamA));
      pln("floatSam.containsAll (floatSamB):         " +
           floatSam.containsAll (floatSamB));
      pln("floatSam.containsAllP(floatReiA):         " +
           floatSam.containsAllP(floatReiA));
      pln("floatSam.containsAllP(floatReiB):         " +
           floatSam.containsAllP(floatReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ double:");
      pln("doubleSam:   " + doubleSam);
      doubleRei[0] = (double) 26;
      doubleSam.set    (1, new Double((double)27));
      doubleSam.setP   (2, (double)28);
      pln("doubleSam:   " + doubleSam);
      pln("doubleSam.getP   (0): " + doubleSam.getP   (0));
      pln("doubleSam.getP   (1): " + doubleSam.getP   (1));
      pln("doubleSam.getP   (2): " + doubleSam.getP   (2));
      pln("doubleSam.get    (0): " + doubleSam.get    (0));
      pln("doubleSam.get    (1): " + doubleSam.get    (1));
      pln("doubleSam.get    (2): " + doubleSam.get    (2));
      pln(Objects.toString(doubleSam.toArrayP()));

      p("     ");
      for (Iterator it = doubleSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("doubleSam.contains (new Double((double)27)): " +
           doubleSam.contains (new Double((double)27)));
      pln("doubleSam.contains (new Double((double)99)): " +
           doubleSam.contains (new Double((double)99)));
      pln("doubleSam.containsP(           (double)27)): " +
           doubleSam.containsP(           (double)27));
      pln("doubleSam.containsP(           (double)99)): " +
           doubleSam.containsP(           (double)99));

      pln("doubleSam.containsAll (doubleSamA):          " +
           doubleSam.containsAll (doubleSamA));
      pln("doubleSam.containsAll (doubleSamB):          " +
           doubleSam.containsAll (doubleSamB));
      pln("doubleSam.containsAllP(doubleReiA):          " +
           doubleSam.containsAllP(doubleReiA));
      pln("doubleSam.containsAllP(doubleReiB):          " +
           doubleSam.containsAllP(doubleReiB));

      pln("-------------------------------------------------------");
      pln("Tests fuer den Typ boolean:");
      pln("booleanSam:   " + booleanSam);
      booleanRei[0] = (boolean) false;
      booleanSam.set    (1, new Boolean((boolean)true));
      booleanSam.setP   (2, (boolean)true);
      pln("booleanSam:   " + booleanSam);
      pln("booleanSam.getP   (0): " + booleanSam.getP   (0));
      pln("booleanSam.getP   (1): " + booleanSam.getP   (1));
      pln("booleanSam.getP   (2): " + booleanSam.getP   (2));
      pln("booleanSam.get    (0): " + booleanSam.get    (0));
      pln("booleanSam.get    (1): " + booleanSam.get    (1));
      pln("booleanSam.get    (2): " + booleanSam.get    (2));
      pln(Objects.toString(booleanSam.toArrayP()));

      p("     ");
      for (Iterator it = booleanSam.iterator(); it.hasNext();) {
         p(it.next() + "  ");
      } // for
      pln();

      pln("booleanSam.contains (new Boolean((boolean)true)) : " +
           booleanSam.contains (new Boolean((boolean)true)));
      pln("booleanSam.contains (new Boolean((boolean)false)): " +
           booleanSam.contains (new Boolean((boolean)false)));
      pln("booleanSam.containsP(            (boolean)true)) : " +
           booleanSam.containsP(            (boolean)true));
      pln("booleanSam.containsP(            (boolean)false)): " +
           booleanSam.containsP(            (boolean)false));

      pln("booleanSam.containsAll (booleanSamA):              " +
           booleanSam.containsAll (booleanSamA));
      pln("booleanSam.containsAll (booleanSamB):              " +
           booleanSam.containsAll (booleanSamB));
      pln("booleanSam.containsAllP(booleanReiA):              " +
           booleanSam.containsAllP(booleanReiA));
      pln("booleanSam.containsAllP(booleanReiB):              " +
           booleanSam.containsAllP(booleanReiB));

      pln("-------------------------------------------------------");

   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // ArraysPTst
/* ------------------------------------------------------------------------
Ausgabe des Programms ArraysPTst:

ArraysPTst: Jetzt geht es los!
-------------------------------------------------------
Tests fuer den Typ byte:
byteSam:   [55, 56, 57]
byteSam:   [56, 57, 58]
byteSam.getP   (0): 56
byteSam.getP   (1): 57
byteSam.getP   (2): 58
byteSam.get    (0): 56
byteSam.get    (1): 57
byteSam.get    (2): 58
Typ: byte[], Laenge: 3
    {56, 57, 58}
     56  57  58
byteSam.contains (new Byte((byte)57)): true
byteSam.contains (new Byte((byte)99)): false
byteSam.containsP(         (byte)57)): true
byteSam.containsP(         (byte)99)): false
byteSam.containsAll (byteSamA):        false
byteSam.containsAll (byteSamB):        true
byteSam.containsAllP(byteReiA):        false
byteSam.containsAllP(byteReiB):        true
-------------------------------------------------------
Tests fuer den Typ char:
charSam:   [A, B, C]
charSam:   [B, C, D]
charSam.getP   (0): B
charSam.getP   (1): C
charSam.getP   (2): D
charSam.get    (0): B
charSam.get    (1): C
charSam.get    (2): D
Typ: char[], Laenge: 3
    {B, C, D}
     B  C  D
charSam.contains (new Character((char)67)): true
charSam.contains (new Character((char)99)): false
charSam.containsP(              (char)67)): true
charSam.containsP(              (char)99)): false
charSam.containsAll (charSamA):             false
charSam.containsAll (charSamB):             true
charSam.containsAllP(charReiA):             false
charSam.containsAllP(charReiB):             true
-------------------------------------------------------
Tests fuer den Typ short:
shortSam:   [75, 76, 77]
shortSam:   [76, 77, 78]
shortSam.getP   (0): 76
shortSam.getP   (1): 77
shortSam.getP   (2): 78
shortSam.get    (0): 76
shortSam.get    (1): 77
shortSam.get    (2): 78
Typ: short[], Laenge: 3
    {76, 77, 78}
     76  77  78
shortSam.contains (new Short((short)77)): true
shortSam.contains (new Short((short)99)): false
shortSam.containsP(          (short)77)): true
shortSam.containsP(          (short)99)): false
shortSam.containsAll (shortSamA):         false
shortSam.containsAll (shortSamB):         true
shortSam.containsAllP(shortReiA):         false
shortSam.containsAllP(shortReiB):         true
-------------------------------------------------------
Tests fuer den Typ int:
intSam:   [85, 86, 87]
intSam:   [86, 87, 88]
intSam.getP   (0): 86
intSam.getP   (1): 87
intSam.getP   (2): 88
intSam.get    (0): 86
intSam.get    (1): 87
intSam.get    (2): 88
Typ: int[], Laenge: 3
    {86, 87, 88}
     86  87  88
intSam.contains (new Integer((int)87)): true
intSam.contains (new Integer((int)99)): false
intSam.containsP(            (int)87)): true
intSam.containsP(            (int)99)): false
intSam.containsAll (intSamA):           false
intSam.containsAll (intSamB):           true
intSam.containsAllP(intReiA):           false
intSam.containsAllP(intReiB):           true
-------------------------------------------------------
Tests fuer den Typ long:
longSam:   [95, 96, 97]
longSam:   [96, 97, 98]
longSam.getP   (0): 96
longSam.getP   (1): 97
longSam.getP   (2): 98
longSam.get    (0): 96
longSam.get    (1): 97
longSam.get    (2): 98
Typ: long[], Laenge: 3
    {96, 97, 98}
     96  97  98
longSam.contains (new Long((long)97)): true
longSam.contains (new Long((long)99)): false
longSam.containsP(         (long)97)): true
longSam.containsP(         (long)99)): false
longSam.containsAll (longSamA):        false
longSam.containsAll (longSamB):        true
longSam.containsAllP(longReiA):        false
longSam.containsAllP(longReiB):        true
-------------------------------------------------------
Tests fuer den Typ float:
floatSam:   [15.0, 16.0, 17.0]
floatSam:   [16.0, 17.0, 18.0]
floatSam.getP   (0): 16.0
floatSam.getP   (1): 17.0
floatSam.getP   (2): 18.0
floatSam.get    (0): 16.0
floatSam.get    (1): 17.0
floatSam.get    (2): 18.0
Typ: float[], Laenge: 3
    {16.0, 17.0, 18.0}
     16.0  17.0  18.0
floatSam.contains (new Float((float)17)): true
floatSam.contains (new Float((float)99)): false
floatSam.containsP(          (float)17)): true
floatSam.containsP(          (float)99)): false
floatSam.containsAll (floatSamA):         false
floatSam.containsAll (floatSamB):         true
floatSam.containsAllP(floatReiA):         false
floatSam.containsAllP(floatReiB):         true
-------------------------------------------------------
Tests fuer den Typ double:
doubleSam:   [25.0, 26.0, 27.0]
doubleSam:   [26.0, 27.0, 28.0]
doubleSam.getP   (0): 26.0
doubleSam.getP   (1): 27.0
doubleSam.getP   (2): 28.0
doubleSam.get    (0): 26.0
doubleSam.get    (1): 27.0
doubleSam.get    (2): 28.0
Typ: double[], Laenge: 3
    {26.0, 27.0, 28.0}
     26.0  27.0  28.0
doubleSam.contains (new Double((double)27)): true
doubleSam.contains (new Double((double)99)): false
doubleSam.containsP(           (double)27)): true
doubleSam.containsP(           (double)99)): false
doubleSam.containsAll (doubleSamA):          false
doubleSam.containsAll (doubleSamB):          true
doubleSam.containsAllP(doubleReiA):          false
doubleSam.containsAllP(doubleReiB):          true
-------------------------------------------------------
Tests fuer den Typ boolean:
booleanSam:   [true, false, true]
booleanSam:   [false, true, true]
booleanSam.getP   (0): false
booleanSam.getP   (1): true
booleanSam.getP   (2): true
booleanSam.get    (0): false
booleanSam.get    (1): true
booleanSam.get    (2): true
Typ: boolean[], Laenge: 3
    {false, true, true}
     false  true  true
booleanSam.contains (new Boolean((boolean)true)) : true
booleanSam.contains (new Boolean((boolean)false)): true
booleanSam.containsP(            (boolean)true)) : true
booleanSam.containsP(            (boolean)false)): true
booleanSam.containsAll (booleanSamA):              true
booleanSam.containsAll (booleanSamB):              true
booleanSam.containsAllP(booleanReiA):              true
booleanSam.containsAllP(booleanReiB):              true
-------------------------------------------------------
------------------------------------------------------------------------ */