// Datei Aufzaehlungen01.java
/* ------------------------------------------------------------------------
Fuenf Aufzaehlungstypen werden vereinbart. Variablen dieser Typen
werden vereinbart und bearbeitet (in if-, for- und switch-Anweisungen).
------------------------------------------------------------------------ */
// Fuenf simple Aufzaehlungstypen:
enum Farbe      {rot, gruen, blau, farblos;}
enum Wein       {weiss, rot, ros;}
enum Zustand    {an, aus, kaputt;}
enum WochenTag  {Mo, Di, Mi, Do, Fr, Sa, So;}
enum Richtung   {oben, rechts, unten, links;}
// ------------------------------------------------------------------------
// Die Klasse Aufzaehlungen01 enthaelt nur eine main-Methode. Darin werden
// die Aufzaehlungstypen Farbe, Wein, Zustand, WochenTag und Richtung
// benutzt.

class Aufzaehlungen01 {

   static public void main(String [] sonja) {

      Farbe     meineFarbe = Farbe.gruen;
      Farbe     deineFarbe = Farbe.rot;
      Farbe     seineFarbe = null;

      Wein      meinWein   = Wein.rot;
      Wein      deinWein   = Wein.ros;

      Zustand   z01        = Zustand.aus;
      Zustand   z02        = Zustand.kaputt;

      WochenTag heute      = WochenTag.Mi;
      WochenTag morgen     = WochenTag.Do;

      Richtung  richtig    = Richtung.oben;
      Richtung  falsch     = Richtung.unten;

      printf("Aufzaehlungen01: Jetzt geht es los!%n");
      printf("--------------------------------------%n");
      printf("A meineFarbe: %s%n",  meineFarbe);
      printf("B deineFarbe: %s%n",  deineFarbe);
      printf("C seineFarbe: %s%n",  seineFarbe);
      printf("--------------------------------------%n");
      printf("D meinWein  : %s%n",  meinWein);
      printf("E deinWein  : %s%n",  deinWein);
      printf("--------------------------------------%n");
      printf("F z01       : %s%n",  z01);
      printf("G z02       : %s%n",  z02);
      printf("--------------------------------------%n");
      printf("H heute     : %s%n",  heute);
      printf("I morgen    : %s%n",  morgen);
      printf("--------------------------------------%n");
      printf("J richtig   : %s%n",  richtig);
      printf("K falsch    : %s%n",  falsch);
      printf("--------------------------------------%n");
      // Aufzaehlungswerte in if-Anweisungen:
      if (deineFarbe == Farbe.rot) {
         printf("L deineFarbe ist gleich rot!%n");
      } else {
         printf("L deineFarbe ist ungleich rot!%n");
      }

      if (meinWein != deinWein) {
         printf("M meinWein und deinWein sind ungleich!%n");
      } else {
         printf("M meinWein und deinWein sind gleich!%n");
      }
      printf("--------------------------------------%n");
      // Aufzaehlungswerte in einer for-Schleife
      printf("N ");
      for (WochenTag wt: WochenTag.values()) {
         printf("%s ", wt);
      }
      printf("%n");
      printf("--------------------------------------%n");
      // Aufzaehlungswerte in einer switch-Anweisung:
      printf("O Your color is ");
      switch (deineFarbe) {
         case rot:   printf("red%n");       break;
         case gruen: printf("green%n");     break;
         case blau:  printf("blue%n");      break;
         default:    printf("colorless%n"); break;
      } // switch
      printf("--------------------------------------%n");
      printf("P heute.compareTo(WochenTag.So): %s%n",
                heute.compareTo(WochenTag.So)
            );
      printf("--------------------------------------%n");
/*
      // Ein paar Befehle, die der Ausfuehrer ablehnt:
      meineFarbe = Wein.rot;     // Fehlermeldung
      deinWein   = Farbe.rot;    // Fehlermeldung
      deinWein   = 0;            // Fehlermeldung
      deinWein   = "rot";        // Fehlermeldung
      if (z01 != Wein.rot) {}    // Fehlermeldung
      switch (deineFarbe) {
         case ros:              // Fehlermeldung
      }
      deinWein   = new Wein();   // Fehlermeldung
*/
      printf("Aufzaehlungen01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Aufzaehlungen01
/* ------------------------------------------------------------------------
Fehlermeldungen des Compilers, wenn die entsprechenden Zeilen keine
Kommentare sind:

D:\Java\Aufzaehlungen01.java:90: incompatible types
found   : Wein
required: Farbe
      meineFarbe = Wein.rot;     // Fehlermeldung
                       ^
D:\Java\Aufzaehlungen01.java:91: incompatible types
found   : Farbe
required: Wein
      deinWein   = Farbe.rot;    // Fehlermeldung
                        ^
D:\Java\Aufzaehlungen01.java:92: incompatible types
found   : int
required: Wein
      deinWein   = 0;            // Fehlermeldung
                   ^
D:\Java\Aufzaehlungen01.java:93: incompatible types
found   : java.lang.String
required: Wein
      deinWein   = "rot";        // Fehlermeldung
                   ^
D:\Java\Aufzaehlungen01.java:94: incomparable types: Zustand and Wein
      if (z01 != Wein.rot) {}    // Fehlermeldung
              ^
D:\Java\Aufzaehlungen01.java:96: unqialified enumeration constant name required
         case ros:              // Fehlermeldung
              ^
D:\Java\Aufzaehlungen01.java:98: enum types may not be instantiated
      deinWein   = new Wein();   // Fehlermeldung
                   ^
---------------------------------------------------------------------------
Ausgabe des Programms Aufzaehlungen01:

Aufzaehlungen01: Jetzt geht es los!
--------------------------------------
A meineFarbe: gruen
B deineFarbe: rot
C seineFarbe: null
--------------------------------------
D meinWein  : rot
E deinWein  : ros
--------------------------------------
F z01       : aus
G z02       : kaputt
--------------------------------------
H heute     : Mi
I morgen    : Do
--------------------------------------
J richtig   : oben
K falsch    : unten
--------------------------------------
L deineFarbe ist gleich rot!
M meinWein und deinWein sind ungleich!
--------------------------------------
N Mo Di Mi Do Fr Sa So
--------------------------------------
O Your color is red
--------------------------------------
P heute.compareTo(WochenTag.So): -4
--------------------------------------
Aufzaehlungen01: Das war's erstmal!
------------------------------------------------------------------------ */
