// Datei Aufzaehlungen03.java
/* ------------------------------------------------------------------------
Ein Aufzaehlungstyp namens FarbeB wird vereinbart. Die Klasse FarbeB
hat einen Konstruktor und jedes FarbeB-Objekt hat ein Attribut namens
wert vom Typ int.
------------------------------------------------------------------------ */
// Die Vereinbarung des enum-Klassentyps FarbeA ist laenger als eine Zeile:

enum FarbeB {
   rot(1), gruen(2), blau(4), farblos(8);  // Die Aufzaehlung

   public final int wert;                  // Ein Objektattribut
   FarbeB (int wert) {this.wert = wert;}   // Ein Konstruktor
} // enum FarbeB
// ------------------------------------------------------------------------
// Die Klasse Aufzaehlungen03 enthaelt nur eine main-Methode. Sie dient
// zum Testen der Klasse FarbeB:
class Aufzaehlungen03 {
   static public void main(String [] sonja) {
      printf("Aufzaehlungen03: Jetzt geht es los!%n");
      printf("---------------------------------%n");
      printf("Alle Farben und ihre Daten:%n%n");
      printf("Name   Ordinalzahl   Wert%n");
      for (FarbeB f: FarbeB.values()) {
         printf("%-8s",   f);
         printf("%5d",    f.ordinal());
         printf("%10d%n", f.wert);
      }
      printf("---------------------------------%n");
      printf("Aufzaehlungen03: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Aufzaehlungen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Aufzaehlungen03:

Aufzaehlungen03: Jetzt geht es los!
---------------------------------
Alle Farben und ihre Daten:

Name   Ordinalzahl   Wert
rot         0         1
gruen       1         2
blau        2         4
farblos     3         8
---------------------------------
Aufzaehlungen03: Das war's erstmal!
------------------------------------------------------------------------ */
