// Datei Aufzaehlungen05.java
/* ------------------------------------------------------------------------
Die drei Aufzaehlungstypen ATyp01, ATyp02 und ATyp03 sind im Paket p00
(jeder in einer eigenen Datei) wie folgt vereinbart:

public enum ATyp01 {a1, a2, a3, a4;}
public enum ATyp02 {    a2,     a4, a6;}
public enum ATyp03 {        a3,     a6, a9;}

Die Aufzaehlungsliterale a2, a3, a4 und a6 kommen somit in mehr als
einem Typ vor.
---------------------------------------------------------------------------
Die drei Aufzaehlungstypen mussten in einem Paket (hier: p00) vereinbart
werden, weil ab Java-Version 1.4 Importe aus dem namenlosen Paket (wie
z. B. import ATyp01) nicht mehr erlaubt sind.
---------------------------------------------------------------------------
Ein Aufzaehlungstyp wie p00.ATyp01 wird in Java realisiert als eine
Klasse, und seine Aufzaehlungsliterale a1, a2, ... sind Namen von
Klassenattributen dieser Klasse p00.ATyp01.

Mit einem "individuellen" import-Befehl wie

import static p00.ATyp01.a2;

vereinbart man a2 als eine Abkuerzung fuer den vollen Namen p00.ATyp01.a2.
Mit einem "pauschalen" import-Befehle wie

import static p00.ATyp02.* vereinbart man a2, a4 und a6 als Abkuerzungen
fuer die vollen Namen p00.ATyp02.a2, p00.ATyp02.a4 bzw. p00.ATyp02.a6.

Falls durch mehrere import-Befehle eine Abkuerzung wie z.B. a2 mehrdeutig
wird, ist in einem bestimmten Sinn ein individueller import-Befehl
"staerker" als ein pauschaler import-Befehl. Die Fehlermeldungen des
Compilers im folgenden Beispiel sollen dies deutlich machen.
------------------------------------------------------------------------ */
  import static p00.ATyp01.a2;
  import static p00.ATyp01.a3;
  import static p00.ATyp01.a4;

//import static p00.ATyp02.a2; // a2 steht schon fuer p00.ATyp01.a2

  import static p00.ATyp02.* ;
  import static p00.ATyp03.* ;
// ------------------------------------------------------------------------
// Die Klasse Aufzaehlungen05 enthaelt nur eine main-Methode. Darin werden
// die Aufzaehlungstypen ATyp01, ATyp02 und ATyp03 aus dem Paket p00
// benutzt.

class Aufzaehlungen05 {

   static public void main(String [] sonja) {

      // Hier wird versucht, mit moeglichst kurzen Bezeichnungen
      // auf die Aufzaehlungsliterale a1, a2, ... der Aufzaehlungs-
      // typen ATyp01, ATyp02 und ATyp03 zuzugreifen. Manchmal muss
      // mann laenger Bezeichnungen verwenden, weil die kuerzeren
      // mehrdeutig sind oder zum falschen Typ gehoeren.

//    p00.ATyp01 a1x =            a1; //     a1 ist hier nicht sichtbar
//    p00.ATyp01 a1y =     ATyp01.a1; // ATyp01 ist hier nicht sichtbar
      p00.ATyp01 a11 = p00.ATyp01.a1;
      p00.ATyp01 a12 =            a2;
      p00.ATyp01 a13 =            a3;
      p00.ATyp01 a14 =            a4;

//    p00.ATyp02 a2x =            a2; // a2 hat falschen Typ ATyp01
      p00.ATyp02 a22 = p00.ATyp02.a2;
      p00.ATyp02 a24 = p00.ATyp02.a4;
//    p00.ATyp02 a2y =            a6; // a6 ist mehrdeutig (ATyp02 oder 03?)
      p00.ATyp02 a26 = p00.ATyp02.a6;

//    p00.ATyp03 a3x =            a3; // a3 hat falschen Typ ATyp01
      p00.ATyp03 a33 = p00.ATyp03.a3;
//    p00.ATyp03 a3y =            a6; // a6 ist mehrdeutig (ATyp02 oder 03?)
      p00.ATyp03 a36 = p00.ATyp03.a6;
      p00.ATyp03 a39 =            a9;

      pln("Aufzaehlungen05: Jetzt geht es los! ");
      pln("---------------------------");
      pln("A a11: " + a11 + ", " + a11.getClass());
      pln("B a12: " + a12 + ", " + a12.getClass());
      pln("C a13: " + a13 + ", " + a13.getClass());
      pln("D a14: " + a14 + ", " + a14.getClass());
      pln("---------------------------");
      pln("E a22: " + a22 + ", " + a22.getClass());
      pln("F a24: " + a24 + ", " + a24.getClass());
      pln("G a26: " + a26 + ", " + a26.getClass());
      pln("---------------------------");
      pln("H a33: " + a33 + ", " + a33.getClass());
      pln("I a36: " + a36 + ", " + a36.getClass());
      pln("J a39: " + a39 + ", " + a39.getClass());
      pln("---------------------------");
      pln("Aufzaehlungen05: Das war's erstmal! ");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
} // Aufzaehlungen05
/* ------------------------------------------------------------------------
Fehlermeldungen des Compilers, wenn die entsprechenden Zeilen keine
Kommentare sind:

D:\Java\Aufzaehlungen05.java:39: a2 is already defined in a single-type import
  import static p00.ATyp02.a2; // a2 ist mehrdeutig (ATyp01 oder 02?)
  ^
D:\Java\Aufzaehlungen05.java:58: cannot find symbol
symbol  : variable a1
location: class Aufzaehlungen05
    p00.ATyp01 a1x =            a1; //     a1 ist hier nicht sichtbar
                                ^
D:\Java\Aufzaehlungen05.java:59: cannot find symbol
symbol  : variable ATyp01
location: class Aufzaehlungen05
    p00.ATyp01 a1y =     ATyp01.a1; // ATyp01 ist hier nicht sichtbar
                         ^
D:\Java\Aufzaehlungen05.java:65: incompatible types
found   : p00.ATyp01
required: p00.ATyp02
    p00.ATyp02 a2x =            a2; // a2 hat falschen Typ ATyp01
                                ^
D:\Java\Aufzaehlungen05.java:68: reference to a6 is ambiguous, both
variable a6 in p00.ATyp03 and
variable a6 in p00.ATyp02 match
    p00.ATyp02 a2y =            a6; // a6 ist mehrdeutig (ATyp02 oder 03?)
                                ^
D:\Java\Aufzaehlungen05.java:71: incompatible types
found   : p00.ATyp01
required: p00.ATyp03
    p00.ATyp03 a3x =            a3; // a3 hat falschen Typ ATyp01
                                ^
D:\Java\Aufzaehlungen05.java:73: reference to a6 is ambiguous, both
variable a6 in p00.ATyp03 and
variable a6 in p00.ATyp02 match
    p00.ATyp03 a3y =            a6; // a6 ist mehrdeutig (ATyp02 oder 03?)
                                ^
---------------------------------------------------------------------------
Ausgabe des Programms Aufzaehlungen05:

Aufzaehlungen05: Jetzt geht es los!
---------------------------
A a11: a1, class p00.ATyp01
B a12: a2, class p00.ATyp01
C a13: a3, class p00.ATyp01
D a14: a4, class p00.ATyp01
---------------------------
E a22: a2, class p00.ATyp02
F a24: a4, class p00.ATyp02
G a26: a6, class p00.ATyp02
---------------------------
H a33: a3, class p00.ATyp03
I a36: a6, class p00.ATyp03
J a39: a9, class p00.ATyp03
---------------------------
Aufzaehlungen05: Das war's erstmal!
------------------------------------------------------------------------ */
