// Datei Ausdruecke01.java
/* ------------------------------------------------------------------------
Zeigt, wie ein Ausdruck als Teil einer Anweisung oder als Teil einer
Vereinbarung vorkommen kann. Als Beispiele werden die folgenden 6 Aus-
druecke verwendet:
Ausdruck1: otto + 3
Ausdruck2: (otto + 98) / (otto * 10) - 1
Ausdruck3: otto < 3
Ausdruck4: "Hallo " + name
Ausdruck5: otto
Ausdruck6: "Hallo!".
------------------------------------------------------------------------ */
class Ausdruecke01 {
   static public void main(String[] sonja) {
      // ------------------------------------------------------------------
      // Eine Anfangsmeldung ausgeben (damit der Benutzer am Bildschirm
      // merkt, dass jetzt das Programm Ausdruecke01 ausgefuehrt wird):
      System.out.println("Ausdruecke01: Jetzt geht es los!");
      // ------------------------------------------------------------------
      // In den Beispiel-Ausdruecken 1 bis 6 kommen die Variablen otto
      // und name vor. Diese Variablen muessen vom Programmierer
      // vereinbart werden, bevor er sie in Ausdruecken verwendet:
      int    otto = 1;
      String name = "Sarah!";
      // ------------------------------------------------------------------
      // Jeder Beispiel-Ausdruck wird als Teil einer Anweisung verwendet
      // (genauer: Als Teil einer printl-Anweisung):
                                                        // Ausgabe zum
                                                        // Bildschirm:
      System.out.println( otto + 3);                    // 4
      System.out.println((otto + 98) / (otto * 10) - 1);// 8
      System.out.println( otto < 3);                    // true
      System.out.println("Hallo " + name);              // Hallo Sarah!
      System.out.println( otto);                        // 1
      System.out.println("Hallo!");                     // Hallo!
      // ------------------------------------------------------------------
      // Jeder Beispiel-Ausdruck wird als Teil einer Vereinbarung verwendet
      // (genauer: Als Teil einer Variablen-Vereinbarung):
                                                        // Anfangswert der
                                                        // vereinbarten Var.
      int     emil =  otto + 3;                         // 4
      int     anna = (otto + 98) / (otto * 10) - 1;     // 8
      boolean bert =  otto < 3;                         // true
      String  carl = "Hallo " + name;                   // Hallo Sarah!
      int     dora =  otto;                             // 1
      String  elsa = "Hallo!";                          // Hallo!
      // ------------------------------------------------------------------
      // Jeder Beispiel-Ausdruck wird als Teil eines Ausdrucks verwendet
      // (genauer: Als Teil der Bedingung einer if-Anweisung):
      if (emil == otto + 3) {
         System.out.println("emil ist o.k.!");
      }

      if (anna == (otto + 98) / (otto * 10) - 1) {
         System.out.println("anna ist o.k.!");
      }

      if (bert == otto < 3) {
         System.out.println("bert ist o.k.!");
      }

      if (carl == "Hallo " + name) {
         System.out.println("carl ist o.k.!");
      } else {
         System.out.println("carl ist komisch!");
      }

      if (dora == otto) {
         System.out.println("dora ist o.k.!");
      }

      if (elsa == "Hallo!") {
         System.out.println("elsa ist o.k.!");
      }
      // ------------------------------------------------------------------
      // Eine Abschlussmeldung ausgeben (damit der Benutzer am Bildschirm
      // merkt, dass das Programm Ausdruecke01 fertig ausgefuehrt ist):
      System.out.println("Ausdruecke01: Das war's erstmal!");
      // ------------------------------------------------------------------
   } // main
} // Ausdruecke01
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausdruecke01:

Ausdruecke01: Jetzt geht es los!
4
8
true
Hallo Sarah!
1
Hallo!
emil ist o.k.!
anna ist o.k.!
bert ist o.k.!
carl ist komisch!
dora ist o.k.!
elsa ist o.k.!
Ausdruecke01: Das war's erstmal!

Anmerkung: Warum der Ausdruck  carl == "Hallo " + name  nicht gleich true
ist wird spaeter (nach gewissen "Vorarbeiten") erklaert.
------------------------------------------------------------------------ */
