// Datei Ausdruecke03.java
/* ------------------------------------------------------------------------
Wenn man ein Vorzeichen (+ oder -) auf einen byte-Wert anwendet, ist das
Ergebnis nicht ein byte-Wert, sondern ein int-Wert. Entsprechendes gilt
fuer die Werte aller "kleinen Ganzzahltypen" (byte, char, short).

Im Gegensatz zu den Vorzeichen bewirken die Inkrement- und Dekrement-
Operationen (++ bzw. --) keine Typumwandlung nach int.

Wird die Ganzzahl 65 als char-Wert zum Bildschirm ausgegeben, so erscheint
dort der Buchstabe A. Wird die Ganzzahl 65 dagegen als int-Wert zum Bild-
schirm ausgegeben erscheint dort die Zeichenkette 65.
------------------------------------------------------------------------ */
class Ausdruecke03 {
   // ---------------------------------------------------------------------
   // Fuer jeden der 3 kleinen Ganzzahltypen (byte, char und short) und
   // fuer den "normalen Ganzzahltyp" int eine Funktion, die den Wert des
   // Typs in einen String umwandelt, der auch den Namen des Typs enthaelt:

   static String toString(byte   b) {return b + " (byte)"  ;}
   static String toString(char   c) {return c + " (char)"  ;}
   static String toString(short  s) {return s + " (short)" ;}
   static String toString(int    i) {return i + " (int)"   ;}
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Vorzeichen + und - werden auf Variablen der kleinen
      // Ganzzahltypen byte, char und short angewendet. Die Werte der
      // gebildeten Ausdruecke werden zusammen mit ihrem Typ ausgegeben.

      byte  byte01  = 65;
      char  char01  = 65;
      short short01 = 65;

      pln("----------------------------------------------");
      pln("A toString(   byte01):  "  + toString(  byte01));
      pln("B toString(  +byte01):  "  + toString( +byte01));
      pln("C toString(  -byte01): "   + toString( -byte01));
      pln("D toString( ++byte01):  "  + toString(++byte01));
      pln("E toString( --byte01):  "  + toString(--byte01));
      pln("----------------------------------------------");
      pln("F toString(   char01):   " + toString(  char01));
      pln("G toString(  +char01):  "  + toString( +char01));
      pln("H toString(  -char01): "   + toString( -char01));
      pln("I toString( ++char01):   " + toString(++char01));
      pln("J toString( --char01):   " + toString(--char01));
      pln("----------------------------------------------");
      pln("K toString(  short01):  "  + toString(  short01));
      pln("L toString( +short01):  "  + toString( +short01));
      pln("M toString( -short01): "   + toString( -short01));
      pln("N toString(++short01):  "  + toString(++short01));
      pln("O toString(--short01):  "  + toString(--short01));
      pln("----------------------------------------------");
      // ------------------------------------------------------------------
   } // main
} // Ausdruecke03
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausdruecke03:

----------------------------------------------
A toString(   byte01):  65 (byte)
B toString(  +byte01):  65 (int)
C toString(  -byte01): -65 (int)
D toString( ++byte01):  66 (byte)
E toString( --byte01):  65 (byte)
----------------------------------------------
F toString(   char01):   A (char)
G toString(  +char01):  65 (int)
H toString(  -char01): -65 (int)
I toString( ++char01):   B (char)
J toString( --char01):   A (char)
----------------------------------------------
K toString(  short01):  65 (short)
L toString( +short01):  65 (int)
M toString( -short01): -65 (int)
N toString(++short01):  66 (short)
O toString(--short01):  65 (short)
----------------------------------------------
------------------------------------------------------------------------ */