// Datei Ausdruecke04.java
/* ------------------------------------------------------------------------
Jedes Literal hat einen bestimmten Typ. Dieses Programm zeigt, welche
Literale zu welchem Typ gehoeren.
------------------------------------------------------------------------ */
import java.util.Formatter;

class Ausdruecke04 {
   // ---------------------------------------------------------------------
   // Fuer jeden der 8 primitiven Typen und zusaetzlich fuer den Typ
   // String eine Funktion, die einen Wert des Typs in einen String
   // umwandelt, der auch den Namen des Typs enthaelt:

   static String toString(byte    b) {return str(""+b, "(byte)"   );}
   static String toString(char    c) {return str(""+c, "(char)"   );}
   static String toString(short   s) {return str(""+s, "(short)"  );}
   static String toString(int     i) {return str(""+i, "(int)"    );}
   static String toString(long    l) {return str(""+l, "(long)"   );}
   static String toString(float   f) {return str(""+f, "(float)"  );}
   static String toString(double  d) {return str(""+d, "(double)" );}
   static String toString(boolean b) {return str(""+b, "(boolean)");}

   static String toString(String  s) {return str(""+s, "(String)" );}

   static String str(String s1, String s2) {
      Formatter f = new Formatter();
      f.format("%20s   %-12s", s1, s2);
      return f.toString();
   } // str
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      // Strings die ein wichtiges Sonderzeichen enthalten:
      final String RS  = "\\"; // Ein Rueckwaerts-Schraegstrich (nicht zwei!)
      final String EA  = "\'"; // Ein einfaches Anfuehrungszeichen '
      final String DA  = "\""; // Ein doppeltes Anfuehrungszeichen "
      final String RSU = RS + "u";

      // Strings mit unterschiedlich vielen Blanks, um bei der Ausgabe
      // Laengenunterschiede auszugleichen:
      final String S22 = "                      ";
      final String S21 = "                     ";
      final String S20 = "                    ";
      final String S19 = "                   ";
      final String S18 = "                  ";
      final String S17 = "                 ";
      final String S15 = "               ";
      final String S13 = "             ";
      final String S11 = "           ";
      final String S10 = "          ";
      final String S09 = "         ";

      printf("--------------------------------------------------------%n");
      printf("Literal im Prog.         Auf dem Bildschirm   Typ%n");

      // Literale verschiedener Typen:
      printf("--------------------------------------------------------%n");
      printf(" 123    "        + S15 + toString(123)     +"%n");
      printf(" 123L   "        + S15 + toString(123L)    +"%n");
      printf(" 123.5  "        + S15 + toString(123.5)   +"%n");
      printf(" 123.5F "        + S15 + toString(123.5F)  +"%n");
      printf(EA + "A"      +EA + S20 + toString('A')     +"%n");
      printf(DA + "A"      +DA + S20 + toString("A")     +"%n");
      printf(DA + "Hallo!" +DA + S15 + toString("Hallo!")+"%n");
      printf(DA + ""       +DA + S21 + toString("")      +"%n");
      printf(true              + S19 + toString(true)    +"%n");
      printf(false             + S18 + toString(false)   +"%n");

      // String-Literale: (UC steht fuer Unicode)
      printf("--------------------------------------------------------%n");
      printf(DA+"AZ"                      +DA+S19+toString("AZ")          +"%n");
      printf(DA+"az"                      +DA+S19+toString("az")          +"%n");
      printf(DA+"09"                      +DA+S19+toString("09")          +"%n");
      printf(DA+"\\\\\\\\"                +DA+S17+toString("\\\\")        +"%n");
      printf(DA+"''"                      +DA+S19+toString("''")          +"%n");
      printf(DA+RS+DA+RS+DA               +DA+S17+toString("\"\"")        +"%n");
      printf(DA+RSU+"0041"+RSU+"005A"     +DA+S09+toString("\u0041\u005A")+"%n"); // UC
      printf(DA+RSU+"0061"+RSU+"007A"     +DA+S09+toString("\u0061\u007A")+"%n"); // UC
      printf(DA+RSU+"0030"+RSU+"0039"     +DA+S09+toString("\u0030\u0039")+"%n"); // UC
      printf(DA+RSU+"005C"+RSU+"005C"     +DA+S09+toString("\u005C\u005C")+"%n"); // UC
      printf(DA+RSU+"0027"+RSU+"0027"     +DA+S09+toString("\u0027\u0027")+"%n"); // UC
      printf(DA+RSU+"005C"+RSU+"0022"     +DA+S09+toString("\u005C\u0022")+"%n"); // UC
      printf(DA+RS +"101" +RS +"132"      +DA+S13+toString("\101\132")    +"%n");
      printf(DA+RS +"141" +RS +"172"      +DA+S13+toString("\141\172")    +"%n");
      printf(DA+RS +"60" +RS +"71"        +DA+S15+toString("\60\71")      +"%n");
      printf(DA+RS +"134" +RS +"134"      +DA+S13+toString("\134\134")    +"%n");
      printf(DA+RS +"47" +RS +"47"        +DA+S15+toString("\47\47")      +"%n");
      printf(DA+RS +"42" +RS +"42"        +DA+S15+toString("\42\42")      +"%n");
      printf(DA+"ABC"                     +DA+S18+toString("ABC")         +"%n");
      printf(DA+"A\\102\\u0043"           +DA+S10+toString("A\102\u0043") +"%n");
      printf(DA+RS+"134"+RS+"47"+RS+"42"  +DA+S11+toString("\134\47\42")  +"%n");
      printf(DA+RSU+"0041"                +DA+S15+toString("\u0041")      +"%n"); // UC
      printf(DA+""                        +DA+S21+toString("")            +"%n");

      // char-Literale:   (UC steht fuer Unicode)
      printf("--------------------------------------------------------%n");
      printf(EA+'A'                       +EA+S20+toString('A')           +"%n");
      printf(EA+'Z'                       +EA+S20+toString('Z')           +"%n");
      printf(EA+'a'                       +EA+S20+toString('a')           +"%n");
      printf(EA+'z'                       +EA+S20+toString('z')           +"%n");
      printf(EA+'0'                       +EA+S20+toString('0')           +"%n");
      printf(EA+'9'                       +EA+S20+toString('9')           +"%n");
      printf(EA+RS+RS                     +EA+S19+toString('\\')          +"%n");
      printf(EA+RS+EA                     +EA+S19+toString('\'')          +"%n");
      printf(EA+RS+DA                     +EA+S19+toString('\"')          +"%n");
      printf(EA+RSU+"0041"                +EA+S15+toString('\u0041')      +"%n"); // UC
      printf(EA+RSU+"005A"                +EA+S15+toString('\u005A')      +"%n"); // UC
      printf(EA+RSU+"0061"                +EA+S15+toString('\u0061')      +"%n"); // UC
      printf(EA+RSU+"007A"                +EA+S15+toString('\u007A')      +"%n"); // UC
      printf(EA+RSU+"0030"                +EA+S15+toString('\u0030')      +"%n"); // UC
      printf(EA+RSU+"0039"                +EA+S15+toString('\u0039')      +"%n"); // UC
      printf(EA+RSU+"005C"+RSU+"005C"     +EA+S09+toString('\u005C\u005C')+"%n"); // UC
      printf(EA+RSU+"005C"+RSU+"0027"     +EA+S09+toString('\u005C\u0027')+"%n"); // UC
      printf(EA+RSU+"0022"                +EA+S15+toString('\u0022')      +"%n"); // UC
      printf(EA+RS+"101"                  +EA+S17+toString('\101')        +"%n");
      printf(EA+RS+"132"                  +EA+S17+toString('\132')        +"%n");
      printf(EA+RS+"141"                  +EA+S17+toString('\141')        +"%n");
      printf(EA+RS+"172"                  +EA+S17+toString('\172')        +"%n");
      printf(EA+RS+"60"                   +EA+S18+toString('\60')         +"%n");
      printf(EA+RS+"71"                   +EA+S18+toString('\71')         +"%n");
      printf(EA+RS+"134"                  +EA+S17+toString('\134')        +"%n");
      printf(EA+RS+"47"                   +EA+S18+toString('\47')         +"%n");
      printf(EA+RS+"42"                   +EA+S18+toString('\42')         +"%n");

      // int-Literale
      printf("--------------------------------------------------------%n");
      printf(" 165                   " + toString(165)                    +"%n");
      printf(" 0xA5                  " + toString(0xA5)                   +"%n");
      printf(" 0245                  " + toString(0245)                   +"%n");
      printf(" 2147483647            " + toString( 2147483647)            +"%n");
      printf(" 0x7FFFFFFF            " + toString( 0x7FFFFFFF)            +"%n");
//    printf(" 2147483648            " + toString( 2147483648)            +"%n");
      printf("-2147483648            " + toString(-2147483648)            +"%n");
      printf(" 0x80000000            " + toString( 0x80000000)            +"%n");

      // long-Literale
      printf("--------------------------------------------------------%n");
      printf(" 165L                  " + toString(165L)                   +"%n");
      printf(" 0xA5L                 " + toString(0xA5L)                  +"%n");
      printf(" 0245L                 " + toString(0245L)                  +"%n");
      printf(" 9223372036854775807L  " + toString( 9223372036854775807L)  +"%n");
      printf(" 0x7FFFFFFFFFFFFFFFL   " + toString( 0x7FFFFFFFFFFFFFFFL)   +"%n");
//    printf(" 9223372036854775808L  " + toString( 9223372036854775808L)  +"%n");
      printf("-9223372036854775808L  " + toString(-9223372036854775808L)  +"%n");
      printf(" 0x8000000000000000L   " + toString( 0x8000000000000000L)   +"%n");

      // double-Literale:
      printf("--------------------------------------------------------%n");
      printf(" 123                   " + toString( 123)        +"%n");
      printf(" 123.0                 " + toString( 123.0)      +"%n");
      printf(" 123D                  " + toString( 123D)       +"%n");
      printf(" 123E0                 " + toString( 123E0)      +"%n");
      printf(" 123.0E0D              " + toString( 123.0E0D)   +"%n");
      printf(" 12.345000             " + toString( 12.345000)  +"%n");
      printf(" 12.345E18             " + toString( 12.345E18)  +"%n");
      printf(" 12.345E-8             " + toString( 12.345E-8)  +"%n");
//    printf(" 12.345E+308           " + toString( 12.345E+308)+"%n");
      printf(" 12.345E+307           " + toString( 12.345E+307)+"%n");
      printf(" 12.345E-308           " + toString( 12.345E-308)+"%n");
      printf(" 12.345E-324           " + toString( 12.345E-324)+"%n");
//    printf(" 12.345E-325           " + toString( 12.345E-325)+"%n");

      // float-Literale:
      printf("--------------------------------------------------------%n");
      printf(" 12345F                " + toString( 12345F)     +"%n");
      printf(" 12.345E0F             " + toString( 12.345E0F)  +"%n");
      printf(" 12.345E37F            " + toString( 12.345E37F) +"%n");
//    printf(" 12.345E38F            " + toString( 12.345E38F) +"%n");
      printf(" 12.345E-38F           " + toString( 12.345E-38F)+"%n");
      printf(" 12.345E-46F           " + toString( 12.345E-46F)+"%n");
//    printf(" 12.345E-47F           " + toString( 12.345E-47F)+"%n");
      printf("--------------------------------------------------------%n");
      printf("Ausdruecke04: Das war's erstmal!%n");
      // ------------------------------------------------------------------
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Ausdruecke04
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausdruecke04:

--------------------------------------------------------
Literal im Prog.         Auf dem Bildschirm   Typ
--------------------------------------------------------
 123                                    123   (int)
 123L                                   123   (long)
 123.5                                123.5   (double)
 123.5F                               123.5   (float)
'A'                                       A   (char)
"A"                                       A   (String)
"Hallo!"                             Hallo!   (String)
""                                            (String)
true                                   true   (boolean)
false                                 false   (boolean)
--------------------------------------------------------
"AZ"                                     AZ   (String)
"az"                                     az   (String)
"09"                                     09   (String)
"\\\\"                                   \\   (String)
"''"                                     ''   (String)
"\"\""                                   ""   (String)
"\u0041\u005A"                           AZ   (String)
"\u0061\u007A"                           az   (String)
"\u0030\u0039"                           09   (String)
"\u005C\u005C"                            \   (String)
"\u0027\u0027"                           ''   (String)
"\u005C\u0022"                            "   (String)
"\101\132"                               AZ   (String)
"\141\172"                               az   (String)
"\60\71"                                 09   (String)
"\134\134"                               \\   (String)
"\47\47"                                 ''   (String)
"\42\42"                                 ""   (String)
"ABC"                                   ABC   (String)
"A\102\u0043"                           ABC   (String)
"\134\47\42"                            \'"   (String)
"\u0041"                                  A   (String)
""                                            (String)
--------------------------------------------------------
'A'                                       A   (char)
'Z'                                       Z   (char)
'a'                                       a   (char)
'z'                                       z   (char)
'0'                                       0   (char)
'9'                                       9   (char)
'\\'                                      \   (char)
'\''                                      '   (char)
'\"'                                      "   (char)
'\u0041'                                  A   (char)
'\u005A'                                  Z   (char)
'\u0061'                                  a   (char)
'\u007A'                                  z   (char)
'\u0030'                                  0   (char)
'\u0039'                                  9   (char)
'\u005C\u005C'                            \   (char)
'\u005C\u0027'                            '   (char)
'\u0022'                                  "   (char)
'\101'                                    A   (char)
'\132'                                    Z   (char)
'\141'                                    a   (char)
'\172'                                    z   (char)
'\60'                                     0   (char)
'\71'                                     9   (char)
'\134'                                    \   (char)
'\47'                                     '   (char)
'\42'                                     "   (char)
--------------------------------------------------------
 165                                    165   (int)
 0xA5                                   165   (int)
 0245                                   165   (int)
 2147483647                      2147483647   (int)
 0x7FFFFFFF                      2147483647   (int)
-2147483648                     -2147483648   (int)
 0x80000000                     -2147483648   (int)
--------------------------------------------------------
 165L                                   165   (long)
 0xA5L                                  165   (long)
 0245L                                  165   (long)
 9223372036854775807L   9223372036854775807   (long)
 0x7FFFFFFFFFFFFFFFL    9223372036854775807   (long)
-9223372036854775808L  -9223372036854775808   (long)
 0x8000000000000000L   -9223372036854775808   (long)
--------------------------------------------------------
 123                                    123   (int)
 123.0                                123.0   (double)
 123D                                 123.0   (double)
 123E0                                123.0   (double)
 123.0E0D                             123.0   (double)
 12.345000                           12.345   (double)
 12.345E18                        1.2345E19   (double)
 12.345E-8                        1.2345E-7   (double)
 12.345E+307                     1.2345E308   (double)
 12.345E-308                    1.2345E-307   (double)
 12.345E-324                       1.0E-323   (double)
--------------------------------------------------------
 12345F                             12345.0   (float)
 12.345E0F                           12.345   (float)
 12.345E37F                       1.2345E38   (float)
 12.345E-38F                     1.2345E-37   (float)
 12.345E-46F                        1.4E-45   (float)
--------------------------------------------------------
Ausdruecke04: Das war's erstmal!
------------------------------------------------------------------------ */