// Datei Ausnahmen02.java
/* ------------------------------------------------------------------------
Mit einem try-catch-Befehl kann man Ausnahmen fangen und behandeln. In den
try-Block schreibt man die gefaehrlichen Befehle, die moeglicherweise eine
Ausnahme werfen. Jeder catch-Block faengt Ausnahmen eines bestimmten
Typs und behandelt sie (indem seine Befehle ausgefuehrt werden).
Siehe auch Ausnahmen01.
------------------------------------------------------------------------ */
class Ausnahmen02 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Eine Ausnahme wird geworfen und dann gefangen und behandelt:

      int a = 17;
      int b = 0;
      int q;

      pln("A Ausnahmen02: Jetzt geht es los!\n");

      try {
         pln("B " + a + " / " + b + " ist"); // Wird noch ausgefuehrt.
         q = a / b;                          // Wirft eine Ausnahme!
         pln("C gleich " + q);               // Wird nicht mehr ausgefuehrt.
      } catch (ArithmeticException otto) {
         pln("------------------------------------------------------");
         pln("D Eine Ausnahme des Typs ArithmeticException trat auf!");
         pln("E Sie enthielt folgende Meldung:");
         pln("F " + otto.getMessage());
         pln("------------------------------------------------------");
      } // try-catch-Befehl

      pln("G Das Programm Ausnahmen02 wird ordnungsgemaess beendet!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Ausnahmen02
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausnahmen02:

A Ausnahmen02: Jetzt geht es los!

B 17 / 0 ist
------------------------------------------------------
D Eine Ausnahme des Typs ArithmeticException trat auf!
E Sie enthielt folgende Meldung:
F / by zero
------------------------------------------------------
G Das Programm Ausnahmen02 wird ordnungsgemaess beendet!
------------------------------------------------------------------------ */