// Datei Ausnahmen03.java
/* ------------------------------------------------------------------------
Was kann man mit einem Ausnahmeobjekt alles machen, nachdem man es
gefangen hat? Dieses Programm demonstriert die Methoden
getMessage, printStackTrace und getStackTrace, die in jedem
Ausnahme-Objekt (Throwable-Objekt) enthalten sind.

Throwable ist per Definition (die direkte oder eine indirekte) Oberklasse
aller Ausnahmeklassen, insbesondere also auch der Ausnahmeklasse
ArithmeticException.

Siehe auch Ausnahmen04.
------------------------------------------------------------------------ */
class Ausnahmen03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Ruft die gefaehrliche Methode metA auf. Faengt und behandelt
      // die dadurch geworfene Ausnahme.

      pln("Ausnahmen03: Jetzt geht es los!\n");

      try {
         metA(12, 3);
         metA(17, 0);
         metA(14, 2);
      } catch (ArithmeticException ex) {
         bearbeiteAusnahmeobjekt(ex);
      } // try-catch-Befehl
   } // main
   // ---------------------------------------------------------------------
   static void metA(int a, int b) {
      // Ruft die gefaehrliche Methode metB auf:
      metB(a, b);
   } // metA
   // ---------------------------------------------------------------------
   static void metB(int a, int b) {
      // Ruft die gefaehrliche Methode metC auf:
      metC(a, b);
   } // metB
   // ---------------------------------------------------------------------
   static void metC(int a, int b) {
      // Gibt auf jeden Fall eine kleine Meldung ("A ... ist") aus.
      // Wirft ein Ausnahme, falls b gleich 0 ist.
      p("A " + a + " / " + b + " ist ");
      int quot = a / b;        // ArithmeticException falls b gleich 0 ist!
      pln("gleich " + quot);
   } // metB
   // ---------------------------------------------------------------------
   static void bearbeiteAusnahmeobjekt(Throwable ausOb) {
      // Ruft einig Objektmethoden des Ausnahmeobjekts ausOb auf:
      pln();
      pln("----------------------------------------------------------------");
      pln("B ausOb:\n");
      pln("  " + ausOb);
      pln("----------------------------------------------------------------");
      pln("C ausOb.getMessage():\n" );
      pln("  " + ausOb.getMessage());
      pln("----------------------------------------------------------------");
      pln("D ausOb.printStackTrace():\n");
      p  ("  "); ausOb.printStackTrace();
      pln("----------------------------------------------------------------");
      pln("E ster = ausOb.getStackTrace():\n");
      pln("  Die Reihung ster (stack trace element Reihung) sieht so aus:");
      StackTraceElement[] ster = ausOb.getStackTrace();
      for (StackTraceElement ste : ster) {
         pln ("\t   " + ste);
      }
      pln("----------------------------------------------------------------");

   } // bearbeiteAusnahmeobjekt
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Ausnahmen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausnahmen03:

Ausnahmen03: Jetzt geht es los!

A 12 / 3 ist gleich 4
A 17 / 0 ist
----------------------------------------------------------------
B ausOb:

  java.lang.ArithmeticException: / by zero
----------------------------------------------------------------
C ausOb.getMessage():

  / by zero
----------------------------------------------------------------
D ausOb.printStackTrace():

  java.lang.ArithmeticException: / by zero
   at Ausnahmen03.metC(Ausnahmen03.java:43)
   at Ausnahmen03.metB(Ausnahmen03.java:36)
   at Ausnahmen03.metA(Ausnahmen03.java:31)
   at Ausnahmen03.main(Ausnahmen03.java:22)
----------------------------------------------------------------
E ster = ausOb.getStackTrace():

  Die Reihung ster (stack trace element Reihung) sieht so aus:
      Ausnahmen03.metC(Ausnahmen03.java:43)
      Ausnahmen03.metB(Ausnahmen03.java:36)
      Ausnahmen03.metA(Ausnahmen03.java:31)
      Ausnahmen03.main(Ausnahmen03.java:22)
----------------------------------------------------------------
------------------------------------------------------------------------ */