// Datei Ausnahmen05.java
/* ------------------------------------------------------------------------
Ein "gefaehrliches" Unterprogramm (dividiere) wird mehrfach aufgerufen.
Falls dabei eine Ausnahme auftritt, wird sie gefangen und behandelt, so
dass das Programm nicht abgebrochen wird.
------------------------------------------------------------------------ */
class Ausnahmen05 {
   // ---------------------------------------------------------------------
   static String dividiere(String s1, String s2) {
      // Wandelt s1 und s2 in int-Werte um, dividiert die int-Werte,
      // wandelt das Divisionsergebnis in einen String um und liefert
      // diesen String als Ergebnis.
      // Dabei wird evtl. eine Ausnahme des Typs NumberFormatException
      // oder             eine Ausnahme des Typs   ArithmeticException
      // geworfen, aber hier in dieser Methode nicht behandelt.

      // Diese Methode ist (hoffentlich) einfach und leicht lesbar,
      // weil sie nur einen Normalfall beschreibt, aber keine
      // Ausnahmefaelle behandelt.

      int n1   = Integer.parseInt(s1); // evtl. NumberFormatException
      int n2   = Integer.parseInt(s2); // evtl. NumberFormatException
      int quot = n1 / n2;              // evtl.   ArithmeticException
      return "" + quot;
   } // dividiere
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Jede Komponente der Reihung dend wird durch die darunter stehende
      // Komponente der Reihung dor dividiert. Die beiden Komponenten und
      // das Divisionsergebnis werden ausgegeben. Falls die Methode divi-
      // diere eine Ausnahme wirft, wird sie hier gefangen und behandelt.

      String[] dend = {"9", "a", "3", "1", "8"};
      String[] dor  = {"4", "6", "0", "b", "2"};
      String   quot;

      pln("Ausnahmen05: Jetzt geht es los!\n");

      for (int i=0; i<dend.length; i++) {
         try {
            p(dend[i] + " / " + dor [i]);                   // Immer 1.
            quot = dividiere(dend[i], dor[i]);              // Gefaehrlich!
            pln(" ist gleich " + quot);                     // Manchmal 1.
         } catch (NumberFormatException ex01) {
            pln(" wirft eine NumberFormatException");       // Manchmal 2.
            pln("Meldung: " + ex01.getMessage());
         } catch (ArithmeticException   ex02) {
            pln(" wirft eine   ArithmeticException");       // Manchmal 3.
            pln("Meldung: " + ex02.getMessage());
         } finally {
            pln("--------------------------------------");  // Immer 2.
         } // try/catch
      } // for
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Ausnahmen05
/* ------------------------------------------------------------------------
Ausgabe des Programms Ausnahmen05:

Ausnahmen05: Jetzt geht es los!

9 / 4 ist gleich 2
--------------------------------------
a / 6 wirft eine NumberFormatException
Meldung: For input string: "a"
--------------------------------------
3 / 0 wirft eine   ArithmeticException
Meldung: / by zero
--------------------------------------
1 / b wirft eine NumberFormatException
Meldung: For input string: "b"
--------------------------------------
8 / 2 ist gleich 4
--------------------------------------
------------------------------------------------------------------------ */



