// Datei Ausnahmen08.java
/* ------------------------------------------------------------------------
In der Methode met30 wird die Methode bufr.readLine aufgerufen. Dieser
Aufruf loest moeglicherweise eine Ausnahme der Klasse IOException aus. Da
dies eine gepruefte Ausnahmeklasse ist und die Ausnahme in met30 nicht ge-
fangen wird, muss sie in der throws-Klausel von met30 dokumentiert werden.

In met30 wird auch die Methode Integer.decode aufgerufen. Dieser Aufruf
loest moeglicherweise eine Ausnahme der Klasse NumberFormatException aus.
Da dies eine ungepruefte Ausnahmeklasse ist, muss sie nicht unbedingt in
der throws-Klausel von met30 dokumentiert werden. Sie wird hier aber
freiwillig dokumentiert.

In der Methode main wird die Methode met30 aufgerufen. Dieser Aufruf
loest moeglicherweise eine Ausnahme der Klasse IOException aus. Da dies
eine gepruefte Ausnahmeklasse ist und die Ausnahme in main nicht gefangen
wird, muss sie in der throws-Klausel von main dokumentiert werden.
------------------------------------------------------------------------ */
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

class Ausnahmen08 {
   // ---------------------------------------------------------------------
   static void met30() throws IOException, NumberFormatException {
      // Liest solange Ganzzahlen von der Tastatur und gibt sie zum
      // Bildschirm aus, bis der Benutzer "q" eingibt oder durch
      // eine nicht erlaubte Eingabe eine NumberFormatException
      // ausloest.

      // System.in ist die Standardeingabe, normalerweise also
      // die Tastatur:
      InputStreamReader isr  = new InputStreamReader(System.in);
      BufferedReader    bufr = new BufferedReader(isr);
      // Datenfluss:
      // Tastatur --> isr --> bufr --> Programm

      while (true) {
         p  ("A Eine Ganzzahl (q zum Beenden)?  ");

         // Der Aufruf bufr.readLine() wirft moeglicherweise eine
         // Ausnahme des Typs IOException (allerdings sehr selten!)
         String einS = bufr.readLine();
         if (einS.equals("q")) break;

         // Der Aufruf Integer.decode wirft moeglicherweise eine
         // Ausnahme des Typs NumberFormatException (wenn der
         // String einS nicht in einen int-Wert umgewandelt werden
         // kann).
         int einI = Integer.decode(einS).intValue();

         pln("B Folgende Zahl wurde eingegeben: " + einI);
      } // while
      pln("C Das Prog. Ausnahmen08 wird ordnungsgemaess beendet!");
   } // met30
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) throws IOException {
      // Ruft die gefaehrliche Methode met30 auf:
      met30();
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // Ausnahmen08
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm Ausnahmen08:

A Eine Ganzzahl (q zum Beenden)? 255
B Sie haben eingegeben:          255
A Eine Ganzzahl (q zum Beenden)? 0xFF
B Sie haben eingegeben:          255
A Eine Ganzzahl (q zum Beenden)? #FF
B Sie haben eingegeben:          255
A Eine Ganzzahl (q zum Beenden)? 0377
B Sie haben eingegeben:          255
A Eine Ganzzahl (q zum Beenden)? abc
Exception in thread "main" java.lang.NumberFormatException: For input string: "abc"
   at java.lang.NumberFormatException.forInputString(NumberFormatException.java:48)
   at java.lang.Integer.parseInt(Integer.java:426)
   at java.lang.Integer.valueOf(Integer.java:505)
   at java.lang.Integer.decode(Integer.java:866)
   at Ausnahmen08.met30(Ausnahmen08.java:54)
   at Ausnahmen08.main(Ausnahmen08.java:63)
---------------------------------------------------------------------------
Fehlermeldung des Compilers jikes von IBM, wenn die (gepruefte)
Ausnahmeklasse IOException nicht in der throws-Klausel der Methode main
dokumentiert wird:

    59.       met30();
              <----->
*** Error: The method "void met30();" can throw the checked exception
"java/io/IOException", but its invocation is neither enclosed in a try
statement that can catch that exception nor in the body of a method or
constructor that "throws" that exception.
---------------------------------------------------------------------------
Fehlermeldung des Compilers javac von Sun, wenn die (gepruefte)
Ausnahmeklasse IOException nicht in der throws-Klausel der Methode main
dokumentiert wird:

D:\Quellen\Ausnahmen08.java:59: unreported exception
java.io.IOException; must be caught or declared to be thrown
      met30();
      ^
------------------------------------------------------------------------ */
