// Datei Ausnahmen09.java
/* ------------------------------------------------------------------------
In dieser Datei werden vier Ausnahmeklassen und die Hauptklasse des
Programms Ausnahmen09 vereinbart.

Die vier Ausnahmeklassen bilden (zusammen mit der Klasse Exception)
folgenden Vererbungsbaum:

Exception
   |
   +--- ZahlIstNichtGut09
              |
              +--- ZahlIstNegativ09
              |
              +--- ZahlIstNull09
              |
              +--- ZahlIstGerade09

Alle vier Ausnahmeklassen sind geprueft, weil ihre (direkte bzw.
indirekte) Oberklasse Exception geprueft ist.

Siehe auch Ausnahmen10.
------------------------------------------------------------------------ */
class ZahlIstNichtGutA extends Exception{}
// ------------------------------------------------------------------------
class ZahlIstNegativA  extends ZahlIstNichtGutA{}
// ------------------------------------------------------------------------
class ZahlIstNullA     extends ZahlIstNichtGutA{}
// ------------------------------------------------------------------------
class ZahlIstGeradeA   extends ZahlIstNichtGutA{}
// ------------------------------------------------------------------------
class Ausnahmen09 {
   // ---------------------------------------------------------------------
   static int liesGuteZahl() throws ZahlIstNichtGutA {
      // Liest einen String ein, versucht, ihn in einen int-Wert
      // umzuwandeln (evtl. NumberFormatException), wirft eine
      // Ausnahme, falls der int-Wert negativ, gleich 0 oder gerade
      // ist und liefert sonst den eingelesenen int-Wert als Eregebnis.
      String einS = EM.liesString();
      int    einI = Integer.decode(einS).intValue();
      if (einI <  0)     throw new ZahlIstNegativA();
      if (einI == 0)     throw new ZahlIstNullA   ();
      if (einI % 2 == 0) throw new ZahlIstGeradeA ();
      return einI;
   } // liesGuteZahl
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Es wird wiederholt eine Ganzzahl eingelesen und kommentiert
      // wieder ausgegeben, bis der Benutzer eine 0 eingibt.
      while (true) {
         try {
            pln("----------------------------------- ");
            p  ("Eine gute Ganzzahl (0 zum Beenden)? ");
            int n = liesGuteZahl();
            pln(n + " ist tatsaechlich gut!");
         } catch (ZahlIstNullA aus) {
            break;
         } catch (ZahlIstNichtGutA aus) {
            pln("Die eingegebene Zahl ist nicht gut!");
         } // try-catch
      }
      pln("Ausnahmen09 beendet sich ordnungsgemaess!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // Ausnahmen09
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm Ausnahmen09:

-----------------------------------
Eine gute Ganzzahl (0 zum Beenden)? 13
13 ist tatsaechlich gut!
-----------------------------------
Eine gute Ganzzahl (0 zum Beenden)? 12
Die eingegebene Zahl ist nicht gut!
-----------------------------------
Eine gute Ganzzahl (0 zum Beenden)? -5
Die eingegebene Zahl ist nicht gut!
-----------------------------------
Eine gute Ganzzahl (0 zum Beenden)? 0
Ausnahmen09 beendet sich ordnungsgemaess!
------------------------------------------------------------------------ */
