// Datei Autolog02.java
/* ------------------------------------------------------------------------
Im folgenden Satz sollen die Ausdruecke soll[0], soll[1], ... so
durch Zahlen zwischen 1 und 9 ersetzt werden, dass der Satz zutrifft:

"Dieser Satz enthaelt
 genau soll[0] mal die Ziffer 0,
 genau soll[1] mal die Ziffer 1,
 genau soll[2] mal die Ziffer 2,
 genau soll[3] mal die Ziffer 3,
 genau soll[4] mal die Ziffer 4,
 genau soll[5] mal die Ziffer 5,
 genau soll[6] mal die Ziffer 6,
 genau soll[7] mal die Ziffer 7,
 genau soll[8] mal die Ziffer 8,
 genau soll[9] mal die Ziffer 9"

Dieses Programm ermittelt geeignete Zahlen fuer soll[0], soll[1], ... etc.,
indem es alle Moeglichkeiten durchprobiert (mit Hilfe einer rekursiven
Methode suche, siehe auch Autolog01).

Hinweis: Jede Zahl zwischen 0 und 9 kommt in diesem Satz mindestens
einmal vor, naemlich nach "Ziffer". Also muessen alle gesuchten
Zahlen soll[0], soll[1], ... etc. mindestens gleich 1 sein. Also
kommt die Zahl 0 in dem Satz genau einmal vor (nach "Ziffer") und
soll[0] muss deshalb gleich 1 sein.
------------------------------------------------------------------------ */
import java.util.Arrays; // fuer Arrays.equals

class Autolog02 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      pln("Autolog02: Jetzt geht es los!");
      suche(9);
      pln("Es wurde keine Loesung gefunden!");
      pln("---------------------------------------");
      pln("Autolog02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Die 0 kommt 1 Mal vor, die anderen Komponenten werden spaeter mit
   // 1 initialisiert:
   static       int[] soll = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0};
   // ---------------------------------------------------------------------
   static void suche(int n) {
      if (n==0) {

         // Jede Zahl zwischen 0 und 9 kommt
         // mindestens einmal vor (naemlich
         // nach dem Wort "Ziffer"):
         int[] ist = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1};

         // Wie oft kommt jede Zahl i zwischen
         // 0 und 9 in der Reihung soll vor? Die
         // Antworten werden zu den Komponenten
         // ist[i] addiert:
         for (int i=0; i<=9; i++) {
            ist[soll[i]]++;
         }

         // Wenn die Reihungen soll und ist gleich
         // sind, haben wir eine Loesung gefunden:
         if (Arrays.equals(soll, ist)) {
            gibLoesungAus(soll);
             // Wenn wir nur *eine* Loesung suchen:
            pln("---------------------------------------");
            pln("Autolog01: Das war's erstmal!");
            System.exit(0);
         }
         return;
      } // if

      for (soll[n]=1; soll[n]<=9; soll[n]++) {
         suche(n-1);
      }
   } // suche
   // ---------------------------------------------------------------------
   static void gibLoesungAus(int[] ir) {
      pln("---------------------------------------");
      p("\"Dieser Satz enthaelt");

      for (int i=0; i<=9; i++) {
         p("\n genau " + ir[i] + " mal die Ziffer " + i);
      }
      pln("\"");
   } // gibLoesungAus
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Autolog02
/* ------------------------------------------------------------------------
Ausgabe des Programms Autolog02:

Autolog02: Jetzt geht es los!
---------------------------------------
"Dieser Satz enthaelt
 genau 1 mal die Ziffer 0
 genau 7 mal die Ziffer 1
 genau 3 mal die Ziffer 2
 genau 2 mal die Ziffer 3
 genau 1 mal die Ziffer 4
 genau 1 mal die Ziffer 5
 genau 1 mal die Ziffer 6
 genau 2 mal die Ziffer 7
 genau 1 mal die Ziffer 8
 genau 1 mal die Ziffer 9"
---------------------------------------
Autolog01: Das war's erstmal!
------------------------------------------------------------------------ */