// Datei BigDecimal04.java
/* ------------------------------------------------------------------------
Zwei Zahlen vom Typ BigDecimal werden eingelesen, addiert, subtrahiert etc.
und die Ergebnisse werden ausgegeben. Dies wird wiederholt, bis der
Benutzer q eingibt oder eine Ausnahme geworfen wird.
------------------------------------------------------------------------- */
import java.math.BigDecimal;
import java.math.RoundingMode;

class BigDecimal04 {
   // ---------------------------------------------------------------------
   public static void main(String [] sonja) throws java.io.IOException {
      printf("BigDecimal04: Jetzt geht es los!\n");
      final RoundingMode RA  = RoundingMode.HALF_UP; // Rundungsart

      while (true) {
         printf("-----------------------------------------------------\n");
         printf("Zum Beenden bitte q eingeben!\n");
         printf("Eine BigDecimal b1?    : ");
         // Einen String einlesen ...
         String st1 = EM.liesString();
      if (st1.startsWith("q")) break; // Schleife und Programm beenden
         // ... und in ein BigDecimal-Objekt umwandeln:
         BigDecimal b1 = new BigDecimal(st1);;
         printf("Eine BigDecimal b2?    : ");
         // Direkt ein BigDecimal-Objekt einlesen (alle noetigen
         // Umwandlungen finden schon in EM.liesBibDecimal statt):
         BigDecimal b2 = EM.liesBigDecimal();

         printf("---------------------------\n");
         printf("b1                     : %s\n", b1);
         printf("b2                     : %s\n", b2);
         printf("---------------------------\n");
         printf("b1.add     (b2)        : %s\n", b1.add     (b2)        );
         printf("b1.subtract(b2)        : %s\n", b1.subtract(b2)        );
         printf("b1.multiply(b2)        : %s\n", b1.multiply(b2)        );
         printf("b1.divide  (b2,     RA): %s\n", b1.divide  (b2,     RA));
         printf("b1.divide  (b2, 12, RA): %s\n", b1.divide  (b2, 12, RA));
         printf("---------------------------\n");

         // Auf 3 Stellen nach dem Punkt runden, ungefaehrlich:
         printf("b1.setScale(3, RA)     : %s\n", b1.setScale(3, RA));
         printf("b2.setScale(3, RA)     : %s\n", b2.setScale(3, RA));
         // Alle Stellen nach der 3. Nachpunktstelle abschneiden.
         // Gefaehrlich: Falls eine der abzuschneidenden Stellen
         // ungleich 0 ist, wird eine Ausnahme geworfen:
         printf("b1.setScale(3)         : %s\n", b1.setScale(3    ));
      } // while

      printf("BigDecimal04: Das war's erstmal!\n");
   } // end main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // end class BigDecimal04
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm BigDecimal04:

BigDecimal04: Jetzt geht es los!
-----------------------------------------------------
Zum Beenden bitte q eingeben!
Eine BigDecimal b1?    : 3
Eine BigDecimal b2?    : 2.222222222222222222222222222222
---------------------------
b1                     : 3
b2                     : 2.222222222222222222222222222222
---------------------------
b1.add     (b2)        : 5.222222222222222222222222222222
b1.subtract(b2)        : 0.777777777777777777777777777778
b1.multiply(b2)        : 6.666666666666666666666666666666
b1.divide  (b2,     RA): 1
b1.divide  (b2, 12, RA): 1.350000000000
---------------------------
b1.setScale(3, RA)     : 3.000
b2.setScale(3, RA)     : 2.222
b1.setScale(3)         : 3.000
-----------------------------------------------------
Zum Beenden bitte q eingeben!
Eine BigDecimal b1?    : 1.111
Eine BigDecimal b2?    : 2.0005
---------------------------
b1                     : 1.111
b2                     : 2.0005
---------------------------
b1.add     (b2)        : 3.1115
b1.subtract(b2)        : -0.8895
b1.multiply(b2)        : 2.2225555
b1.divide  (b2,     RA): 0.555
b1.divide  (b2, 12, RA): 0.555361159710
---------------------------
b1.setScale(3, RA)     : 1.111
b2.setScale(3, RA)     : 2.001        // 2.0005 Aufgerundet!
b1.setScale(3)         : 1.111
-----------------------------------------------------
Zum Beenden bitte q eingeben!
Eine BigDecimal b1?    : 1.1111
Eine BigDecimal b2?    : 3
---------------------------
b1                     : 1.1111
b2                     : 3
---------------------------
b1.add     (b2)        : 4.1111
b1.subtract(b2)        : -1.8889
b1.multiply(b2)        : 3.3333
b1.divide  (b2,     RA): 0.3704
b1.divide  (b2, 12, RA): 0.370366666667
---------------------------
b1.setScale(3, RA)     : 1.111
b2.setScale(3, RA)     : 3.000
Exception in thread "main" java.lang.ArithmeticException: Rounding necessary
   at java.math.BigDecimal.divide(Unknown Source)
   at java.math.BigDecimal.setScale(Unknown Source)
   at java.math.BigDecimal.setScale(Unknown Source)
   at BigDecimal04.main(BigDecimal04.java:46)
------------------------------------------------------------------------ */
