// Datei BigInteger01.java
/* ------------------------------------------------------------------------
Zwei Zahlen vom Typ BigInteger werden eingelesen, addiert, subtrahiert etc.
und die Ergebnisse werden ausgegeben. Dies wird wiederholt, bis der
Benutzer eine 0 eingibt.
------------------------------------------------------------------------- */
import java.math.BigInteger;

class BigInteger01 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("A BigInteger01: Jetzt geht es los!\n");

      while (true) {
         printf("-----------------------------------------------------\n");
         printf("B Zum Beenden bitte 0 eingeben!\n");
         printf("C BigInteger BI1? ");
         BigInteger bi1 = EM.liesBigInteger();
      if (bi1.compareTo(BigInteger.ZERO) == 0) break;
         printf("D BigInteger BI2? ");
         BigInteger bi2 = EM.liesBigInteger();

         printf("E BI1:            %+d\n", bi1);
         printf("F BI2:            %+d\n", bi2);

         printf("G BI1  +  BI2:    %+d\n", bi1.add     (bi2));
         printf("H BI1  -  BI2:    %+d\n", bi1.subtract(bi2));
         printf("I BI1  *  BI2:    %+d\n", bi1.multiply(bi2));
         printf("J BI1  /  BI2:    %+d\n", bi1.divide  (bi2));

         // Die Methode divideAndRemainder liefert eine Reihung mit zwei
         // Komponenten vom Typ BigInteger: den Quotienten und den Rest.
         BigInteger[] bir = bi1.divideAndRemainder(bi2);
         printf("K BI1 div BI2:    %+d\n", bir[0]); // div wie divide
         printf("L BI1 rem BI2:    %+d\n", bir[1]); // rem wie remainder

         // Die Methode mod wirft eine Ausnahme ArithmeticException, wenn
         // der zweite Operand (der Modulus) nicht groesser als 0 ist. Man
         // beachte den subtilen Unterschied zwischen den beiden Restfunk-
         // tionen rem (d.h. divideAndRemainder) und mod!
         printf("M BI1 mod BI2:    %+d\n", bi1.mod(bi2));
      } // while

      printf("N BigInteger01: Das war's erstmal!");
   } // end main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // end class BigInteger01
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm BigInteger01 (die Kommentare wurden nachtraeg-
lich von Hand eingefuegt):

A BigInteger01: Jetzt geht es los!
-----------------------------------------------------
B Zum Beenden bitte 0 eingeben!
C BigInteger BI1?  555555555555555555555555555555
D BigInteger BI2?  222222222222222222222222222222
E BI1:            +555555555555555555555555555555
F BI2:            +222222222222222222222222222222
G BI1  +  BI2:    +777777777777777777777777777777
H BI1  -  BI2:    +333333333333333333333333333333
I BI1  *  BI2:    +123456790123456790123456790123209876543209876543209876543210
J BI1  /  BI2:    +2
K BI1 div BI2:    +2
L BI1 rem BI2:    +111111111111111111111111111111
M BI1 mod BI2:    +111111111111111111111111111111
-----------------------------------------------------
B Zum Beenden bitte 0 eingeben!
C BigInteger BI1? -17
D BigInteger BI2?   5
E BI1:            -17
F BI2:            +5
G BI1  +  BI2:    -12
H BI1  -  BI2:    -22
I BI1  *  BI2:    -85
J BI1  /  BI2:    -3
K BI1 div BI2:    -3
L BI1 rem BI2:    -2            // -17 / 5 ist gleich -3 Rest -2
M BI1 mod BI2:    +3            // -17 / 5 ist gleich -4 Rest +3
-----------------------------------------------------
B Zum Beenden bitte 0 eingeben!
C BigInteger BI1? -12345
D BigInteger BI2?  10000
E BI1:            -12345
F BI2:            +10000
G BI1  +  BI2:    -2345
H BI1  -  BI2:    -22345
I BI1  *  BI2:    -123450000
J BI1  /  BI2:    -1
K BI1 div BI2:    -1
L BI1 rem BI2:    -2345         // -12345 / 100000 ist gleich -1 Rest -2345
M BI1 mod BI2:    +7655         // -12345 / 100000 ist gleich -2 Rest +7655
-----------------------------------------------------
B Zum Beenden bitte 0 eingeben!
C BigInteger BI1? 0
N BigInteger01: Das war's erstmal!
------------------------------------------------------------------------ */