// Datei BigInteger02.java
/* ------------------------------------------------------------------------
Liest eine Ganzzahl vom Typ int ein und gibt deren Fakultaet aus (als
Zahl vom Typ BigInteger). Gibt ausserdem die Laenge des Ergebnisses (die
Anzahl der Dezimalziffern und die Anzahl der noetigen Binaerziffern) aus.
------------------------------------------------------------------------ */
import java.math.BigInteger;

class BigInteger02 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("BigInteger02: Jetzt geht es los!\n");

      while (true) {
         printf("-----------------------------------------------------\n");
         printf("Eine Ganzzahl n (0 zum Beenden) : ");
         int n = EM.liesInt();
         if (n == 0) break; // Schleife und Programm beenden
         if (n < 0) {
            printf("Die Zahl %d ist zu klein!\n", n);
            continue;
         }

         BigInteger erg    = new BigInteger("1");
//       BigInteger faktor = new BigInteger("1");
         BigInteger faktor = BigInteger.ONE;

         // Jetzt wird die Fakultaet von n berechnet:
         for (int i=1; i < n; i++) {
            faktor = faktor.add(BigInteger.ONE);
            erg    = erg.multiply(faktor);
         }

         // Die Laenge des Ergebnis auf zwei Weisen ermitteln:
         int laengeD = erg.toString ().length();
         int laengeB = erg.bitLength();

         // Das Ergebnis und die Laengen ausgeben:
         printf("Die Fakultaet von %3d ist gleich: %s\n", n, erg);
         printf("Laenge (in Dezimalziffern)      : %d\n", laengeD);
         printf("Laenge (in Binaerziffern)       : %d\n", laengeB);
      } // while

      printf("BigInteger02: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class BigInteger02

/* -------------------------------------------------------------------------
Ein Dialog mit dem Programm BigInteger02 (zu lange Zeilen wurden
nachtraeglich von Hand umgebrochen):

BigInteger02: Jetzt geht es los!
-----------------------------------------------------
Eine Ganzzahl n (0 zum Beenden) : 1
Die Fakultaet von   1 ist gleich: 1
Laenge (in Dezimalziffern)      : 1
Laenge (in Binaerziffern)       : 1
-----------------------------------------------------
Eine Ganzzahl n (0 zum Beenden) : 5
Die Fakultaet von   5 ist gleich: 120
Laenge (in Dezimalziffern)      : 3
Laenge (in Binaerziffern)       : 7
-----------------------------------------------------
Eine Ganzzahl n (0 zum Beenden) : -2
Die Zahl -2 ist zu klein!
-----------------------------------------------------
Eine Ganzzahl n (0 zum Beenden) : 100
Die Fakultaet von 100 ist gleich: 9332621544394415268
16992388562667004907159682643816214685929638952175999
93229915608941463976156518286253697920827223758251185
210916864000000000000000000000000
Laenge (in Dezimalziffern)      : 158
Laenge (in Binaerziffern)       : 525
-----------------------------------------------------
Eine Ganzzahl n (0 zum Beenden) : 0
BigInteger02: Das war's erstmal!
------------------------------------------------------------------------- */
