// Datei BreakContinue02.java
/* ------------------------------------------------------------------------
Die Anweisungen break und continue mit Marken.
------------------------------------------------------------------------ */
class BreakContinue02 {
   // ---------------------------------------------------------------------
   static boolean alleInS1AuchInS2(String s1, String s2) {
      // Liefert true, wenn jedes Zeichen in s1 auch in s2 vorkommt,
      // und sonst false.
      schleife1: for (int i1=0; i1<s1.length(); i1++) {
         char c1 = s1.charAt(i1);
         schleife2: for (int i2=0; i2<s2.length(); i2++) {
            char c2 = s2.charAt(i2);
            if (c1 == c2) continue schleife1;
         }
         return false;
      }
      return true;
   } // alleInS1AuchInS2
   // ---------------------------------------------------------------------
   static void erstesRechtwinkliges(int a_min) {
      // Sucht die ganzzahligen Seitenlaengen eines rechtwinkligen Drei-
      // ecks (schoenen Gruss von Pythagoras), dessen Hypothenuse a groes-
      // ser oder gleich a_min und kleiner als 100 ist und gibt sie aus.
      schleifeA: for (int a=a_min; a<100; a++) {
         schleifeB: for (int b=1; b<=a; b++) {
            schleifeC: for (int c=1; c<=b; c++) {
               if (a*a == b*b + c*c) { // Pythagoras
                  pln("a: " + a + ", b: " + b + ", c: " + c);
                  break schleifeA;
               }
            } // schleifeC
         } // schleifeB
      } // schleifeA
   } // erstesRechtwinkliges
   // ---------------------------------------------------------------------
   static int laengeSatz1(String text) {
      // Wie lang ist der erste (durch einen Punkt, ein
      // Fragezeichen oder ein Ausrufezeichen abgeschlossene)
      // Satz im text? Diese Funktion liefert die Antwort.

      int anz = 0; // Das Ergebnis dieser Funktion
      schleife: for (int i=0; i<text.length(); i++) {
         anz++;
         switch (text.charAt(i)) {
            case '.':
            case '?':
            case '!':  break schleife; // Verlasse schleife
            default :  break;          // Verlasse switch
         }
      } // for
      return anz;
   } // laengeSatz1
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("BreakContinue02: Jetzt geht es los!");

      char daz = '"'; // Ein doppeltes Anfuerhungszeichen

      String s01 = "ABC",          t01 = daz + s01 + daz;
      String s02 = "ABCABC",       t02 = daz + s02 + daz;
      String s03 = "XCYBZA",       t03 = daz + s03 + daz;
      String s04 = "XCYYZA",       t04 = daz + s04 + daz;

      String s05 = "Wieso? Aha! ", t05 = daz + s05 + daz;
      String s06 = "Hallo Sonja!", t06 = daz + s06 + daz;
      String s07 = "Wie gehts?  ", t07 = daz + s07 + daz;

      pln("-------------------------------------------");
      pln("alleInS1AuchInS2(" + t01 + ", " + t03 + "): " +
           alleInS1AuchInS2(    s01,         s03));
      pln("alleInS1AuchInS2(" + t02 + ", " + t03 + "): " +
           alleInS1AuchInS2(    s02,         s03));
      pln("alleInS1AuchInS2(" + t02 + ", " + t04 + "): " +
           alleInS1AuchInS2(    s02,         s04));
      pln("-------------------------------------------");
      erstesRechtwinkliges(7);
      pln("-------------------------------------------");
      pln("laengeSatz1(" + t05 + "): " +
           laengeSatz1(    s05    ));
      pln("laengeSatz1(" + t06 + "): " +
           laengeSatz1(    s06    ));
      pln("laengeSatz1(" + t07 + "): " +
           laengeSatz1(    s07    ));
      pln("-------------------------------------------");

      pln("BreakContinue02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // BreakContinue02
/* ------------------------------------------------------------------------
Ausgabe des Programms BreakContinue02:

BreakContinue02: Jetzt geht es los!
-------------------------------------------
alleInS1AuchInS2("ABC", "XCYBZA"): true
alleInS1AuchInS2("ABCABC", "XCYBZA"): true
alleInS1AuchInS2("ABCABC", "XCYYZA"): false
-------------------------------------------
a: 10, b: 8, c: 6
-------------------------------------------
laengeSatz1("Wieso? Aha! "): 6
laengeSatz1("Hallo Sonja!"): 12
laengeSatz1("Wie gehts?  "): 10
-------------------------------------------
BreakContinue02: Das war's erstmal!
------------------------------------------------------------------------ */
