// Datei E01Anwendung01.java
/* ------------------------------------------------------------------------
Eine E01Punkt-Variable kann nicht nur auf E01Punkt-Objekte zeigen,
sondern auch auf Objekte der Unterklassen E01Rechteck, E01Quadrat,
E01Ellipse und E01Kreis (siehe die Variablen p01 bis p05).

Eine E01Rechteck-Variable kann nicht nur auf E01Rechteck-Objekte zeigen,
sondern auch auf Objekte der Unterklasse E01Quadrat (siehe r01 und r02).

Eine E01Ellipse-Variable kann nicht nur auf E01Ellipse-Objekte zeigen,
sondern auch auf Objekte der Unterklasse E01Kreis (siehe e01 und e02).

Wenn man mit der Methode System.out.println oder mit der Methode pln
(die unten nach der main-Methode vereinbart wird) ein Objekt ausgibt,
wird automatisch die toString-Funktion dieses Objekts aufgerufen und
ihr Ergebnis ausgegeben. Die folgenden beiden Methodenaufrufe haben
somit die gleiche Wirkung:

pln(p01.toString()); // Gibt das Ergebnis der Funktion p01.toString aus
pln(p01);            // Ebenso
------------------------------------------------------------------------ */
class E01Anwendung01 {
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      // Objekte verschiedener Klassen werden erzeugt und ausgegeben:

      E01Punkt    p01 = new E01Punkt   (1.0, 2.0);
      E01Punkt    p02 = new E01Rechteck(2.0, 3.0, 4.0, 5.0);
      E01Punkt    p03 = new E01Quadrat (3.0, 4.0, 5.0);
      E01Punkt    p04 = new E01Ellipse (4.0, 5.0, 6.0, 7.0);
      E01Punkt    p05 = new E01Kreis   (5.0, 6.0, 7.0);

      E01Rechteck r01 = new E01Rechteck(6.0, 7.0, 8.0, 9.0);
      E01Rechteck r02 = new E01Quadrat (7.0, 8.0, 9.0);

      E01Ellipse  e01 = new E01Ellipse (8.0, 9.0, 1.0, 2.0);
      E01Ellipse  e02 = new E01Kreis   (9.0, 1.0, 2.0);

      // Statt      p01.toString() kann man im Folgenden
      // einfach    p01            schreiben
      pln("-------------------------------------------------------------");
      pln("p01: " + p01.toString());
      pln("p02: " + p02.toString());
      pln("p03: " + p03.toString());
      pln("p04: " + p04.toString());
      pln("p05: " + p05.toString());
      pln("-------------------------------------------------------------");
      pln("r01: " + r01.toString());
      pln("r02: " + r02.toString());
      pln("-------------------------------------------------------------");
      pln("e01: " + e01.toString());
      pln("e02: " + e02.toString());
      pln("-------------------------------------------------------------");
      pln("E01Anwendung01: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class E01Anwendung01
/* ------------------------------------------------------------------------
Ausgabe des Programms E01Anwendung01:

-------------------------------------------------------------
p01: Punkt: (1.0, 2.0)
p02: Rechteck, Mittelpunkt: (2.0, 3.0), Seiten: 4.0|5.0
p03: Quadrat,  Mittelpunkt: (3.0, 4.0), Seite:  5.0
p04: Ellipse,  Mittelpunkt: (4.0, 5.0), Radien: 6.0|7.0
p05: Kreis,    Mittelpunkt: (5.0, 6.0), Radius: 7.0
-------------------------------------------------------------
r01: Rechteck, Mittelpunkt: (6.0, 7.0), Seiten: 8.0|9.0
r02: Quadrat,  Mittelpunkt: (7.0, 8.0), Seite:  9.0
-------------------------------------------------------------
e01: Ellipse,  Mittelpunkt: (8.0, 9.0), Radien: 1.0|2.0
e02: Kreis,    Mittelpunkt: (9.0, 1.0), Radius: 2.0
-------------------------------------------------------------
E01Anwendung01: Das war's erstmal!
------------------------------------------------------------------------ */