// Datei E01Anwendung02.java
/* ------------------------------------------------------------------------
Zeigt, wie man es NICHT machen soll.

Die Methode reihungAusgeben02 in diesem Programm ist eine nicht-empfehlens-
werte Alternative zur Methode reihungAusgeben03 im Programm E01Anwendung03.

Die Methode reihungAusgeben02 ist nicht nur wesentlich komplizierter als
reihungAusgeben03, sondern auch "aenderungsunfreundlicher". Wenn eine
weitere Unterklasse von E01Punkt hinzukommt (z.B. eine Unterklasse namens
E01Kreis) sind komplizierte Aenderungen an reihungAusgeben02 erforderlich,
wohingegen reihungAusgeben03 ohne Aenderungen auch Objekte der neuen Klasse
ausgeben kann.
------------------------------------------------------------------------ */
class E01Anwendung02 {
   // ---------------------------------------------------------------------
   static private E01Punkt[] produziereReihung() {
      // Erzeugt und liefert eine Reihung, die eine "wilde Mischung" von
      // E01Rechteck-, E01Quadrat- und E01Ellipse-Objekten enthaelt:
      E01Punkt[] pr = new E01Punkt[5];
      pr[0] = new E01Ellipse (1.0, -2.0, 3.0, 4.0);
      pr[1] = new E01Quadrat (2.0, -3.0, 4.0);
      pr[2] = new E01Ellipse (3.0, -4.0, 5.0, 6.0);
      pr[3] = new E01Rechteck(4.0, -5.0, 6.0, 7.0);
      pr[4] = new E01Rechteck(5.0, -6.0, 7.0, 8.0);
//    pr[4] = new E01Kreis   (6.0, -7.0, 8.0);

      return pr;
   } // produziereReihung
   // ---------------------------------------------------------------------
   static void reihungAusgeben02(E01Punkt[] pr, String name) {
      // Gibt alle Komponenten von pr aus.
      printf("Die Komponenten der Reihung " + name + ":%n");

      String      s0, s1, s2, s3, s4;
      E01Punkt    p;
      E01Rechteck r;
      E01Ellipse  e;

      for (int i=0; i<pr.length; i++) {
         s0 = name + "[" + i + "]: "; // z.B. "tab[3]: "
         s2 = pr[i].text();           // z.B. "(2.0, 3.0)"

         if        (pr[i] instanceof E01Quadrat)  {
            s1 = "Quadrat,  Mittelpunkt: ";
            s3 = ", Seite:  ";
            s4 =  "" + ((E01Quadrat)pr[i]).getSeiteX();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (pr[i] instanceof E01Rechteck) {
            r  = (E01Rechteck) pr[i];
            s1 = "Rechteck, Mittelpunkt: ";
            s3 = ", Seiten: ";
            s4 = r.getSeiteX() + "|" + r.getSeiteY();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (pr[i] instanceof E01Ellipse)  {
            e  = (E01Ellipse) pr[i];
            s1 = "Ellipse,  Mittelpunkt: ";
            s3 = ", Radien: ";
            s4 = e.getRadiusX() + "|" + e.getRadiusY();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (pr[i] instanceof E01Punkt)    {
            s1 = "Punkt: ";
            printf(s0 + s1 + s2 + "%n");
         } else {
            printf("Objekt einer unbekannten Klasse!%n");
         } // if
      } // for
   } // reihungAusgeben02
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {

      E01Punkt[] tab = produziereReihung();
      printf("-----------------------------------------------------------%n");
      reihungAusgeben02(tab, "tab");
      printf("-----------------------------------------------------------%n");
      printf("E01Anwendung02: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class E01Anwendung02
/* ------------------------------------------------------------------------
Ausgabe des Programms E01Anwendung02:

-----------------------------------------------------------
Die Komponenten der Reihung tab:
tab[0]: Ellipse,  Mittelpunkt: (1.0, -2.0), Radien: 3.0|4.0
tab[1]: Quadrat,  Mittelpunkt: (2.0, -3.0), Seite:  4.0
tab[2]: Ellipse,  Mittelpunkt: (3.0, -4.0), Radien: 5.0|6.0
tab[3]: Rechteck, Mittelpunkt: (4.0, -5.0), Seiten: 6.0|7.0
tab[4]: Rechteck, Mittelpunkt: (5.0, -6.0), Seiten: 7.0|8.0
-----------------------------------------------------------
E01Anwendung02: Das war's erstmal!
------------------------------------------------------------------------ */