// Datei E01Ellipse.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert eine Ellipse auf einer zwei-
dimensionalen Ebene. Die Hauptachsen der Ellipse liegen parallel zu den
Achsen.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E01Punkt
        |
        +---E01Rechteck
        |     |
        |     +---E01Quadrat
        |
        +---E01Ellipse
------------------------------------------------------------------------ */
class E01Ellipse extends E01Punkt {
   // Die Radien dieser Ellipse:
   private double radiusX; // Radius in x-Richtung
   private double radiusY; // Radius in y-Richtung

   public E01Ellipse(double x,       double y,
                     double radiusX, double radiusY) {
      super(x, y);
      this.radiusX = radiusX;
      this.radiusY = radiusY;
   } // Konstruktor E01Ellipse

   public double getRadiusX() {return radiusX;}
   public double getRadiusY() {return radiusY;}

   // Funktionen, die den Umfang bzw. die Flaeche dieses Objekts
   // liefern:
   public double getUmfang()  {
      // Berechnet den Umfang nach einer Naeherungsformel:
      double summ = radiusX + radiusY;
      double prod = radiusX * radiusY;
      return Math.PI * (1.5 * summ - Math.sqrt(prod));
   } // getUmfang

   public double getFlaeche() {return Math.PI*radiusX*radiusY;}

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      return new String("Ellipse,  Mittelpunkt: " + text() +
         ", Radien: " + radiusX + "|" + radiusY);
   } // toString

} // class E01Ellipse