// Datei E01Kreis.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Kreis auf einer zwei-
dimensionalen Ebene.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E01Punkt
        |
        +---E01Rechteck
        |     |
        |     +---E01Quadrat
        |
        +---E01Ellipse
              |
              +---E01Kreis
------------------------------------------------------------------------ */
class E01Kreis extends E01Ellipse {

   public E01Kreis(double x, double y, double radius) {
      super(x, y, radius, radius);
   } // Konstruktor E01Kreis

   public double getUmfang()  {
      return 2.0 * Math.PI * getRadiusX();
   } // getUmfang

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      return new String("Kreis,    Mittelpunkt: " + text() +
         ", Radius: " + getRadiusX());
   } // toString

} // class E01Kreis