// Datei E01Punkt.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Punkt auf einer zwei-
dimensionalen Ebene.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E01Punkt
        |
        +---E01Rechteck
        |     |
        |     +---E01Quadrat
        |
        +---E01Ellipse
------------------------------------------------------------------------ */
class E01Punkt {
   // Die Koordinaten dieses Punktes:
   private double x, y;

   public E01Punkt(double x, double y) {
      this.x = x;
      this.y = y;
   } // Konstruktor E01Punkt

   public double urAbstand()  {
      // Liefert den Abstand dieses Punktes vom Punkt (0, 0)
      return Math.sqrt(x*x + y*y);
   } // urAbstand

   public void urSpiegeln() {
      // Spiegelt diesen Punkt am Punkt (0, 0)
      x = -x; y = -y;
   } // urSpiegeln

   public String text() {
      // Liefert die Koordinaten dieses Punktes,
      // z.B. "(2.0, 3.5)"
      return new String("("  + x +  ", "  + y +  ")");
   } // text

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      return new String("Punkt: "  + text());
   } // toString

} // class E01Punkt