// Datei E01Rechteck.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert ein Rechteck auf einer zwei-
dimensionalen Ebene. Das Rechteck hat achsenparallele Seiten.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E01Punkt
        |
        +---E01Rechteck
        |     |
        |     +---E01Quadrat
        |
        +---E01Ellipse
------------------------------------------------------------------------ */
class E01Rechteck extends E01Punkt {
   // Die Seiten des Rechtecks:
   private double seiteX;
   private double seiteY;

   public E01Rechteck(double x,      double y,
                      double seiteX, double seiteY) {
      super(x, y);
      this.seiteX = seiteX;
      this.seiteY = seiteY;
   } // Konstruktor E01Rechteck

   // Funktionen, die die Laenge der x- bzw. y-Seite liefern:
   public double getSeiteX()  {return seiteX;}
   public double getSeiteY()  {return seiteY;}

   // Funktionen, die den Umfang bzw. die Flaeche dieses Objekts
   // liefern:
   public double getUmfang()  {return 2 * (seiteX + seiteY);}
   public double getFlaeche() {return      seiteX * seiteY;}

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      return new String("Rechteck, Mittelpunkt: " +
         text() + ", Seiten: " + seiteX + "|" + seiteY);
   } // toString
} // class E01Rechteck