// Datei E02Anwendung02.java
/* ------------------------------------------------------------------------
Zeigt, wie man es NICHT machen soll.

Die Methode reihungAusgeben02 in diesem Programm ist eine nicht-empfehlens-
werte Alternative zur Methode reihungAusgeben03 im Programm E02Anwendung03.

Die Methode reihungAusgeben02 ist nicht nur wesentlich komplizierter als
reihungAusgeben03, sondern auch "aenderungsunfreundlicher". Wenn eine
weitere Unterklasse von E02GeoFigur hinzukommt (z.B. eine Unterklasse namens
E02Kreis) sind komplizierte Aenderungen an reihungAusgeben02 erforderlich,
wohingegen reihungAusgeben03 ohne Aenderungen auch Objekte der neuen Klasse
ausgeben kann.
------------------------------------------------------------------------ */
class E02Anwendung02 {
   // ---------------------------------------------------------------------
   static private E02GeoFigur[] produziereReihung() {
      // Erzeugt und liefert eine Reihung, die eine "wilde Mischung" von
      // E02Rechteck-, E02Quadrat- und E02Ellipse-Objekten enthaelt:
      E02GeoFigur[] pr = new E02GeoFigur[5];
      pr[0] = new E02Ellipse (1.0, -2.0, 3.0, 4.0);
      pr[1] = new E02Quadrat (2.0, -3.0, 4.0);
      pr[2] = new E02Ellipse (3.0, -4.0, 5.0, 6.0);
      pr[3] = new E02Rechteck(4.0, -5.0, 6.0, 7.0);
      pr[4] = new E02Rechteck(5.0, -6.0, 7.0, 8.0);
//    pr[4] = new E02Kreis   (6.0, -7.0, 8.0);

      return pr;
   } // produziereReihung
   // ---------------------------------------------------------------------
   static void reihungAusgeben02(E02GeoFigur[] gr, String name) {
      // Gibt alle Komponenten von gr aus.
      printf("Die Komponenten der Reihung " + name + ":%n");

      String      s0, s1, s2, s3, s4;
      E02GeoFigur    p;
      E02Rechteck r;
      E02Ellipse  e;

      for (int i=0; i<gr.length; i++) {
         s0 = name + "[" + i + "]: "; // z.B. "tab[3]: "
         s2 = gr[i].text();           // z.B. "(2.0, 3.0)"

         if        (gr[i] instanceof E02Quadrat)  {
            s1 = "Quadrat,  Mittelpunkt: ";
            s3 = ", Seite:  ";
            s4 =  "" + ((E02Quadrat)gr[i]).getSeiteX();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (gr[i] instanceof E02Rechteck) {
            r  = (E02Rechteck) gr[i];
            s1 = "Rechteck, Mittelpunkt: ";
            s3 = ", Seiten: ";
            s4 = r.getSeiteX() + "|" + r.getSeiteY();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (gr[i] instanceof E02Ellipse)  {
            e  = (E02Ellipse) gr[i];
            s1 = "Ellipse,  Mittelpunkt: ";
            s3 = ", Radien: ";
            s4 = e.getRadiusX() + "|" + e.getRadiusY();
            printf(s0 + s1 + s2 + s3 + s4 + "%n");
         } else if (gr[i] instanceof E02GeoFigur)    {
            s1 = "Punkt: ";
            printf(s0 + s1 + s2 + "%n");
         } else {
            printf("Objekt einer unbekannten Klasse!%n");
         } // if
      } // for
   } // reihungAusgeben02
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      E02GeoFigur[] tab = produziereReihung();
      printf("E02Anwendung02: Jetzt geht es los!%n");
      printf("-----------------------------------------------------------%n");
      reihungAusgeben02(tab, "tab");
      printf("-----------------------------------------------------------%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class E02Anwendung02
/* ------------------------------------------------------------------------
Ausgabe des Programms E02Anwendung02:

E02Anwendung02: Jetzt geht es los!
-----------------------------------------------------------
Die Komponenten der Reihung tab:
tab[0]: Ellipse,  Mittelpunkt: (1.0, -2.0), Radien: 3.0|4.0
tab[1]: Quadrat,  Mittelpunkt: (2.0, -3.0), Seite:  4.0
tab[2]: Ellipse,  Mittelpunkt: (3.0, -4.0), Radien: 5.0|6.0
tab[3]: Rechteck, Mittelpunkt: (4.0, -5.0), Seiten: 6.0|7.0
tab[4]: Rechteck, Mittelpunkt: (5.0, -6.0), Seiten: 7.0|8.0
-----------------------------------------------------------
------------------------------------------------------------------------ */