// Datei E02GeoFigur.java
/* ------------------------------------------------------------------------
Die Objekte der Unterklassen dieser abstrakten Klassen sollten geometrische
Figuren (Rechtecke, Quadrate, Ellipsen, ...) auf einer zweidimensionalen
Ebene darstellen. Diese abstrakte Klasse beschreibt, was alle Objekte ihrer
Unterklassen gemeinsam haben (naemlich zwei Koordinaten x und y und
Methoden namens urAbstand, urSpiegeln, text, getFlaeche und getUmfang).

Man beachte: Obwohl diese Klasse abstrakt ist, hat sie einen Konstruktor.
Der wird von Konstruktoren von Unterklassen aufgerufen.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
public abstract class E02GeoFigur {
   // Die Koordinaten dieser Figur:
   private double x, y;

   public E02GeoFigur(double x, double y) {
      this.x = x;
      this.y = y;
   } // Konstruktor E02GeoFigur

   public double urAbstand()  {
      // Liefert den Abstand dieser Figur vom Punkt (0, 0)
      return Math.sqrt(x*x + y*y);
   } // urAbstand

   public void urSpiegeln() {
      // Spiegelt diesen Punkt am Punkt (0, 0)
      x = -x; y = -y;
   } // urSpiegeln

   public String text() {
      // Liefert die Koordinaten dieser Figur,
      // z.B. "(2.0, 3.5)"
      return new String("("  + x +  ", "  + y +  ")");
   } // text

   abstract public double getFlaeche();
      // Liefert die Oberflaeche dieser Figur.

   abstract public double getUmfang();
      // Liefert den Umfang dieser Figur.
} // class E02GeoFigur