// Datei E02GeoFigurMitFarbe.java
/* ------------------------------------------------------------------------
Diese abstrakte Klasse beerbt die abstrakte Klasse E02GeoFigur. Dabei
erbt sie unter anderem zwei abstrakte Objektmethoden (getUmfang und
getFlaeche). Da diese Klasse E02GeoFigurMitFarbe selbst auch abstrakt
ist, muss sie die geerbten abstrakten Methoden nicht implementieren
(sondern kann diese Verpflichtung "an ihre Erben weiterreichen").

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur (abstrakt)
        |
        +---E02GeoFigurMitFarbe (abstrakt)
        |     |
        |     +---E02RechteckMitFarbe (konkret)
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
public abstract class E02GeoFigurMitFarbe extends E02GeoFigur {
   private Farbe farbe;

   // Vier verschiedene Konstruktoren erlauben es, beim Erzeugen
   // eines Objekts wahlweise Koordinaten und eine Farbe oder
   // nur Koordinaten oder nur eine Farbe oder keine Parameter
   // anzugeben.
   // Diese Konstruktoren duerfen nur (mit dem Schluesselwort
   // super) in der ersten Zeile eines Konstruktors einer
   // Unterklasse dieser abstrakten Klasse E02GeoFigurMitFarbe
   // aufgerufen werden.

   // Koordinaten und eine Farbe:
   E02GeoFigurMitFarbe(double x, double y, Farbe farbe) {
      super(x, y);
      this.farbe = farbe;
   } // Konstruktor E02GeoFigurMitFarbe

   // Koordinaten, aber keine Farbe:
   E02GeoFigurMitFarbe(double x, double y) {
      super(x, y);
      this.farbe = Farbe.rot;
   } // Konstruktor E02GeoFigurMitFarbe

   // Nur eine Farbe, keine Koordinaten:
   E02GeoFigurMitFarbe(Farbe farbe) {
      super(0.0, 0.0);
      this.farbe = farbe;
   } // Konstruktor E02GeoFigurMitFarbe

   // Keine Parameter (ein Standardkonstruktor):
   E02GeoFigurMitFarbe() {
      super(0.0, 0.0);
      this.farbe = Farbe.rot;
   } // Konstruktor E02GeoFigurMitFarbe

   public String text() {
      // Liefert den Text einer E02GeoFigur gefolgt von
      // ihrer Farbe, z.B. so: "(2.0, 3.5), Farbe: rot"
      return super.text() + ", Farbe: " + farbe;
   } // text

} // class E02GeoFigurMitFarbe