// Datei E02Kreis.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Kreis auf einer zwei-
dimensionalen Ebene.

Jede mit der Anmerkung (annotation) @Override markierte Methode muss eine
geerbte Methode ueberschreiben, sonst meldet der Compiler einen Fehler.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
class E02Kreis extends E02Ellipse {

   public E02Kreis(double x, double y, double radius) {
      super(x, y, radius, radius);
   } // Konstruktor E02Kreis

   @Override public double getUmfang()  {
      return 2.0 * Math.PI * getRadiusX();
   } // getUmfang

   @Override public String toString() {
      // Liefert eine String-Repraesentation dieser Figur:
      return new String("Kreis,    Mittelpunkt: " + text() +
         ", Radius: " + getRadiusX());
   } // toString

} // class E02Kreis