// Datei E02Quadrat.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert ein Quadrat auf einer zwei-
dimensionalen Ebene. Die Seiten des Quadrats liegen parallel zu den
Achsen des Koordinatensystems.

Jede mit der Anmerkung (annotation) @Override markierte Methode muss eine
geerbte Methode ueberschreiben, sonst meldet der Compiler einen Fehler.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
class E02Quadrat extends E02Rechteck {

   public E02Quadrat(double x, double y, double seite) {
      super(x, y, seite, seite);
   } // Konstruktor E02Quadrat

   @Override public String toString() {
      // Liefert eine String-Repraesentation dieser Figur:
      return new String("Quadrat,  Mittelpunkt: " +
         text() + ", Seite:  " + getSeiteX());
   } // toString

} // class E02Quadrat