// Datei E02Rechteck.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert ein Rechteck auf einer zwei-
dimensionalen Ebene. Die Seiten des Rechtecks liegen parallel zu den
Achsen des Koordinatensystems.

Jede mit der Anmerkung (annotation) @Override markierte Methode muss eine
geerbte Methode ueberschreiben, sonst meldet der Compiler einen Fehler.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
class E02Rechteck extends E02GeoFigur {
   // Die Seiten dieses Rechtecks:
   private double seiteX;
   private double seiteY;

   public E02Rechteck(double x,      double y,
                      double seiteX, double seiteY) {
      super(x, y);
      this.seiteX = seiteX;
      this.seiteY = seiteY;
   } // Konstruktor E02Rechteck

   // Funktionen, die die Laenge der x- bzw. y-Seite liefern:
   public double getSeiteX()  {return seiteX;}
   public double getSeiteY()  {return seiteY;}

   // Funktionen, die den Umfang bzw. die Flaeche dieser Figur
   // liefern:
   @Override public double getUmfang()  {return 2 * (seiteX + seiteY);}
   @Override public double getFlaeche() {return      seiteX * seiteY;}

   @Override public String toString() {
      // Liefert eine String-Repraesentation dieser Figur:
      return new String("Rechteck, Mittelpunkt: " +
         text() + ", Seiten: " + seiteX + "|" + seiteY);
   } // toString
} // class E02Rechteck