// Datei E02RechteckMitFarbe.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert ein Rechteck auf einer zwei-
dimensionalen Ebene, dem eine Farbe (ein Objekt des Typs Farbe, ver-
einbart in der Datei Aufzaehlung01.java) zugeordnet ist. Die Seiten des
Rechtecks liegen parallel zu den Achsen des Koordinatensystems.

Diese Klasse gehoert zu folgendem Beerbungsbaum:

Object
 |
 +----E02GeoFigur (abstrakt)
        |
        +---E02GeoFigurMitFarbe (abstrakt)
        |     |
        |     +---E02RechteckMitFarbe (konkret)
        |
        +---E02Rechteck
        |     |
        |     +---E02Quadrat
        |
        +---E02Ellipse
              |
              +---E02Kreis
------------------------------------------------------------------------ */
class E02RechteckMitFarbe extends E02GeoFigurMitFarbe {
   // Die Seiten dieses Rechtecks:
   private double seiteX;
   private double seiteY;

   // Zwei Konstruktoren, einer mit 5 und einer mit 0 Parametern:
   public E02RechteckMitFarbe(double  x,      double y,
                              double  seiteX, double seiteY,
                              Farbe   farbe) {
      super(x, y, farbe);
      this.seiteX = seiteX;
      this.seiteY = seiteY;
   } // Konstruktor E02RechteckMitFarbe

   public E02RechteckMitFarbe() {
      super();
      this.seiteX = 0.0;
      this.seiteY = 0.0;
   } // Konstruktor E02RechteckMitFarbe

   // Funktionen, die die Laenge der x- bzw. y-Seite liefern:
   public double getSeiteX()  {return seiteX;}
   public double getSeiteY()  {return seiteY;}

   // Funktionen, die den Umfang bzw. die Flaeche dieser Figur
   // liefern:
   public double getUmfang()  {return 2 * (seiteX + seiteY);}
   public double getFlaeche() {return      seiteX * seiteY;}

   public String toString() {
      // Liefert eine String-Repraesentation dieser Figur:
      return new String("Rechteck, Mittelpunkt: " +
         text() + ", Seiten: " + seiteX + "|" + seiteY);
   } // toString
} // class E02RechteckMitFarbe