// Datei EMTst01.java
/* ------------------------------------------------------------------------
Ein Programm zum Testen des Eingabemoduls EM.
------------------------------------------------------------------------ */
// Der folgende Befehl "import EM;" ist nicht noetig, aber eigentlich er-
// laubt (und als Dokumentation sinnvoll). Der Java-Compiler javac (Version
// 1.4) von Sun akzeptiert den Befehl aber nicht. Das ist ein Fehler des
// Compilers. Der Compiler jikes von IBM akzeptiert den import-Befehl.

// import EM;
import java.math.BigInteger;
import java.math.BigDecimal;
/* ------------------------------------------------------------------------
Programm zum Testen der Klasse EM (Eingabe-Modul).
------------------------------------------------------------------------ */
class EMTst {
   // ---------------------------------------------------------------------
   static void hilf() {
      // Gibt einen kleinen Hilfetext zur Standardausgabe aus. Der Text
      // erlaeutert die Buchstaben b, c, s etc., die der Benutzer als
      // Antwort auf die Frage "Was soll eingelesen werden?" eingeben
      // kann.

      pln("b: byte       | c: char       | s: short   | i: int    | l: long");
      pln("f: float      | d: double     | w: boolean | z: String |");
      pln("I: BigInteger | D: BigDecimal |");
      pln("h: Diese Hilfe| q: quit       |");
   }
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      // Liest wiederholt einen Buchstaben (b, c, s, ...) ein und
      // ruft das entsprechende Unterprogramm auf. Beendet sich,
      // wenn der Benutzer den Buchstaben 'q' eingibt.
      hilf();

      schleife: while (true) {
         p("Was soll eingelesen werden (b, c, s, i ..., h, q)? ");
         char c = (char) EM.liesChar();
         switch (c) {
            case 'b':       byteTst(); break;
            case 'c':       charTst(); break;
            case 's':      shortTst(); break;
            case 'i':        intTst(); break;
            case 'l':       longTst(); break;
            case 'f':      floatTst(); break;
            case 'd':     doubleTst(); break;
            case 'w':    booleanTst(); break;
            case 'z':     stringTst(); break;
            case 'I': bigIntegerTst(); break;
            case 'D': bigDecimalTst(); break;
            case 'h': hilf();          break;
            case 'q':                  break schleife;
            default : hilf();          break;
         } // switch
      } // schleife: while
      pln("EMTst: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   static void byteTst() {
      while (true) {
         p  ("Ein byte-Wert (q zum Beenden)?         ");
         byte byte01 = (byte) EM.liesByte();
         if (byte01 == 'q') break;
         pln("Ihre Eingabe:                          " + byte01);
      }
   } // byteTst
   // ---------------------------------------------------------------------
   static void charTst() {
      while (true) {
         p  ("Ein char-Wert (q zum Beenden)?         ");
         char char01 = (char) EM.liesChar();
         if (char01 == 'q') break;
         pln("Ihre Eingabe:                       -->" + char01 + "<--");
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void shortTst() {
      while (true) {
         p  ("Ein short-Wert (999 zum Beenden)?      ");
         short short01 = EM.liesShort();
         if (short01 == 999) break;
         pln("Ihre Eingabe:                          " + short01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void intTst() {
      while (true) {
         p  ("Ein int-Wert (999 zum Beenden)?        ");
         int int01 = EM.liesInt();
         if (int01 == 999) break;
         pln("Ihre Eingabe:                          " + int01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void longTst() {
      while (true) {
         p  ("Ein long-Wert (999 zum Beenden)?       ");
         long long01 = EM.liesLong();
         if (long01 == 999) break;
         pln("Ihre Eingabe:                          " + long01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void floatTst() {
      while (true) {
         p  ("Ein float-Wert (999 zum Beenden)?      ");
         float float01 = EM.liesFloat();
         if (float01 == 999) break;
         pln("Ihre Eingabe:                          " + float01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void doubleTst() {
      while (true) {
         p  ("Ein double-Wert (999 zum Beenden)?     ");
         double double01 = EM.liesDouble();
         if (double01 == 999) break;
         pln("Ihre Eingabe:                          " + double01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void booleanTst() {
      while (true) {
         p  ("Ein boolean-Wert (false zum Beenden)?  ");
         boolean boolean01 = EM.liesBoolean();
         pln("Ihre Eingabe:                          " + boolean01);
         if (boolean01 == false) break;
      }
   } // charTst
   // ---------------------------------------------------------------------
   static void stringTst() {
      while (true) {
         p  ("Ein string-Wert (q zum Beenden)?       ");
         String string01 = EM.liesString();
         if (string01.equals("q")) break;
         pln("Ihre Eingabe:                       -->" + string01 + "<--");
      }
   } // charTst
   // ---------------------------------------------------------------------
   static final BigInteger BI999 = new BigInteger("999");

   static void bigIntegerTst() {
      while (true) {
         p  ("Ein BigInteger-Wert (999 zum Beenden)? ");
         BigInteger bigInteger01 = EM.liesBigInteger();
         if (bigInteger01.equals(BI999)) break;
         pln("Ihre Eingabe:                          " + bigInteger01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   static final BigDecimal BD999 = new BigDecimal("999");

   static void bigDecimalTst() {
      while (true) {
         p  ("Ein BigDecimal-Wert (999 zum Beenden)? ");
         BigDecimal bigDecimal01 = EM.liesBigDecimal();
         if (bigDecimal01.equals(BD999)) break;
         pln("Ihre Eingabe:                          " + bigDecimal01);
      }
   } // charTst
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class EMTst01