// Datei Ersetzen01.java
/* ------------------------------------------------------------------------
Def. *homonym* ("bezeichnungsgleich"):
Zwei Attribute sind homonym, wenn ihre Namen   gleich sind.
Zwei Methoden  sind homonym, wenn ihre Profile gleich sind.

Vereinbart man in einer Klasse ein Element, welches homonym zu einem
geerbten Element ist, so wird das geerbte Element durch das vereinbarte
Element *ersetzt*. Es gibt zwei Arten von ersetzen:
*verdecken* (engl. to hide) und *ueberschreiben* (engl. to override).

Merke: Ueberschreiben ist "endgueltiger" als verdecken, denn ein Verwender
der Unterklasse kann verdeckte Elemente z.B. mit Cast-Befehlen aufdecken,
aber ueberschriebene Elemente kann er nicht "entueberschreiben".

In diesem Programm wird demonstriert:

Ein  Objektattribut verdeckt      ein  (homonymes, geerbtes) Objektattribut.
Eine Objektmethode  ueberschreibt eine (homonyme,  geerbte)  Objektmethode.
------------------------------------------------------------------------ */
// Die Klasse Mittel erbt zwei Objektelemente att und met und ersetzt sie.
// Das geerbte Objektattribut att wird verdeckt.
// Die geerbte Objektmethode  met wird ueberschrieben.
// Fuer die Klasse Unter gilt ganz Entsprechendes wie fuer Mittel.

class Ober {
   String att = new String("   Ober-Attribut");
   String met() {return    "   Ober-Methode ";}
} // class Ober

class Mittel extends Ober {
   String att = new String(" Mittel-Attribut");
   String met() {return    " Mittel-Methode ";}
} // class Mittel

class Unter  extends Mittel{
   String att = new String("  Unter-Attribut");
   String met() {return    "  Unter-Methode ";}
} // class Unter
// ------------------------------------------------------------------------
class Ersetzen01 {
   static public void main(String [] sonja) {
      // Ueber Referenzvariablen mit unterschiedlichen Typen (verein-
      // barten Typen), aber demselben Zieltypen (momentanen Typ) wird
      // auf Elemente von Unter-Objekten zugegriffen

      // Referenzvariablen mit unterschiedlichen Typen
      // werden vereinbart:
      Ober   oOb = new Unter(); // oOb: Typ Ober,   Zieltyp Unter
      Mittel mOb = new Unter(); // mOb: Typ Mittel, Zieltyp Unter
      Unter  uOb = new Unter(); // uOb: Typ Unter,  Zieltyp Unter

      // Mit diesen Referenzvariablen wird auf die Elemente namens att
      // und met in den 3 Unter-Objekten oOb, mOb und uOb zugegriffen
      // (die Cast-Befehle in den Zeilen D, H und L kann man auch
      // weglassen, sie bewirken "identische Umdeutungen"):
      pln("-----------------------------------");
      pln("A " +           oOb .att + ", " +           oOb .met());
      pln("B " +           mOb .att + ", " +           mOb .met());
      pln("C " +           uOb .att + ", " +           uOb .met());
      pln("-----------------------------------");
      pln("D " + ((  Ober) oOb).att + ", " + ((  Ober) oOb).met());
      pln("E " + ((Mittel) oOb).att + ", " + ((Mittel) oOb).met());
      pln("F " + (( Unter) oOb).att + ", " + (( Unter) oOb).met());
      pln("-----------------------------------");
      pln("G " + ((  Ober) mOb).att + ", " + ((  Ober) mOb).met());
      pln("H " + ((Mittel) mOb).att + ", " + ((Mittel) mOb).met());
      pln("I " + (( Unter) mOb).att + ", " + (( Unter) mOb).met());
      pln("-----------------------------------");
      pln("J " + ((  Ober) uOb).att + ", " + ((  Ober) uOb).met());
      pln("K " + ((Mittel) uOb).att + ", " + ((Mittel) uOb).met());
      pln("L " + (( Unter) uOb).att + ", " + (( Unter) uOb).met());
      pln("-----------------------------------");
      pln("Ersetzen01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Ersetzen01
/* ------------------------------------------------------------------------
Ausgabe des Programms Ersetzen01:

-----------------------------------
A    Ober-Attribut,   Unter-Methode
B  Mittel-Attribut,   Unter-Methode
C   Unter-Attribut,   Unter-Methode
-----------------------------------
D    Ober-Attribut,   Unter-Methode
E  Mittel-Attribut,   Unter-Methode
F   Unter-Attribut,   Unter-Methode
-----------------------------------
G    Ober-Attribut,   Unter-Methode
H  Mittel-Attribut,   Unter-Methode
I   Unter-Attribut,   Unter-Methode
-----------------------------------
J    Ober-Attribut,   Unter-Methode
K  Mittel-Attribut,   Unter-Methode
L   Unter-Attribut,   Unter-Methode
-----------------------------------
Ersetzen01: Das war's erstmal!
------------------------------------------------------------------------ */