// Datei Ersetzen08.java
/* ------------------------------------------------------------------------
Wenn man eine Basisklasse erweitert und Methoden ueberschreibt, sollte
man genau wissen, von welchen Methoden der Basisklasse die ueberschriebenen
Methoden aufgerufen werden.

Die Klasse LongReihungBasis enthaelt zwei Methoden ink und inkAll und
inkAll ruft ink auf.

Die Klasse LongReihung Erweiterung enthaelt ein Attribut anzInk in
dem gezaehlt werden soll, wieviele Reihungkomponenten inkrementiert
wurden. Weil der Programmierer dieser Klasse nicht beruecksichtig hat,
dass die Methode inkAll die Methode ink aufruft, werden die durch
inkAll bewirkten Inkrementierungen doppelt gezaehlt.
------------------------------------------------------------------------ */
class LongReihungBasis {
   // Jedes Objekt dieser Klasse enthaelt eine Reihung von long-Variablen.
   // Die Komponenten dieser Reihung kann man inkrementieren, und zwar
   // einzeln (mit ink) oder alle auf einmal (mit inkAll).

   protected long[] r;
   public  LongReihungBasis(int laenge) {r = new long[laenge];}

   public  void ink(int ind) {
      if (0 <= ind && ind <= r.length) r[ind]++;
   } // ink

   public void inkAll() {
      for (int ind=0; ind<r.length; ind++) {
         ink(ind);
      }
   } // inkAll
} // class LongReihungBasis
// ========================================================================
class LongReihungErweiterung extends LongReihungBasis {
   // Jedes Objekt dieser Klasse soll zaehlen, wie oft eine Komponente
   // seiner long-Reihung r inkrementiert wurde. Die Reihung r ist
   // ein geerbtes, privates Objektattribut.
   private int anzInk = 0;
   public  int getAnzInk() {return anzInk;}

   public LongReihungErweiterung(int laenge) {super(laenge);}

   public void ink(int ind) {
      anzInk++;               // Die Anzahl der Inkrementierungen erhoehen
      super.ink(ind);
   } // ink

   public void inkAll() {
      anzInk += r.length;     // Die Anzahl der Inkrementierungen erhoehen
      super.inkAll();
   } // inkAll
} // LongReihungErweiterung
// ========================================================================
class Ersetzen08 {
   static public void main(String [] sonja) {
      pln("-----------------------------------");
      LongReihungErweiterung rb = new LongReihungErweiterung(3);
      pln("A rb.getAnzInk(): " + rb.getAnzInk());
      rb.ink(0);
      rb.ink(1);
      rb.ink(2);
      pln("B rb.getAnzInk(): " + rb.getAnzInk());
      rb.inkAll();
      pln("C rb.getAnzInk(): " + rb.getAnzInk() + " Wieso nicht 6??");
      pln("-----------------------------------");
      pln("Ersetzen08: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Ersetzen08
/* ------------------------------------------------------------------------
Ausgabe des Programms Ersetzen08:

-----------------------------------
A rb.getAnzInk(): 0
B rb.getAnzInk(): 3
C rb.getAnzInk(): 9 Wieso nicht 6??
-----------------------------------
Ersetzen08: Das war's erstmal!
------------------------------------------------------------------------ */