// Datei Ersetzen09.java
/* ------------------------------------------------------------------------
In einer Unterklasse darf man eine geerbte Methode m nicht durch eine
Methode mit gleicher Signatur, aber ungleichem Rueckgabetyp ueberschreiben.

Zu dieser Regel gibt es eine Ausnahme. Dieses Programm demonstriert die
Regel und die Ausnahme.
------------------------------------------------------------------------ */
class Zweitupel {
   // Jedes Objekt dieser Klasse enthaelt zwei long-Zahlen.
   long zahl1;
   long zahl2;

   // Zwei Objektmethoden mit den Profilen
   // "Double dop double" und "Zweitupel neu long":
   Integer   verdopple (Integer d) {return 2*d;}
   Zweitupel alleGleich(long z)    {return new Zweitupel(z, z);}

   public String toString() {
      return "(" + zahl1 + ", " + zahl2 + ")";
   }

   Zweitupel(long zahl1, long zahl2) {
      this.zahl1 = zahl1;
      this.zahl2 = zahl2;
   } // Konstruktor Zweitupel
} // class Zweitupel
// ========================================================================
class Dreitupel extends Zweitupel {
   // Jedes Objekt dieser Klasse enthaelt drei long-Zahlen
   long zahl3;

   // In der Oberklasse Zweitupel gibt es eine Methode mit der
   // Signatur "long   sum int double". Hier eine Methode mit der
   // Signatur "double sum int double" zu vereinbaren ist deshalb
   // deshalb verboten:
// Number verdopple(Integer d) {return 2*d;} // Fehler

   // In der Oberklasse Zweitupel gibt es eine Methode mit der
   // Signatur "Zweitupel neu long". Hier eine Methode mit der
   // Signatur "Dreitupel new long" zu vereinbaren ist trotzdem
   // als Ausnahme erlaubt (weil Dreitupel eine Erweiterung von
   // Zweitupel ist):
   Dreitupel alleGleich(long z) {return new Dreitupel(z, z, z);}

   public String toString() {
      return "(" + zahl1 + ", " + zahl2 + ", " + zahl3 + ")";
   }

   Dreitupel(long zahl1, long zahl2, long zahl3) {
      super(zahl1, zahl2);
      this.zahl3 = zahl3;
   } // Konstruktor Dreitupel
} // class Dreitupel
// ========================================================================
class Ersetzen09 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      Zweitupel z01 = new Zweitupel(10, 20);
      Dreitupel d01 = new Dreitupel(30, 40, 50);

      printf("----------------------------------%n");
      printf("A z01               : %s%n", z01);
      printf("B d01               : %s%n", d01);
      printf("----------------------------------%n");
      printf("C z01.verdopple (3) : %d%n", z01.verdopple (3));
      printf("D z01.alleGleich(2) : %s%n", z01.alleGleich(2));
      printf("E d01.alleGleich(3) : %s%n", d01.alleGleich(3));
      printf("----------------------------------%n");
      printf("Ersetzen09: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Ersetzen09
/* ------------------------------------------------------------------------
Fehlermeldung des Compilers javac von Sun, wenn die entsprechende Zeile
kein Kommentar ist:

D:\meineDateien\BspJaSp\Ersetzen09.java:37: verdopple(java.lang.Integer)
in Dreitupel cannot override verdopple(java.lang.Integer) in Zweitupel;
attempting to use incompatible return type
found   : java.lang.Number
required: java.lang.Integer
   Number verdopple(Integer d) {return 2*d;} // Fehler
          ^
---------------------------------------------------------------------------
Ausgabe des Programms Ersetzen09:

----------------------------------
A z01               : (10, 20)
B d01               : (30, 40, 50)
----------------------------------
C z01.verdopple (3) : 6
D z01.alleGleich(2) : (2, 2)
E d01.alleGleich(3) : (3, 3, 3)
----------------------------------
Ersetzen09: Das war's erstmal!
------------------------------------------------------------------------ */
