// Datei Faden01.java
/* ------------------------------------------------------------------------
Die Klasse Faden01 erweitert die Klass Thread. Deshalb ist jedes
Faden01-Objekt ein Faden (thread), der nebenlaeufig zu anderen Faeden
ausgefuehrt wird

Im Programm Faden01Tst werden zwei Faeden des Typs Faden01 erzeugt und
gestartet. Diese Faeden geben um die Wette Meldungen zur Stanardausgabe
aus und schlafen zwischendurch eine zufaellige Anzahl von Millisekunden.
------------------------------------------------------------------------ */
import java.util.Random;

class Faden01 extends Thread {
   // ---------------------------------------------------------------------
   static Random r01 = new Random(); // Ein Zufallszahlengenerator

   public void run() {
      String name   = getName();
      int    millis = 0;

      for (int i=1; i<=5; i++) {
         pln(i + ". " + name + ", msec: " + millis);
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 500 nach millis bringen:
            millis =  r01.nextInt(500);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            sleep(millis);
         } catch (InterruptedException ie) {
            pln(ie);
         } // catch
      } // for
   } // run
   // ---------------------------------------------------------------------
   // Zwei Konstruktoren:
   Faden01(String name) {super(name);}     // "Selbstgewaehlter" Name
   Faden01()            {super();}         // Name wird automatisch erzeugt
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
} // class Faden01
// ========================================================================
class Faden01Tst {
   static public void main(String [] sonja) {
      Faden01 f1 = new Faden01();          // Name wird automatisch erzeugt
      Faden01 f2 = new Faden01(" Faden-1");// "Selbstgewaehlter" Name
      f1.start();
      f2.start();
   } // main
   // ---------------------------------------------------------------------
} // class Faden01Tst
/* ------------------------------------------------------------------------
Drei moegliche Ausgabe des Programms Faden01Tst:

| 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   |
| 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   |
| 2.  Faden-1, msec: 50  | 2. Thread-0, msec: 204 | 2. Thread-0, msec: 157 |
| 3.  Faden-1, msec: 36  | 2.  Faden-1, msec: 433 | 2.  Faden-1, msec: 206 |
| 4.  Faden-1, msec: 42  | 3.  Faden-1, msec: 65  | 3. Thread-0, msec: 65  |
| 2. Thread-0, msec: 195 | 3. Thread-0, msec: 463 | 3.  Faden-1, msec: 159 |
| 5.  Faden-1, msec: 380 | 4.  Faden-1, msec: 486 | 4.  Faden-1, msec: 100 |
| 3. Thread-0, msec: 420 | 5.  Faden-1, msec: 53  | 4. Thread-0, msec: 479 |
| 4. Thread-0, msec: 76  | 4. Thread-0, msec: 409 | 5.  Faden-1, msec: 373 |
| 5. Thread-0, msec: 43  | 5. Thread-0, msec: 226 | 5. Thread-0, msec: 194 |
------------------------------------------------------------------------ */
