// Datei Faden02Tst.java
/* ------------------------------------------------------------------------
Die Klasse Faden02 implementiert die Schnittstelle Runnable. Deshalb
enthaelt jedes Faden02-Objekt eine run-Methode, die man von einem
Thread-Objekt nebenlaeufig zu anderen Faeden (threads) ausfuehren
lassen kann.

Im Programm Faden02Tst werden zwei Faden02-Objekte namens r1 und r2
erzeugt. Ausserdem werden zwei Thread-Objekte namens f1 und f2 er-
zeugt, mit der Ausfuehrung der Methoden r1.run bzw. r2.run beauftragt
und gestartet. Die run-Methoden (und somit die Faeden f1 und f2)
geben um die Wette Meldungen zur Stanardausgabe aus und schlafen
zwischendurch eine zufaellige Anzahl von Millisekunden.

Diese Datei hat einige Aehnlichkeit mit der Datei Faden01Tst.java.
Zeilen, die hier anders sind als dort sind mit dem Kommentar "// <---"
gekennzeichnet.
------------------------------------------------------------------------ */
import java.util.Random;

class Faden02 implements Runnable {
   // ---------------------------------------------------------------------
   static Random r01 = new Random(); // Ein Zufallszahlengenerator

   public void run() {
      String name   = Thread.currentThread().getName();            //  <---
      int    millis = 0;

      for (int i=1; i<=5; i++) {
         pln(i + ". " + name + ", msec: " + millis);
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 500 nach millis bringen:
            millis =  r01.nextInt(500);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            Thread.sleep(millis);                                  // <---
         } catch (InterruptedException ie) {
            pln(ie);
         } // catch
      } // for
   } // run
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
} // class Faden02
// ========================================================================
class Faden02Tst {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      Runnable r1 = new Faden02();                                 //  <---
      Runnable r2 = new Faden02();                                 //  <---
      Thread   f1 = new Thread(r1);                                //  <---
      Thread   f2 = new Thread(r2, " Faden-1");                    //  <---
      f1.start();
      f2.start();
   } // main
   // ---------------------------------------------------------------------
} // class Faden02Tst
/* ------------------------------------------------------------------------
Drei moegliche Ausgabe des Programms Faden02Tst:

| 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   |
| 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   |
| 2. Thread-0, msec: 67  | 2.  Faden-1, msec: 187 | 2. Thread-0, msec: 204 |
| 2.  Faden-1, msec: 379 | 3.  Faden-1, msec: 122 | 2.  Faden-1, msec: 395 |
| 3. Thread-0, msec: 317 | 2. Thread-0, msec: 340 | 3. Thread-0, msec: 359 |
| 4. Thread-0, msec: 102 | 3. Thread-0, msec: 451 | 3.  Faden-1, msec: 252 |
| 5. Thread-0, msec: 89  | 4.  Faden-1, msec: 496 | 4.  Faden-1, msec: 280 |
| 3.  Faden-1, msec: 394 | 5.  Faden-1, msec: 259 | 4. Thread-0, msec: 394 |
| 4.  Faden-1, msec: 389 | 4. Thread-0, msec: 344 | 5.  Faden-1, msec: 135 |
| 5.  Faden-1, msec: 463 | 5. Thread-0, msec: 380 | 5. Thread-0, msec: 244 |
------------------------------------------------------------------------ */