// Datei Faden03Tst.java
/* ------------------------------------------------------------------------
Drei Faeden geben um die Wette Meldungen zur Standardausgabe aus.
Dazu wird die Klasse Thread erweitert.
Eine Variante der Klasse Faden01
------------------------------------------------------------------------ */
import java.util.Random;

class Faden03 extends Thread {
   static Random r01 = new Random(); // Ein Zufallszahlengenerator
   // ---------------------------------------------------------------------
   static public void machWas(String name) {
      int millis = 0;
      for (int i=1; i<=5; i++) {
         pln(i + ". " + name + ", msec: " + millis);
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 500 nach millis bringen:
            millis =  r01.nextInt(500);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            sleep(millis);
         } catch (InterruptedException ie) {
            pln(ie);
         } // catch
      } // for
   } // machWas
   // ---------------------------------------------------------------------
   public void run() {
      String name = getName();
      machWas(name);
   } // run
   // ---------------------------------------------------------------------
   // Zwei Konstruktoren:
   Faden03(String name) {super(name);}     // "Selbstgewaehlter" Name
   Faden03()            {super();}         // Name wird automatisch erzeugt
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Faden03
// ========================================================================
class Faden03Tst {
   static public void main(String [] sonja) {
      Faden03 f1 = new Faden03();          // Name wird automatisch erzeugt
      Faden03 f2 = new Faden03(" Faden-1");// "Selbstgewaehlter" Name
      f1.start();
      f2.start();
      String name = Thread.currentThread().getName();
      Faden03.machWas("    " + name);
   } // main
   // ---------------------------------------------------------------------
} // class Faden03Tst
/* ------------------------------------------------------------------------
Drei moegliche Ausgabe des Programms Faden03Tst:

| 1.     main, msec: 0   | 1.     main, msec: 0   | 1.     main, msec: 0   |
| 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   | 1. Thread-0, msec: 0   |
| 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   | 1.  Faden-1, msec: 0   |
| 2.  Faden-1, msec: 23  | 2.  Faden-1, msec: 248 | 2.     main, msec: 225 |
| 2. Thread-0, msec: 172 | 2.     main, msec: 369 | 2.  Faden-1, msec: 234 |
| 3.  Faden-1, msec: 283 | 2. Thread-0, msec: 454 | 3.     main, msec: 196 |
| 3. Thread-0, msec: 164 | 3.  Faden-1, msec: 277 | 2. Thread-0, msec: 417 |
| 4.  Faden-1, msec: 33  | 3. Thread-0, msec: 130 | 3. Thread-0, msec: 143 |
| 2.     main, msec: 353 | 3.     main, msec: 393 | 4.     main, msec: 188 |
| 5.  Faden-1, msec: 64  | 4. Thread-0, msec: 367 | 3.  Faden-1, msec: 488 |
| 3.     main, msec: 66  | 4.  Faden-1, msec: 476 | 5.     main, msec: 315 |
| 4.     main, msec: 195 | 5.  Faden-1, msec: 88  | 4. Thread-0, msec: 374 |
| 5.     main, msec: 165 | 4.     main, msec: 461 | 5. Thread-0, msec: 135 |
| 4. Thread-0, msec: 444 | 5.     main, msec: 150 | 4.  Faden-1, msec: 368 |
| 5. Thread-0, msec: 478 | 5. Thread-0, msec: 432 | 5.  Faden-1, msec: 57  |
------------------------------------------------------------------------ */