// Datei Faden04Tst.java
/* ------------------------------------------------------------------------
Faden-Objekte (thread objects) kann man auch als Komponenten einer
Reihung (array) erzeugen und verwalten. Das ist insbesondere dann
nuetzlich, wenn man sehr viele Faeden erzeugen und verwalten will.

Dieses Programm Faden04Tst erwartet als Kommandozeilenparameter
zwei Ganzzahlen, z.B. so:

> java Faden04Tst  4  20

In diesem Fall werden dann 4 Faeden gestartet und jeder gibt 20 mal
seinen Namen (FA, FB, FC bzw. FD) und eine lfd. Nr. zwischen 1 und 20
zur Standardausgabe aus.
------------------------------------------------------------------------ */
import java.util.Random;

class Faden04 implements Runnable {

   static Random r01 = new Random();
   // ---------------------------------------------------------------------
   private final   int wieOft;
   public  Faden04(int wieOft) {this.wieOft = wieOft;}
   // ---------------------------------------------------------------------
   public void run() {
      for (int i=1; i<=wieOft; i++) {
         String ausgabe = Thread.currentThread().getName() + i + "   ";
         // Immer 5 Zeichen ausgeben, unabhaengig von Stelligkeit von i:
         p(ausgabe.substring(0, 5));
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 1000 nach millis bringen:
            int millis = r01.nextInt(1000);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            Thread.sleep(millis);
         } catch (InterruptedException ie) {
            pln(ie);
         } // catch
      } // for
   } // run
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Faden04
// ========================================================================
class Faden04Tst {
   static int    anzahl =  4; // Anzahl der Faeden
   static int    wieOft = 20; // Wie oft soll jeder eine Meldung ausgeben?

   static public void main(String [] sonja) {
      // 2 Kommandozeilenparameter holen (falls vorhanden):
      if (sonja.length == 2) {
         anzahl = Integer.parseInt(sonja[0]);
         wieOft = Integer.parseInt(sonja[1]);
      }

      Runnable[] rr = new Faden04[anzahl]; // Reihung von Runnable-Ob.
      Thread  [] tr = new Thread [anzahl]; // Reihung von Thread-Ob.
      char        c = 'A'; // Der erste Faden wird FA heissen

      // anzahl viele Faden04-Objekte und Thread-Objekte erzeugen und
      // die Thread-Objekte starten:
      for (int i=0; i<anzahl; i++) {
         rr[i] = new Faden04(wieOft);
         tr[i] = new Thread(rr[i], ("F" + c++));
         tr[i].start();
      }
   } // main
   // ---------------------------------------------------------------------
} // class Faden04Tst
/* ------------------------------------------------------------------------
Eine moegliche Ausgabe des Programms Faden04Tst (nachtraeglich von Hand um-
gebrochen):

FA1  FB1  FC1  FD1  FB2  FA2  FD2  FA3  FA4  FC2  FB3  FB4  FD3  FB5  FC3  FA5
FB6  FA6  FD4  FD5  FD6  FC4  FA7  FB7  FD7  FA8  FC5  FA9  FA10 FC6  FB8  FB9
FD8  FB10 FC7  FD9  FA11 FD10 FD11 FC8  FA12 FB11 FD12 FC9  FB12 FC10 FD13 FA13
FD14 FA14 FB13 FD15 FD16 FC11 FD17 FA15 FC12 FB14 FB15 FC13 FD18 FB16 FA16 FA17
FB17 FD19 FA18 FC14 FA19 FB18 FB19 FA20 FD20 FB20 FC15 FC16 FC17 FC18 FC19 FC20
------------------------------------------------------------------------ */