// Datei Faden05Tst.java
/* ------------------------------------------------------------------------
Ein Faden namens A versucht, die globale Variable text mit lauter 'A's zu
fuellen und dann auszugeben. Nebenlaeufig dazu versucht ein Faden namens B,
dieselbe Variable text mit lauter 'B's zu fuellen und auszugeben. Die Aus-
gaben enthalten manchmal inkonsistente Kombinationen von 'A's und 'B's
------------------------------------------------------------------------ */
import java.util.Random;

class Faden05 implements Runnable {
   // Die globale Variable text soll mit Daten gefuellt werden:
   static private StringBuilder text =
      new StringBuilder("XXXXXXXXXXXXXXXXXXXX");
   // ---------------------------------------------------------------------
   static public void fuelleUndDrucke(StringBuilder sb, char zeichen) {
      // Fuellt die Variable sb mit dem zeichen und gibt sie aus:
      for (int j=0, laenge=sb.length(); j<laenge; j++) {
         sb.setCharAt(j, zeichen);
         schlaf(10);                             // maximal 10 Millis
      } // for
      p("Faden " + zeichen + ": " + text + " ");
   } // fuelleUndDrucke
   // ---------------------------------------------------------------------
   public void run() {
      String name = Thread.currentThread().getName(); // "A" bzw. "B"
      char   erst = name.charAt(0);                   // 'A' bzw. 'B'

      for (int i=1; i<=10; i++) {
         fuelleUndDrucke(text, erst);
         pln(i);
         schlaf(1000);                           // maximal 1000 Millis
      } // for
   } // run
   // ---------------------------------------------------------------------
   static Random r01 = new Random();
   static void schlaf(int maxMillis) {
      // Legt den aufrufenden Faden eine zufaellige Anzahl von Millisek.
      // (zwischen 0 und maxMillis) schlafen.
      try {
         Thread.sleep(r01.nextInt(maxMillis));
      } catch (InterruptedException ie) {
         pln(ie);
      } // catch
   } // schlaf
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Faden05
// ========================================================================
class Faden05Tst {
   static public void main(String [] sonja) {
      Runnable r1 = new Faden05();
      Runnable r2 = new Faden05();
      Thread   f1 = new Thread(r1, "A");
      Thread   f2 = new Thread(r2, "B");
      f1.start();
      f2.start();
   } // main
} // class Faden05Tst
/* ------------------------------------------------------------------------
Zwei moegliche Ausgabe des Programms Faden05Tst:

| Faden B: BAAAAAAABAAAAAAAAABB 1  | Faden B: BAAAAAAAAAAAAAAAAABB 1  |
| Faden A: BAAAAAAABAAAAAAAAAAA 1  | Faden A: BAAAAAAAAAAAAAAAAAAA 1  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 2  | Faden A: AAAAAAAAAAAAAAAAAAAA 2  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 2  | Faden B: BBBBBBBBBBBBBBBBBBBB 2  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 3  | Faden A: AAAAAAAAAAAAAAAAAAAA 3  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 4  | Faden A: BBAAAAAAAAAAAAAAAAAA 4  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 3  | Faden B: BBBBBBBBBBBBBBBBBBBB 3  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 5  | Faden B: AAAAABBBBBBBBBBBBBBB 4  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 6  | Faden A: AAAAAAAAAAAAAAAAAAAA 5  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 4  | Faden A: AAAAAAAAAAAAAAAAAAAA 6  |
| Faden A: AAAABABBAABAAABBAABB 7  | Faden A: AAAAAAAAAAAAAAAAAAAA 7  |
| Faden B: AAAABABBAABAAABBAABB 5  | Faden B: AAAAAAAAAAAAAABABAAB 5  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 8  | Faden A: AAAAAAAAAAAAAABABAAA 8  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 9  | Faden B: BBBBBBBBBBBBBBBBBBBB 6  |
| Faden A: AAAAAAAAAAAAAAAAAAAA 10 | Faden B: BBBBBBBBBBBBBBBBBBBB 7  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 6  | Faden B: BBBBBBBBBBBBBBBBBBBB 8  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 7  | Faden A: BBBAAAAAAAAAAAAAAAAA 9  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 8  | Faden B: BBBBBBBBBBBBBBBBBBBB 9  |
| Faden B: BBBBBBBBBBBBBBBBBBBB 9  | Faden A: AAAAAAAAAAAAAAAAAAAA 10 |
| Faden B: BBBBBBBBBBBBBBBBBBBB 10 | Faden B: BBBBBBBBBBBBBBBBBBBB 10 |
------------------------------------------------------------------------ */
