// Datei Faden08Tst.java
/* ------------------------------------------------------------------------
Die Klasse Faden08 erweitert die Klass Thread. Deshalb ist jedes
Faden08-Objekt ein Faden (thread), der nebenlaeufig zu anderen Faeden
ausgefuehrt wird

Im Programm Faden08Tst werden zwei Faeden des Typs Faden08 erzeugt und
gestartet. Diese Faeden geben um die Wette Meldungen zur Stanardausgabe
aus und schlafen zwischendurch eine zufaellige Anzahl von Millisekunden.
------------------------------------------------------------------------ */
import java.util.Random;

class Faden08 extends Thread {
   // ---------------------------------------------------------------------
   static int    znr = 0;
   static Random r01 = new Random(); // Ein Zufallszahlengenerator

   public void run() {
      String name   = getName();
      int    millis = 0;

      for (int i=1; i<=5; i++) {
         printf("%2d. Zeile, i=%d von %s\n", ++znr, i, name);
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 500 nach millis bringen:
            millis =  r01.nextInt(500);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            sleep(millis);
         } catch (InterruptedException ie) {
            printf("%s\n", ie);
         } // catch
      } // for
   } // run
   // ---------------------------------------------------------------------
   // Zwei Konstruktoren:
   Faden08(String name) {super(name);}     // "Selbstgewaehlter" Name
   Faden08()            {super();}         // Name wird automatisch erzeugt
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Faden08
// ========================================================================
class Faden08Tst {
   static public void main(String [] sonja) {
      Faden08 f1 = new Faden08();          // Name wird automatisch erzeugt
      Faden08 f2 = new Faden08(" Faden-1");// "Selbstgewaehlter" Name
      f1.start();
      f2.start();
   } // main
   // ---------------------------------------------------------------------
} // class Faden08Tst
/* ------------------------------------------------------------------------
Zwei moegliche Ausgabe des Programms Faden08Tst:

|  1. Zeile, i=1 von Thread-0 |  1. Zeile, i=1 von Thread-0 |
|  2. Zeile, i=1 von  Faden-1 |  2. Zeile, i=1 von  Faden-1 |
|  3. Zeile, i=2 von Thread-0 |  3. Zeile, i=2 von  Faden-1 |
|  4. Zeile, i=3 von Thread-0 |  4. Zeile, i=2 von Thread-0 |
|  5. Zeile, i=4 von Thread-0 |  5. Zeile, i=3 von  Faden-1 |
|  6. Zeile, i=2 von  Faden-1 |  6. Zeile, i=4 von  Faden-1 |
|  7. Zeile, i=5 von Thread-0 |  7. Zeile, i=3 von Thread-0 |
|  8. Zeile, i=3 von  Faden-1 |  8. Zeile, i=4 von Thread-0 |
|  9. Zeile, i=4 von  Faden-1 |  9. Zeile, i=5 von  Faden-1 |
| 10. Zeile, i=5 von  Faden-1 | 10. Zeile, i=5 von Thread-0 |
------------------------------------------------------------------------ */
