// Datei Faden09Tst.java
/* ------------------------------------------------------------------------
Eine Fadengruppe (ein Objekt der Klasse ThreadGroup) kann Faeden und/oder
Fadengruppen enthalten (aehnlich wie ein Verzeichnis Dateien und Verzeich-
nisse enthalten kann).
------------------------------------------------------------------------ */
import java.util.Random;

class Faden09 extends Thread {
   // ---------------------------------------------------------------------
   static Random r01 = new Random(); // Ein Zufallszahlengenerator

   public void run() {
      String gName = getThreadGroup().getName(); // Gruppen-Name
      String fName = getName();                  //   Faden-Name
      int    millis = 0;

      for (int i=1; i<=5; i++) {
         p(gName + "-" + fName + "-" + i + " ");
         try {
            // Eine zufaellige Ganzzahl zwischen
            // 0 und 500 nach millis bringen:
            millis =  r01.nextInt(500);
            // Den aktuellen Faden mindestens
            // millis Millisekunden schlafen lassen:
            sleep(millis);
         } catch (InterruptedException ie) {
            pln(ie);
         } // catch
      } // for
   } // run
   // ---------------------------------------------------------------------
   // Zwei Konstruktoren:
   Faden09(ThreadGroup tg, String name) {super(tg, name);}     // "Selbstgewaehlter" Name
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
} // class Faden09
// ========================================================================
class Faden09Tst {
   static public void main(String [] sonja) {

      // Die Fadengruppe MF enthaelt zwei Untergruppen GB und KB:
      ThreadGroup MF = new ThreadGroup("MF");     // Meine Faeden
      ThreadGroup GB = new ThreadGroup(MF, "GB"); // GrossBuchstaben
      ThreadGroup KB = new ThreadGroup(MF, "KB"); // KleinBuchstaben

      // Die Fadengruppe GB enthaelt 3 Faeden namen A, B und C:
      Faden09     A  = new Faden09(GB, "A");
      Faden09     B  = new Faden09(GB, "B");
      Faden09     C  = new Faden09(GB, "C");

      // Die Fadengruppe KB enthaelt 2 Faeden namens a und b:
      Faden09     a  = new Faden09(KB, "a");
      Faden09     b  = new Faden09(KB, "b");

      // Alle Faeden starten:
      A.start();
      B.start();
      C.start();
      a.start();
      b.start();

   } // main
   // ---------------------------------------------------------------------
} // class Faden09Tst
/* ------------------------------------------------------------------------
Eine moegliche Ausgabe des Programms Faden09Tst:

GB-A-1 GB-B-1 GB-C-1 KB-a-1 KB-b-1 GB-B-2 GB-C-2 GB-A-2 GB-A-3 KB-a-2
KB-b-2 GB-A-4 GB-B-3 KB-b-3 GB-A-5 KB-a-3 GB-C-3 GB-B-4 KB-a-4 GB-B-5
KB-b-4 KB-a-5 KB-b-5 GB-C-4 GB-C-5
------------------------------------------------------------------------ */
