// Datei FarbeAK.java
/* ------------------------------------------------------------------------
Diese Klasse deutet an, wie man *vor* der Java-Version 5.0 Aufzaehlungs-
typen selbst vereinbaren konnte. "AK" soll an "alte Klasse" oder an
"Aufzaehlungstyp selbst als Klasse vereinbart" erinnern.

Diese Klasse stellt ihren Verwendern vor allem drei unveraenderbare
Variablen namens ROT, GRUEN und BLAU zur Verfuegung, die man als
"Werte eines Aufzaehlungstyps" verstehen und benutzen kann.

Siehe auch die Schnittstelle FarbeAS.
------------------------------------------------------------------------ */
class FarbeAK {
   // ---------------------------------------------------------------------
   private final String NAME;

   public String toString() {return NAME;}
   // ---------------------------------------------------------------------
   static public final FarbeAK ROT   = new FarbeAK("rot");
   static public final FarbeAK GRUEN = new FarbeAK("gruen");
   static public final FarbeAK BLAU  = new FarbeAK("blau");
   // ---------------------------------------------------------------------
   // Ein *privater* Konstruktor, damit der Ausfuehrer der Klasse keinen
   // oeffentlichen (Standard-) Konstruktor schenkt. So wird verhindert,
   // dass Verwender dieser Klasse weitere Objekte erzeugen.
   private FarbeAK(String name) {
      NAME = name;
   } // Konstruktor FarbeAK
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      pln("FarbeAK: Jetzt geht es los!");
      pln("FarbeAK: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class FarbeAK
