// Datei For05.java
/* ------------------------------------------------------------------------
for-Schleifen mit leeren Teilen.

Erlaeuterung: Die Ausfuehrung einer for-Schleife wird normal beendet,
wenn die Bedingung der Schleife den Wert false hat. Wenn die Bedingung
vom Programmierer leer gelassen wird, kann sie nie den Wert false
haben und somit kann eine for-Schleife mit leerer Bedingung nicht normal
beendet werden. Eine solche Schleife sollte durch eine break-Anweisung
oder durch eine Ausnahme beendet werden.
------------------------------------------------------------------------ */
class For05 {
   // ---------------------------------------------------------------------
   static int leereTeileA(int n) {
      // Der Wert von n wird solange verdoppelt, bis er groesser
      // als 1000 ist. Dann wird er als Ergebnis geliefert.

      // Eine for-Schleife mit leerem Initialisierungsteil und
      // leerem Rumpf:
      for (; n<1000; n=2*n) {}

      return n;
   } // leereTeileA
   // ---------------------------------------------------------------------
   static int leereTeileB(int n) {
      // Der Wert von n wird solange verdoppelt, bis er groesser
      // als 1000 ist. Dann wird er als Ergebnis geliefert.

      // Eine for-Schleife mit leerem Initialisierungsteil und
      // leerer Bedingung:
      for ( ; ; n=2*n) {
         if (n>1000) break;
      }

      return n;
   } // leereTeileB
   // ---------------------------------------------------------------------
   static int leereTeileC(int n) {
      // Der Wert von n wird solange verdoppelt, bis er groesser
      // als 1000 ist. Dann wird er als Ergebnis geliefert.

      // Eine for-Schleife mit leerem Initialisierungsteil,
      // leerer Bedingung und leerem Fortschaltungsteil:
      for (;;) {
         n = 2*n;
         if (n>1000) break;
      }

      return n;
   } // leereTeileC
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {

      pln("A " + leereTeileA(2));
      pln("B " + leereTeileB(2));
      pln("C " + leereTeileC(2));
      pln("-------------------------");
      pln("For05: Das war's erstmal!");
   } // main
} // class For05
/* ------------------------------------------------------------------------
Ausgabe des Programms For05:

A 1024
B 1024
C 1024
-------------------------
For05: Das war's erstmal!
------------------------------------------------------------------------ */