// Datei Format01.java
/* ------------------------------------------------------------------------
Ganzzahlen mit printf und %d formatieren und ausgeben.
Mit %d duerfen Werte der folgenden Ganzzahltypen formatiert werden:
byte, Byte, short, Short, int, Integer, long, Long und BigInteger.

Dieses Programm gibt einige printf-Befehle und ihre Ergebnisse
zum Bildschirm aus. Der Programmtext ist relativ schwer, aber die
Ausgabe des Programms (hoffentlich) relativ leicht zu lesen.
------------------------------------------------------------------------ */
import java.math.BigInteger;

class Format01 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Format01: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      // Ganzzahlvariablen verschiedener Typen mit den
      // Werten 123 und -123:
      byte       b1p =  123;
      byte       b1m = -123;
      short      s1p =  123;
      short      s1m = -123;
      int        i1p =  123;
      int        i1m = -123;
      long       l1p =  123;
      long       l1m = -123;

      Byte       B1p =  123;
      Byte       B1m = -123;
      Short      S1p =  123;
      Short      S1m = -123;
      Integer    I1p =  123;
      Integer    I1m = -123;
      Long       L1p =  123L;
      Long       L1m = -123L;

      BigInteger BIp = new BigInteger("123");
      BigInteger BIm = new BigInteger("-123");
      // ------------------------------------------------------------------
      // Text-Strings, die einen printf-Befehl darstellen:
      String ts01 = "printf(\"-->%%d<--\",    %s): ";
      String ts02 = "printf(\"-->%%6d<--\",   %s): ";
      String ts03 = "printf(\"-->%%+6d<--\",  %s): ";
      String ts04 = "printf(\"-->%% 6d<--\",  %s): ";
      String ts05 = "printf(\"-->%%-6d<--\",  %s): ";
      String ts06 = "printf(\"-->%%+-6d<--\", %s): ";
      String ts07 = "printf(\"-->%% -6d<--\", %s): ";

      // Format-Strings fuer einen printf-Befehl:
      String fs01 = "-->%d<--%n";
      String fs02 = "-->%6d<--%n";   // Breite 6
      String fs03 = "-->%+6d<--%n";  // Breite 6, Vorzeich. +/-
      String fs04 = "-->% 6d<--%n";  // Breite 6, Vorzeich. Blank/-
      String fs05 = "-->%-6d<--%n";  // Breite 6, linksbuendig
      String fs06 = "-->%+-6d<--%n"; // Breite 6, linksbuendig, Vorz. +/-
      String fs07 = "-->% -6d<--%n"; // Breite 6, linksbuendig, Vorz. Blank/-

      // Als Beispiele werden die Variablen b1p, b1m, BIp und BIm mit
      // verschiedenen Formatstrings formatiert und ausgegeben.
      // Genauso kann man auch andere Ganzzahlvariablen (z.B.
      // s1p, s1m, i1p, i1m, B1p, B1m etc.) bearbeiten.
      printf("----------------------------%n");
      printf("A " + ts01, "b1p"); printf(fs01, b1p);
      printf("B " + ts01, "b1m"); printf(fs01, b1m);
      printf("C " + ts02, "b1p"); printf(fs02, b1p);
      printf("D " + ts02, "b1m"); printf(fs02, b1m);
      printf("E " + ts03, "b1p"); printf(fs03, b1p);
      printf("F " + ts03, "b1m"); printf(fs03, b1m);
      printf("G " + ts04, "b1p"); printf(fs04, b1p);
      printf("H " + ts04, "b1m"); printf(fs04, b1m);
      printf("I " + ts05, "b1p"); printf(fs05, b1p);
      printf("J " + ts05, "b1m"); printf(fs05, b1m);
      printf("K " + ts06, "b1p"); printf(fs06, b1p);
      printf("L " + ts06, "b1m"); printf(fs06, b1m);
      printf("M " + ts07, "b1p"); printf(fs07, b1p);
      printf("N " + ts07, "b1m"); printf(fs07, b1m);
      printf("----------------------------%n");
      printf("O " + ts01, "BIp"); printf(fs01, BIp);
      printf("P " + ts01, "BIm"); printf(fs01, BIm);
      printf("Q " + ts02, "BIp"); printf(fs02, BIp);
      printf("R " + ts02, "BIm"); printf(fs02, BIm);
      printf("S " + ts03, "BIp"); printf(fs03, BIp);
      printf("T " + ts03, "BIm"); printf(fs03, BIm);
      printf("U " + ts04, "BIp"); printf(fs04, BIp);
      printf("V " + ts04, "BIm"); printf(fs04, BIm);
      printf("V " + ts05, "BIp"); printf(fs05, BIp);
      printf("X " + ts05, "BIm"); printf(fs05, BIm);
      printf("Y " + ts06, "BIp"); printf(fs06, BIp);
      printf("Z " + ts06, "BIm"); printf(fs06, BIm);
      printf("a " + ts07, "BIp"); printf(fs07, BIp);
      printf("b " + ts07, "BIm"); printf(fs07, BIm);
      printf("----------------------------%n");
      printf("Format01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
} // Format01
/* ------------------------------------------------------------------------
Ausgabe des Programms Format01:

Format01: Jetzt geht es los!
----------------------------
A printf("-->%d<--",    b1p): -->123<--
B printf("-->%d<--",    b1m): -->-123<--
C printf("-->%6d<--",   b1p): -->   123<--
D printf("-->%6d<--",   b1m): -->  -123<--
E printf("-->%+6d<--",  b1p): -->  +123<--
F printf("-->%+6d<--",  b1m): -->  -123<--
G printf("-->% 6d<--",  b1p): -->   123<--
H printf("-->% 6d<--",  b1m): -->  -123<--
I printf("-->%-6d<--",  b1p): -->123   <--
J printf("-->%-6d<--",  b1m): -->-123  <--
K printf("-->%+-6d<--", b1p): -->+123  <--
L printf("-->%+-6d<--", b1m): -->-123  <--
M printf("-->% -6d<--", b1p): --> 123  <--
N printf("-->% -6d<--", b1m): -->-123  <--
----------------------------
O printf("-->%d<--",    BIp): -->123<--
P printf("-->%d<--",    BIm): -->-123<--
Q printf("-->%6d<--",   BIp): -->   123<--
R printf("-->%6d<--",   BIm): -->  -123<--
S printf("-->%+6d<--",  BIp): -->  +123<--
T printf("-->%+6d<--",  BIm): -->  -123<--
U printf("-->% 6d<--",  BIp): -->   123<--
V printf("-->% 6d<--",  BIm): -->  -123<--
V printf("-->%-6d<--",  BIp): -->123   <--
X printf("-->%-6d<--",  BIm): -->-123  <--
Y printf("-->%+-6d<--", BIp): -->+123  <--
Z printf("-->%+-6d<--", BIm): -->-123  <--
a printf("-->% -6d<--", BIp): --> 123  <--
b printf("-->% -6d<--", BIm): -->-123  <--
----------------------------
Format01: Das war's erstmal!
------------------------------------------------------------------------ */
