// Datei Format03.java
/* ------------------------------------------------------------------------
Bruchzahlen mit printf und %g formatieren und ausgeben.
Mit %g duerfen Werte der folgenden Bruchzahltypen formatiert werden:
float, Float, double, Double und BigDecimal

Dieses Programm gibt einige printf-Befehle und die Ergebnisse, die sie
zum Bildschirm ausgeben, zum Bildschirm aus.
------------------------------------------------------------------------ */
import java.math.BigDecimal;

class Format03 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Format03: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      // Ganzzahlvariablen verschiedener Typen mit den
      // Werten 123 und -123:
      float      f1p =  12.345F;
      float      f1m = -12.345F;
      float      f2p =  76.543e12F;
      float      f2m = -76.543e12F;

      double     d1p =  12.345;
      double     d1m = -12.345;
      double     d2p =  76.543e12;
      double     d2m = -76.543e12;

      BigDecimal B1p = new BigDecimal( "12.345");
      BigDecimal B1m = new BigDecimal("-12.345");
      BigDecimal B2p = new BigDecimal( "76.543e12");
      BigDecimal B2m = new BigDecimal("-76.543e12");
      // ------------------------------------------------------------------
      // Text-Strings, die einen printf-Befehl darstellen:
      String ts01 = "printf(\"-->%%+g<--\",     %s): ";
      String ts02 = "printf(\"-->%%+11g<--\",   %s): ";
      String ts03 = "printf(\"-->%%+11.4g<--\", %s): ";
      String ts04 = "printf(\"-->%%+11.2g<--\", %s): ";
      String ts05 = "printf(\"-->%%+10.4g<--\", %s): ";
      String ts06 = "printf(\"-->%%+10.2g<--\", %s): ";
      String ts07 = "printf(\"-->%%+.2g<--\",   %s): ";

      // Format-Strings fuer einen printf-Befehl:
      String fs01 = "-->%+g<--%n";
      String fs02 = "-->%+11g<--%n";   // Breite 11
      String fs03 = "-->%+11.4g<--%n"; // Breite 11, Genau. 4
      String fs04 = "-->%+11.2g<--%n"; // Breite 11, Genau. 2
      String fs05 = "-->%+10.4g<--%n"; // Breite 10, Genau. 4
      String fs06 = "-->%+10.2g<--%n"; // Breite 10, Genau. 2
      String fs07 = "-->%+.2g<--%n";   //            Genau. 2

      // Als Beispiele werden die Variablen f1p, f1m, f2p, f2m,
      // B1p, B1m, B2p und B2m mit verschiedenen Formatstrings formatiert
      // und ausgegeben.
      // Genauso kann man auch andere Ganzzahlvariablen (z.B.
      // d1p, d1m, d2p und d2m etc.) bearbeiten.
      printf("----------------------------%n");
      printf("A " + ts01, "f1p"); printf(fs01, f1p);
      printf("B " + ts01, "f1m"); printf(fs01, f1m);
      printf("C " + ts02, "f1p"); printf(fs02, f1p);
      printf("D " + ts02, "f1m"); printf(fs02, f1m);
      printf("E " + ts03, "f1p"); printf(fs03, f1p);
      printf("F " + ts03, "f1m"); printf(fs03, f1m);
      printf("G " + ts04, "f1p"); printf(fs04, f1p);
      printf("H " + ts04, "f1m"); printf(fs04, f1m);
      printf("I " + ts05, "f1p"); printf(fs05, f1p);
      printf("J " + ts05, "f1m"); printf(fs05, f1m);
      printf("K " + ts06, "f1p"); printf(fs06, f1p);
      printf("L " + ts06, "f1m"); printf(fs06, f1m);
      printf("M " + ts07, "f1p"); printf(fs07, f1p);
      printf("N " + ts07, "f1m"); printf(fs07, f1m);
      printf("----------------------------%n");
      printf("O " + ts01, "f2p"); printf(fs01, f2p);
      printf("P " + ts01, "f2m"); printf(fs01, f2m);
      printf("Q " + ts02, "f2p"); printf(fs02, f2p);
      printf("R " + ts02, "f2m"); printf(fs02, f2m);
      printf("S " + ts03, "f2p"); printf(fs03, f2p);
      printf("T " + ts03, "f2m"); printf(fs03, f2m);
      printf("U " + ts04, "f2p"); printf(fs04, f2p);
      printf("V " + ts04, "f2m"); printf(fs04, f2m);
      printf("V " + ts05, "f2p"); printf(fs05, f2p);
      printf("X " + ts05, "f2m"); printf(fs05, f2m);
      printf("Y " + ts06, "f2p"); printf(fs06, f2p);
      printf("Z " + ts06, "f2m"); printf(fs06, f2m);
      printf("a " + ts07, "f2p"); printf(fs07, f2p);
      printf("b " + ts07, "f2m"); printf(fs07, f2m);
      printf("----------------------------%n");
      printf("c " + ts01, "B1p"); printf(fs01, B1p);
      printf("d " + ts01, "B1m"); printf(fs01, B1m);
      printf("e " + ts02, "B1p"); printf(fs02, B1p);
      printf("f " + ts02, "B1m"); printf(fs02, B1m);
      printf("g " + ts03, "B1p"); printf(fs03, B1p);
      printf("h " + ts03, "B1m"); printf(fs03, B1m);
      printf("i " + ts04, "B1p"); printf(fs04, B1p);
      printf("j " + ts04, "B1m"); printf(fs04, B1m);
      printf("k " + ts05, "B1p"); printf(fs05, B1p);
      printf("l " + ts05, "B1m"); printf(fs05, B1m);
      printf("m " + ts06, "B1p"); printf(fs06, B1p);
      printf("n " + ts06, "B1m"); printf(fs06, B1m);
      printf("o " + ts07, "B1p"); printf(fs07, B1p);
      printf("p " + ts07, "B1m"); printf(fs07, B1m);
      printf("----------------------------%n");
      printf("q " + ts01, "B2p"); printf(fs01, B2p);
      printf("r " + ts01, "B2m"); printf(fs01, B2m);
      printf("s " + ts02, "B2p"); printf(fs02, B2p);
      printf("t " + ts02, "B2m"); printf(fs02, B2m);
      printf("u " + ts03, "B2p"); printf(fs03, B2p);
      printf("v " + ts03, "B2m"); printf(fs03, B2m);
      printf("w " + ts04, "B2p"); printf(fs04, B2p);
      printf("x " + ts04, "B2m"); printf(fs04, B2m);
      printf("y " + ts05, "B2p"); printf(fs05, B2p);
      printf("z " + ts05, "B2m"); printf(fs05, B2m);
      printf("1 " + ts06, "B2p"); printf(fs06, B2p);
      printf("2 " + ts06, "B2m"); printf(fs06, B2m);
      printf("3 " + ts07, "B2p"); printf(fs07, B2p);
      printf("4 " + ts07, "B2m"); printf(fs07, B2m);
      printf("----------------------------%n");
      printf("Format03: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
} // Format03
/* ------------------------------------------------------------------------
Ausgabe des Programms Format03:

Format03: Jetzt geht es los!
----------------------------
A printf("-->%+g<--",     f1p): -->+12.3450<--
B printf("-->%+g<--",     f1m): -->-12.3450<--
C printf("-->%+11g<--",   f1p): -->   +12.3450<--
D printf("-->%+11g<--",   f1m): -->   -12.3450<--
E printf("-->%+11.4g<--", f1p): -->     +12.35<--
F printf("-->%+11.4g<--", f1m): -->     -12.35<--
G printf("-->%+11.2g<--", f1p): -->        +12<--
H printf("-->%+11.2g<--", f1m): -->        -12<--
I printf("-->%+10.4g<--", f1p): -->    +12.35<--
J printf("-->%+10.4g<--", f1m): -->    -12.35<--
K printf("-->%+10.2g<--", f1p): -->       +12<--
L printf("-->%+10.2g<--", f1m): -->       -12<--
M printf("-->%+.2g<--",   f1p): -->+12<--
N printf("-->%+.2g<--",   f1m): -->-12<--
----------------------------
O printf("-->%+g<--",     f2p): -->+7.65430e+13<--
P printf("-->%+g<--",     f2m): -->-7.65430e+13<--
Q printf("-->%+11g<--",   f2p): -->+7.65430e+13<--
R printf("-->%+11g<--",   f2m): -->-7.65430e+13<--
S printf("-->%+11.4g<--", f2p): --> +7.654e+13<--
T printf("-->%+11.4g<--", f2m): --> -7.654e+13<--
U printf("-->%+11.2g<--", f2p): -->   +7.7e+13<--
V printf("-->%+11.2g<--", f2m): -->   -7.7e+13<--
V printf("-->%+10.4g<--", f2p): -->+7.654e+13<--
X printf("-->%+10.4g<--", f2m): -->-7.654e+13<--
Y printf("-->%+10.2g<--", f2p): -->  +7.7e+13<--
Z printf("-->%+10.2g<--", f2m): -->  -7.7e+13<--
a printf("-->%+.2g<--",   f2p): -->+7.7e+13<--
b printf("-->%+.2g<--",   f2m): -->-7.7e+13<--
----------------------------
c printf("-->%+g<--",     B1p): -->+12,3450<--
d printf("-->%+g<--",     B1m): -->-12,3450<--
e printf("-->%+11g<--",   B1p): -->   +12,3450<--
f printf("-->%+11g<--",   B1m): -->   -12,3450<--
g printf("-->%+11.4g<--", B1p): -->     +12,35<--
h printf("-->%+11.4g<--", B1m): -->     -12,35<--
i printf("-->%+11.2g<--", B1p): -->        +12<--
j printf("-->%+11.2g<--", B1m): -->        -12<--
k printf("-->%+10.4g<--", B1p): -->    +12,35<--
l printf("-->%+10.4g<--", B1m): -->    -12,35<--
m printf("-->%+10.2g<--", B1p): -->       +12<--
n printf("-->%+10.2g<--", B1m): -->       -12<--
o printf("-->%+.2g<--",   B1p): -->+12<--
p printf("-->%+.2g<--",   B1m): -->-12<--
----------------------------
q printf("-->%+g<--",     B2p): -->+7.65430e+13<--
r printf("-->%+g<--",     B2m): -->-7.65430e+13<--
s printf("-->%+11g<--",   B2p): -->+7.65430e+13<--
t printf("-->%+11g<--",   B2m): -->-7.65430e+13<--
u printf("-->%+11.4g<--", B2p): --> +7.654e+13<--
v printf("-->%+11.4g<--", B2m): --> -7.654e+13<--
w printf("-->%+11.2g<--", B2p): -->   +7.7e+13<--
x printf("-->%+11.2g<--", B2m): -->   -7.7e+13<--
y printf("-->%+10.4g<--", B2p): -->+7.654e+13<--
z printf("-->%+10.4g<--", B2m): -->-7.654e+13<--
1 printf("-->%+10.2g<--", B2p): -->  +7.7e+13<--
2 printf("-->%+10.2g<--", B2m): -->  -7.7e+13<--
3 printf("-->%+.2g<--",   B2p): -->+7.7e+13<--
4 printf("-->%+.2g<--",   B2m): -->-7.7e+13<--
----------------------------
Format03: Das war's erstmal!
------------------------------------------------------------------------ */
