// Datei Format05.java
/* ------------------------------------------------------------------------
Bruchzahlen mit printf und %a formatieren und ausgeben.
Mit %a duerfen Werte der folgenden Bruchzahltypen formatiert werden:
float, Float, double, und Double (aber nicht BigDecimal!).

Dieses Programm gibt einige printf-Befehle und die Ergebnisse, die sie
zum Bildschirm ausgeben, zum Bildschirm aus.
------------------------------------------------------------------------ */
import java.math.BigDecimal;

class Format05 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Format05: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      // Ganzzahlvariablen verschiedener Typen mit den
      // Werten 123 und -123:
      float      f1p =  12.345F;
      float      f1m = -12.345F;
      float      f2p =  76.543e12F;
      float      f2m = -76.543e12F;

      double     d1p =  12.345;
      double     d1m = -12.345;
      double     d2p =  76.543e12;
      double     d2m = -76.543e12;
      // ------------------------------------------------------------------
      // Text-Strings, die einen printf-Befehl darstellen:
      String ts01 = "printf(\"-->%%+a<--\",     %s): ";
      String ts02 = "printf(\"-->%%+11a<--\",   %s): ";
      String ts03 = "printf(\"-->%%+11.4a<--\", %s): ";
      String ts04 = "printf(\"-->%%+11.2a<--\", %s): ";
      String ts05 = "printf(\"-->%%+10.4a<--\", %s): ";
      String ts06 = "printf(\"-->%%+10.2a<--\", %s): ";
      String ts07 = "printf(\"-->%%+.2a<--\",   %s): ";

      // Format-Strings fuer einen printf-Befehl:
      String fs01 = "-->%+a<--%n";
      String fs02 = "-->%+11a<--%n";   // Breite 11
      String fs03 = "-->%+11.4a<--%n"; // Breite 11, Genau. 4
      String fs04 = "-->%+11.2a<--%n"; // Breite 11, Genau. 2
      String fs05 = "-->%+10.4a<--%n"; // Breite 10, Genau. 4
      String fs06 = "-->%+10.2a<--%n"; // Breite 10, Genau. 2
      String fs07 = "-->%+.2a<--%n";   //            Genau. 2

      // Als Beispiele werden die Variablen f1p, f1m, f2p, f2m,
      // d1p, d1m, d2p und d2m mit verschiedenen Formatstrings formatiert
      // und ausgegeben.
      printf("----------------------------%n");
      printf("A " + ts01, "f1p"); printf(fs01, f1p);
      printf("B " + ts01, "f1m"); printf(fs01, f1m);
      printf("C " + ts02, "f1p"); printf(fs02, f1p);
      printf("D " + ts02, "f1m"); printf(fs02, f1m);
      printf("E " + ts03, "f1p"); printf(fs03, f1p);
      printf("F " + ts03, "f1m"); printf(fs03, f1m);
      printf("G " + ts04, "f1p"); printf(fs04, f1p);
      printf("H " + ts04, "f1m"); printf(fs04, f1m);
      printf("I " + ts05, "f1p"); printf(fs05, f1p);
      printf("J " + ts05, "f1m"); printf(fs05, f1m);
      printf("K " + ts06, "f1p"); printf(fs06, f1p);
      printf("L " + ts06, "f1m"); printf(fs06, f1m);
      printf("M " + ts07, "f1p"); printf(fs07, f1p);
      printf("N " + ts07, "f1m"); printf(fs07, f1m);
      printf("----------------------------%n");
      printf("O " + ts01, "f2p"); printf(fs01, f2p);
      printf("P " + ts01, "f2m"); printf(fs01, f2m);
      printf("Q " + ts02, "f2p"); printf(fs02, f2p);
      printf("R " + ts02, "f2m"); printf(fs02, f2m);
      printf("S " + ts03, "f2p"); printf(fs03, f2p);
      printf("T " + ts03, "f2m"); printf(fs03, f2m);
      printf("U " + ts04, "f2p"); printf(fs04, f2p);
      printf("V " + ts04, "f2m"); printf(fs04, f2m);
      printf("V " + ts05, "f2p"); printf(fs05, f2p);
      printf("X " + ts05, "f2m"); printf(fs05, f2m);
      printf("Y " + ts06, "f2p"); printf(fs06, f2p);
      printf("Z " + ts06, "f2m"); printf(fs06, f2m);
      printf("a " + ts07, "f2p"); printf(fs07, f2p);
      printf("b " + ts07, "f2m"); printf(fs07, f2m);
      printf("----------------------------%n");
      printf("c " + ts01, "d1p"); printf(fs01, d1p);
      printf("d " + ts01, "d1m"); printf(fs01, d1m);
      printf("e " + ts02, "d1p"); printf(fs02, d1p);
      printf("f " + ts02, "d1m"); printf(fs02, d1m);
      printf("g " + ts03, "d1p"); printf(fs03, d1p);
      printf("h " + ts03, "d1m"); printf(fs03, d1m);
      printf("i " + ts04, "d1p"); printf(fs04, d1p);
      printf("j " + ts04, "d1m"); printf(fs04, d1m);
      printf("k " + ts05, "d1p"); printf(fs05, d1p);
      printf("l " + ts05, "d1m"); printf(fs05, d1m);
      printf("m " + ts06, "d1p"); printf(fs06, d1p);
      printf("n " + ts06, "d1m"); printf(fs06, d1m);
      printf("o " + ts07, "d1p"); printf(fs07, d1p);
      printf("p " + ts07, "d1m"); printf(fs07, d1m);
      printf("----------------------------%n");
      printf("q " + ts01, "d2p"); printf(fs01, d2p);
      printf("r " + ts01, "d2m"); printf(fs01, d2m);
      printf("s " + ts02, "d2p"); printf(fs02, d2p);
      printf("t " + ts02, "d2m"); printf(fs02, d2m);
      printf("u " + ts03, "d2p"); printf(fs03, d2p);
      printf("v " + ts03, "d2m"); printf(fs03, d2m);
      printf("w " + ts04, "d2p"); printf(fs04, d2p);
      printf("x " + ts04, "d2m"); printf(fs04, d2m);
      printf("y " + ts05, "d2p"); printf(fs05, d2p);
      printf("z " + ts05, "d2m"); printf(fs05, d2m);
      printf("1 " + ts06, "d2p"); printf(fs06, d2p);
      printf("2 " + ts06, "d2m"); printf(fs06, d2m);
      printf("3 " + ts07, "d2p"); printf(fs07, d2p);
      printf("4 " + ts07, "d2m"); printf(fs07, d2m);
      printf("----------------------------%n");
      printf("Format05: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
} // Format05
/* ------------------------------------------------------------------------
Ausgabe des Programms Format05:

Format05: Jetzt geht es los!
----------------------------
A printf("-->%+a<--",     f1p): -->+0x1.8b0a3ep3<--
B printf("-->%+a<--",     f1m): -->-0x1.8b0a3ep3<--
C printf("-->%+11a<--",   f1p): -->+0x1.8b0a3ep3<--
D printf("-->%+11a<--",   f1m): -->-0x1.8b0a3ep3<--
E printf("-->%+11.4a<--", f1p): -->+0x1.8b0ap3<--
F printf("-->%+11.4a<--", f1m): -->-0x1.8b0ap3<--
G printf("-->%+11.2a<--", f1p): -->  +0x1.8bp3<--
H printf("-->%+11.2a<--", f1m): -->  -0x1.8bp3<--
I printf("-->%+10.4a<--", f1p): -->+0x1.8b0ap3<--
J printf("-->%+10.4a<--", f1m): -->-0x1.8b0ap3<--
K printf("-->%+10.2a<--", f1p): --> +0x1.8bp3<--
L printf("-->%+10.2a<--", f1m): --> -0x1.8bp3<--
M printf("-->%+.2a<--",   f1p): -->+0x1.8bp3<--
N printf("-->%+.2a<--",   f1m): -->-0x1.8bp3<--
----------------------------
O printf("-->%+a<--",     f2p): -->+0x1.16763ap46<--
P printf("-->%+a<--",     f2m): -->-0x1.16763ap46<--
Q printf("-->%+11a<--",   f2p): -->+0x1.16763ap46<--
R printf("-->%+11a<--",   f2m): -->-0x1.16763ap46<--
S printf("-->%+11.4a<--", f2p): -->+0x1.1676p46<--
T printf("-->%+11.4a<--", f2m): -->-0x1.1676p46<--
U printf("-->%+11.2a<--", f2p): --> +0x1.16p46<--
V printf("-->%+11.2a<--", f2m): --> -0x1.16p46<--
V printf("-->%+10.4a<--", f2p): -->+0x1.1676p46<--
X printf("-->%+10.4a<--", f2m): -->-0x1.1676p46<--
Y printf("-->%+10.2a<--", f2p): -->+0x1.16p46<--
Z printf("-->%+10.2a<--", f2m): -->-0x1.16p46<--
a printf("-->%+.2a<--",   f2p): -->+0x1.16p46<--
b printf("-->%+.2a<--",   f2m): -->-0x1.16p46<--
----------------------------
c printf("-->%+a<--",     d1p): -->+0x1.8b0a3d70a3d71p3<--
d printf("-->%+a<--",     d1m): -->-0x1.8b0a3d70a3d71p3<--
e printf("-->%+11a<--",   d1p): -->+0x1.8b0a3d70a3d71p3<--
f printf("-->%+11a<--",   d1m): -->-0x1.8b0a3d70a3d71p3<--
g printf("-->%+11.4a<--", d1p): -->+0x1.8b0ap3<--
h printf("-->%+11.4a<--", d1m): -->-0x1.8b0ap3<--
i printf("-->%+11.2a<--", d1p): -->  +0x1.8bp3<--
j printf("-->%+11.2a<--", d1m): -->  -0x1.8bp3<--
k printf("-->%+10.4a<--", d1p): -->+0x1.8b0ap3<--
l printf("-->%+10.4a<--", d1m): -->-0x1.8b0ap3<--
m printf("-->%+10.2a<--", d1p): --> +0x1.8bp3<--
n printf("-->%+10.2a<--", d1m): --> -0x1.8bp3<--
o printf("-->%+.2a<--",   d1p): -->+0x1.8bp3<--
p printf("-->%+.2a<--",   d1m): -->-0x1.8bp3<--
----------------------------
q printf("-->%+a<--",     d2p): -->+0x1.1676394cd8p46<--
r printf("-->%+a<--",     d2m): -->-0x1.1676394cd8p46<--
s printf("-->%+11a<--",   d2p): -->+0x1.1676394cd8p46<--
t printf("-->%+11a<--",   d2m): -->-0x1.1676394cd8p46<--
u printf("-->%+11.4a<--", d2p): -->+0x1.1676p46<--
v printf("-->%+11.4a<--", d2m): -->-0x1.1676p46<--
w printf("-->%+11.2a<--", d2p): --> +0x1.16p46<--
x printf("-->%+11.2a<--", d2m): --> -0x1.16p46<--
y printf("-->%+10.4a<--", d2p): -->+0x1.1676p46<--
z printf("-->%+10.4a<--", d2m): -->-0x1.1676p46<--
1 printf("-->%+10.2a<--", d2p): -->+0x1.16p46<--
2 printf("-->%+10.2a<--", d2m): -->-0x1.16p46<--
3 printf("-->%+.2a<--",   d2p): -->+0x1.16p46<--
4 printf("-->%+.2a<--",   d2m): -->-0x1.16p46<--
----------------------------
Format05: Das war's erstmal!
------------------------------------------------------------------------ */
