// Datei Format06.java
/* ------------------------------------------------------------------------
Objekte und primitive Werte mit printf und %s, %h und %b formatieren und
ausgeben.
Mit %s, %h und %b duerfen Werte aller Typen formatiert werden. %s bewirkt
eine Umwandlung in einen String, %h in eine hexadezimale Darstellung und
%b in eine der Zeichenketten "true" bzw. "false".

Dieses Programm gibt einige printf-Befehle und die Ergebnisse, die sie
zum Bildschirm ausgeben, zum Bildschirm aus.
------------------------------------------------------------------------ */
import java.math.BigInteger;

class Format06 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Format06: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      // Ganzzahlvariablen verschiedener Typen mit den
      // Werten 123 und -123:
      byte       b1p =  123;
      byte       b1m = -123;
      short      s1p =  123;
      short      s1m = -123;
      int        i1p =  123;
      int        i1m = -123;
      long       l1p =  123;
      long       l1m = -123;
      boolean    w1p = true;
      boolean    w1m = false;

      Byte       B1p =  123;
      Byte       B1m = -123;
      Short      S1p =  123;
      Short      S1m = -123;
      Integer    I1p =  123;
      Integer    I1m = -123;
      Long       L1p =  123L;
      Long       L1m = -123L;
      Boolean    W1p = null;
      Boolean    W1m = false;

      BigInteger BIp = new BigInteger("123");
      BigInteger BIm = new BigInteger("-123");
      // ------------------------------------------------------------------
      // Text-Strings, die einen printf-Befehl darstellen:
      String ts01 = "printf(\"-->%%s<--\",   %s): ";
      String ts02 = "printf(\"-->%%6s<--\",  %s): ";
      String ts03 = "printf(\"-->%%-6s<--\", %s): ";
      String ts04 = "printf(\"-->%%.2s<--\", %s): ";
      String ts05 = "printf(\"-->%%h<--\",   %s): ";
      String ts06 = "printf(\"-->%%6h<--\",  %s): ";
      String ts07 = "printf(\"-->%%-6h<--\", %s): ";
      String ts08 = "printf(\"-->%%.3h<--\", %s): ";
      String ts09 = "printf(\"-->%%6b<--\",  %s): ";

      // Format-Strings fuer einen printf-Befehl:
      String fs01 = "-->%s<--%n";    // String
      String fs02 = "-->%6s<--%n";   // String, min. Breite 6
      String fs03 = "-->%-6s<--%n";  // String, min. Breite 6, linksbuendig
      String fs04 = "-->%.2s<--%n";  // String, max. Breite 2
      String fs05 = "-->%h<--%n";    // Hex.
      String fs06 = "-->%6h<--%n";   // Hex.,   min. Breite 6
      String fs07 = "-->%-6h<--%n";  // Hex.,   min. Breite 6, linksbuendig
      String fs08 = "-->%.3h<--%n";  // Hex.,   max. Breite 3
      String fs09 = "-->%6b<--%n";   // boolean

      // Als Beispiele werden die Variablen b1p, b1m, BIp, BIm, W1p und
      // W1m mit verschiedenen Formatstrings formatiert und ausgegeben.
      // Genauso kann man auch beliebige andere Werte (z.B.
      // s1p, s1m, i1p, i1m, B1p, B1m etc.) bearbeiten.
      printf("----------------------------%n");
      printf("A " + ts01, "b1p"); printf(fs01, b1p);
      printf("B " + ts01, "b1m"); printf(fs01, b1m);
      printf("C " + ts02, "b1p"); printf(fs02, b1p);
      printf("D " + ts02, "b1m"); printf(fs02, b1m);
      printf("E " + ts03, "b1p"); printf(fs03, b1p);
      printf("F " + ts03, "b1m"); printf(fs03, b1m);
      printf("G " + ts04, "b1p"); printf(fs04, b1p);
      printf("H " + ts04, "b1m"); printf(fs04, b1m);
      printf("I " + ts05, "b1p"); printf(fs05, b1p);
      printf("J " + ts05, "b1m"); printf(fs05, b1m);
      printf("K " + ts06, "b1p"); printf(fs06, b1p);
      printf("L " + ts06, "b1m"); printf(fs06, b1m);
      printf("M " + ts07, "b1p"); printf(fs07, b1p);
      printf("N " + ts07, "b1m"); printf(fs07, b1m);
      printf("O " + ts01, "b1p"); printf(fs08, b1p);
      printf("P " + ts01, "b1m"); printf(fs08, b1m);
      printf("Q " + ts02, "b1p"); printf(fs09, b1p);
      printf("R " + ts02, "b1m"); printf(fs09, b1m);
      printf("----------------------------%n");
      printf("S " + ts01, "BIp"); printf(fs01, BIp);
      printf("T " + ts01, "BIm"); printf(fs01, BIm);
      printf("U " + ts02, "BIp"); printf(fs02, BIp);
      printf("V " + ts02, "BIm"); printf(fs02, BIm);
      printf("W " + ts03, "BIp"); printf(fs03, BIp);
      printf("X " + ts03, "BIm"); printf(fs03, BIm);
      printf("Y " + ts04, "BIp"); printf(fs04, BIp);
      printf("Z " + ts04, "BIm"); printf(fs04, BIm);
      printf("a " + ts05, "BIp"); printf(fs05, BIp);
      printf("b " + ts05, "BIm"); printf(fs05, BIm);
      printf("c " + ts06, "BIp"); printf(fs06, BIp);
      printf("d " + ts06, "BIm"); printf(fs06, BIm);
      printf("e " + ts07, "BIp"); printf(fs07, BIp);
      printf("f " + ts07, "BIm"); printf(fs07, BIm);
      printf("g " + ts08, "BIp"); printf(fs08, BIp);
      printf("h " + ts08, "BIm"); printf(fs08, BIm);
      printf("i " + ts09, "BIp"); printf(fs09, BIp);
      printf("j " + ts09, "BIm"); printf(fs09, BIm);
      printf("----------------------------%n");
      printf("k " + ts01, "W1p"); printf(fs01, W1p);
      printf("l " + ts01, "W1m"); printf(fs01, W1m);
      printf("m " + ts02, "W1p"); printf(fs02, W1p);
      printf("n " + ts02, "W1m"); printf(fs02, W1m);
      printf("o " + ts03, "W1p"); printf(fs03, W1p);
      printf("p " + ts03, "W1m"); printf(fs03, W1m);
      printf("q " + ts04, "W1p"); printf(fs04, W1p);
      printf("r " + ts04, "W1m"); printf(fs04, W1m);
      printf("s " + ts05, "W1p"); printf(fs05, W1p);
      printf("t " + ts05, "W1m"); printf(fs05, W1m);
      printf("u " + ts06, "W1p"); printf(fs06, W1p);
      printf("v " + ts06, "W1m"); printf(fs06, W1m);
      printf("w " + ts07, "W1p"); printf(fs07, W1p);
      printf("x " + ts07, "W1m"); printf(fs07, W1m);
      printf("y " + ts08, "W1p"); printf(fs08, W1p);
      printf("z " + ts08, "W1m"); printf(fs08, W1m);
      printf("1 " + ts09, "W1p"); printf(fs09, W1p);
      printf("2 " + ts09, "W1m"); printf(fs09, W1m);
      printf("----------------------------%n");
      printf("Format06: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
} // Format06
/* ------------------------------------------------------------------------
Ausgabe des Programms Format06:

Format06: Jetzt geht es los!
----------------------------
A printf("-->%s<--",   b1p): -->123<--
B printf("-->%s<--",   b1m): -->-123<--
C printf("-->%6s<--",  b1p): -->   123<--
D printf("-->%6s<--",  b1m): -->  -123<--
E printf("-->%-6s<--", b1p): -->123   <--
F printf("-->%-6s<--", b1m): -->-123  <--
G printf("-->%.2s<--", b1p): -->12<--
H printf("-->%.2s<--", b1m): -->-1<--
I printf("-->%h<--",   b1p): -->7b<--
J printf("-->%h<--",   b1m): -->ffffff85<--
K printf("-->%6h<--",  b1p): -->    7b<--
L printf("-->%6h<--",  b1m): -->ffffff85<--
M printf("-->%-6h<--", b1p): -->7b    <--
N printf("-->%-6h<--", b1m): -->ffffff85<--
O printf("-->%s<--",   b1p): -->7b<--
P printf("-->%s<--",   b1m): -->fff<--
Q printf("-->%6s<--",  b1p): -->  true<--
R printf("-->%6s<--",  b1m): -->  true<--
----------------------------
S printf("-->%s<--",   BIp): -->123<--
T printf("-->%s<--",   BIm): -->-123<--
U printf("-->%6s<--",  BIp): -->   123<--
V printf("-->%6s<--",  BIm): -->  -123<--
W printf("-->%-6s<--", BIp): -->123   <--
X printf("-->%-6s<--", BIm): -->-123  <--
Y printf("-->%.2s<--", BIp): -->12<--
Z printf("-->%.2s<--", BIm): -->-1<--
a printf("-->%h<--",   BIp): -->7b<--
b printf("-->%h<--",   BIm): -->ffffff85<--
c printf("-->%6h<--",  BIp): -->    7b<--
d printf("-->%6h<--",  BIm): -->ffffff85<--
e printf("-->%-6h<--", BIp): -->7b    <--
f printf("-->%-6h<--", BIm): -->ffffff85<--
g printf("-->%.3h<--", BIp): -->7b<--
h printf("-->%.3h<--", BIm): -->fff<--
i printf("-->%6b<--",  BIp): -->  true<--
j printf("-->%6b<--",  BIm): -->  true<--
----------------------------
k printf("-->%s<--",   W1p): -->null<--
l printf("-->%s<--",   W1m): -->false<--
m printf("-->%6s<--",  W1p): -->  null<--
n printf("-->%6s<--",  W1m): --> false<--
o printf("-->%-6s<--", W1p): -->null  <--
p printf("-->%-6s<--", W1m): -->false <--
q printf("-->%.2s<--", W1p): -->nu<--
r printf("-->%.2s<--", W1m): -->fa<--
s printf("-->%h<--",   W1p): -->null<--
t printf("-->%h<--",   W1m): -->4d5<--
u printf("-->%6h<--",  W1p): -->  null<--
v printf("-->%6h<--",  W1m): -->   4d5<--
w printf("-->%-6h<--", W1p): -->null  <--
x printf("-->%-6h<--", W1m): -->4d5   <--
y printf("-->%.3h<--", W1p): -->nul<--
z printf("-->%.3h<--", W1m): -->4d5<--
1 printf("-->%6b<--",  W1p): --> false<--
2 printf("-->%6b<--",  W1m): --> false<--
----------------------------
Format06: Das war's erstmal!
------------------------------------------------------------------------ */
