// Datei Format10.java
/* ------------------------------------------------------------------------
Ein "Ausprobier- und Trainingsprogramm" zum Kennenlernen des
printf-Befehls.

In einer aeusseren Schleife liest dieses Programm wiederholt von der
Standardeingabe einen Wert w ein (der zu einem der 11 Typen byte, char,
short, int, long, float, double, boolean, String, BigInteger oder BigDecimal
gehoeren kann).
   In einer inneren Schleife liest es dann wiederholt einen Formatstring f
   ein und gibt den Wert w formatiert mit f zur Standardausgabe aus.
   Durch Eingabe von q in der inneren Schleife gelangt der Benutzer in
   die aeussere Schleife (wo der naechste Wert eingelesen wird).
Durch Eingabe von q in der aeusseren Schleife beendet der Benutzer das
Programm.

Alle Ausnahmen durch falsche Formatstrings oder andere Fehler in den
Eingaben werden abgefangen und gemeldet. Danach wird das Programm fort-
gesetzt. Eine kleine Anleitung wird beim Programmstart und spaeter nach
jeder Eingabe eines falschen Typbuchstabens ausgegeben.

Achtung: Beim Formatieren behandelt der Ausfuehrer primitive Werte wie
123 oder 12.345 genau so, wie die entsprechenden Huellobjekte.
------------------------------------------------------------------------ */
import java.math.BigInteger;
import java.math.BigDecimal;

class Format10 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Format10: Jetzt geht es los!%n");

      gibAnleitungAus();

      // Auessere Schleife, in der ein Wert eingelesen wird:
      while (true) {
         Object datenO  = liesDaten();

         String typName;
         String datenS;

         if (datenO != null) {
            if (datenO.equals("q")) break;
            // Typname ohne "java.lang." davor:
            typName = datenO.getClass().getName().substring(10);
            datenS  = nachString(datenO);
         } else {
            typName = "Object";
            datenS  = "null";
         }

         // Innere Schleife, in der ein Formatstring eingelesen wird:
         while (true) {
            printf("Ein Formatstring       (q zum Beenden)%n");
            printf("z.B. s oder H oder +8d oder 5.2f etc.:  ");
            String format = EM.liesString();
            if (format.equals("q")) break;

            printf("Hinweis: Die Variable dora ist vom Typ %s%n", typName);
            printf("         und hat den Wert: %s%n%n", datenS);

            // Der printf-Befehl, der gleich ausgefuehrt wird, wird
            // erstmal ausgegeben:
            format = "->%" + format + "<--";
            printf("printf(\"%s\", dora): ", format);

            // Jetzt wird versucht, den printf-Befehl auszufuehren:
            try {
               printf(format+"%n", datenO);
            } catch (Throwable t) {
               printf("%nDer printf-Befehl loeste folg. Ausnahme aus:%n");
               printf("%s%n", t);
            } // try/catch
            printf("----------------------\n");
         } // while
      } // while

      printf("Format10: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   static Object liesDaten() {
      // Liest (moeglicherweise wiederholt) solange einen String ein,
      // bis der Benutzer einen mit einem richtigen Typ buchstaben am
      // Anfang eingibt. Wandelt den Rest des Strings in ein Objekt
      // des entsprechenden Typs um und liefert das Objekt als
      // Ergebnis. Wenn eine Ausnahme auftritt wird ein weiterer
      // String eingelesen (bis alles klappt).

      while (true) {
         printf("==============================================%n");
         printf("Typbuchstabe und Daten (q zum Beenden)%n");
         printf("z.B. i123 oder d45.678 oder SABC etc.:  ");

         String ein = EM.liesString();

         try {
            char   typ = ein.charAt(0);     // Typbuchstabe (hoffentlich)
            String dat = ein.substring(1);  // Rest des Strings

            switch (typ) {
               case 'q': return "q";
               case 'c': return dat.charAt(0);
               case 'b': return    Byte.valueOf(dat);
               case 's': return   Short.valueOf(dat);
               case 'i': return Integer.valueOf(dat);
               case 'l': return    Long.valueOf(dat);
               case 'f': return   Float.valueOf(dat);
               case 'd': return  Double.valueOf(dat);
               case 'n': return null;
               case 'B': return Boolean.valueOf(dat);
               case 'S': return dat;
               case 'I': return new BigInteger(dat);
               case 'D': return new BigDecimal(dat);
               default: {
                  printf("Ihre Eingabe (%s) ist nicht akzeptabel!%n", ein);
                  gibAnleitungAus();
                  continue;
               }
            } // switch
         } catch (Throwable t) {
            printf("Ihre Eingabe (%s) hat folgende Ausnahme ausgeloest:%n", ein);
            printf("%s%n", t);
            continue;
         } // try/catch
      } // while
   } // liesDaten
   // ---------------------------------------------------------------------
   static String nachString(Object ob) {
      // Wandelt ob in einen String um. Der Ergebnisstring wird mit
      // Anfuehrungszeichen oder auf andere Weise verziert, wenn ob
      // zu einem speziellen Typ gehoert.

      String erg = ob.toString();
      Class  kob = ob.getClass();

      // In gewissen Faellen wird der Ergebnisstring verziert:
      if (kob == Character.class) return "'"  + erg + "'";
      if (kob ==    String.class) return "\"" + erg + "\"";
      if (kob ==     Float.class) return        erg + "F";
      if (kob ==      Long.class) return        erg + "L";

      // Ergebnis ohne Verzierungen:
      return erg;
   } // nachString
   // ---------------------------------------------------------------------
   static void gibAnleitungAus() {
      printf("+--------------------------------------------+%n");
      printf("| Typbuchstaben und ihre Bedeutung:          |%n");
      printf("+--------------------------------------------+%n");
      printf("| q Beenden                                  |%n");
      printf("| c char       (bzw. Character)              |%n");
      printf("| b byte       (bzw. Byte)                   |%n");
      printf("| s short      (bzw. Short)                  |%n");
      printf("| i int        (bzw. Integer)                |%n");
      printf("| l long       (bzw. Long)                   |%n");
      printf("| f float      (bzw. Float)                  |%n");
      printf("| d double     (bzw. Double)                 |%n");
      printf("| n null       (vom Typ Object)              |%n");
      printf("| B boolean    (bzw. Boolean)                |%n");
      printf("| S String                                   |%n");
      printf("| I BigInteger                               |%n");
      printf("| D BigDecimal                               |%n");
      printf("+--------------------------------------------+%n");
   } // gibAnleitungAus
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Format10