// Datei GenTypen01.java
/* ------------------------------------------------------------------------
Drei simple Klassen "zum Sammeln von Objekten" werden vereinbart und
benutzt:
Die nicht-generische Klasse PaarA
Die       generische Klasse PaarB<T>     (mit einem Parameter )
Die       generische Klasse PaarC<S, T>  (mit zwei  Parametern)

Abkuerzungen: CF Compilezeitfehler, LF Laufzeitfehler
------------------------------------------------------------------------ */
// ==============================================================
class PaarA {       // Eine nicht-generische Klasse
   Object k1;       // Komponente 1
   Object k2;       // Komponente 2
   // -----------------------------------------------------------
   PaarA(Object k1, Object k2) {
      this.k1 = k1;
      this.k2 = k2;
   } // Konstruktor PaarA
   // -----------------------------------------------------------
   public String toString() {
      return "[" + k1 + ", " + k2 + "]";
   } // toString
   // -----------------------------------------------------------
} // Klasse PaarA
// ==============================================================
class PaarB<K> {    // Eine generische Klasse, 1 Parameter K
   K k1;            // Komponente 1
   K k2;            // Komponente 2
   // -----------------------------------------------------------
   PaarB(K k1, K k2) {
      this.k1 = k1;
      this.k2 = k2;
   } // Konstruktor PaarB
   // -----------------------------------------------------------
   public String toString() {
      return "[" + k1 + ", " + k2 + "]";
   } // toString
   // -----------------------------------------------------------
} // Klasse PaarB
// ==============================================================
class PaarC<S, T> { // Eine generische Klasse, 2 Parameter S, T
   S k1;            // Komponente 1
   T k2;            // Komponente 2
   // -----------------------------------------------------------
   PaarC(S k1, T k2) {
      this.k1 = k1;
      this.k2 = k2;
   } // Konstruktor PaarC
   // -----------------------------------------------------------
   public String toString() {
      return "[" + k1 + ", " + k2 + "]";
   } // toString
   // -----------------------------------------------------------
} // Klasse PaarC
// ==============================================================
class GenTypen01 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("GenTypen01: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      // Objekte, die als Komponenten von Paaren verwendet werden sollen:
      String                s1 = new String("Eins");
      String                s2 = new String("Zwei");

      Double                d1 = new Double(1.1);
      Double                d2 = new Double(2.2);

      int[]                 r1 = new int[] {111, 112, 113};
      int[]                 r2 = new int[] {221, 222};
      // ------------------------------------------------------------------
      // Objekte des Typs PaarA:
      PaarA                 a1 = new PaarA                (s1, s2);
      PaarA                 a2 = new PaarA                (d1, d2);
      PaarA                 a3 = new PaarA                (s1, d2);
      PaarA                 a4 = new PaarA                (r1, s2);
      PaarA                 a5 = new PaarA                (a1, a2);
      // ------------------------------------------------------------------
      // Objekte verschiedener PaarB-Typen:
      PaarB<String>         b1 = new PaarB<String>        (s1, s2);
      PaarB<Double>         b2 = new PaarB<Double>        (d1, d2);
      PaarB<Object>         b3 = new PaarB<Object>        (s1, d2);
      PaarB<int[]>          b4 = new PaarB<int[]>         (r1, r2);
      PaarB<PaarB<String>>  b5 = new PaarB<PaarB<String>> (b1, b1);
//    PaarB<String>         b6 = new PaarB<String>        (s1, d2); // CF
//    PaarB<Double>         b7 = new PaarB<Double>        (s1, d2); // CF
      // ------------------------------------------------------------------
      // Objekte verschiedener PaarC-Typen:
      PaarC<String, String> c1 = new PaarC<String, String>(s1, s2);
      PaarC<Double, Double> c2 = new PaarC<Double, Double>(d1, d2);
      PaarC<String, Double> c3 = new PaarC<String, Double>(s1, d2);
      PaarC<int[],  String> c4 = new PaarC<int[],  String>(r1, s2);
//    PaarC<String, Double> c5 = new PaarC<String, Double>(s1, s2); // CF
//    PaarC<String, Double> c6 = new PaarC<String, Double>(d1, d2); // CF
//    PaarC<String, Double> c7 = new PaarC<String, Double>(d1, s2); // CF
      // ------------------------------------------------------------------
      printf("----------------------------------%n");
      printf("A a1: %s%n", a1);
      printf("B a2: %s%n", a2);
      printf("C a3: %s%n", a3);
      printf("D a4: %s%n", a4);
      printf("E a5: %s%n", a5);
      printf("----------------------------------%n");
      printf("F b1: %s%n", b1);
      printf("G b2: %s%n", b2);
      printf("H b3: %s%n", b3);
      printf("I b4: %s%n", b4);
      printf("J b5: %s%n", b5);
      printf("----------------------------------%n");
      printf("K c1: %s%n", c1);
      printf("L c2: %s%n", c2);
      printf("M c3: %s%n", c3);
      printf("N c4: %s%n", c4);
      printf("----------------------------------%n");
      printf("O (String) a1.k1 + '?': %s%n", ((String) a1.k1 + '?'));
      printf("P (Double) a2.k1 + 3.3: %s%n", ((Double) a2.k1 + 3.3));
      printf("Q (String) a3.k1 + '!': %s%n", ((String) a3.k1 + '!'));
      printf("R ((int[]) a4.k1)[0]  : %s%n", (((int[]) a4.k1)[0]  ));
      printf("S ((PaarA) a5.k1).k2  : %s%n", (((PaarA) a5.k1).k2  ));
      printf("----------------------------------%n");
      printf("T          b1.k1 + '?': %s%n", (         b1.k1 + '?'));
      printf("U          b2.k1 + 4.4: %s%n", (         b2.k1 + 4.4));
      printf("V (String) b3.k1 + '!': %s%n", ((String) b3.k1 + '!'));
      printf("W          b4.k1 [1]  : %s%n", (         b4.k1[1]   ));
      printf("X          b5.k2.k1   : %s%n", (         b5.k2.k1   ));
      printf("----------------------------------%n");
      printf("Y          c1.k1 + '?': %s%n", (         c1.k1 + '?'));
      printf("Z          c2.k1 + 5.5: %s%n", (         c2.k1 + 5.5));
      printf("A          c3.k1 + '!': %s%n", (         c3.k1 + '!'));
      printf("B          c4.k2 + '!': %s%n", (         c4.k2 + '!'));
      printf("----------------------------------%n");
      // Fehlerhafte Zugriffe auf Komponenten von Paaren:
//    String t1 = (String) a3.k2;                                   // LF
//    String t2 = (String) b3.k2;                                   // LF
//    String t3 = (String) c3.k2;                                   // CF

      printf("GenTypen01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // GenTypen01
/* ------------------------------------------------------------------------
Ausgabe des Programms GenTypen01:

GenTypen01: Jetzt geht es los!
----------------------------------
A a1: [Eins, Zwei]
B a2: [1.1, 2.2]
C a3: [Eins, 2.2]
D a4: [[I@cf2c80, Zwei]
E a5: [[Eins, Zwei], [1.1, 2.2]]
----------------------------------
F b1: [Eins, Zwei]
G b2: [1.1, 2.2]
H b3: [Eins, 2.2]
I b4: [[I@cf2c80, [I@1729854]
J b5: [[Eins, Zwei], [Eins, Zwei]]
----------------------------------
K c1: [Eins, Zwei]
L c2: [1.1, 2.2]
M c3: [Eins, 2.2]
N c4: [[I@cf2c80, Zwei]
----------------------------------
O (String) a1.k1 + '?': Eins?
P (Double) a2.k1 + 3.3: 4.4
Q (String) a3.k1 + '!': Eins!
R ((int[]) a4.k1)[0]  : 111
S ((PaarA) a5.k1).k2  : Zwei
----------------------------------
T          b1.k1 + '?': Eins?
U          b2.k1 + 4.4: 5.5
V (String) b3.k1 + '!': Eins!
W          b4.k1 [1]  : 112
X          b5.k2.k1   : Eins
----------------------------------
Y          c1.k1 + '?': Eins?
Z          c2.k1 + 5.5: 6.6
A          c3.k1 + '!': Eins!
B          c4.k2 + '!': Zwei!
----------------------------------
GenTypen01: Das war's erstmal!
---------------------------------------------------------------------------
Fehlermeldungen des Compilers, wenn die entsprechenden Zeilen keine
Kommentare sind:

D:\Java\GenTypen01.java:85: cannot find symbol
symbol  : constructor PaarB(java.lang.String,java.lang.Double)
location: class PaarB<java.lang.String>
    PaarB<String>         b6 = new PaarB<String>        (s1, d2); // CF
                               ^
D:\Java\GenTypen01.java:86: cannot find symbol
symbol  : constructor PaarB(java.lang.String,java.lang.Double)
location: class PaarB<java.lang.Double>
    PaarB<Double>         b7 = new PaarB<Double>        (s1, d2); // CF
                               ^
D:\Java\GenTypen01.java:94: cannot find symbol
symbol  : constructor PaarC(java.lang.String,java.lang.String)
location: class PaarC<java.lang.String,java.lang.Double>
    PaarC<String, Double> c5 = new PaarC<String, Double>(s1, s2); // CF
                               ^
D:\Java\GenTypen01.java:95: cannot find symbol
symbol  : constructor PaarC(java.lang.Double,java.lang.Double)
location: class PaarC<java.lang.String,java.lang.Double>
    PaarC<String, Double> c6 = new PaarC<String, Double>(d1, d2); // CF
                               ^
D:\Java\GenTypen01.java:96: cannot find symbol
symbol  : constructor PaarC(java.lang.Double,java.lang.String)
location: class PaarC<java.lang.String,java.lang.Double>
    PaarC<String, Double> c7 = new PaarC<String, Double>(d1, s2); // CF
                               ^
D:\Java\GenTypen01.java:136: inconvertible types
found   : java.lang.Double
required: java.lang.String
    String t3 = (String) c3.k2;                                   // CF
                           ^
---------------------------------------------------------------------------
Fehlermeldungen waehrend der Ausfuehrung des Programms, wenn die
entsprechenden Zeilen keine Kommentare sind:

Exception in thread "main"
java.lang.ClassCastException: java.lang.Double
   at GenTypen01.main(GenTypen01.java:133)

Exception in thread "main"
java.lang.ClassCastException: java.lang.Double
   at GenTypen01.main(GenTypen01.java:134)
------------------------------------------------------------------------ */
