// Datei GenTypen08.java
/* --------------------------------------------------------------
Sei PaarK eine generische Klasse (siehe unten). Dann gilt der
rohe Typ PaarK als Obertyp aller parametrisierten Typen
PaarK<String>, PaarK<Double>, PaarK<Object>, ... etc.
Zuweisungen von p-Werten an rohe  Variablen sind typsicher.
Zuweisungen von rohen Werten an p-Variablen sind dagegen
typunsicher, werden vom Ausfuehrer aber nicht (mit einer
Fehlermeldung) abgelehnt, sondern mit einer Warnung akzeptiert.
In solchen Faellen ist der Programmierer dafuer verantwortlich,
dass keine Laufzeitfehler auftreten.
-------------------------------------------------------------- */
// ==============================================================
class PaarK<K> {    // Eine generische Klasse, 1 Parameter K
   K k1;            // Komponente 1
   K k2;            // Komponente 2
   // -----------------------------------------------------------
   PaarK(K k1, K k2) {
      this.k1 = k1;
      this.k2 = k2;
   } // Konstruktor PaarK
   // -----------------------------------------------------------
   public String toString() {
      return "[" + k1 + ", " + k2 + "]";
   } // toString
   // -----------------------------------------------------------
} // Klasse PaarK
// ==============================================================
class GenTypen08 {
   // -----------------------------------------------------------
   static public void main(String [] sonja) {
      printf("GenTypen08: Jetzt geht es los!%n");
      // --------------------------------------------------------
      PaarK<String> ps_01, ps_02, ps_03; //    p-Variablen
      PaarK<Double> pd_01, pd_02, pd_03; //    p-Variablen
      PaarK         roh01, roh02, roh03; // Rohe Variablen
      // --------------------------------------------------------
      ps_01 = new PaarK<String>("aaa", "AAA");
      roh01 = ps_01;
//    pd_01 = ps_01;                           // Fehlermeldung
      // --------------------------------------------------------
      roh02 = new PaarK<String>("bbb", "BBB");
      roh03 = new PaarK        ("ccc", 1.1);   // Warnung
      // --------------------------------------------------------
      ps_02 = roh02;                           // Warnung
      ps_03 = roh03;                           // Warnung
      // --------------------------------------------------------
      pd_02 = roh02;                           // Warnung
      pd_03 = roh03;                           // Warnung
      // --------------------------------------------------------

      printf("----------------------------------%n");
      printf("A ps_01: %s%n", ps_01);
      printf("B roh01: %s%n", roh01);
      printf("----------------------------------%n");
      printf("C roh02: %s%n", roh02);
      printf("D roh03: %s%n", roh03);
      printf("----------------------------------%n");
      printf("E ps_02: %s%n", ps_02);
      printf("F ps_03: %s%n", ps_03);
      printf("----------------------------------%n");
      printf("G pd_02: %s%n", pd_02);
      printf("H pd_03: %s%n", pd_03);
      printf("----------------------------------%n");
      Double d2 = pd_03.k2;
//    String s1 = pd_03.k1;                    // Fehlermeldung
      Double d1 = pd_03.k1;                    // Laufzeitfehler
      printf("----------------------------------%n");
      printf("GenTypen08: Das war's erstmal!%n");
   } // main
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // -----------------------------------------------------------
} // GenTypen08
/* ------------------------------------------------------------------------
Warnungen des Compilers:

D:\Java\GenTypen08.java:43: warning: unchecked call to PaarK(K,K)
as a member of the raw type PaarK
      roh03 = new PaarK        ("ccc", "CCC"); // Warnung
              ^
D:\Java\GenTypen08.java:45: warning: unchecked assignment:
PaarK to PaarK<java.lang.String>
      ps_02 = roh02;                           // Warnung
              ^
D:\Java\GenTypen08.java:46: warning: unchecked assignment:
PaarK to PaarK<java.lang.String>
      ps_03 = roh03;                           // Warnung
              ^
D:\Java\GenTypen08.java:48: warning: unchecked assignment:
PaarK to PaarK<java.lang.Double>
      pd_02 = roh02;                           // Warnung
              ^
D:\Java\GenTypen08.java:49: warning: unchecked assignment:
PaarK to PaarK<java.lang.Double>
      pd_03 = roh03;                           // Warnung
              ^
---------------------------------------------------------------------------
Ausgabe des Programms GenTypen08:

GenTypen08: Jetzt geht es los!
----------------------------------
A ps_01: [aaa, AAA]
B roh01: [aaa, AAA]
----------------------------------
C roh02: [bbb, BBB]
D roh03: [ccc, 1.1]
----------------------------------
E ps_02: [bbb, BBB]
F ps_03: [ccc, 1.1]
----------------------------------
G pd_02: [bbb, BBB]
H pd_03: [ccc, 1.1]
----------------------------------
java.lang.ClassCastException: java.lang.String
   at GenTypen08.main(GenTypen08.java:67)
Exception in thread "main"
---------------------------------------------------------------------------
Fehlermeldung des Compilers, wenn die entsprechende Zeile
kein Kommentar ist:

D:\Java\GenTypen08.java:40: incompatible types
found   : PaarK<java.lang.String>
required: PaarK<java.lang.Double>
    pd_01 = ps_01;
            ^
D:\Java\GenTypen08.java:66: incompatible types
found   : java.lang.Double
required: java.lang.String
      String s1 = pd_03.k1;
                       ^
------------------------------------------------------------------------ */
