// Datei GenTypen10.java
/* ------------------------------------------------------------------------
Fortsetzung des Programms GenTypen05: Dort wurden die folgenden
vertauscheEtc-Methoden C, D und E vom Ausfuehrer abgelehnt:

static void vertauscheEtcC(PaarI<? extends Number>) {...}
static void vertauscheEtcD(PaarI<? super   Number>) {...}
static void vertauscheEtcF(PaarI<?>)                {...}

Hier werden diese Methoden mit Hilfe einer Methode namens
fangDenJokerUndVertausche zum Laufen gebracht. Diese
Methode faengt den Jokertyp ? der obigen Methoden in
ihrer Typvariablen FALLE und kann damit die gewuenschte
Vertauschung (der Komponenten p.k1 und p.k2) durchfuehren.

Die Methoden fangDenJokerUndVertausche2 und fangDenJokerUndVertausche3
sollen zeigen, dass man zwei Joker zwar in zwei Fallen, aber nicht
in einer Falle fangen kann.
---------------------------------------------------------------------------
Zur Erinnerung: Die abstrakte Klasse Number ist ein Obertyp von Double und
Integer etc. und (wie alle Typen) ein Untertyp von Object:

Object <--- Number <--+-- Double
                      |
                      +-- Integer
------------------------------------------------------------------------ */
// ==============================================================
class PaarM<K> {    // Eine generische Klasse, 1 Parameter K
   K k1;            // Komponente 1
   K k2;            // Komponente 2
   // -----------------------------------------------------------
   PaarM(K k1, K k2) {
      this.k1 = k1;
      this.k2 = k2;
   } // Konstruktor PaarM
   // -----------------------------------------------------------
   public String toString() {
      return "[" + k1 + ", " + k2 + "]";
   } // toString
   // -----------------------------------------------------------
} // Klasse PaarM
// ==============================================================
class GenTypen10 {
   // -----------------------------------------------------------
   // Vier vertauscheEtc-Methoden C, D, E und X und eine
   // Hilfsmethode mit dem etwas geschwaetzigen Namen
   // fangDenJokerUndVertausche:

   static public
   void vertauscheEtcC(PaarM<? extends Number> p) {
      fangDenJokerUndVertausche(p);
      printf("C %s%n", p);
   } // vertauscheEtcC
   // ---------------------------------------------
   static public
   void vertauscheEtcD(PaarM<? super   Number> p) {
      fangDenJokerUndVertausche(p);
      printf("D %s%n", p);
   } // vertauscheEtcD
   // ---------------------------------------------
   static public
   void vertauscheEtcF(PaarM<?>                p) {
      fangDenJokerUndVertausche(p);
      printf("F %s%n", p);
   } // vertauscheEtcF
   // ---------------------------------------------
   static public
   void vertauscheEtcX(PaarM<?> p1, PaarM<?> p2) {
      fangDenJokerUndVertausche(p1);
      printf("X %s%n", p1);
      fangDenJokerUndVertausche(p2);
      printf("X %s%n", p2);
   } // vertauscheEtcX
   // ---------------------------------------------
   static private <FALLE>
   void fangDenJokerUndVertausche(PaarM<FALLE> p) {
      FALLE tmp = p.k1;
      p.k1      = p.k2;
      p.k2      = tmp;
   } // fangDenJokerUndVertausche
   // -----------------------------------------------------------
   // Eine vertauscheEtc-Methode Y und
   // zwei Hilfsmethoden mit den noch geschwaetzigeren Namen
   // fangDenJokerUndVertausche2 und 3:

   static public
   void vertauscheEtcY(PaarM<?> p1, PaarM<?> p2) {
      fangDenJokerUndVertausche2(p1, p2);
      printf("Y %s%n", p1);
      printf("Y %s%n", p2);
      fangDenJokerUndVertausche2(p1, p2);
//    fangDenJokerUndVertausche3(p1, p2);
      printf("Y %s%n", p1);
      printf("Y %s%n", p2);
   } // vertauscheEtcX
   // ---------------------------------------------
   // Zwei Joker in zwei Fallen fangen geht:
   static private <FALLE1, FALLE2>
   void fangDenJokerUndVertausche2(PaarM<FALLE1> p1, PaarM<FALLE2> p2) {
      FALLE1 tmp1 = p1.k1;
      p1.k1       = p1.k2;
      p1.k2       = tmp1;

      FALLE2 tmp2 = p2.k1;
      p2.k1       = p2.k2;
      p2.k2       = tmp2;
   } // fangDenJokerUndVertausche2
   // ---------------------------------------------
   // Zwei Joker in einer Falle fangen geht nicht:
   static private <FALLE>
   void fangDenJokerUndVertausche3(PaarM<FALLE>  p1, PaarM<FALLE>  p2) {
      printf("Hallo!%n");
   } // fangDenJokerUndVertausche2
   // -----------------------------------------------------------
   static public void main(String [] sonja) {
      printf("GenTypen10: Jetzt geht es los!%n");

      // Objekte verschiedener Typen, die als Komponenten
      // von Paaren verwendet werden sollen:
      String         s1    = new String ("Eins");
      String         s2    = new String ("Zwei");
      Double         d1    = new Double (1.1);
      Double         d2    = new Double (2.2);
      Integer        i1    = new Integer(111);
      Integer        i2    = new Integer(222);

      // Objekte verschiedener PaarM-Typen:
      PaarM<Object>  pOb02 = new PaarM<Object> (s1, s2);
      PaarM<Object>  pOb03 = new PaarM<Object> (d1, i1);
      PaarM<String>  pSt01 = new PaarM<String> (s1, s2);
      PaarM<Number>  pNu01 = new PaarM<Number> (d1, i1);
      PaarM<Double>  pDo01 = new PaarM<Double> (d1, d2);
      PaarM<Integer> pIn01 = new PaarM<Integer>(i1, i2);

      // Die Methoden vertauscheEtcA, ...B und ...E werden jeweils
      // zweimal auf dasselbe PaarM-Objekt angewendet (damit der
      // Vertausche-Effekt besonders leicht erkennbar wird):
      printf("-------------------------------------%n");
      printf("vertauscheEtcC(pNu01): "); vertauscheEtcC(pNu01);
      printf("vertauscheEtcC(pNu01): "); vertauscheEtcC(pNu01);
      printf("vertauscheEtcC(pDo01): "); vertauscheEtcC(pDo01);
      printf("vertauscheEtcC(pDo01): "); vertauscheEtcC(pDo01);
      printf("vertauscheEtcC(pIn01): "); vertauscheEtcC(pIn01);
      printf("vertauscheEtcC(pIn01): "); vertauscheEtcC(pIn01);
      printf("-------------------------------------%n");
      printf("vertauscheEtcD(pOb02): "); vertauscheEtcD(pOb02);
      printf("vertauscheEtcD(pOb02): "); vertauscheEtcD(pOb02);
      printf("vertauscheEtcD(pOb03): "); vertauscheEtcD(pOb03);
      printf("vertauscheEtcD(pOb03): "); vertauscheEtcD(pOb03);
      printf("vertauscheEtcD(pNu01): "); vertauscheEtcD(pNu01);
      printf("vertauscheEtcD(pNu01): "); vertauscheEtcD(pNu01);
      printf("-------------------------------------%n");
      printf("vertauscheEtcF(pOb02): "); vertauscheEtcF(pOb02);
      printf("vertauscheEtcF(pOb02): "); vertauscheEtcF(pOb02);
      printf("vertauscheEtcF(pOb03): "); vertauscheEtcF(pOb03);
      printf("vertauscheEtcF(pOb03): "); vertauscheEtcF(pOb03);
      printf("vertauscheEtcF(pSt01): "); vertauscheEtcF(pSt01);
      printf("vertauscheEtcF(pSt01): "); vertauscheEtcF(pSt01);
      printf("vertauscheEtcF(pNu01): "); vertauscheEtcF(pNu01);
      printf("vertauscheEtcF(pNu01): "); vertauscheEtcF(pNu01);
      printf("vertauscheEtcF(pDo01): "); vertauscheEtcF(pDo01);
      printf("vertauscheEtcF(pDo01): "); vertauscheEtcF(pDo01);
      printf("vertauscheEtcF(pIn01): "); vertauscheEtcF(pIn01);
      printf("vertauscheEtcF(pIn01): "); vertauscheEtcF(pIn01);
      printf("-------------------------------------%n");
      printf("vertauscheEtcX(pOb02, pOb03): %n");
              vertauscheEtcX(pOb02, pOb03);
      printf("-------------------------------------%n");
      printf("vertauscheEtcY(pOb02, pOb03): %n");
              vertauscheEtcY(pOb02, pOb03);
      printf("-------------------------------------%n");

      printf("GenTypen10: Das war's erstmal!%n");
   } // main
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // -----------------------------------------------------------
} // class GenTypen10
/* ------------------------------------------------------------------------
Ausgabe des Programms GenTypen10:

GenTypen10: Jetzt geht es los!
-------------------------------------
vertauscheEtcC(pNu01): C [111, 1.1]
vertauscheEtcC(pNu01): C [1.1, 111]
vertauscheEtcC(pDo01): C [2.2, 1.1]
vertauscheEtcC(pDo01): C [1.1, 2.2]
vertauscheEtcC(pIn01): C [222, 111]
vertauscheEtcC(pIn01): C [111, 222]
-------------------------------------
vertauscheEtcD(pOb02): D [Zwei, Eins]
vertauscheEtcD(pOb02): D [Eins, Zwei]
vertauscheEtcD(pOb03): D [111, 1.1]
vertauscheEtcD(pOb03): D [1.1, 111]
vertauscheEtcD(pNu01): D [111, 1.1]
vertauscheEtcD(pNu01): D [1.1, 111]
-------------------------------------
vertauscheEtcF(pOb02): F [Zwei, Eins]
vertauscheEtcF(pOb02): F [Eins, Zwei]
vertauscheEtcF(pOb03): F [111, 1.1]
vertauscheEtcF(pOb03): F [1.1, 111]
vertauscheEtcF(pSt01): F [Zwei, Eins]
vertauscheEtcF(pSt01): F [Eins, Zwei]
vertauscheEtcF(pNu01): F [111, 1.1]
vertauscheEtcF(pNu01): F [1.1, 111]
vertauscheEtcF(pDo01): F [2.2, 1.1]
vertauscheEtcF(pDo01): F [1.1, 2.2]
vertauscheEtcF(pIn01): F [222, 111]
vertauscheEtcF(pIn01): F [111, 222]
-------------------------------------
vertauscheEtcX(pOb02, pOb03):
X [Zwei, Eins]
X [111, 1.1]
-------------------------------------
vertauscheEtcY(pOb02, pOb03):
Y [Eins, Zwei]
Y [1.1, 111]
Y [Zwei, Eins]
Y [111, 1.1]
-------------------------------------
GenTypen10: Das war's erstmal!
---------------------------------------------------------------------------
Fehlermeldung des Compilers, wenn die betreffende Zeile kein Kommentar ist:

D:\Java\GenTypen10.java:92:
<FALLE>fangDenJokerUndVertausche3(PaarM<FALLE>,PaarM<FALLE>) in GenTypen10
cannot be applied to (PaarM<?>,PaarM<?>); no instance(s) of
type variable(s) FALLE exist so that argument type PaarM<?> conforms to
formal parameter type PaarM<FALLE>
      fangDenJokerUndVertausche3(p1, p2);
      ^
------------------------------------------------------------------------ */
