// Datei GenTypen14.java
/* ------------------------------------------------------------------------
Ein roher generischer Typ wie ArrayList oder GenTyp (siehe unten) ist
als Komponententyp einer Reihung erlaubt, ein parametrisierter Typ wie
ArrayList<String> oder GenTyp<String> dagegen nicht (Grund: das
Kovarianz-Problem).
------------------------------------------------------------------------ */
import java.util.ArrayList;

// Ein besonders schlichter generischer Typ namens GenTyp:
class GenTyp<T> {}

// Die Hauptklasse dieses Programms:
class GenTypen14 {
   static public void main(String [] sonja) {

      String           [] r01 = new String           [3];

      ArrayList        [] r02 = new ArrayList        [3];
      GenTyp           [] r03 = new GenTyp           [3];

//    Object              r04 = new ArrayList<String>[3]; // Fehler
//    Object              r05 = new GenTyp   <String>[3]; // Fehler

//    Object              r06 = new ArrayList<Object>[3]; // Fehler
//    Object              r07 = new GenTyp   <Object>[3]; // Fehler

      Object              r08 = new ArrayList<?>     [3];
      Object              r09 = new GenTyp   <?>     [3];

      ArrayList        [] r10 = r02;
      GenTyp           [] r11 = r03;

      ArrayList<String>[] r12 = r02;                      // Warnung
      GenTyp   <String>[] r13 = r03;                      // Warnung

      System.out.println("GenTypen14: Jetzt geht es los!");
      System.out.println("GenTypen14: Das war's erstmal!");

   } // main

} // class GenTypen
/* ------------------------------------------------------------------------
4 Fehlermeldungen und 2 Warnungen des Compilers javac von Sun:

D:\Java\GenTypen14.java:22: generic array creation
      Object              r04 = new ArrayList<String>[3]; // Fehler
                                ^
D:\Java\GenTypen14.java:23: generic array creation
      Object              r05 = new GenTyp   <String>[3]; // Fehler
                                ^
D:\Java\GenTypen14.java:25: generic array creation
      Object              r06 = new ArrayList<Object>[3]; // Fehler
                                ^
D:\Java\GenTypen14.java:26: generic array creation
      Object              r07 = new GenTyp   <Object>[3]; // Fehler
                                ^
D:\Java\GenTypen14.java:34: warning: [unchecked] unchecked conversion
found   : java.util.ArrayList[]
required: java.util.ArrayList<java.lang.String>[]
      ArrayList<String>[] r12 = r02;                      // Warnung
                                ^
D:\Java\GenTypen14.java:35: warning: [unchecked] unchecked conversion
found   : GenTyp[]
required: GenTyp<java.lang.String>[]
      GenTyp   <String>[] r13 = r03;                      // Warnung
                                ^
------------------------------------------------------------------------ */
