// Datei GenTypen16.java
/* ------------------------------------------------------------------------
In der generischen Klasse K<T> wird eine generische Methode
<M, N extends K> void m() {...} vereinbart. Innerhalb dieser Methode m
sind also die drei Typvariablen T, M und N sichtbar, so dass man dort
die 7 Typen K, K<T>, K<?>, K<Object>, K<String>, K<N> und K<M> benutzen
kann. Welcher dieser 7 Typen ist ein Untertyp von welchen anderen dieser
7 Typen? Die Fehlermeldungen, mit denen der Compiler die Methode m in
der folgenden Klasse K<T> ablehnt, beantworten diese Frage.
------------------------------------------------------------------------ */
class K<T> {

   <M, N extends K> void m() {
      // Es werden 7 mal 7 gleich 49 Referenzvariablen namens v11 bis v77
      // vereinbart und initialisiert. Einige der Vereinbarungen werden
      // vom Ausfuehrer akzeptiert, einige loesen Warnungen aus und einige
      // werden abgelehnt:

      K         v11 = new K        ();
      K         v12 = new K<T>     ();
//    K         v13 = new K<?>     (); // Fehler
      K         v14 = new K<Object>();
      K         v15 = new K<String>();
      K         v16 = new K<M>     ();
      K         v17 = new K<N>     ();

      K<T>      v21 = new K        (); // Warnung
      K<T>      v22 = new K<T>     ();
//    K<T>      v23 = new K<?>     (); // Fehler
//    K<T>      v24 = new K<Object>(); // Fehler
//    K<T>      v25 = new K<String>(); // Fehler
//    K<T>      v26 = new K<M>     (); // Fehler
//    K<T>      v27 = new K<N>     (); // Fehler

      K<?>      v31 = new K        ();
      K<?>      v32 = new K<T>     ();
//    K<?>      v33 = new K<?>     (); // Fehler
      K<?>      v34 = new K<Object>();
      K<?>      v35 = new K<String>();
      K<?>      v36 = new K<M>     ();
      K<?>      v37 = new K<N>     ();

      K<Object> v41 = new K        (); // Warnung
//    K<Object> v42 = new K<T>     (); // Fehler
//    K<Object> v43 = new K<?>     (); // Fehler
      K<Object> v44 = new K<Object>();
//    K<Object> v45 = new K<String>(); // Fehler
//    K<Object> v46 = new K<M>     (); // Fehler
//    K<Object> v47 = new K<N>     (); // Fehler

      K<String> v51 = new K        (); // Warnung
//    K<String> v52 = new K<T>     (); // Fehler
//    K<String> v53 = new K<?>     (); // Fehler
//    K<String> v54 = new K<Object>(); // Fehler
      K<String> v55 = new K<String>();
//    K<String> v56 = new K<M>     (); // Fehler
//    K<String> v57 = new K<N>     (); // Fehler

      K<N>      v61 = new K        (); // Warnung
//    K<N>      v62 = new K<T>     (); // Fehler
//    K<N>      v63 = new K<?>     (); // Fehler
//    K<N>      v64 = new K<Object>(); // Fehler
//    K<N>      v65 = new K<String>(); // Fehler
//    K<N>      v66 = new K<M>     (); // Fehler
      K<N>      v67 = new K<N>     ();

      K<M>      v71 = new K        (); // Warnung
//    K<M>      v72 = new K<T>     (); // Fehler
//    K<M>      v73 = new K<?>     (); // Fehler
//    K<M>      v74 = new K<Object>(); // Fehler
//    K<M>      v75 = new K<String>(); // Fehler
      K<M>      v76 = new K<M>     ();
//    K<M>      v77 = new K<N>     (); // Fehler
   } // m

} // class K<T>
// ------------------------------------------------------------------------
class GenTypen16 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("GenTypen16: Jetzt geht es los!%n");
      printf("GenTypen16: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class GenTypen16
