// Datei GleitRech03.java
/* ------------------------------------------------------------------------
Liest eine float-Zahl float01 und eine anzahl ein. Gibt anzahl viele
"aufeinanderfolgende" float-Zahlen (mit float01 beginnend) aus, jeweils
mit der "natuerlichen Anzahl von Nachpunktstellen" und zusaetzlich exakt.
Fuer die exakte Darstellung werden BigDecimal-Objekte verwendet.
------------------------------------------------------------------------ */
import java.math.BigDecimal;

class GleitRech03 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      float float01;
      int   anzahl, bits;

      while (true) {
         printf("-----------------------------------------------------\n");
         printf("Eine Bruchzahl (999 zum Beenden)? ");
         float01 = EM.liesFloat();
         if (float01 == 999) break;
         printf("Eine Anzahl (1..500)            ? ");
         anzahl = EM.liesInt();

         anzahl = Math.max(anzahl,   1); // Mindestens 1
         anzahl = Math.min(anzahl, 500); // Hoechstens 500

         for (int i=1; i<=anzahl; i++) {

            // Die Zahl float01 "einfach so" in einen String umwandeln
            // und ausgeben. Dabei werden nur soviele Dezimalziffern
            // ausgegeben, wie noetig sind, um die Darstellung dieser
            // Zahl von den Darstellungen der naechstgroesseren und der
            // naechstkleineren Zahl zu unterscheiden:
            printf("%3d: %-15s", i, float01+"");

            // Den primitiven Wert von float1 in ein BigDecimal-Objekt
            // und dann in einen String umwandeln. Der String wird
            // nur ausgegeben, wenn er weniger als 50 Zeichen lang ist.
            BigDecimal bd = new BigDecimal(float01);
            String     st = "" + bd;
            if (st.length() < 50) {
               printf("exakt: %s\n", st);
            } else {
               printf("exakt: Zu lang!\n");
            }

            // Den Wert der Variablen float01 durch den naechstgroesseren
            // float-Wert ersetzen:
            bits    = Float.floatToIntBits(float01); // float nach int
            bits++;                                  // int um 1 erhoehen
            float01 = Float.intBitsToFloat(bits);    // int nach float
         } // for
      } // while

      printf("GleitRech03: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class GleitRech03
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm GleitRech03:

-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 0.3
Eine Anzahl (1..500)            ? 10
  1: 0.3            exakt: 0.300000011920928955078125
  2: 0.30000004     exakt: 0.3000000417232513427734375
  3: 0.30000007     exakt: 0.30000007152557373046875
  4: 0.3000001      exakt: 0.3000001013278961181640625
  5: 0.30000013     exakt: 0.300000131130218505859375
  6: 0.30000016     exakt: 0.3000001609325408935546875
  7: 0.3000002      exakt: 0.30000019073486328125
  8: 0.30000022     exakt: 0.3000002205371856689453125
  9: 0.30000025     exakt: 0.300000250339508056640625
 10: 0.30000028     exakt: 0.3000002801418304443359375
-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 70007
Eine Anzahl (1..500)            ? 10
  1: 70007.0        exakt: 70007
  2: 70007.01       exakt: 70007.0078125
  3: 70007.016      exakt: 70007.015625
  4: 70007.02       exakt: 70007.0234375
  5: 70007.03       exakt: 70007.03125
  6: 70007.04       exakt: 70007.0390625
  7: 70007.05       exakt: 70007.046875
  8: 70007.055      exakt: 70007.0546875
  9: 70007.06       exakt: 70007.0625
 10: 70007.07       exakt: 70007.0703125
-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 999
GleitRech03: Das war's erstmal!
------------------------------------------------------------------------ */