// Datei GleitRech04.java
/* ------------------------------------------------------------------------
Liest eine double-Zahl double01 und eine anzahl ein. Gibt anzahl viele
"aufeinanderfolgende" double-Zahlen (mit double01 beginnend) aus, jeweils
mit der "natuerlichen Anzahl von Nachpunktstellen" und zusaetzlich exakt.
Fuer die exakte Darstellung werden BigDecimal-Objekte verwendet.
------------------------------------------------------------------------ */
import java.math.BigDecimal;

class GleitRech04 {
   static public void main(String [] sonja) {
      double double01;
      int    anzahl;
      long   bits;

      while (true) {
         printf("-----------------------------------------------------\n");
         printf("Eine Bruchzahl (999 zum Beenden)? ");
         double01 = EM.liesFloat();
         if (double01 == 999) break;
         printf("Eine Anzahl (1..500)            ? ");
         anzahl = EM.liesInt();

         anzahl = Math.max(anzahl,   1);
         anzahl = Math.min(anzahl, 500);

         for (int i=1; i<=anzahl; i++) {

            // Die Zahl double01 "einfach so" ohne spezielle Formatierung
            // ausgeben. Dabei werden nur soviele Dezimalziffern ausge-
            // geben, wie noetig sind, um die Darstellung dieser Zahl
            // von den Darstellungen der naechstgroesseren und der
            // naechstkleineren Zahl zu unterscheiden:
            printf("%3d: %-23s", i, double01+"");

            // Falls die exakte Darstellung von double01 weniger als 50
            // Zeichen lang ist, wird sie auch (auf der gleichen Zeile)
            // ausgegeben:
            BigDecimal bd = new BigDecimal(double01);
            String     st = "" + bd;
            if (st.length() < 50) {
               printf("exakt: %s\n", st);
            } else {
               printf("exakt: Zu lang!\n");
            }

            // Den Wert der Variablen double01 durch den naechstgroesseren
            // double-Wert ersetzen:
            bits     = Double.doubleToLongBits(double01);// double nach long
            bits++;                                      // long um 1 erhoehen
            double01 = Double.longBitsToDouble(bits);    // long nach double
         } // for
      } // while

      printf("GleitRech04: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class GleitRech04
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm GleitRech04 (nach der Eingabe von 100 und 10
fehlen einige exakte Darstellungen, weil sie laenger als 49 Zeichen sind):

-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 333E5
Eine Anzahl (1..500)            ? 10
  1: 3.33E7                 exakt: 33300000
  2: 3.3300000000000004E7   exakt: 33300000.0000000037252902984619140625
  3: 3.3300000000000007E7   exakt: 33300000.000000007450580596923828125
  4: 3.330000000000001E7    exakt: 33300000.0000000111758708953857421875
  5: 3.3300000000000015E7   exakt: 33300000.00000001490116119384765625
  6: 3.330000000000002E7    exakt: 33300000.0000000186264514923095703125
  7: 3.3300000000000022E7   exakt: 33300000.000000022351741790771484375
  8: 3.3300000000000026E7   exakt: 33300000.0000000260770320892333984375
  9: 3.330000000000003E7    exakt: 33300000.0000000298023223876953125
 10: 3.3300000000000034E7   exakt: 33300000.0000000335276126861572265625
-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 70007
Eine Anzahl (1..500)            ? 10
  1: 70007.0                exakt: 70007
  2: 70007.00000000001      exakt: 70007.000000000014551915228366851806640625
  3: 70007.00000000003      exakt: 70007.00000000002910383045673370361328125
  4: 70007.00000000004      exakt: 70007.000000000043655745685100555419921875
  5: 70007.00000000006      exakt: 70007.0000000000582076609134674072265625
  6: 70007.00000000007      exakt: 70007.000000000072759576141834259033203125
  7: 70007.00000000009      exakt: 70007.00000000008731149137020111083984375
  8: 70007.0000000001       exakt: 70007.000000000101863406598567962646484375
  9: 70007.00000000012      exakt: 70007.000000000116415321826934814453125
 10: 70007.00000000013      exakt: 70007.000000000130967237055301666259765625
-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? 100
Eine Anzahl (1..500)            ? 10
  1: 100.0                  exakt: 100
  2: 100.00000000000001     exakt: Zu lang!
  3: 100.00000000000003     exakt: 100.000000000000028421709430404007434844970703125
  4: 100.00000000000004     exakt: Zu lang!
  5: 100.00000000000006     exakt: 100.00000000000005684341886080801486968994140625
  6: 100.00000000000007     exakt: Zu lang!
  7: 100.00000000000009     exakt: 100.000000000000085265128291212022304534912109375
  8: 100.0000000000001      exakt: Zu lang!
  9: 100.00000000000011     exakt: 100.0000000000001136868377216160297393798828125
 10: 100.00000000000013     exakt: Zu lang!
-----------------------------------------------------
Eine Bruchzahl (999 zum Beenden)? GleitRech04: 999
Das war's erstmal!
------------------------------------------------------------------------ */