// Datei GleitRech05.java
/* ------------------------------------------------------------------------
Was kommt heraus, wenn man die besonderen float-Werte -0, +0, -Infinity,
Infinity und NaN multipliziert bzw. dividiert? Dieses Programm gibt
zwei Tabellen aus, in denen alle Antworten stehen.

Das Beispielprogramm GleitRech06 rechnet mit double-Werten und gibt die
gleichen Tabellen aus wie das vorliegende Programm.
------------------------------------------------------------------------ */
class GleitRech05 {
   // ---------------------------------------------------------------------
   // Eine Tabelle floatTab mit 7 + 4 gleich 11 float-Werten. Zu jedem
   // dieser float-Werte gibt es in der Tabelle namenTab einen entsprech-
   // enden Namen (vom Typ String). Fuer 3 der float-Werte werden zuerst
   // kuerzere Namen vereinbart:

   static float mInf = Float.NEGATIVE_INFINITY;
   static float pInf = Float.POSITIVE_INFINITY;
   static float nan  = Float.NaN;

   static float[] floatTab = new float[] {
      mInf,     -3.0F,    -0.0F,    +0.0F,    +3.0F,    pInf,     nan,
      +9.0F,    +1.0F,    -9.0F,    -1.0F,
   }; // Reifung floatTab
   // ------------------------------------------------------------------
   // Eine Tabelle namenTab mit 7 + 4 gleich 11 Namen fuer die float-
   // Werte in der Tabelle floatTab:

   static String[] namenTab = new String[] {
      " -Inf ", " neg  ", " -0   ", " +0   ", " pos  ", " +Inf ", " NaN  ",
      " per  ", " per  ", " ner  ", " ner  ",
   }; // Reihung namenTab
   // ---------------------------------------------------------------------
   static String floatToName(float f) {
      // Falls f in der Tabelle floatTab vorkommt, wird die entsprechende
      // Komponente der Tabelle namenTab geliefert, sonst "Fehler!!".

      // Die primitiven float-Werte f und floatTab[i] muessen in Float-
      // Objekte umgewandelt und mit equals verglichen werden, damit
      // +0 ungleich -0 und NaN gleich NaN ist.

      Float  F   = new Float(f);
      String erg = "Fehler!!";

      for (int i=0; i<floatTab.length; i++) {
         Float FRI = new Float(floatTab[i]);
         if (F.equals(FRI)) {
            erg = namenTab[i];
            break;
         }
      } // for

      return erg;
   } // floatToName
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Gibt zwei Tabellen aus die darstellen, was beim Multiplizieren
      // bzw. Dividieren der besonderen float-Werte -0, +0 , -Infinity,
      // Infiniyt und NaN herauskommt.

      // ------------------------------------------------------------------
      // Ein paar Ueberschriftenzeilen (M fuer Multipliaktion und D fuer
      // Division):

      String uebM = "   *   |  -Inf   neg    -0     +0     pos    +Inf   Nan  ";
      String uebD = "   /   |  -Inf   neg    -0     +0     pos    +Inf   Nan  ";
      String ueb2 = "-------|-------------------------------------------------";
      String ueb3 = "---------------------------------------------------------";
      // ------------------------------------------------------------------
      pln("GleitRech05, Rechenregeln fuer float-Werte:");

      // Die Tabelle fuer die Multiplikation ausgeben:
      pln(ueb3);
      pln(uebM); // M wie Multiplikation
      pln(ueb2);
      for (int i=0; i<7; i++) {
         p(namenTab[i] + " | ");
         for (int j=0; j<7; j++) {
            float  prod = floatTab[i] * floatTab[j]; // Multiplikation!
            String name = floatToName(prod);
            p(name + " ");
         }
         pln();
      }
      pln(ueb3);

      pln();

      // ------------------------------------------------------------------
      // Die Tabelle fuer die Multiplikation ausgeben:
      pln(ueb3);
      pln(uebD); // D wie Division
      pln(ueb2);
      for (int i=0; i<7; i++) {
         p(namenTab[i] + " | ");
         for (int j=0; j<7; j++) {
            float quot = floatTab[i] / floatTab[j]; // Division!
            String name = floatToName(quot);
            p(name + " ");
         }
         pln();
      }
      pln(ueb3);
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
} // class GleitRech05
/* ------------------------------------------------------------------------
Ausgabe des Programms GleitRech05:

GleitRech05, Rechenregeln fuer float-Werte:
---------------------------------------------------------
   *   |  -Inf   neg    -0     +0     pos    +Inf   Nan
-------|-------------------------------------------------
 -Inf  |  +Inf   +Inf   NaN    NaN    -Inf   -Inf   NaN
 neg   |  +Inf   per    +0     -0     ner    -Inf   NaN
 -0    |  NaN    +0     +0     -0     -0     NaN    NaN
 +0    |  NaN    -0     -0     +0     +0     NaN    NaN
 pos   |  -Inf   ner    -0     +0     per    +Inf   NaN
 +Inf  |  -Inf   -Inf   NaN    NaN    +Inf   +Inf   NaN
 NaN   |  NaN    NaN    NaN    NaN    NaN    NaN    NaN
---------------------------------------------------------

---------------------------------------------------------
   /   |  -Inf   neg    -0     +0     pos    +Inf   Nan
-------|-------------------------------------------------
 -Inf  |  NaN    +Inf   +Inf   -Inf   -Inf   NaN    NaN
 neg   |  +0     per    +Inf   -Inf   ner    -0     NaN
 -0    |  +0     +0     NaN    NaN    -0     -0     NaN
 +0    |  -0     -0     NaN    NaN    +0     +0     NaN
 pos   |  -0     ner    -Inf   +Inf   per    +0     NaN
 +Inf  |  NaN    -Inf   -Inf   +Inf   +Inf   NaN    NaN
 NaN   |  NaN    NaN    NaN    NaN    NaN    NaN    NaN
---------------------------------------------------------
------------------------------------------------------------------------ */