// Datei GleitRech06.java
/* ------------------------------------------------------------------------
Was kommt heraus, wenn man die besonderen double-Werte -0, +0, -Infinity,
Infinity und NaN multipliziert bzw. dividiert? Dieses Programm gibt
zwei Tabellen aus, in denen alle Antworten stehen.

Das Beispielprogramm GleitRech05 rechnet mit float-Werten und gibt die
gleichen Tabellen aus wie das vorliegende Programm.
------------------------------------------------------------------------ */
class GleitRech06 {
   // ---------------------------------------------------------------------
   // Eine Tabelle doubleTab mit 7 + 4 gleich 11 double-Werten. Zu jedem
   // dieser double-Werte gibt es in der Tabelle namenTab einen entsprech-
   // enden Namen (vom Typ String). Fuer 3 der double-Werte werden zuerst
   // kuerzere Namen vereinbart:

   static double mInf = Double.NEGATIVE_INFINITY;
   static double pInf = Double.POSITIVE_INFINITY;
   static double nan  = Double.NaN;

   static double[] doubleTab = new double[] {
      mInf,     -3.0D,    -0.0D,    +0.0D,    +3.0D,    pInf,     nan,
      +9.0D,    +1.0D,    -9.0D,    -1.0D,
   }; // Reifung doubleTab
   // ------------------------------------------------------------------
   // Eine Tabelle namenTab mit 7 + 4 gleich 11 Namen fuer die double-
   // Werte in der Tabelle doubleTab:

   static String[] namenTab = new String[] {
      " -Inf ", " neg  ", " -0   ", " +0   ", " pos  ", " +Inf ", " NaN  ",
      " per  ", " per  ", " ner  ", " ner  ",
   }; // Reihung namenTab
   // ---------------------------------------------------------------------
   static String doubleToName(double f) {
      // Falls f in der Tabelle doubleTab vorkommt, wird die entsprechende
      // Komponente der Tabelle namenTab geliefert, sonst "Fehler!!".

      // Die primitiven double-Werte f und doubleTab[i] muessen in Double-
      // Objekte umgewandelt und mit equals verglichen werden, damit
      // +0 ungleich -0 und NaN gleich NaN ist.

      Double  F   = new Double(f);
      String erg = "Fehler!!";

      for (int i=0; i<doubleTab.length; i++) {
         Double FRI = new Double(doubleTab[i]);
         if (F.equals(FRI)) {
            erg = namenTab[i];
            break;
         }
      } // for

      return erg;
   } // doubleToName
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Gibt zwei Tabellen aus die darstellen, was beim Multiplizieren
      // bzw. Dividieren der besonderen double-Werte -0, +0 , -Infinity,
      // Infiniyt und NaN herauskommt.

      // ------------------------------------------------------------------
      // Ein paar Ueberschriftenzeilen (M fuer Multipliaktion und D fuer
      // Division):

      String uebM = "   *   |  -Inf   neg    -0     +0     pos    +Inf   Nan  ";
      String uebD = "   /   |  -Inf   neg    -0     +0     pos    +Inf   Nan  ";
      String ueb2 = "-------|-------------------------------------------------";
      String ueb3 = "---------------------------------------------------------";
      // ------------------------------------------------------------------
      pln("GleitRech05, Rechenregeln fuer double-Werte:");

      // Die Tabelle fuer die Multiplikation ausgeben:
      pln(ueb3);
      pln(uebM); // M wie Multiplikation
      pln(ueb2);
      for (int i=0; i<7; i++) {
         p(namenTab[i] + " | ");
         for (int j=0; j<7; j++) {
            double  prod = doubleTab[i] * doubleTab[j]; // Multiplikation!
            String name = doubleToName(prod);
            p(name + " ");
         }
         pln();
      }
      pln(ueb3);

      pln();

      // ------------------------------------------------------------------
      // Die Tabelle fuer die Multiplikation ausgeben:
      pln(ueb3);
      pln(uebD); // D wie Division
      pln(ueb2);
      for (int i=0; i<7; i++) {
         p(namenTab[i] + " | ");
         for (int j=0; j<7; j++) {
            double quot = doubleTab[i] / doubleTab[j]; // Division!
            String name = doubleToName(quot);
            p(name + " ");
         }
         pln();
      }
      pln(ueb3);
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
} // class GleitRech06
/* ------------------------------------------------------------------------
Ausgabe des Programms GleitRech06:

GleitRech05, Rechenregeln fuer double-Werte:
---------------------------------------------------------
   *   |  -Inf   neg    -0     +0     pos    +Inf   Nan
-------|-------------------------------------------------
 -Inf  |  +Inf   +Inf   NaN    NaN    -Inf   -Inf   NaN
 neg   |  +Inf   per    +0     -0     ner    -Inf   NaN
 -0    |  NaN    +0     +0     -0     -0     NaN    NaN
 +0    |  NaN    -0     -0     +0     +0     NaN    NaN
 pos   |  -Inf   ner    -0     +0     per    +Inf   NaN
 +Inf  |  -Inf   -Inf   NaN    NaN    +Inf   +Inf   NaN
 NaN   |  NaN    NaN    NaN    NaN    NaN    NaN    NaN
---------------------------------------------------------

---------------------------------------------------------
   /   |  -Inf   neg    -0     +0     pos    +Inf   Nan
-------|-------------------------------------------------
 -Inf  |  NaN    +Inf   +Inf   -Inf   -Inf   NaN    NaN
 neg   |  +0     per    +Inf   -Inf   ner    -0     NaN
 -0    |  +0     +0     NaN    NaN    -0     -0     NaN
 +0    |  -0     -0     NaN    NaN    +0     +0     NaN
 pos   |  -0     ner    -Inf   +Inf   per    +0     NaN
 +Inf  |  NaN    -Inf   -Inf   +Inf   +Inf   NaN    NaN
 NaN   |  NaN    NaN    NaN    NaN    NaN    NaN    NaN
---------------------------------------------------------
------------------------------------------------------------------------ */