// Datei Grabo05.java
/* ------------------------------------------------------------------------
Weil die Klasse Grabo05 die Klasse JFrame erweitert, wird jedes
Grabo05-Objekt auf dem Bildschirm als Fenster (mit Rahmen,
Ueberschrift und 3 Knoepfen) dargestellt. In einem solchen
Fenster koennen sieben Arten von Fenster-Ereignissen eintreten:

1. windowActivated
2. windowClosed
3. windowClosing
4. windowDeactivated
5. windowDeiconified
6. windowIconified
7. windowOpened

Vom Konstruktor wird bei jedem neuen Garabo05-Objekt ein
WindowListener-Objekt angemeldet, welches fuer jede Art von
Fenster-Ereignis eine entsprechende Behandlungsmethode enthaelt.
Diese Behandlungsmethoden geben eine kleine Meldung zur
Standardausgabe aus. Wird die Behandlungsmethode windowClosing
zum zweiten Mal aufgerufen, beendet sie das gesamte Programm.

Das Ereignis windowClosing tritt ein, wenn der Benutzer das Fenster
schliesst, indem er den Fenster-Schliessen-Knopf anklickt.

Das Ereignis windowClosed tritt ein, wenn das Fenster mit dem Befehl
dispose zerstoert wird.
------------------------------------------------------------------------ */
import javax.swing.JFrame;
import java .awt  .event.WindowListener;
import java .awt  .event.WindowAdapter;
import java .awt  .event.WindowEvent;
import java .awt        .Graphics;
import java .awt        .Color;

class Grabo05 extends JFrame {
   static private int aufrufeInsgesamt = 0;
   static private int aufrufeClosing   = 0;
   // ---------------------------------------------------------------------
   Grabo05(String uebSchrift) {
      super(uebSchrift);

      // Bei dem neuen, zu initialisierenden Grabo05-Objekt wird ein
      // WindowListener-Objekt angemeldet, welches fuer jedes moegliche
      // Fenster-Ereignis eine kleine Methode enthaelt.
      this.addWindowListener(new WindowListener() {
         // ---------------------------------------------------------------
         public void windowActivated  (WindowEvent we) {
            gibAus(we);
         } // windowActivated
         // ---------------------------------------------------------------
         public void windowClosed     (WindowEvent we) {
            gibAus(we);
         } // windowClosed
         // ---------------------------------------------------------------
         public void windowClosing    (WindowEvent we) {
            gibAus(we);
            // Erst beim 2. Aufruf dieser Methode wird
            // das Programm beendet:
            dispose(); // Bewirkt, dass windowClosed aufgerufen wird
            if (++aufrufeClosing >= 2) System.exit(0);
         } // windowClosing
         // ---------------------------------------------------------------
         public void windowDeactivated(WindowEvent we) {
            gibAus(we);
         } // windowDeactivated
         // ---------------------------------------------------------------
         public void windowDeiconified(WindowEvent we) {
            gibAus(we);
         } // windowDeiconified
         // ---------------------------------------------------------------
         public void windowIconified  (WindowEvent we) {
            gibAus(we);
         } // windowIconified
         // ---------------------------------------------------------------
         public void windowOpened     (WindowEvent we) {
            gibAus(we);
         } // windowOpened
         // ---------------------------------------------------------------
         private void gibAus(WindowEvent we) {
            String name     = we.getWindow().getName();
            String str1     = we.toString ();
            int    bis1     = str1.indexOf(",");
            String ereignis = str1.substring(34, bis1);
            printf("%2d. %s: %s\n", ++aufrufeInsgesamt, name, ereignis);
         } // gibAus
         // ---------------------------------------------------------------
      });
   } // Konstruktor Grabo05
   // ---------------------------------------------------------------------
   public void paint(Graphics gert) {
      super.paint(gert); // Sollte man immer so machen!
      gert.setColor(Color.black);
      gert.drawString("Zum Beenden, den Fenster-",       20, 45);
      gert.drawString("Schliessen-Knopf  x  anklicken!", 20, 60);
   } // paint
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Grabo05
// ------------------------------------------------------------------------