// Datei Grabo06.java
/* ------------------------------------------------------------------------
Weil die Klasse Grabo06 die Klasse JFrame erweitert, wird jedes
Grabo06-Objekt auf dem Bildschirm als Fenster (mit Rahmen,
Ueberschrift und 3 Knoepfen) dargestellt. In einem solchen
Fenster koennen acht Arten von *Maus-Ereignissen* eintreten,
die in drei Gruppen eingeteilt sind:

Gruppe 1: Mouse-Ereignisse       (5 Arten):
   mouseClicked       // Ein Druck und ein Loslassen eines Mausknopfes
   mouseEntered       // Maus wurde in  das Fenster hineinbewegt
   mouseExited        // Maus wurde aus dem Fenster hinausbewegt
   mousePressed       // Ein Druck auf einen Mausknopf
   mouseReleased      // Ein Loslassen eines Mausknopfes

Gruppe 2: MouseMotion-Ereignisse (2 Arten):
   mouseDragged       // Maus mit einem gedrueckten Knopf bewegt
   mouseMoved         // Maus ohne      gedrueckten Knopf bewegt

Gruppe 3: MouseWheel-Ereignisse  (1 Art):
   mouseWheelMoved    // Das Maus-Rad wurde bewegt

Methoden zur Behandlung all dieser Maus-Ereignisse werden in
drei Objekte verpackt und diese werden vom Konstruktor bei
jedem neuen Grabo06-Objekt angemeldet. Als "Behandlung" eines
Ereignisses wird hier nur eine Meldung (mit Informationen
ueber das Ereignis) zur Standardausgabe ausgegeben.
------------------------------------------------------------------------ */
import javax.swing      .JFrame;
import java .awt  .event.MouseListener;        // Gruppe 1
import java .awt  .event.MouseMotionListener;  // Gruppe 2
import java .awt  .event.MouseWheelListener;   // Gruppe 3
import java .awt  .event.MouseEvent;
import java .awt  .event.MouseWheelEvent;
import java .awt        .Graphics;
import java .awt        .Color;
import java .util       .Formatter;

class Grabo06 extends JFrame {

   // Wie oft wurden alle Behandlungsmethoden (mouseClicke,
   // mouseEntered, ... etc.) zusammengenommen aufgerufen?
   static private int aufrufeInsgesamt = 0;
   // ------------------------------------------------------------------
   // Fuenf Methoden mouseClicked bis mouseReleased werden in ein
   // MouseListener-Objekt namens ml verpackt:
   static MouseListener ml = new MouseListener() {
      // ---------------------------------------------------------------
      public void mouseClicked (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mouseClicked
      // ---------------------------------------------------------------
      public void mouseEntered (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mouseEntered
      // ---------------------------------------------------------------
      public void mouseExited  (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mouseExited
      // ---------------------------------------------------------------
      public void mousePressed (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mousePressed
      // ---------------------------------------------------------------
      public void mouseReleased(MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mouseReleased
      // ---------------------------------------------------------------
   }; // MouseListener ml
   // ---------------------------------------------------------------------
   // Zwei Methoden mouseDragged und mouseMoved werden in ein
   // MouseMotionListener-Objekt namens mml verpackt:
   static MouseMotionListener mml = new MouseMotionListener() {
      // ---------------------------------------------------------------
      public void mouseDragged (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // mouseDragged
      // ---------------------------------------------------------------
      public void mouseMoved   (MouseEvent mev) {
         pln(mevToFormatter(mev));
      } // windowClosed
      // ---------------------------------------------------------------
   }; // MouseMotionListener mml
   // ---------------------------------------------------------------------
   // Eine Methode mouseWheelMoved wird in ein MouseWheelListener-Objekt
   // namens mwl verpackt:
   static MouseWheelListener mwl = new MouseWheelListener() {
      // ---------------------------------------------------------------
      public void mouseWheelMoved (MouseWheelEvent mwev) {
         pln(mwevToFormatter(mwev));
      } // mouseDragged
      // ---------------------------------------------------------------
   }; // MouseWheelListener mwl
   // ---------------------------------------------------------------------
   Grabo06(String uebSchrift) {
      super(uebSchrift);

      // Drei Objekte mit 5 + 2 + 1 gleich 8 Methoden zur Behandlung
      // aller moeglichen Maus-Ereignisse werden bei dem neuen, zu
      // initialisierenden Objekt angemeldet:
      this.addMouseListener        (ml);
      this.addMouseMotionListener (mml);
      this.addMouseWheelListener  (mwl);

      // Damit man durch Schliessen eines Grabo06-Fensters
      // das umgebende Programm beenden kann:
      this.setDefaultCloseOperation(Grabo01.EXIT_ON_CLOSE);
      this.setBounds(30, 20, 300, 200);
      this.setVisible(true);

   } // Konstruktor Grabo06
   // ---------------------------------------------------------------------
   public void paint(Graphics gert) {
      super.paint(gert); // Sollte man immer so machen!
      gert.setColor(Color.black);
      gert.drawString("Fuehren Sie alle moeglichen", 20, 45);
      gert.drawString("Maus-Aktionen durch!",        20, 60);
   } // paint
   // ---------------------------------------------------------------------
   static private Formatter mevToFormatter(MouseEvent mev) {
      // Holt die wichtigsten Informationen aus dem Ereignis mev,
      // schreibt sie in ein Formatter-Objekt erg und liefert
      // erg als Ergebnis:
      Formatter erg      = new Formatter();
      String    str1     = mev.toString();
      int       von11    = str1.indexOf("frame");
      String    name     = str1.substring(von11, von11 + 6);
      int       von12    = str1.indexOf("_")+1;
      int       bis12    = str1.indexOf(",");
      String    ereignis = str1.substring(von12, bis12);
      String    str2     = mev.getPoint().toString();
      int       von21    = str2.indexOf("[");
      String    ort      = str2.substring(von21);
      int       knopf    = mev.getButton();

      // 5 Informationen in das Formatter-Objekt erg schreiben:
      erg.format("%3d. %6s: %8s, %14s, MausKnopf: %d",
         ++aufrufeInsgesamt, name, ereignis, ort, knopf);

      return erg;
   } // mevToFormatter
   // ---------------------------------------------------------------------
   static private Formatter mwevToFormatter(MouseWheelEvent mwev) {
      // Holt die wichtigsten Informationen aus dem Ereignis mwev,
      // schreibt sie in ein Formatter-Objekt erg und liefert
      // erg als Ergebnis:
      Formatter erg = mevToFormatter(mwev);
      int       wro = mwev.getWheelRotation();
      erg.format(" Rot.Klicks: %d", wro); // Um wieviele Klicks wurde das
                                          // Mausrad rotiert?
      return erg;
   } // mwevToFormatter
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Grabo06
// ------------------------------------------------------------------------