// Datei Grabo07.java
/* ------------------------------------------------------------------------
Ein Grabo07-Objekt ist ein Fenster (JFrame-Objekt), welches zwei
Etiketts (JLabel-Objekte) und einem Knopf (JButton-Objekt) enthaelt.
Wenn der Benutzer den Knopf anklickt oder die Tastenkombination
Alt-k eingibt wird eine Meldung zur Standardausgabe ausgegeben
und eine "selbstgeschriebene" Methode (machWas) aufgerufen.

Die Schnittstelle ActionListener enthaelt nur eine Methode (namens
actionPerformed). Nachdem man ein ActionListener-Objekt ALO bei einem
JButton-Objekt JBO angemeldet hat (mit dem Methodenaufruf
JBO.addActionListener(ALO);) wird die Methode  ALO.actionPerformed
jedesmal ausgefuehrt, wenn der Benutzer den JBO-Knopf anklickt.
------------------------------------------------------------------------ */
import javax.swing      .JFrame;
import javax.swing      .JLabel;
import javax.swing      .JButton;
import java .awt  .event.ActionListener;
import java .awt  .event.ActionEvent;
import java .util       .Random;

class Grabo07 extends JFrame {
   private JLabel  meinEtikett1; // Muss Element der Klasse sein
   private JLabel  meinEtikett2; // Muss Element der Klasse sein
   private JButton meinKnopf;    // Koennte auch lokal zum Konstruktor sein
   // ---------------------------------------------------------------------
   Grabo07(String ueberSchrift) {
      super(ueberSchrift);
      meinEtikett1 = new JLabel("Knopf anklicken (oder Alt-k)!");
      meinEtikett2 = new JLabel("");
      meinKnopf    = new JButton("Knopf der I.");
      meinKnopf.setMnemonic('k'); // Eingabe von Alt-k als Klickersatz
      // ------------------------------------------------------------------
      // Jetzt wird ein anonymes Objekt einer anonymen ActionListener-
      // Klasse bei dem JButton-Objekt meinKnopf angemeldet:
      meinKnopf.addActionListener(new ActionListener() {
         int anzahl = 0;          // Anzahl der Klicks auf meinKnopf
         public void actionPerformed(ActionEvent ae) {
            anzahl++;
            printf("actionPerformed: %2d ", anzahl);
            meinEtikett2.setText("Anzahl Klicks: "   + anzahl);
            machWas();
         } // actionPerformed
      });
      // ------------------------------------------------------------------
      // Die Etiketten und den Knopf in das Fenster einfuegen:
      this.add(meinEtikett1, "North");
      this.add(meinEtikett2, "Center");
      this.add(meinKnopf,    "East");

      this.setDefaultCloseOperation(Grabo01.EXIT_ON_CLOSE);
      this.setBounds(30, 20, 300, 100);
      this.setVisible(true);
   } // Konstruktor Grabo07
   // ---------------------------------------------------------------------
   static Random r = new Random();

   static void machWas() {
      // Gibt eine zufaellige Anzahl (zwischen 1 und 50) von
      // zufaellig gewaehlten Grossbuchstaben aus.
      int zufaelligeAnzahl = r.nextInt(50) + 1; // 1 bis 50 (statt 0 bis 49)
      for (int i=1; i<=zufaelligeAnzahl; i++) {
         char zufaelligesZeichen = (char) (r.nextInt(26) + 'A');
         printf("%c", zufaelligesZeichen);
      }
      printf("\n");
   } // machWas
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Grabo07
/* ------------------------------------------------------------------------
Eine Ausgabe des Programms Grabo07 zur Standardausgabe:

actionPerformed:  1 ZYJKIJHDBWGMVXTEUUO
actionPerformed:  2 KESGDOQNFYOJB
actionPerformed:  3 IMBERNFTAUKDL
actionPerformed:  4 YDAWHIAGVCQCSYOJERZMYAZBKCN
actionPerformed:  5 FKHIX
------------------------------------------------------------------------ */
