// Datei Hallo06.java
/* ------------------------------------------------------------------------
Mit den Funktionen liesString bzw. liesInt kann man einen String-Wert bzw.
einen int-Wert von der Standardeingbe (Tastatur) einlesen.
Hallo06 ist eine Klasse, aber kein Programm (weil die Klasse keine
main-Methode enthaelt)
------------------------------------------------------------------------ */
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

class Hallo06 {
   // ---------------------------------------------------------------------
   // Die Standardeingabe System.in wird mit einem Eingabestrom namens isr
   // und isr mit einem weiteren Eingabestrom namens bfr verbunden:
   static private InputStreamReader isr = new InputStreamReader(System.in);
   static private BufferedReader    bfr = new BufferedReader   (isr);
   // So kommen Eingabedate von der Standardeingabe ins Programm:
   // System.in ---> isr ---> bfr ---> Programm
   // ---------------------------------------------------------------------
   static public String liesString() {
      // Liest einen String von der Standardeingab und liefert ihn als
      // Ergebnis. Falls eine Ausnahme des Typs IOException auftritt (was
      // sehr unwahrscheinlich ist), wird ein leerer String als Ergebnis
      // geliefert.
      try {
         return bfr.readLine();
      } // try
      catch (IOException ausnahme01) {
         System.out.println("Fehler beim Einlesen eines Strings!");
         System.out.println("Hallo06.liesString liefert leeren String!");
         return new String();
      } // catch
   } // liesString
   // ---------------------------------------------------------------------
   static public int liesInt() {
      // Liest einen int-Wert von der Standardeingabe und liefert ihn als
      // Ergebnis. Falls eine Ausnahme des Typs IOException oder des Typs
      // NumberFormatException auftritt, wird eine Fehlermeldung ausgegeben
      // und 0 als Ergebnis geliefert.
      try {
         return Integer.parseInt(bfr.readLine());
      }
      catch (Throwable ausnahme01) {
         System.out.println("Fehler beim Einlesen eines int-Wertes!");
         System.out.println("Hallo06.liesInt liefert den int-Wert 0!");
         return 0;
      } // catch
   } // liesInt
   // ---------------------------------------------------------------------
} // class Hallo06