// Datei Huellen02.java
/* ------------------------------------------------------------------------
Wenn man primitive Werte der Typen char, short, int oder long mit
Autoverhuellung in Objekte der entsprechenden Huellklasse umwandeln
laesst und die Huellobjekte dann mit dem Operator == vergleicht, ist
(127 == 127) gleich truen, aber (128 == 128) ist false.

Erklaerung: Wenn ein primitiver Wert (der Typen char, short, int oder
long) zwischen 0 und 127 (einschliesslich) autoverhuellt wird, wird
kein neues Huellobjekt erzeugt, sondern ein vorgefertigtes, "schon
immer bereitliegendes" Objekt der passenden Huellklassen genommen.
Fuer Werte ab 128 wird beim Autoverhuellen jeweils ein neues Objekt
(mit einer neuen Referenz) erzeugt.
------------------------------------------------------------------------ */
class Huellen02 {
   // ---------------------------------------------------------------------
   static boolean gleich(Character a, Character b) {
      return a == b;
   } // gleich
   // ---------------------------------------------------------------------
   static boolean gleich(Short     a, Short     b) {
      return a == b;
   } // gleich
   // ---------------------------------------------------------------------
   static boolean gleich(Integer   a, Integer   b) {
      return a == b;
   } // gleich
   // ---------------------------------------------------------------------
   static boolean gleich(Long      a, Long      b) {
      return a == b;
   } // gleich
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {

      final int VON = 125;
      final int BIS = 130;

      printf("Huellen02: Jetzt geht es los!\n");
      printf("------------------------\n");
      for (char n=VON; n<=BIS; n++) {
         int i = n;
         printf("char : gleich(%3d, %3d): %s\n", i, i, gleich(n, n));
      }
      printf("------------------------\n");
      for (short n=VON; n<=BIS; n++) {
         printf("short: gleich(%3d, %3d): %s\n", n, n, gleich(n, n));
      }
      printf("------------------------\n");
      for (int n=VON; n<=BIS; n++) {
         printf("int  : gleich(%3d, %3d): %s\n", n, n, gleich(n, n));
      }
      printf("------------------------\n");
      for (long n=VON; n<=BIS; n++) {
         printf("long : gleich(%3d, %3d): %s\n", n, n, gleich(n, n));
      }
      printf("------------------------\n");
      printf("Huellen02: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Huellen02
/* ------------------------------------------------------------------------
Ausgabe des Programms Huellen02:

Huellen02: Jetzt geht es los!
------------------------
char : gleich(125, 125): true
char : gleich(126, 126): true
char : gleich(127, 127): true
char : gleich(128, 128): false
char : gleich(129, 129): false
char : gleich(130, 130): false
------------------------
short: gleich(125, 125): true
short: gleich(126, 126): true
short: gleich(127, 127): true
short: gleich(128, 128): false
short: gleich(129, 129): false
short: gleich(130, 130): false
------------------------
int  : gleich(125, 125): true
int  : gleich(126, 126): true
int  : gleich(127, 127): true
int  : gleich(128, 128): false
int  : gleich(129, 129): false
int  : gleich(130, 130): false
------------------------
long : gleich(125, 125): true
long : gleich(126, 126): true
long : gleich(127, 127): true
long : gleich(128, 128): false
long : gleich(129, 129): false
long : gleich(130, 130): false
------------------------
Huellen02: Das war's erstmal!
------------------------------------------------------------------------ */