// Datei If03.java
/* --------------------------------------------------------------
Das Maximum von 5 Zahlen wird ermittelt.
Die Methode max1 enthaelt eine (hoffentlich abschreckende)
geschachtelte if-if-Anweisung. Die Methode max2 erreicht das
Gleiche mit mehreren einfachen if-Anweisungen.

Zum Testen der Methoden max1 und max2 werden Objekte der Klasse
Permutationen verwendet. Diese Klasse ist selbst gestrickt
(sie stammt nicht aus der Standardbibliothek).
-------------------------------------------------------------- */
class If03 {
   // -----------------------------------------------------------
   static void max1(int a, int b, int c, int d, int e) {
      // Ermittelt das Maximum der 5 Parameter a bis e und git es
      // (zusammen mit den Parametern) aus.

      int max;
                                // Welche Variablen kommen noch
                                // als Maximum in Frage?
                                // a b c d e   alle 5
      if (a < b) {              //   b c d e   nur noch 4 etc.
         if (b < c) {           //     c d e
            if (c < d) {        //       d e
               if (d < e) {     //         e
                  max = e;
               } else {         //       d
                  max = d;
               }
            } else {            //     c   e
               if (c < e) {     //         e
                  max = e;
               } else {         //     c
                  max = c;
               }
            }
         } else {               //   b   d e
            if (b < d) {        //       d e
               if (d < e) {     //         e
                  max = e;
               } else {         //       d
                  max = d;
               }
            } else {            //   b     e
               if (b < e) {     //         e
                  max = e;
               } else {         //   b
                  max = b;
               }
            }
         }
      } else {                  // a   c d e
         if (a < c) {           //     c d e
            if (c < d) {        //       d e
               if (d < e) {     //         e
                  max = e;
               } else {         //       d
                  max = d;
               }
            } else {            //     c   e
               if (c < e) {     //         e
                  max = e;
               } else {         //     c
                  max = c;
               }
            }
         } else {               // a     d e
            if (a < d) {        //       d e
               if (d < e) {     //         e
                  max = e;
               } else {         //       d
                  max = d;
               }
            } else {            // a       e
               if (a < e) {     //    e
                  max = e;
               } else {         // a
                  max = a;
               }
            }
         }
      } // if

      printf("max1: Das Maximum von %d %d %d %d %d ist gleich %d%n",
                                     a, b, c, d, e,           max);
   } // max1
   // -----------------------------------------------------------
   static void max2(int a, int b, int c, int d, int e) {
      // Macht das Gleiche wie max1, aber eleganter:
      // Ermittelt das Maximum der 5 Parameter a bis e und git es
      // (zusammen mit den Parametern) aus.

      int max = a;

      if (max < b) max = b;
      if (max < c) max = c;
      if (max < d) max = d;
      if (max < e) max = e;

      printf("max2: Das Maximum von %d %d %d %d %d ist gleich %d%n",
                                     a, b, c, d, e,           max);
   } // max2
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Methoden max1 und max2 werden getestet (mit allen
      // Permutationen der Zahlen 1, 2, 3, 4, 5).
      // Achtung: p ist gleichzeitig der Name einer Methode (zum
      // drucken) und der Name einer Variablen (vom Typ int[])!

      printf("If03: Jetzt geht es los!%n");
      printf("------------------------------------------------%n");

      Permutationen permus; // Eine Quelle vieler Permutationen
      int[]         p;      // Eine Permutation

      printf("Test der Methode max1: -------------------------%n");
      permus = new Permutationen(5);
      for (int i=permus.anzahlPermutationen()+1; i>=1; i--) {
         printf("%3d ", permus.nrDerNaechsten());
         p = permus.naechste();
         max1(p[0], p[1], p[2], p[3], p[4]);
      }
      printf("%n");

      printf("Test der Methode max2: -------------------------%n");
      permus = new Permutationen(5);
      for (int i=permus.anzahlPermutationen()+1; i>=1; i--) {
         printf("%3d ", permus.nrDerNaechsten());
         p = permus.naechste();
         max2(p[0], p[1], p[2], p[3], p[4]);
      }
      printf("------------------------------------------------%n");
      printf("If03: Das war's erstmal!%n");

   } // main
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // -----------------------------------------------------------
} // class If03
/* ------------------------------------------------------------------------
Auszuege aus der Ausgabe des Programms If03:

If03: Jetzt geht es los!
------------------------------------------------
Test der Methode max1: -------------------------
  1 max1: Das Maximum von 1 2 3 4 5 ist gleich 5
  2 max1: Das Maximum von 1 2 3 5 4 ist gleich 5
  3 max1: Das Maximum von 1 2 4 3 5 ist gleich 5
...
119 max1: Das Maximum von 5 4 3 1 2 ist gleich 5
120 max1: Das Maximum von 5 4 3 2 1 ist gleich 5
  1 max1: Das Maximum von 1 2 3 4 5 ist gleich 5

Test der Methode max2: -------------------------
  1 max2: Das Maximum von 1 2 3 4 5 ist gleich 5
  2 max2: Das Maximum von 1 2 3 5 4 ist gleich 5
  3 max2: Das Maximum von 1 2 4 3 5 ist gleich 5
...
119 max2: Das Maximum von 5 4 3 1 2 ist gleich 5
120 max2: Das Maximum von 5 4 3 2 1 ist gleich 5
  1 max2: Das Maximum von 1 2 3 4 5 ist gleich 5
------------------------------------------------
If03: Das war's erstmal!
------------------------------------------------------------------------ */