// Datei Init01Tst.java
/* ------------------------------------------------------------------------
Ein Programm mit 2 Klasseninitialisierern. Das sind Bloecke, die
1. direkt in der Klasse (ausserhalb von allen Methode) stehen
2. mit dem Schluesselwort static gekennzeichnet sind
3. genau einmal ausgefuerht werden (beim Laden der Klasse, noch
   vor der main-Methode, in der Reihenfolge, in der sie in der
   Klasse stehen)

Klasseninitialisierer werden z.B. dazu benutzt, Klassenattribute zu
initialisieren, die man nicht einfach "mit dem Wert eines Ausdrucks"
initialisieren kann. Hier wird eine Reihung mit zufaelligen int-Werten
gefuellt und ausgegeben.
------------------------------------------------------------------------ */
import java.util.Random;
class Init01Tst {
   // ---------------------------------------------------------------------
   static int[]  kri = new int[15];  // Klassen-Attribut, Reihung von int
   static Random ran = new Random();
   // ---------------------------------------------------------------------
   static { // Klasseninitialisierer 1, Anfang
      printf("---------------------------------------------\n");
      printf("Der Klasseninitialisierer 1 wurde aufgerufen!\n");
      // Die Reihung kri wird mit zufaelligen Zahlen (0 bis 99) gefuellt:
      for (int i=0; i<kri.length; i++) {
         kri[i] = ran.nextInt(100);
      }
   } // Klasseninitialisierer 1, Ende
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Init01Tst: Jetzt geht es los!\n");
      printf("Init01Tst: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   static { // Klasseninitialisierer 2, Anfang
      printf("Der Klasseninitialisierer 2 wurde aufgerufen!\n");
      // Die Reihung kri wird ausgegeben:
      for (int n: kri) printf("%2d ", n);
      printf("\n");
      printf("---------------------------------------------\n");
   } // Klasseninitialisierer 2, Ende
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Init01Tst
/* ------------------------------------------------------------------------
Ausgabe des Programms Init01Tst:

---------------------------------------------
Der Klasseninitialisierer 1 wurde aufgerufen!
Der Klasseninitialisierer 2 wurde aufgerufen!
43 63 16 95 32 41 93 92 11 15 39 49 83 26 24
---------------------------------------------
Init01Tst: Jetzt geht es los!
Init01Tst: Das war's erstmal!
------------------------------------------------------------------------ */
