// Datei Init02.java
/* ------------------------------------------------------------------------
Eine Klasse mit zwei Objektinitialisierern. Das sind Bloecke, die
1. direkt in der Klasse (ausserhalb von allen Methoden stehen),
2. nicht mit static gekennzeichnet sind und
3. jedesmal ausgefuehrt werden, wenn ein Objekt dieser Klasse erzeugt
   wird (noch vor dem betreffenden Konstruktor, in der Reihenfolge,
   in der sie in der Klassenvereinbarung stehen).

Objektinitialisierer werden z.B. dazu benutzt, Objektattribute zu
initialisieren, die man nicht einfach "mit dem Wert eines Ausdrucks"
initialisieren kann. Hier wird eine Reihung mit zufaelligen int-Werten
gefuellt und ausgegeben. Die Klasse Init02 hat zwei Konstruktoren um
zu zeigen, dass die Objektinitialisierer vor jedem Konstruktor aus-
gefuehrt werden.
------------------------------------------------------------------------ */
import java.util.Random;
class Init02 {
   // ---------------------------------------------------------------------
   int[]  ori = new int[15];   // Objekt-Attribut, Reihung von int
   Random ran = new Random();
   // ---------------------------------------------------------------------
   { // Objektinitialisierer 1, Anfang
      printf("---------------------------------------------\n");
      printf("Der Objektinitialisierer 1 wurde aufgerufen! \n");
      for (int i=0; i<ori.length; i++) {
         ori[i] = ran.nextInt(100);
      }
   } // Objektinitialisierer 1, Ende
   // ---------------------------------------------------------------------
   Init02(int a) {
      printf("Der Konstruktor Init02-A wurde aufgerufen!   \n");
      printf("---------------------------------------------\n");
   } // Konstruktor Init02
   // ---------------------------------------------------------------------
   Init02(double b) {
      printf("Der Konstruktor Init02-B wurde aufgerufen!   \n");
      printf("---------------------------------------------\n");
   } // Konstruktor Init02
   // ---------------------------------------------------------------------
   { // Objektinitialisierer 2, Anfang
      printf("Der Objektinitialisierer 2 wurde aufgerufen! \n");
      for (int n: ori) printf("%3d", n);
      printf("\n");
   } // Objektinitialisierer 2, Ende
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Init02
