// Datei Init03Tst.java
/* ------------------------------------------------------------------------
Dieses Programm leistet ganz Aehnliches wie das Programm Init01Tst.
Anstelle von zwei Klasseninitialisierern werden hier zwei Initiali-
sierungsfunktionen namens initFunk1 und initFunk2 verwenden. Ein
Klassenattribut namens ccc wird nur vereinbart, damit es mit
initFunk2 initialisiert werden kann und ist ansonsten ueberfluessig.

Achtung: Die Reihenfolge der Vereinbarungen ist hier wichtig. Die
Attribute kri und ccc muessen NACH "ihren" Initialisierungsfunktionen
initFunk1 bzw. initFunk2 vereinbart werden, weil der Ausfuehrer die
Vereinbarungen "von oben nach unten" ausfhrt und die vereinbarten
Groessen in dieser Reihenfolge erzeugt.
------------------------------------------------------------------------ */
import java.util.Random;
class Init03Tst {
   // ---------------------------------------------------------------------
   static Random ran = new Random();
   // ---------------------------------------------------------------------
   static int[] initFunk1() {
      printf("---------------------------------------------%n");
      printf("Die Funktion initFunk1 wurde aufgerufen!     %n");
      // Eine Reihung erg wird mit zufaelligen Zahlen (0 bis 99) gefuellt
      // und als Ergebnis geliefert:
      int[] erg = new int[15];
      for (int i=0; i<erg.length; i++) {
         erg[i] = ran.nextInt(100);
      }
      return erg;
   } // initFunk
   // ---------------------------------------------------------------------
   static char initFunk2(int[] r) {
      printf("Die Funktion initFunk2 wurde aufgerufen!     %n");
      // Die Reihung r wird ausgegeben:
      for (int n: kri) printf("%2d ", n);
      printf("%n");
      printf("---------------------------------------------%n");
      return 'X'; // Der Rueckgabewert ist unwesentlich
   } // initFunk2
   // ---------------------------------------------------------------------
   static int[]  kri = initFunk1();    // Klassen-Attribut, Reihung von int
   static char   ccc = initFunk2(kri);
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Init03Tst: Jetzt geht es los!%n");
      printf("Init03Tst: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Init03Tst
/* ------------------------------------------------------------------------
Ausgabe des Programms Init03Tst:

---------------------------------------------
Die Funktion initFunk1 wurde aufgerufen!
Die Funktion initFunk2 wurde aufgerufen!
 2 15 37 71 36 81  1 68 69 45 65 31 14 46 42
---------------------------------------------
Init03Tst: Jetzt geht es los!
Init03Tst: Das war's erstmal!
------------------------------------------------------------------------ */
