// Datei IntTst.java
/* ------------------------------------------------------------------------
Programm zum Testen der Klasse Int. Eine Reihung namens IntR von Int-Objek-
ten wird vereinbart. Auf jedes Paar von Komponenten dieser Reihung werden
alle Rechenfunktionen (add, sub, mul, div und mod) angewendet. Dabei auf-
tretende Ausnahmen und die Ergebnisse der Berechnungen werden zum Bild-
schirm protokolliert.
------------------------------------------------------------------------ */
class IntTst {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      pln("IntTst: Jetzt geht es los! ----------------------------------");

      // Ein Reihung mit den zu testenden Objekten:
      Int[] IntR = {
         new Int(0),
         new Int(1),
         new Int(7),
         new Int(3),
         new Int(Integer.MIN_VALUE),
         new Int(Integer.MAX_VALUE),
      }; // IntR

      // Das Testprotokoll ist viele Zeilen lang:
      int zeilenNr = 0;

      for (int i=0; i<IntR.length; i++) {
         Int n1 = IntR[i];
         for (int j=0; j<IntR.length; j++) {
            Int n2 = IntR[j];

            pln(++zeilenNr + " n1: " + n1 + ", n2: " + n2);

            // Alle moeglichen Rechenfunktionen auf n1 und n2 anwenden:
            try { // Addition
               p  ("   n1.add(n2): ");
               pln(n1.add(n2));
            } catch (ArithmeticException ae) {
               pln("   ArithmeticException: " + ae.getMessage());
            }

            try { // Subtraktion
               p  ("   n1.sub(n2): ");
               pln(n1.sub(n2));
            } catch (ArithmeticException ae) {
               pln("   ArithmeticException: " + ae.getMessage());
            }

            try { // Multiplikation
               p  ("   n1.mul(n2): ");
               pln(n1.mul(n2));
            } catch (ArithmeticException ae) {
               pln("   ArithmeticException: " + ae.getMessage());
            }

            try { // Division
               p  ("   n1.div(n2): ");
               pln(n1.div(n2));
            } catch (ArithmeticException ae) {
               pln("   ArithmeticException: " + ae.getMessage());
            }

            try { // Restfunktion
               p  ("   n1.mod(n2): ");
               pln(n1.mod(n2));
            } catch (ArithmeticException ae) {
               pln("   ArithmeticException: " + ae.getMessage());
            }

         } // for j
      } // for i

      pln("IntTst: Das war's erstmal! ----------------------------------");

   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // IntTst
/* ------------------------------------------------------------------------
IntTst: Jetzt geht es los! ----------------------------------
1 n1: 0, n2: 0
   n1.add(n2): 0
   n1.sub(n2): 0
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
2 n1: 0, n2: 1
   n1.add(n2): 1
   n1.sub(n2): -1
   n1.mul(n2): 0
   n1.div(n2): 0
   n1.mod(n2): 0
3 n1: 0, n2: 7
   n1.add(n2): 7
   n1.sub(n2): -7
   n1.mul(n2): 0
   n1.div(n2): 0
   n1.mod(n2): 0
4 n1: 0, n2: 3
   n1.add(n2): 3
   n1.sub(n2): -3
   n1.mul(n2): 0
   n1.div(n2): 0
   n1.mod(n2): 0
5 n1: 0, n2: -2147483648
   n1.add(n2): -2147483648
   n1.sub(n2):    ArithmeticException: 2147483648 ist kein int-Wert!
   n1.mul(n2): 0
   n1.div(n2): 0
   n1.mod(n2): 0
6 n1: 0, n2: 2147483647
   n1.add(n2): 2147483647
   n1.sub(n2): -2147483647
   n1.mul(n2): 0
   n1.div(n2): 0
   n1.mod(n2): 0
7 n1: 1, n2: 0
   n1.add(n2): 1
   n1.sub(n2): 1
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
8 n1: 1, n2: 1
   n1.add(n2): 2
   n1.sub(n2): 0
   n1.mul(n2): 1
   n1.div(n2): 1
   n1.mod(n2): 0
9 n1: 1, n2: 7
   n1.add(n2): 8
   n1.sub(n2): -6
   n1.mul(n2): 7
   n1.div(n2): 0
   n1.mod(n2): 1
10 n1: 1, n2: 3
   n1.add(n2): 4
   n1.sub(n2): -2
   n1.mul(n2): 3
   n1.div(n2): 0
   n1.mod(n2): 1
11 n1: 1, n2: -2147483648
   n1.add(n2): -2147483647
   n1.sub(n2):    ArithmeticException: 2147483649 ist kein int-Wert!
   n1.mul(n2): -2147483648
   n1.div(n2): 0
   n1.mod(n2): 1
12 n1: 1, n2: 2147483647
   n1.add(n2):    ArithmeticException: 2147483648 ist kein int-Wert!
   n1.sub(n2): -2147483646
   n1.mul(n2): 2147483647
   n1.div(n2): 0
   n1.mod(n2): 1
13 n1: 7, n2: 0
   n1.add(n2): 7
   n1.sub(n2): 7
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
14 n1: 7, n2: 1
   n1.add(n2): 8
   n1.sub(n2): 6
   n1.mul(n2): 7
   n1.div(n2): 7
   n1.mod(n2): 0
15 n1: 7, n2: 7
   n1.add(n2): 14
   n1.sub(n2): 0
   n1.mul(n2): 49
   n1.div(n2): 1
   n1.mod(n2): 0
16 n1: 7, n2: 3
   n1.add(n2): 10
   n1.sub(n2): 4
   n1.mul(n2): 21
   n1.div(n2): 2
   n1.mod(n2): 1
17 n1: 7, n2: -2147483648
   n1.add(n2): -2147483641
   n1.sub(n2):    ArithmeticException: 2147483655 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -15032385536 ist kein int-Wert!
   n1.div(n2): 0
   n1.mod(n2): 7
18 n1: 7, n2: 2147483647
   n1.add(n2):    ArithmeticException: 2147483654 ist kein int-Wert!
   n1.sub(n2): -2147483640
   n1.mul(n2):    ArithmeticException: 15032385529 ist kein int-Wert!
   n1.div(n2): 0
   n1.mod(n2): 7
19 n1: 3, n2: 0
   n1.add(n2): 3
   n1.sub(n2): 3
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
20 n1: 3, n2: 1
   n1.add(n2): 4
   n1.sub(n2): 2
   n1.mul(n2): 3
   n1.div(n2): 3
   n1.mod(n2): 0
21 n1: 3, n2: 7
   n1.add(n2): 10
   n1.sub(n2): -4
   n1.mul(n2): 21
   n1.div(n2): 0
   n1.mod(n2): 3
22 n1: 3, n2: 3
   n1.add(n2): 6
   n1.sub(n2): 0
   n1.mul(n2): 9
   n1.div(n2): 1
   n1.mod(n2): 0
23 n1: 3, n2: -2147483648
   n1.add(n2): -2147483645
   n1.sub(n2):    ArithmeticException: 2147483651 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -6442450944 ist kein int-Wert!
   n1.div(n2): 0
   n1.mod(n2): 3
24 n1: 3, n2: 2147483647
   n1.add(n2):    ArithmeticException: 2147483650 ist kein int-Wert!
   n1.sub(n2): -2147483644
   n1.mul(n2):    ArithmeticException: 6442450941 ist kein int-Wert!
   n1.div(n2): 0
   n1.mod(n2): 3
25 n1: -2147483648, n2: 0
   n1.add(n2): -2147483648
   n1.sub(n2): -2147483648
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
26 n1: -2147483648, n2: 1
   n1.add(n2): -2147483647
   n1.sub(n2):    ArithmeticException: -2147483649 ist kein int-Wert!
   n1.mul(n2): -2147483648
   n1.div(n2): -2147483648
   n1.mod(n2): 0
27 n1: -2147483648, n2: 7
   n1.add(n2): -2147483641
   n1.sub(n2):    ArithmeticException: -2147483655 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -15032385536 ist kein int-Wert!
   n1.div(n2): -306783378
   n1.mod(n2): -2
28 n1: -2147483648, n2: 3
   n1.add(n2): -2147483645
   n1.sub(n2):    ArithmeticException: -2147483651 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -6442450944 ist kein int-Wert!
   n1.div(n2): -715827882
   n1.mod(n2): -2
29 n1: -2147483648, n2: -2147483648
   n1.add(n2):    ArithmeticException: -4294967296 ist kein int-Wert!
   n1.sub(n2): 0
   n1.mul(n2):    ArithmeticException: 4611686018427387904 ist kein int-Wert!
   n1.div(n2): 1
   n1.mod(n2): 0
30 n1: -2147483648, n2: 2147483647
   n1.add(n2): -1
   n1.sub(n2):    ArithmeticException: -4294967295 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -4611686016279904256 ist kein int-Wert!
   n1.div(n2): -1
   n1.mod(n2): -1
31 n1: 2147483647, n2: 0
   n1.add(n2): 2147483647
   n1.sub(n2): 2147483647
   n1.mul(n2): 0
   n1.div(n2):    ArithmeticException: / by zero
   n1.mod(n2):    ArithmeticException: / by zero
32 n1: 2147483647, n2: 1
   n1.add(n2):    ArithmeticException: 2147483648 ist kein int-Wert!
   n1.sub(n2): 2147483646
   n1.mul(n2): 2147483647
   n1.div(n2): 2147483647
   n1.mod(n2): 0
33 n1: 2147483647, n2: 7
   n1.add(n2):    ArithmeticException: 2147483654 ist kein int-Wert!
   n1.sub(n2): 2147483640
   n1.mul(n2):    ArithmeticException: 15032385529 ist kein int-Wert!
   n1.div(n2): 306783378
   n1.mod(n2): 1
34 n1: 2147483647, n2: 3
   n1.add(n2):    ArithmeticException: 2147483650 ist kein int-Wert!
   n1.sub(n2): 2147483644
   n1.mul(n2):    ArithmeticException: 6442450941 ist kein int-Wert!
   n1.div(n2): 715827882
   n1.mod(n2): 1
35 n1: 2147483647, n2: -2147483648
   n1.add(n2): -1
   n1.sub(n2):    ArithmeticException: 4294967295 ist kein int-Wert!
   n1.mul(n2):    ArithmeticException: -4611686016279904256 ist kein int-Wert!
   n1.div(n2): 0
   n1.mod(n2): 2147483647
36 n1: 2147483647, n2: 2147483647
   n1.add(n2):    ArithmeticException: 4294967294 ist kein int-Wert!
   n1.sub(n2): 0
   n1.mul(n2):    ArithmeticException: 4611686014132420609 ist kein int-Wert!
   n1.div(n2): 1
   n1.mod(n2): 0
IntTst: Das war's erstmal! ----------------------------------
------------------------------------------------------------------------ */
