// Datei JavaNamen01.java
/* ------------------------------------------------------------------------
Sei c eine char-Variable.

Der Methodenaufruf Character.isJavaIdentifierStart(c) liefert true,
wenn c als erstes Zeichens eines Java-Namens erlaubt ist.

Der Methodenaufruf Character.isJavaIdentifierPart(c) liefert true,
wenn c als nicht-erstes Zeichens eines Java-Namens erlaubt ist.

Der Methodenaufruf Character.isDigit(c)(c) liefert true,
wenn c als Ziffer gilt.

Dieses Programm ermittelt, wieviele char-Werte als erstes Zeichen eines
Namens, bzw. als nicht-erstes Zeichen erlaubt sind bzw. als Ziffer
gelten.
------------------------------------------------------------------------ */

class JavaNamen01 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("JavaNamen01: Jetzt geht es los!%n");

      int anzIdentifierStart = 0;
      int anzIdentifierPart  = 0;
      int anzZiffern         = 0;

      // Alle 65536 Werte des Typs char werden geprueft:
      for (char c=Character.MIN_VALUE; c<Character.MAX_VALUE; c++) {
         if (Character.isJavaIdentifierStart(c)) anzIdentifierStart++;
         if (Character.isJavaIdentifierPart (c)) anzIdentifierPart ++;
         if (Character.isDigit(c))               anzZiffern        ++;
      }
      printf("----------------------------------%n");
      printf("Wieviele verschiedene Zeichen sind%n");
      printf("in Java-Bezeichnern erlaubt?%n");
      printf("Als erstes Zeichen: %,d Stück%n", anzIdentifierStart);
      printf("An anderen Stellen: %,d Stück%n", anzIdentifierPart);
      printf("Ziffern:            %,d Stück%n", anzZiffern);
      printf("----------------------------------%n");

      printf("JavaNamen01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class JavaNamen01
/* ------------------------------------------------------------------------
Ausgabe des Programms JavaNamen01:

JavaNamen01: Jetzt geht es los!
----------------------------------
Wieviele verschiedene Zeichen sind
in Java-Bezeichnern erlaubt?
Als erstes Zeichen: 45.951 Stück
An anderen Stellen: 46.908 Stück
Ziffern:            208 Stück
----------------------------------
JavaNamen01: Das war's erstmal!
------------------------------------------------------------------------ */
