// Datei Kommerziell01.java
/* ------------------------------------------------------------------------
Ungenauigkeiten beim Berechnen von Geldbetraegen, Gewichten, ... etc.
("beim kommerziellen Rechnen") mit Gleitpunktzahlen.
------------------------------------------------------------------------ */
class Kommerziell01 {
   // ---------------------------------------------------------------------
   static final String MINUSZEILE = "------------------------------" +
                                    "------------------------------";
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      printf("Kommerziell01: Jetzt geht es los!\n");
      printf("%s\n", MINUSZEILE);
      // ------------------------------------------------------------------
      // Parametersatz01 fuer PrintRechnung (ziemlich genau):
      float preisProKg01    =  4.90F;
      float gewicht01       = 22.400F;
      // ------------------------------------------------------------------
      // Parametersatz02 fuer PrintRechnung (etwas ungenau):
      float gewichtsEinheit = 0.1F; // 100 g
      float    preisEinheit = 0.1F; //  10 Cent

      float preisProKg02    =   129 * preisEinheit    - 8;
      float gewicht02       = 25824 * gewichtsEinheit - 2560;
      // ------------------------------------------------------------------
      // Parametersatz03 fuer PrintRechnung (sehr ungenau):
      float preisProKg03    =  4.9049999F;
      float gewicht03       = 22.4004999F;
      // ------------------------------------------------------------------
      // Drei unterschiedlich genaue (sonst gleiche) Rechnungen ausgeben:
      printRechnung(preisProKg01, gewicht01);
      printRechnung(preisProKg02, gewicht02);
      printRechnung(preisProKg03, gewicht03);

      printf("Kommerziell01: Das war's erstmal!\n");
   } // main
   // ---------------------------------------------------------------------
   static void printRechnung(float preisProKg, float gewicht) {
      // Gibt eine Rechnung mit anzahl vielen Posten (Zeilen) aus:
      int   anzahl         = 10;
      float preisProStk    = preisProKg  * gewicht;
      float preisProPosten = preisProStk * anzahl;
      float summe          = 0.0F;

      // Ueberschriften ausgeben:
      String f1 = "%12s %11s %11s %11s %11s\n";
      printf(f1, "Preis/kg", "Gewicht", "Preis/Stk", "Anzahl", "Preis");
      printf(f1, "in Euro",  "in kg",   "in Euro",   "",       "in Euro");

      // anzahl viele Postenzeilen ausgeben:
      for (int i=0; i<anzahl; i++) {
         printf(" %11.2f"  , preisProKg);
         printf(" %11.3f"  , gewicht);
         printf(" %11.2f"  , preisProStk);
         printf(" %11d"    , anzahl);
         printf(" %11.2f\n", preisProPosten);
         summe += preisProPosten;
      }
      // Summenzeile ausgeben:
      printf("%-48s %11.2f\n", "Rechnungs-Summe:", summe);

      printf("%s\n", MINUSZEILE);
      printf("Der (ziemlich) genaue Preis/kg: %9.6f\n", preisProKg);
      printf("Das (ziemlich) genaue Gewicht:  %9.6f\n", gewicht);
      printf("%s\n", MINUSZEILE);
   } // printRechnung
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Kommerziell01
/* ------------------------------------------------------------------------
Ausgabe des Programms Kommerziell01:

Kommerziell01: Jetzt geht es los!
------------------------------------------------------------
    Preis/kg     Gewicht   Preis/Stk      Anzahl       Preis
     in Euro       in kg     in Euro                 in Euro
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
        4,90      22,400      109,76          10     1097,60
Rechnungs-Summe:                                    10976,00
------------------------------------------------------------
Der (ziemlich) genaue Preis/kg:  4,900000
Das (ziemlich) genaue Gewicht:  22,400000
------------------------------------------------------------
    Preis/kg     Gewicht   Preis/Stk      Anzahl       Preis
     in Euro       in kg     in Euro                 in Euro
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
        4,90      22,400      109,76          10     1097,61
Rechnungs-Summe:                                    10976,07
------------------------------------------------------------
Der (ziemlich) genaue Preis/kg:  4,900001
Das (ziemlich) genaue Gewicht:  22,400146
------------------------------------------------------------
    Preis/kg     Gewicht   Preis/Stk      Anzahl       Preis
     in Euro       in kg     in Euro                 in Euro
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
        4,90      22,400      109,87          10     1098,74
Rechnungs-Summe:                                    10987,44
------------------------------------------------------------
Der (ziemlich) genaue Preis/kg:  4,905000
Das (ziemlich) genaue Gewicht:  22,400499
------------------------------------------------------------
Kommerziell01: Das war's erstmal!
------------------------------------------------------------------------ */






















































