// Datei Konstruktor01.java
/* ------------------------------------------------------------------------
In einem Konstruktor kann man als ersten Befehl einen anderen Konstruktor
der selben Klasse aufrufen, muss dazu allerdings den Namen "this"
verwenden (nicht den normalen Namen des Konstruktors).
------------------------------------------------------------------------ */
class Konstruktor01 {
   int n1 = 3;
   int n2 = 3;
   int n3 = 3;

   Konstruktor01(int n1) {
      this.n1 += n1;
   } // Konstruktor A der Klasse Konstruktor01

   Konstruktor01(int n1, int n2) {
//    this(n1, n2);  // Rekursiver this-Aufruf, nicht erlaubt
      this(n1);      // Aufruf des Konstruktors A
      this.n2 += n2;
   } // Konstruktor B der Klasse Konstruktor01

   Konstruktor01(int n1, int n2, int n3) {
      this(n1, n2);  // Aufruf des Konstruktors B
//    this(n1);      // this-Aufruf nur als erster Befehl erlaubt
      this.n3 += n3;
   } // Konstruktor C der Klasse Konstruktor01

   public String toString() {
      return "n1: " + n1 + ", n2: " + n2 + ", n3: " + n3;
   } // toString
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("Konstruktor01: Jetzt geht es los!");
      pln("---------------------------------");
      Konstruktor01 obA = new Konstruktor01(1);
      Konstruktor01 obB = new Konstruktor01(2, 3);
      Konstruktor01 obC = new Konstruktor01(4, 5, 6);

      pln("obA: " + obA);
      pln("obB: " + obB);
      pln("obC: " + obC);

      pln("---------------------------------");
      pln("Konstruktor01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // Konstruktor01
/* ------------------------------------------------------------------------
Fehlermeldung des Compilers, wenn die entsprechenden Zeilen keine
Kommentare sind:

D:\Java\Konstruktor01.java:16:
recursive constructor invocation
   Konstruktor01(int n1, int n2) {
   ^

D:\Java\Konstruktor01.java:24:
call to this must be first statement in constructor
      this(n1, n2); // Mehrere solche Aufrufe sind nicht erlaubt
          ^
---------------------------------------------------------------------------
Ausgabe des Programms Konstruktor01:

Konstruktor01: Jetzt geht es los!
---------------------------------
obA: n1: 4, n2: 3, n3: 3
obB: n1: 5, n2: 6, n3: 3
obC: n1: 7, n2: 8, n3: 9
---------------------------------
Konstruktor01: Das war's erstmal!
------------------------------------------------------------------------ */
