// Datei Layout01.java
/* ------------------------------------------------------------------------
Welche Behaelter (Objekte der verschiedenen Container-Typen) haben
standardmaessig was fuer ein Layout? Dieses Programm gibt die Antwort
aus.
------------------------------------------------------------------------ */
import java.awt   .Container;
import java.awt   .Frame;
import java.awt   .Window;
import java.awt   .Panel;
import java.applet.Applet;

import javax.swing.JFrame;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JApplet;
// ------------------------------------------------------------------------
class Layout01 {
   static public void main(String [] sonja) {
      pln("Layout01   : Jetzt geht es los!");

      // Behaelter verschiedener Klassen vereinbaren:
      Container co01 = new Container();
      Container fr01 = new Frame();
      Container wi01 = new Window((Frame)fr01);
      Container pa01 = new Panel();
      Container ap01 = new Applet();

      Container fr02 = new JFrame();
      Container hb02 = Box.createHorizontalBox();
      Container vb02 = Box.createVerticalBox();
      Container pa02 = new JPanel();
      Container ap02 = new JApplet();

      // Die LayoutManager-Objekte der einzelnen Behaelter ausgeben:
      pln("----------------------------------");
      pln("A Container: " + co01.getLayout());
      pln("B Frame    : " + fr01.getLayout().getClass().getName());
      pln("C Window   : " + wi01.getLayout().getClass().getName());
      pln("D Panel    : " + pa01.getLayout().getClass().getName());
      pln("E Applet   : " + ap01.getLayout().getClass().getName());
      pln("----------------------------------");
      pln("F JFrame   : " + fr02.getLayout().getClass().getName());
      pln("G Box (h)  : " + hb02.getLayout().getClass().getName());
      pln("H Box (v)  : " + vb02.getLayout().getClass().getName());
      pln("I JPanel   : " + pa02.getLayout().getClass().getName());
      pln("J JApplet  : " + ap02.getLayout().getClass().getName());
      pln("----------------------------------");
      pln("Layout01   : Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Layout01
/* ------------------------------------------------------------------------
Ausgabe des Programms Layout01:

Layout01   : Jetzt geht es los!
----------------------------------
A Container: null
B Frame    : java.awt.BorderLayout
C Window   : java.awt.BorderLayout
D Panel    : java.awt.FlowLayout
E Applet   : java.awt.FlowLayout
----------------------------------
F JFrame   : java.awt.BorderLayout
G Box (h)  : javax.swing.BoxLayout
H Box (v)  : javax.swing.BoxLayout
I JPanel   : java.awt.FlowLayout
J JApplet  : java.awt.BorderLayout
----------------------------------
Layout01   : Das war's erstmal!
------------------------------------------------------------------------ */