// Datei Layout04.java
/* ------------------------------------------------------------------------
Ein Container-Objekt copa mit einem BoxLayout zu versehen erfordert einen
Befehl, in dem das Objekt copa *zweimal* erwaehnt wird, etwa so:

copa.setLayout(new BoxLayout(copa, BoxLayout.X_AXIS));

Die Klasse MeinBoxLayout hat einen Konstruktor, der den Befehl
copa.setLayout(...) "miterledigt", so dass man nur noch einen der folgenden
beiden Befehlen zu schreiben braucht:

new MeinBoxLayout(copa, BoxLayout.X_AXIS);
MeinBoxLayout.set(copa, BoxLayout.X_AXIS);
------------------------------------------------------------------------ */
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import java .awt  .Container;
// ------------------------------------------------------------------------
// Die Klasse MeinBoxLayout ist eine "sehr kleine" Erweiterung der Klasse
// BoxLayout:
class MeinBoxLayout extends BoxLayout {
   public MeinBoxLayout(Container c, int axis) {
      super(c, axis);
      c.setLayout(this); // c wird mit diesem BoxLayout-Objekt versehen!
   } // Konstruktor MeinBoxLayout

   // Die set-Methode ersetzt "new" und die Konstruktor-Syntax:
   static public MeinBoxLayout set(Container c, int axis) {
      return new MeinBoxLayout(c, axis);
   } // set
} // class MeinBoxLayout
// ------------------------------------------------------------------------
class Layout04 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      pln("Layout04: Jetzt geht es los!");

      JFrame r01 = new JFrame("Prog. Layout04: Mit MeinBoxLayout!");
      JFrame r02 = new JFrame("Prog. Layout04: Mit MeinBoxLayout!");

      r01.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      r02.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      Container copa01 = r01.getContentPane();
      Container copa02 = r02.getContentPane();

      // Um den Container copa01 mit einem neuem BoxLayout zu versehen,
      // genuegt es, ein MeinBoxLayout-Objekt zu erzeugen und copa01
      // als Parameter anzugeben. Ein copa01.setLayout(...)-Befehl ist hier
      // nicht mehr noetig:
      new MeinBoxLayout(copa01, BoxLayout.X_AXIS);

      // Einen aehnlichen Effekt kann man mit der set-Methode erzielen:
      MeinBoxLayout.set(copa02, BoxLayout.X_AXIS);

      // Die Behaelter copa01 und copa02 mit Component-Objekten fuellen:
      for (int i=0; i<5; i++) {
         copa01.add(new JButton("Knopf"  + i));
         copa02.add(new JButton("Button" + i));
      }

      r01.setBounds(200, 200, 500, 100);
      r02.setBounds(200, 320, 500, 100);
      r01.setVisible(true);
      r02.setVisible(true);

      pln("Layout04: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Layout04