// Datei Locale01.java
/* ------------------------------------------------------------------------
Die Methoden Locale.setDefault und Locale.getDefault werden
ausprobiert, gewisse Ergebnisse werden ausgegeben.
------------------------------------------------------------------------ */
import java.util.Locale;
import java.io  .FileOutputStream;
import java.io  .OutputStreamWriter;
import java.io  .FileNotFoundException;

class Locale01 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) throws FileNotFoundException {
      printf("Locale01: Jetzt geht es los!%n");
      printf("----------------------------%n");

      FileOutputStream   felix1 = new FileOutputStream("Locale01_1.tmp");
      FileOutputStream   felix2 = new FileOutputStream("Locale01_2.tmp");
      FileOutputStream   felix3 = new FileOutputStream("Locale01_3.tmp");

      Locale             hier      = Locale.getDefault();
      OutputStreamWriter oswHier   = new OutputStreamWriter(felix1);
      printf("getEncoding   (): %s%n", oswHier.getEncoding());
      printf("getISO3Country(): %s%n", hier.getISO3Country());

      Locale.setDefault(Locale.TAIWAN);
      hier      = Locale.getDefault();
      OutputStreamWriter oswTaiwan = new OutputStreamWriter(felix2);
      printf("getEncoding   (): %s%n", oswTaiwan.getEncoding());
      printf("getISO3Country(): %s%n", hier.getISO3Country());

      Locale.setDefault(Locale.CHINA);
      hier      = Locale.getDefault();
      OutputStreamWriter oswChina  = new OutputStreamWriter(felix3);
      printf("getEncoding   (): %s%n", oswChina.getEncoding());
      printf("getISO3Country(): %s%n", hier.getISO3Country());

      printf("----------------------------%n");
      printf("Locale01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Locale01
/* ------------------------------------------------------------------------
Ausgabe des Programms Locale01:

Locale01: Jetzt geht es los!
----------------------------
getEncoding   (): Cp1252
getISO3Country(): DEU
getEncoding   (): Cp1252
getISO3Country(): TWN
getEncoding   (): Cp1252
getISO3Country(): CHN
----------------------------
Locale01: Das war's erstmal!
------------------------------------------------------------------------ */
