// Datei Markierung01.java
/* ------------------------------------------------------------------------
Dieses Programm Markierung01 leistet Folgendes:
------------------------------------------------------------------------ */
import java.io  .Serializable;
import java.lang.Cloneable;
// ------------------------------------------------------------------------
class Mit0M {                                     // Mit 0 Markierungen
   public String toString() {return "Ein Mit0M-Objekt";}
} // class Mit0M
// ------------------------------------------------------------------------
class Mit1M  implements Serializable {            // Mit 1 Markierung
   public String toString() {return "Ein Mit1M-Objekt";}
} // class Mit1M
// ------------------------------------------------------------------------
class Mit2M  implements Serializable, Cloneable { // Mit 2 Markierungen
   public String toString() {return "Ein Mit2M-Objekt";}
} // class Mit2M
// ------------------------------------------------------------------------
class Markierung01 {
   // ---------------------------------------------------------------------
   static void gibMarkierungenAus(Object ob) {
      boolean istSerializable = (ob instanceof Serializable);
      boolean istCloneable    = (ob instanceof Cloneable);

      pln("----------------------------------");
      pln(ob + " ist");
      pln("Serializable: " + (istSerializable?"Ja":"Nein"));
      pln("Cloneable:    " + (istCloneable   ?"Ja":"Nein"));
   } // gibMarkierungenAus
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("Markierung01: Jetzt geht es los!!");

      Object ob0 = new Mit0M();
      Object ob1 = new Mit1M();
      Object ob2 = new Mit2M();

      gibMarkierungenAus(ob0);
      gibMarkierungenAus(ob1);
      gibMarkierungenAus(ob2);

      pln("----------------------------------");
      pln("Markierung01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Markierung01
/* ------------------------------------------------------------------------
Ausgabe des Programms Markierung01:

Markierung01: Jetzt geht es los!!
----------------------------------
Ein Mit0M-Objekt ist
Serializable: Nein
Cloneable:    Nein
----------------------------------
Ein Mit1M-Objekt ist
Serializable: Ja
Cloneable:    Nein
----------------------------------
Ein Mit2M-Objekt ist
Serializable: Ja
Cloneable:    Ja
----------------------------------
Markierung01: Das war's erstmal!
------------------------------------------------------------------------ */
