// Datei MeineKonstantenTst.java
/* ------------------------------------------------------------------------
Die Klasse MeineKonstantenTst implementiert die Schnittstelle
MeineKonstanten. Deshalb darf man hier auf die in der Schnittstelle
vereinbarten Konstanten mit ihren einfachen Namen (PI, KRAGENWEITE und
MWS) zugreifen und muss nicht unbedingt zusammengesetzte Namen wie
MeineKonstanten.PI, MeineKonstanten.KRAGENWEITE etc. angeben.

Durch die Klausel ... implements MeineKonstanten ... am Anfang der
Klasse MeineKonstantenTst wird die Klasse nicht zu irgendwelchen
Implementierungsarbeiten verpflichtet, weil die Schnittstelle
MeineKonstanten nur Konstanten, aber keine Methoden enthaelt.

Ab der Java-Version 5.0 kann man den gleichen Komfort erreichen,
indem man die Konstanten als Klassenattribute einer Klasse vereinbart
und statisch importiert (mit import static ...).
------------------------------------------------------------------------ */
import java.math.BigDecimal;

class MeineKonstantenTst implements MeineKonstanten {
   // ---------------------------------------------------------------------
   static double     radius  = 2.0;
   static double     flaeche = 2 * PI * radius*radius;
   static BigDecimal betrag  = new BigDecimal("200.00");
   static BigDecimal steuer  = betrag.multiply(MWSt);
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      pln("------------------------------------------------------");
      pln("radius: " + radius + ", flaeche: " + flaeche);
      pln("betrag: " + betrag + ", steuer:  " + steuer);
      pln("------------------------------------------------------");
      pln("                PI:          " +                 PI);
      pln("                KRAGENWEITE: " +                 KRAGENWEITE);
      pln("                MWSt:        " +                 MWSt);
      pln("------------------------------------------------------");
      pln("MeineKonstanten.PI:          " + MeineKonstanten.PI);
      pln("MeineKonstanten.KRAGENWEITE: " + MeineKonstanten.KRAGENWEITE);
      pln("MeineKonstanten.MWSt:        " + MeineKonstanten.MWSt);
      pln("------------------------------------------------------");
      pln("MeineKonstantenTst: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class MeineKonstantenTst
/* ------------------------------------------------------------------------
Ausgabe des Programms MeinesKonstantenTst:

------------------------------------------------------
radius: 2.0, flaeche: 25.132741228718345
betrag: 200.00, steuer:  32.0000
------------------------------------------------------
                PI:          3.141592653589793
                KRAGENWEITE: 41
                MWSt:        0.16
------------------------------------------------------
MeineKonstanten.PI:          3.141592653589793
MeineKonstanten.KRAGENWEITE: 41
MeineKonstanten.MWSt:        0.16
------------------------------------------------------
MeineKonstantenTst: Das war's erstmal!
------------------------------------------------------------------------ */
