// Datei Methoden04.java
/* ------------------------------------------------------------------------
Dieses Programm enthaelt Prozeduren, die verschiedene geometrische Figuren
(Rechtecke, Dreiecke, Rauten) ausgeben. In der main-Methode werden die
Prozeduren mehrfach aufgerufen.

Die Figuren bestehen aus schwarzen und weissen "Einheiten", d.h. aus
Paaren von Sternchen "**" und Paaren von Punkten "..". Eine solche Einheit
erscheint auf einem Bildschirm ungefaehr als Quadrat, wohingegen ein
einzelnes Zeichen nur ein laengliches Rechteck belegt. Quadrate sind
deshalb bessere "Grundeinheiten" fuer Figuren als laengliche Rechtecke.
------------------------------------------------------------------------ */
class Methoden04 {
   // ---------------------------------------------------------------------
   static final String SCHWARZ = "**************************************";
   static final String WEISS   = "......................................";
   // ---------------------------------------------------------------------
   // Eine Funktion mit dem Rueckgabetyp String und einem int-Parameter:
   static String schwarzeEinheiten(int anzahl) {
      // Liefert einen String, der aus anzahl vielen schwarzen Einheiten
      // besteht. Eine schwarze Einheit besteht aus 2 Zeichen des Strings
      // SCHWARZ:
      return SCHWARZ.substring(0, 2*anzahl);
   } // schwarzeEinheiten

   // Eine Funktion mit dem Rueckgabetyp String und einem int-Parameter:
   static String weisseEinheiten(int anzahl) {
      // Liefert einen String, der aus anzahl vielen weissen Einheiten
      // besteht. Eine weisse Einheit besteht aus 2 Zeichen des Strings
      // WEISS:
      return WEISS.substring(0, 2*anzahl);
   } // weisseEinheiten
   // ---------------------------------------------------------------------
   // Eine Prozedur mit 2 Parametern:
   static void druckeRechteck(int breite, int hoehe) {
      // Gibt ein Rechteck aus schwarzen Einheiten aus. Das Rechteck
      // besteht aus hoehe vielen Zeilen mit je breite vielen schwarzen
      // Einheiten darauf.

      for (int zeile=1; zeile<=hoehe; zeile++) {
         pln(schwarzeEinheiten(breite));
      } // for zeile

   } // druckeRechteck
   // ---------------------------------------------------------------------
   // Eine Prozedur mit einem Parameter:
   static void druckeDreieckA(int hoehe) {
      // Gibt ein Dreieck aus, welches aus hoehe vielen Zeilen besteht.
      // Die erste Zeile enthaelt eine, die letzte Zeile 2*hoehe-1 viele
      // schwarze Einheiten, d.h. die Spitze des Dreiecks zeigt nach oben,
      // aehnlich wie bei einem A.

      int anzWE = hoehe-1; // Anz. weisse   Einheiten in der 1. Zeile
      int anzSE = 1;       // Anz. schwarze Einheiten in der 1. Zeile

      for (int zeile=1; zeile<=hoehe; zeile++) {
         p(  weisseEinheiten(anzWE)); // Vorne    weisse   Einheiten
         p(schwarzeEinheiten(anzSE)); // Dahinter schwarze Einheiten
         pln();                       // Zeilenwechsel

         anzWE -= 1;
         anzSE += 2;
      } // for zeile

   } // druckeDreieckA
   // ---------------------------------------------------------------------
   // Eine Prozedur mit einem Parameter:
   static void druckeDreieckV(int hoehe) {
      // Gibt ein Dreieck aus, welches aus hoehe vielen Zeilen besteht.
      // Die erste Zeile enthaelt 2*hoehe-1 viele, die letzte Zeile eine
      // schwarze Einheiten, d.h. die Spitze des Dreiecks zeigt nach unten,
      // aehnlich wie bei einem V.

      int anzWE = 0;         // Anz. weisse   Einheiten in der 1. Zeile
      int anzSE = 2*hoehe-1; // Anz. schwarze Einheiten in der 1. Zeile

      for (int zeile=1; zeile<=hoehe; zeile++) {
         p(  weisseEinheiten(anzWE)); // Vorne    weisse   Einheiten
         p(schwarzeEinheiten(anzSE)); // Dahinter schwarze Einheiten
         pln();                       // Zeilenwechsel

         anzWE += 1;
         anzSE -= 2;
      } // for zeile

   } // druckeDreieckV
   // ---------------------------------------------------------------------
   // Eine Prozedur mit einem Parameter:
   static void druckeRaute(int hoehe) {
      // Gibt eine Raute aus, die aus hoehe vielen Zeilen besteht (genauer:
      // aus 2*(hoehe/2) vielen Zeilen. Das ist eine gerade Zeilenzahl,
      // selbst wenn hoehe ungerade ist). Mit Raute ist hier "eine Art
      // Quadrat, das auf einer Spitze steht" gemeint.

      // Der Programmierer hat hier die Methoden druckeDreieckA und
      // druckeDreieckV aufgerufen, statt "alles noch mal neu zu
      // programmieren". Diese Art von Faulheit ist sehr empfehlenswert.

      druckeDreieckA(hoehe/2);
      druckeDreieckV(hoehe/2);
   } // druckeRaute
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Gibt eine paar Rechtecke, Dreiecke und Rauten aus:

      pln("Rechteck 7x3:"); druckeRechteck(7, 3); pln();
      pln("Rechteck 5x5:"); druckeRechteck(5, 5); pln();
      pln("DreieckA 6:");   druckeDreieckA(6);    pln();
      pln("DreieckA 3:");   druckeDreieckA(3);    pln();
      pln("DreieckV 4:");   druckeDreieckV(4);    pln();
      pln("DreieckV 5:");   druckeDreieckV(5);    pln();

      pln("Raute 8:");      druckeRaute   (8);    pln();
      pln("Raute 4:");      druckeRaute   (4);    pln();
      pln("Raute 5:");      druckeRaute   (5);    pln();

      pln("------------------------------");
      pln("Methoden04: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Methoden04
/* ------------------------------------------------------------------------
Ausgabe des Programms Methoden04:

Rechteck 7x3:
**************
**************
**************

Rechteck 5x5:
**********
**********
**********
**********
**********

DreieckA 6:
..........**
........******
......**********
....**************
..******************
**********************

DreieckA 3:
....**
..******
**********

DreieckV 4:
**************
..**********
....******
......**

DreieckV 5:
******************
..**************
....**********
......******
........**

Raute 8:
......**
....******
..**********
**************
**************
..**********
....******
......**

Raute 4:
..**
******
******
..**

Raute 5:
..**
******
******
..**

------------------------------
Methoden04: Das war's erstmal!
------------------------------------------------------------------------ */
