// Datei Methoden08.java
/* ------------------------------------------------------------------------
Wenn man einer Methode eine primitive Variable pap als aktuellen Parameter
uebergibt, wird der entsprechende primitive formale Parameter pfp mit einer
Kopie des Wertes von pap initialisiert. Veraenderungen an der Variablen
pfp in der Methode wirken sich nicht auf die Variable pap aus.

Wenn man einer Methode eine Referenzvariable rap als aktuellen Parameter
uebergibt, wird der entsprechende Referenz-formale-Parameter rfp ebenfalls
mit einer Kopie des Wertes von rap initialisiert. Damit haben die Variablen
rap und rfp gleiche Werte und zeigen auf denselben Zielwert. Wird in der
Methode der Zielwert des formalen Parameters rfp veraendert so ist das
gleichzeitig eine Veraenderung des Zielwertes des aktuellen Parameters rap.

Hier wird versucht, diese Tatsache anhand eines Beispiels zu verdeutlichen.
------------------------------------------------------------------------ */
class Methoden08 {
   // -----------------------------------------------------------
   // Eine Prozedur ("void-Methode") mit
   // einem primitiven formalen Parameter pfp und
   // einem   Referenz-formalen-Parameter rfp:
   static void druckeUndVeraendere(int pfp, StringBuffer rfp) {
      // Der primitive formale Parameter pfp und
      // der  Referenz-formale-Parameter rfp werden
      // ausgegeben, veraendert und erneut ausgegeben:

      pln("Vorher : pfp: " + pfp + ", rfp: " + rfp);
      pfp = pfp + 1;   // pfp wird veraendert!
      rfp.append("!"); // rfp wird veraendert!
      pln("Nachher: pfp: " + pfp + ", rfp: " + rfp);
   } // druckeUndVeraendere
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Methode druckeUndVeraendere wird mehrmals mit
      // denselben Variablen als Parameter aufgerufen.
      // Werden diese Variablen veraendert oder nicht?

      // Ein primitiver aktueller Parameter pap und
      // ein   Referenz-aktueller Parameter rap:
      int          pap = 17;
      StringBuffer rap = new StringBuffer("Hallo");

      // Die Methode druckeUndVerandere wird mehrmals auf die
      // Variablen pap und rap angewendet und die (veraenderten?)
      // Variablen werden ausgegeben:
      pln("---------------------------------");
      druckeUndVeraendere(pap, rap);
      pln("In main: pap: " + pap + ", rap: " + rap);
      pln("---------------------------------");
      druckeUndVeraendere(pap, rap);
      pln("In main: pap: " + pap + ", rap: " + rap);
      pln("---------------------------------");
      druckeUndVeraendere(pap, rap);
      pln("In main: pap: " + pap + ", rap: " + rap);
      pln("---------------------------------");
      pln("Methoden08: Das war's erstmal!");

   } // main
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // -----------------------------------------------------------
} // class Methoden08
/* ------------------------------------------------------------------------
Ausgabe des Programms Methoden08:

---------------------------------
Vorher : pfp: 17, rfp: Hallo
Nachher: pfp: 18, rfp: Hallo!
In main: pap: 17, rap: Hallo!
---------------------------------
Vorher : pfp: 17, rfp: Hallo!
Nachher: pfp: 18, rfp: Hallo!!
In main: pap: 17, rap: Hallo!!
---------------------------------
Vorher : pfp: 17, rfp: Hallo!!
Nachher: pfp: 18, rfp: Hallo!!!
In main: pap: 17, rap: Hallo!!!
---------------------------------
Methoden08: Das war's erstmal!
------------------------------------------------------------------------ */
