// Datei Methoden09.java
/* ------------------------------------------------------------------------
Innerhalb einer Klasse darf man mehrere Methoden mit gleichen Namen
vereinbaren, aber nur, wenn die Methoden unterschiedliche Signaturen
besitzen.

Def.: Die Signatur einer Methode besteht aus dem Namen der Methode
gefolgt von den Namen der Typen ihrer Parameter.

Ein Methodenname ist ueberladen, wenn er mehrere Methoden (mit unter-
schiedlichen Signaturen) bezeichnet. In der Klasse Methoden09 werden die
Methodennamen max, min und gibAus ueberladen.

Die beiden gibAus-Methoden haben folgende (unterschiedliche) Signaturen:
gibAus String int
gibAus int String
------------------------------------------------------------------------ */
class Methoden09 {
   // -----------------------------------------------------------
   // Vier Methoden namens max: Jede liefert den Wert ihres
   // groessten Parameters als Ergebnis.
   // -----------------------------------------------------------
   static public int max(int n1, int n2) {
      int erg = n1;
      if (erg < n2) erg = n2;
      return erg;
   } // max
   // -----------------------------------------------------------
   static public int max(int n1, int n2, int n3) {
      int erg = n1;
      if (erg < n2) erg = n2;
      if (erg < n3) erg = n3;
      return erg;
   } // max
   // -----------------------------------------------------------
   static public int max(int n1, int n2, int n3, int n4) {
      int erg = n1;
      if (erg < n2) erg = n2;
      if (erg < n3) erg = n3;
      if (erg < n4) erg = n4;
      return erg;
   } // max
   // -----------------------------------------------------------
   static public int max(int n1, int n2, int n3, int n4, int n5) {
      int erg = n1;
      if (erg < n2) erg = n2;
      if (erg < n3) erg = n3;
      if (erg < n4) erg = n4;
      if (erg < n5) erg = n5;
      return erg;
   } // max
   // -----------------------------------------------------------
   // Vier Methoden namens min: Jede liefert den Wert ihres
   // kleinsten Parameters als Ergebnis.
   // Diese min-Methoden sind "nach einem anderen Muster"
   // programmiert als die max-Methoden.
   // -----------------------------------------------------------
   static public int min(int n1, int n2) {
      int erg = n1;
      if (erg > n2) erg = n2;
      return erg;
   } // min
   // -----------------------------------------------------------
   static public int min(int n1, int n2, int n3) {
      return min(n1, min(n2, n3));
   } // min
   // -----------------------------------------------------------
   static public int min(int n1, int n2, int n3, int n4) {
      return min(n1, min(n2, min(n3, n4)));
   } // min
   // -----------------------------------------------------------
   static public int min(int n1, int n2, int n3, int n4, int n5) {
      return min(n1, min(n2, min(n3, min(n4, n5))));
   } // min
   // -----------------------------------------------------------
   // Zwei Methoden namens gibAus, die sich durch die Reihenfolge
   // ihrer beiden Parameter unterscheiden.
   // -----------------------------------------------------------
   static public void gibAus(String name, int alter) {
      pln(name + " ist " + alter + " Jahre alt!");
   } // gibAus
   // -----------------------------------------------------------
   static public void gibAus(int alter, String name) {
      gibAus(name, alter);
   } // gibAus
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      pln("---------------------");
      pln("max(3, 1):          " + max(3, 1));
      pln("max(3, 5, 1):       " + max(3, 5, 1));
      pln("max(5, 1, 3, 8):    " + max(5, 1, 3, 8));
      pln("max(3, 7, 5, 1, 2): " + max(3, 7, 5, 1, 2));
      pln("---------------------");
      pln("min(3, 1):          " + min(3, 1));
      pln("min(2, 5, 3):       " + min(2, 5, 3));
      pln("min(5, 7, 3, 8):    " + min(5, 7, 3, 8));
      pln("min(4, 2, 5, 7, 3): " + min(4, 2, 5, 7, 3));
      pln("----------------------------------");
      gibAus("Eduard Meierbeer", 27);
      gibAus(26, "Gundula Braufrau");
      pln("----------------------------------");
      pln("Methoden09: Das war's erstmal!");
   } // main
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // -----------------------------------------------------------
} // class Methoden09
/* ------------------------------------------------------------------------
Ausgabe des Programms Methoden09:

---------------------
max(3, 1):          3
max(3, 5, 1):       5
max(5, 1, 3, 8):    8
max(3, 7, 5, 1, 2): 7
---------------------
min(3, 1):          1
min(2, 5, 3):       2
min(5, 7, 3, 8):    3
min(4, 2, 5, 7, 3): 2
----------------------------------
Eduard Meierbeer ist 27 Jahre alt!
Gundula Braufrau ist 26 Jahre alt!
----------------------------------
Methoden09: Das war's erstmal!
------------------------------------------------------------------------ */