// Datei Operatoren01.java
/* ------------------------------------------------------------------------
In diesem Programm werden die folgenden Operatoren "vorgefuehrt":

Die Vorzeichen                                        +n,  -n
Die prae- und postfix Inkrement-Operatoren            ++n, n++
Die prae- und postfix Dekrement-Operatoren            --n, n--
Der                logische           Nicht-Operator  !b
Der       schwache logische            Und-Operator   b  &  c
Der                logische exklusive Oder-Operator   b  ^  c
Der       schwache logische inklusive Oder-Operator   b  |  c
Der nicht-schwache logische            Und-Operator   b  && c
Der nicht-schwache logische inklusive Oder-Operator   b  || c
Der Shift-rechts-mit-Vorzeichen-Operator              n  >> n
Der Shift-rechts-ohne-Vorzeichen-Operaotr             n >>> m
Der Shift-links-Operator                              n  << m
Der bitweise                          Nicht-Operator  ~ n
Der bitweise                           Und-Operator   n  &  m
Der bitweise                exklusive Oder-Operator   n  ^  m
Der bitweise                inklusive Oder-Operator   n  |  m
---------------------------------------------------------------------------
Hinweise:
1. Wenn man ein Vorzeichen (+ oder -) auf einen Wert eines "kleinen
   Ganzzahltyps" (byte-, char- oder short) anwendet, wandelt der Aus-
   fuehrer ihn in einen int-Wert um (siehe Zeile AB und das Programm
   Ausdruecke03).
2. Wenn man einen Inkrement-Operator ++ oder einen Dekrement-Operator --
   auf eine byte-, char- oder short-Variable anwendet, findet keine
   Typumwandlung statt (siehe Zeilen BB, CB, DB und EB und das Programm
   Ausdruecke03).
3. Der Unterschied zwischen den schwachen logischen Operatoren (& und |)
   und den nicht-schwachen logischen Operatoren (&& und ||) wird in den
   Programmen Operatoren02 und Operatoren03 erlaeutert.
4. Wenn man einen der Shift-Operatoren (>>, >>> oder <<) auf einen Wert
   eines "kleinen Ganzzahltyps" (byte-, char- oder short) anwendet,
   wandelt der Ausfuehrer ihn in einen int-Wert um und das Ergebnis der
   Operation ist ein int-Wert. In diesem Programm werden die Shift-
   Operationen deshalb nur auf int- und long-Werte angewendet.
5. Wenn man eine Shift-Operation auf einen int-Wert anwendet, werden von
   der Shift-Zahl (d.h. vom rechten Parameter) nur die niedrigsten 5 Bits
   genommen, die eine Zahl zwischen 0 und 31 darstellen. Ob man als
   Shift-Zahl 0 oder 32, 1 oder 33, 2 oder 34 etc. angibt macht also
   keinen Unterschied.
6. Wenn man eine Shift-Operation auf einen long-Wert anwendet, werden von
   der Shift-Zahl (d.h. vom rechten Parameter) nur die niedrigsten 6 Bits
   genommen, die eine Zahl zwischen 0 und 63 darstellen. Ob man als
   Shift-Zahl 0 oder 64, 1 oder 65, 2 oder 66 etc. angibt macht also
   keinen Unterschied.
------------------------------------------------------------------------ */
class Operatoren01 {
   // Von jedem numerischen Typ wird eine Variable vereinbart (von den
   // Typen int und long sogar zwei):
   static byte    b01 = 65;
   static char    c01 = 65;
   static short   s01 = 65;
   static int     i01 = 65, i02;
   static long    l01 = 65, l02;
   static float   f01 = 65.5F;
   static double  d01 = 65.5;

   // Strings zum Trennen von Zahlen und Ausgleichen von Laengenunter-
   // schieden in Ausgabezeilen:
   static final String t1 = ", ";
   static final String t2 = ",  ";
   static final String t3 = ",   ";
   static final String t4 = ",    ";
   // ---------------------------------------------------------------------
   static void vorzeichen() {
      pln("   Vorzeichen: keines, + und -: -----------------------------");
      pln("AA b01, +b01, -b01: " +  b01 + t3 +  +b01  + t3  + -b01);
      pln("AB c01, +c01, -c01: " +  c01 + t4 +  +c01  + t3  + -c01);
      pln("AC s01, +s01, -s01: " +  s01 + t3 +  +s01  + t3  + -s01);
      pln("AD i01, +i01, -i01: " +  i01 + t3 +  +i01  + t3  + -i01);
      pln("AE l01, +l01, -l01: " +  l01 + t3 +  +l01  + t3  + -l01);
      pln("AF f01, +f01, -f01: " +  f01 + t1 +  +f01  + t1  + -f01);
      pln("AG d01, +d01, -d01: " +  d01 + t1 +  +d01  + t1  + -d01);
      pln();
   } // vorzeichen
   // ---------------------------------------------------------------------
   static void inkrementPrae() {
      pln("   Inkrement, praefix: --------------------------------------");
      pln("BA b01, ++b01, b01: " +  b01 + t3 +  ++b01  + t3  + b01);
      pln("BB c01, ++c01, c01: " +  c01 + t4 +  ++c01  + t4  + c01);
      pln("BC s01, ++s01, s01: " +  s01 + t3 +  ++s01  + t3  + s01);
      pln("BD i01, ++i01, i01: " +  i01 + t3 +  ++i01  + t3  + i01);
      pln("BE l01, ++l01, l01: " +  l01 + t3 +  ++l01  + t3  + l01);
      pln("BF f01, ++f01, f01: " +  f01 + t1 +  ++f01  + t1  + f01);
      pln("BG d01, ++d01, d01: " +  d01 + t1 +  ++d01  + t1  + d01);
      pln();
   } // inkrement
   // ---------------------------------------------------------------------
   static void inkrementPost() {
      pln("   Inkrement, postfix: --------------------------------------");
      pln("CA b01, b01++, b01: " +  b01 + t3 +  b01++   + t3  + b01);
      pln("CB c01, c01++, c01: " +  c01 + t4 +  c01++   + t4  + c01);
      pln("CC s01, s01++, s01: " +  s01 + t3 +  s01++   + t3  + s01);
      pln("CD i01, i01++, i01: " +  i01 + t3 +  i01++   + t3  + i01);
      pln("CE l01, l01++, l01: " +  l01 + t3 +  l01++   + t3  + l01);
      pln("CF f01, f01++, f01: " +  f01 + t1 +  f01++   + t1  + f01);
      pln("CG d01, d01++, d01: " +  d01 + t1 +  d01++   + t1  + d01);
      pln();
   } // inkrement
   // ---------------------------------------------------------------------
   static void dekrementPrae() {
      pln("   Inkrement, praefix: --------------------------------------");
      pln("DA b01, --b01, b01: " +  b01 + t3 +  --b01  + t3  + b01);
      pln("DB c01, --c01, c01: " +  c01 + t4 +  --c01  + t4  + c01);
      pln("DC s01, --s01, s01: " +  s01 + t3 +  --s01  + t3  + s01);
      pln("DD i01, --i01, i01: " +  i01 + t3 +  --i01  + t3  + i01);
      pln("DE l01, --l01, l01: " +  l01 + t3 +  --l01  + t3  + l01);
      pln("DF f01, --f01, f01: " +  f01 + t1 +  --f01  + t1  + f01);
      pln("DG d01, --d01, d01: " +  d01 + t1 +  --d01  + t1  + d01);
      pln();
   } // inkrement
   // ---------------------------------------------------------------------
   static void dekrementPost() {
      pln("   Inkrement, praefix: --------------------------------------");
      pln("EA b01, b01--, b01: " +  b01 + t3 +  b01--  + t3  + b01);
      pln("EB c01, c01--, c01: " +  c01 + t4 +  c01--  + t4  + c01);
      pln("EC s01, s01--, s01: " +  s01 + t3 +  s01--  + t3  + s01);
      pln("ED i01, i01--, i01: " +  i01 + t3 +  i01--  + t3  + i01);
      pln("EE l01, l01--, l01: " +  l01 + t3 +  l01--  + t3  + l01);
      pln("EF f01, f01--, f01: " +  f01 + t1 +  f01--  + t1  + f01);
      pln("EG d01, d01--, d01: " +  d01 + t1 +  d01--  + t1  + d01);
      pln();
   } // inkrement
   // ---------------------------------------------------------------------
   static void logischesNicht() {
      pln("   Logisches Nicht: -----------------------------------------");
      pln("FA !false         : " + !false);
      pln("FB !true          : " + !true);
      pln();
   } // logischesNicht
   // ---------------------------------------------------------------------
   static void logischesUndSchwach() {
      pln("   Logisches Und, schwach: ----------------------------------");
      pln("GA true  &  true  : " + (true  &  true ));
      pln("GB true  &  false : " + (true  &  false));
      pln("GC false &  true  : " + (false &  true ));
      pln("GD false &  false : " + (false &  false));
      pln();
   } // logischesUndSchwach
   // ---------------------------------------------------------------------
   static void logischesOderExklusiv() {
      pln("   Logisches Oder, exklusiv: --------------------------------");
      pln("HA true  ^  true  : " + (true  ^  true ));
      pln("HB true  ^  false : " + (true  ^  false));
      pln("HC false ^  true  : " + (false ^  true ));
      pln("HD false ^  false : " + (false ^  false));
      pln();
   } // logischesOderExklusiv
   // ---------------------------------------------------------------------
   static void logischesOderInklusivSchwach() {
      pln("   Logisches Oder, inklusiv, schwach: -----------------------");
      pln("IA true  |  true  : " + (true  |  true ));
      pln("IB true  |  false : " + (true  |  false));
      pln("IC false |  true  : " + (false |  true ));
      pln("ID false |  false : " + (false |  false));
      pln();
   } // logischesOderInklusivSchwach
   // ---------------------------------------------------------------------
   static void logischesUndNichtSchwach() {
      pln("   Logisches Und, nicht-schwach: ----------------------------");
      pln("JA true  && true  : " + (true  && true ));
      pln("JB true  && false : " + (true  && false));
      pln("JC false && true  : " + (false && true ));
      pln("JD false && false : " + (false && false));
      pln();
   } // logischesUndNichtSchwach
   // ---------------------------------------------------------------------
   static void logischesOderInklusivNichtSchwach() {
      pln("   Logisches Oder, inklusiv, nicht-schwach: -----------------");
      pln("KA true  || true  : " + (true  || true ));
      pln("KB true  || false : " + (true  || false));
      pln("KC false || true  : " + (false || true ));
      pln("KD false || false : " + (false || false));
      pln();
   } // logischesOderInklusivNichtSchwach
   // ---------------------------------------------------------------------
   static void shiftRechtsMitVorzeichen() {
      pln("   Shift nach rechts, das Vorzeichen nachziehend: -----------");
      pln("LA i01       " + bin( i01));
      pln("LB i01 >>  1:" + bin((i01 >>  1)));
      pln("LC i01 >>  2:" + bin((i01 >>  2)));
      pln("LD i01 >>  3:" + bin((i01 >>  3)));
      pln("LE i01 >>  4:" + bin((i01 >>  4)));
      pln("   ---------");
      pln("LF i02       " + bin( i02));
      pln("LG i02 >>  1:" + bin((i02 >>  1)));
      pln("LH i02 >>  2:" + bin((i02 >>  2)));
      pln("LI i02 >>  3:" + bin((i02 >>  3)));
      pln("LJ i02 >>  4:" + bin((i02 >>  4)));
      pln("   ---------");
      pln("LK l01       " + bin( l01));
      pln("LL l01 >>  1:" + bin((l01 >>  1)));
      pln("LM l01 >>  2:" + bin((l01 >>  2)));
      pln("LN l01 >>  3:" + bin((l01 >>  3)));
      pln("LO l01 >>  4:" + bin((l01 >>  4)));
      pln("  ---------");
      pln("LP l02       " + bin( l02));
      pln("LQ l02 >>  1:" + bin((l02 >>  1)));
      pln("LR l02 >>  2:" + bin((l02 >>  2)));
      pln("LS l02 >>  3:" + bin((l02 >>  3)));
      pln("LT l02 >>  4:" + bin((l02 >>  4)));
      pln();
   } // shiftRechtsMitVorzeichen
   // ---------------------------------------------------------------------
   static void shiftRechtsOhneVorzeichen() {
      pln("   Shift nach rechts, Nullen nachziehend: -------------------");
      pln("MA i01       " + bin( i01));
      pln("MB i01 >>> 1:" + bin((i01 >>> 1)));
      pln("MC i01 >>> 2:" + bin((i01 >>> 2)));
      pln("MD i01 >>> 3:" + bin((i01 >>> 3)));
      pln("ME i01 >>> 4:" + bin((i01 >>> 4)));
      pln("   ---------");
      pln("MF i02       " + bin( i02));
      pln("MG i02 >>> 1:" + bin((i02 >>> 1)));
      pln("MH i02 >>> 2:" + bin((i02 >>> 2)));
      pln("MI i02 >>> 3:" + bin((i02 >>> 3)));
      pln("MJ i02 >>> 4:" + bin((i02 >>> 4)));
      pln("   ---------");
      pln("MK l01       " + bin( l01));
      pln("ML l01 >>> 1:" + bin((l01 >>> 1)));
      pln("MM l01 >>> 2:" + bin((l01 >>> 2)));
      pln("MN l01 >>> 3:" + bin((l01 >>> 3)));
      pln("MO l01 >>> 4:" + bin((l01 >>> 4)));
      pln("  ----------");
      pln("MP l02       " + bin( l02));
      pln("MQ l02 >>> 1:" + bin((l02 >>> 1)));
      pln("MR l02 >>> 2:" + bin((l02 >>> 2)));
      pln("MS l02 >>> 3:" + bin((l02 >>> 3)));
      pln("MT l02 >>> 4:" + bin((l02 >>> 4)));
      pln() ;
   } // shiftRechtsOhneVorzeichen
   // ---------------------------------------------------------------------
   static void shiftLinks() {
      pln("   Shift nach links (Nullen nachziehend): -------------------");
      pln("NA i01       " + bin( i01));
      pln("NB i01 <<  1:" + bin((i01 <<  1)));
      pln("NC i01 <<  2:" + bin((i01 <<  2)));
      pln("ND i01 <<  3:" + bin((i01 <<  3)));
      pln("NE i01 <<  4:" + bin((i01 <<  4)));
      pln("   ---------");
      pln("NF i02       " + bin( i02));
      pln("NG i02 <<  1:" + bin((i02 <<  1)));
      pln("NH i02 <<  2:" + bin((i02 <<  2)));
      pln("NI i02 <<  3:" + bin((i02 <<  3)));
      pln("NJ i02 <<  4:" + bin((i02 <<  4)));
      pln("   ---------");
      pln("NK l01       " + bin( l01));
      pln("NL l01 <<  1:" + bin((l01 <<  1)));
      pln("NM l01 <<  2:" + bin((l01 <<  2)));
      pln("NN l01 <<  3:" + bin((l01 <<  3)));
      pln("NO l01 <<  4:" + bin((l01 <<  4)));
      pln("  ----------");
      pln("NP l02       " + bin( l02));
      pln("NQ l02 <<  1:" + bin((l02 <<  1)));
      pln("NR l02 <<  2:" + bin((l02 <<  2)));
      pln("NS l02 <<  3:" + bin((l02 <<  3)));
      pln("NT l02 <<  4:" + bin((l02 <<  4)));
      pln() ;
   } // shiftLinks
   // ---------------------------------------------------------------------
   static void bitweiseNicht() {
      pln("   Bitweise Nicht: --------------------------------------------");
      pln("OA i01:       " + bin( i01));
      pln("OB ~i02:      " + bin(~i01));
      pln();
      pln("OC  l01:      " + bin( l01));
      pln("OD ~l02:      " + bin(~l01));
      pln();
   } // bitweiseNicht
   // ---------------------------------------------------------------------
   static void bitweiseUnd() {
      pln("   Bitweise Und: --------------------------------------------");
      pln("PA i01:       " + bin(i01));
      pln("PB i02:       " + bin(i02));
      pln("PC i01 & i02: " + bin(i01 & i02));
      pln();
      pln("PD l01:       " + bin(l01));
      pln("PE l02:       " + bin(l02));
      pln("PF l01 & l02: " + bin(l01 & l02));
      pln();
   } // bitweiseUnd
   // ---------------------------------------------------------------------
   static void bitweiseOderExklusiv() {
      pln("   Bitweise Oder, exklusiv: ---------------------------------");
      pln("QA i01:       " + bin(i01));
      pln("QB i02:       " + bin(i02));
      pln("QC i01 ^ i02: " + bin(i01 ^ i02));
      pln();
      pln("QD l01:       " + bin(l01));
      pln("QE l02:       " + bin(l02));
      pln("QF l01 ^ l02: " + bin(l01 ^ l02));
      pln();
   } // bitweiseOderExklusiv
   // ---------------------------------------------------------------------
   static void bitweiseOderInklusiv() {
      pln("   Bitweise Oder, inklusiv: ---------------------------------");
      pln("RA i01:       " + bin(i01));
      pln("RB i02:       " + bin(i02));
      pln("RC i01 | i02: " + bin(i01 | i02));
      pln();
      pln("RD l01:       " + bin(l01));
      pln("RE l02:       " + bin(l02));
      pln("RF l01 | l02: " + bin(l01 | l02));
      pln();
   } // bitweiseOderInklusiv
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
   static String bin(int  n) {
      return bin(n, 32);
   } // bin

   static String bin(long n) {
      return bin(n, 64);
   } // bin

   static String bin(long n, int len) {
      StringBuffer erg = new StringBuffer(len);
      for (int i=1; i<= len; i++) {
         char bit = n%2 == 0 ? '0' : '1';
         erg.insert(0, bit);
         if (i % 4 == 0) erg.insert(0, " ");
         n = n >> 1;
      }
      return erg.toString();
   } // bin
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      vorzeichen();
      inkrementPrae();
      inkrementPost();
      dekrementPrae();
      dekrementPost();

      logischesNicht();
      logischesUndSchwach();
      logischesOderExklusiv();
      logischesOderInklusivSchwach();
      logischesUndNichtSchwach();
      logischesOderInklusivNichtSchwach();

      i01 = 0x18181818;
      i02 = 0x81818181;
      l01 = 0x0123456789ABCDEFL;
      l02 = 0xFEDCBA9876543210L;

      shiftRechtsMitVorzeichen();
      shiftRechtsOhneVorzeichen();
      shiftLinks();

      i01 = 0xFF00FF00;
      i02 = 0xF0F0F0F0;
      l01 = 0xFF00FF00FF00FF00L;
      l02 = 0xF0F0F0F0F0F0F0F0L;

      bitweiseNicht();
      bitweiseUnd();
      bitweiseOderExklusiv();
      bitweiseOderInklusiv();

      pln("--------------------------------");
      pln("Operatoren01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
} // class Operatoren01
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren01:

   Vorzeichen: keines, + und -: -----------------------------
AA b01, +b01, -b01: 65,   65,   -65
AB c01, +c01, -c01: A,    65,   -65
AC s01, +s01, -s01: 65,   65,   -65
AD i01, +i01, -i01: 65,   65,   -65
AE l01, +l01, -l01: 65,   65,   -65
AF f01, +f01, -f01: 65.5, 65.5, -65.5
AG d01, +d01, -d01: 65.5, 65.5, -65.5

   Inkrement, praefix: --------------------------------------
BA b01, ++b01, b01: 65,   66,   66
BB c01, ++c01, c01: A,    B,    B
BC s01, ++s01, s01: 65,   66,   66
BD i01, ++i01, i01: 65,   66,   66
BE l01, ++l01, l01: 65,   66,   66
BF f01, ++f01, f01: 65.5, 66.5, 66.5
BG d01, ++d01, d01: 65.5, 66.5, 66.5

   Inkrement, postfix: --------------------------------------
CA b01, b01++, b01: 66,   66,   67
CB c01, c01++, c01: B,    B,    C
CC s01, s01++, s01: 66,   66,   67
CD i01, i01++, i01: 66,   66,   67
CE l01, l01++, l01: 66,   66,   67
CF f01, f01++, f01: 66.5, 66.5, 67.5
CG d01, d01++, d01: 66.5, 66.5, 67.5

   Inkrement, praefix: --------------------------------------
DA b01, --b01, b01: 67,   66,   66
DB c01, --c01, c01: C,    B,    B
DC s01, --s01, s01: 67,   66,   66
DD i01, --i01, i01: 67,   66,   66
DE l01, --l01, l01: 67,   66,   66
DF f01, --f01, f01: 67.5, 66.5, 66.5
DG d01, --d01, d01: 67.5, 66.5, 66.5

   Inkrement, praefix: --------------------------------------
EA b01, b01--, b01: 66,   66,   65
EB c01, c01--, c01: B,    B,    A
EC s01, s01--, s01: 66,   66,   65
ED i01, i01--, i01: 66,   66,   65
EE l01, l01--, l01: 66,   66,   65
EF f01, f01--, f01: 66.5, 66.5, 65.5
EG d01, d01--, d01: 66.5, 66.5, 65.5

   Logisches Nicht: -----------------------------------------
FA !false         : true
FB !true          : false

   Logisches Und, schwach: ----------------------------------
GA true  &  true  : true
GB true  &  false : false
GC false &  true  : false
GD false &  false : false

   Logisches Oder, exklusiv: --------------------------------
HA true  ^  true  : false
HB true  ^  false : true
HC false ^  true  : true
HD false ^  false : false

   Logisches Oder, inklusiv, schwach: -----------------------
IA true  |  true  : true
IB true  |  false : true
IC false |  true  : true
ID false |  false : false

   Logisches Und, nicht-schwach: ----------------------------
JA true  && true  : true
JB true  && false : false
JC false && true  : false
JD false && false : false

   Logisches Oder, inklusiv, nicht-schwach: -----------------
KA true  || true  : true
KB true  || false : true
KC false || true  : true
KD false || false : false

   Shift nach rechts, das Vorzeichen nachziehend: -----------
LA i01        0001 1000 0001 1000 0001 1000 0001 1000
LB i01 >>  1: 0000 1100 0000 1100 0000 1100 0000 1100
LC i01 >>  2: 0000 0110 0000 0110 0000 0110 0000 0110
LD i01 >>  3: 0000 0011 0000 0011 0000 0011 0000 0011
LE i01 >>  4: 0000 0001 1000 0001 1000 0001 1000 0001
   ---------
LF i02        1000 0001 1000 0001 1000 0001 1000 0001
LG i02 >>  1: 1100 0000 1100 0000 1100 0000 1100 0000
LH i02 >>  2: 1110 0000 0110 0000 0110 0000 0110 0000
LI i02 >>  3: 1111 0000 0011 0000 0011 0000 0011 0000
LJ i02 >>  4: 1111 1000 0001 1000 0001 1000 0001 1000
   ---------
LK l01        0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110 1111
LL l01 >>  1: 0000 0000 1001 0001 1010 0010 1011 0011 1100 0100 1101 0101 1110 0110 1111 0111
LM l01 >>  2: 0000 0000 0100 1000 1101 0001 0101 1001 1110 0010 0110 1010 1111 0011 0111 1011
LN l01 >>  3: 0000 0000 0010 0100 0110 1000 1010 1100 1111 0001 0011 0101 0111 1001 1011 1101
LO l01 >>  4: 0000 0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110
  ---------
LP l02        1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001 0000
LQ l02 >>  1: 1111 1111 0110 1110 0101 1101 0100 1100 0011 1011 0010 1010 0001 1001 0000 1000
LR l02 >>  2: 1111 1111 1011 0111 0010 1110 1010 0110 0001 1101 1001 0101 0000 1100 1000 0100
LS l02 >>  3: 1111 1111 1101 1011 1001 0111 0101 0011 0000 1110 1100 1010 1000 0110 0100 0010
LT l02 >>  4: 1111 1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001

   Shift nach rechts, Nullen nachziehend: -------------------
MA i01        0001 1000 0001 1000 0001 1000 0001 1000
MB i01 >>> 1: 0000 1100 0000 1100 0000 1100 0000 1100
MC i01 >>> 2: 0000 0110 0000 0110 0000 0110 0000 0110
MD i01 >>> 3: 0000 0011 0000 0011 0000 0011 0000 0011
ME i01 >>> 4: 0000 0001 1000 0001 1000 0001 1000 0001
   ---------
MF i02        1000 0001 1000 0001 1000 0001 1000 0001
MG i02 >>> 1: 0100 0000 1100 0000 1100 0000 1100 0000
MH i02 >>> 2: 0010 0000 0110 0000 0110 0000 0110 0000
MI i02 >>> 3: 0001 0000 0011 0000 0011 0000 0011 0000
MJ i02 >>> 4: 0000 1000 0001 1000 0001 1000 0001 1000
   ---------
MK l01        0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110 1111
ML l01 >>> 1: 0000 0000 1001 0001 1010 0010 1011 0011 1100 0100 1101 0101 1110 0110 1111 0111
MM l01 >>> 2: 0000 0000 0100 1000 1101 0001 0101 1001 1110 0010 0110 1010 1111 0011 0111 1011
MN l01 >>> 3: 0000 0000 0010 0100 0110 1000 1010 1100 1111 0001 0011 0101 0111 1001 1011 1101
MO l01 >>> 4: 0000 0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110
  ----------
MP l02        1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001 0000
MQ l02 >>> 1: 0111 1111 0110 1110 0101 1101 0100 1100 0011 1011 0010 1010 0001 1001 0000 1000
MR l02 >>> 2: 0011 1111 1011 0111 0010 1110 1010 0110 0001 1101 1001 0101 0000 1100 1000 0100
MS l02 >>> 3: 0001 1111 1101 1011 1001 0111 0101 0011 0000 1110 1100 1010 1000 0110 0100 0010
MT l02 >>> 4: 0000 1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001

   Shift nach links (Nullen nachziehend): -------------------
NA i01        0001 1000 0001 1000 0001 1000 0001 1000
NB i01 <<  1: 0011 0000 0011 0000 0011 0000 0011 0000
NC i01 <<  2: 0110 0000 0110 0000 0110 0000 0110 0000
ND i01 <<  3: 1100 0000 1100 0000 1100 0000 1100 0000
NE i01 <<  4: 1000 0001 1000 0001 1000 0001 1000 0000
   ---------
NF i02        1000 0001 1000 0001 1000 0001 1000 0001
NG i02 <<  1: 0000 0011 0000 0011 0000 0011 0000 0010
NH i02 <<  2: 0000 0110 0000 0110 0000 0110 0000 0100
NI i02 <<  3: 0000 1100 0000 1100 0000 1100 0000 1000
NJ i02 <<  4: 0001 1000 0001 1000 0001 1000 0001 0000
   ---------
NK l01        0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110 1111
NL l01 <<  1: 0000 0010 0100 0110 1000 1010 1100 1111 0001 0011 0101 0111 1001 1011 1101 1110
NM l01 <<  2: 0000 0100 1000 1101 0001 0101 1001 1110 0010 0110 1010 1111 0011 0111 1011 1100
NN l01 <<  3: 0000 1001 0001 1010 0010 1011 0011 1100 0100 1101 0101 1110 0110 1111 0111 1000
NO l01 <<  4: 0001 0010 0011 0100 0101 0110 0111 1000 1001 1010 1011 1100 1101 1110 1111 0000
  ----------
NP l02        1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001 0000
NQ l02 <<  1: 1111 1101 1011 1001 0111 0101 0011 0000 1110 1100 1010 1000 0110 0100 0010 0000
NR l02 <<  2: 1111 1011 0111 0010 1110 1010 0110 0001 1101 1001 0101 0000 1100 1000 0100 0000
NS l02 <<  3: 1111 0110 1110 0101 1101 0100 1100 0011 1011 0010 1010 0001 1001 0000 1000 0000
NT l02 <<  4: 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001 0000 0000

   Bitweise Nicht: --------------------------------------------
OA i01:        1111 1111 0000 0000 1111 1111 0000 0000
OB ~i02:       0000 0000 1111 1111 0000 0000 1111 1111

OC  l01:       1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000
OD ~l02:       0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111

   Bitweise Und: --------------------------------------------
PA i01:        1111 1111 0000 0000 1111 1111 0000 0000
PB i02:        1111 0000 1111 0000 1111 0000 1111 0000
PC i01 & i02:  1111 0000 0000 0000 1111 0000 0000 0000

PD l01:        1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000
PE l02:        1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000
PF l01 & l02:  1111 0000 0000 0000 1111 0000 0000 0000 1111 0000 0000 0000 1111 0000 0000 0000

   Bitweise Oder, exklusiv: ---------------------------------
QA i01:        1111 1111 0000 0000 1111 1111 0000 0000
QB i02:        1111 0000 1111 0000 1111 0000 1111 0000
QC i01 ^ i02:  0000 1111 1111 0000 0000 1111 1111 0000

QD l01:        1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000
QE l02:        1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000
QF l01 ^ l02:  0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000

   Bitweise Oder, inklusiv: ---------------------------------
RA i01:        1111 1111 0000 0000 1111 1111 0000 0000
RB i02:        1111 0000 1111 0000 1111 0000 1111 0000
RC i01 | i02:  1111 1111 1111 0000 1111 1111 1111 0000

RD l01:        1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000 1111 1111 0000 0000
RE l02:        1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000 1111 0000
RF l01 | l02:  1111 1111 1111 0000 1111 1111 1111 0000 1111 1111 1111 0000 1111 1111 1111 0000

--------------------------------
Operatoren01: Das war's erstmal!
------------------------------------------------------------------------ */