// Datei Operatoren02.java
/* ------------------------------------------------------------------------
Demonstriert den Unterschied zwischen den schwachen logischen Operatoren
Und und Oder (&  und |)     und den nicht-schwachen logischen Operatoren
Und und Oder (&& und ||) mit Hilfe einer Funktion mit Seiteneffekt.

Def.: Ein Ausdruck A ist undefiniert, wenn der Ausfuehrer seinen Wert
      nicht berechnen kann (weil er dabei in eine Endlosschleife oder in
      eine Endlosrekursion geraet oder weil er die Berechnung mit einer
      Ausnahme abbrechen muss).

Beispiel: Seien n1 und n2 zwei int-Variablen. Falls n2 den Wert 0 hat,
sind die Ausdruecke (n1/n2) und (n1/n2 > 5) undefiniert.

Def.: Sei op eine zweistellige Operation und seien A1 und A2 zwei Ausdruecke,
      die (typenmaessig) als aktuelle Parameter fuer op geeignet sind.
      Die Operation op ist nicht-schwach, wenn der Ausdruck (A1 op A2) in
      mindestens einem Fall definiert ist, obwohl mind. einer der Parameter
      A1 oder A2 undefiniert ist. Sonst ist op schwach.

Beispiel: Die Oder-Operation || ist nicht-schwach, weil ein Ausdruck wie
true || A2 den definierten Wert true hat, auch wenn A2 undefiniert ist.

Beispiel: Die  Und-Operation && ist nicht-schwach, weil ein Ausdruck wie
false && A2 den definierten Wert false hat, auch wenn A2 undefiniert ist.
------------------------------------------------------------------------ */
class Operatoren02 {
   // ---------------------------------------------------------------------
   // Ein Funktion mit Seiteneffekt (MS) auf den Bildschirm:
   static boolean istPositivMS(int n) {
      // Liefert true, wenn n eine positive Zahl ist, sonst false.
      // Als Seiteneffekt wird eine Meldung ausgegeben.

      pln("   istPositivMS: Untersucht wird die Zahl " + n);

      return n > 0;
   } // istPositivMS
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      // ------------------------------------------------------------------
      // Die nicht-schwache Oder-Operation || wertet eventuell nur ihren
      // ersten Parameter aus:
      if (istPositivMS(17) || istPositivMS(-3)) {
         pln("AA Mindestens eine Zahl ist positiv!");
      } else {
         pln("AB Keine der beiden Zahlen ist positiv!");
      } // if
      pln("--------------------------------------------");
      // ------------------------------------------------------------------
      // Die schwache Oder-Operation | wertet immer beide Parameter aus:
      if (istPositivMS(17) |  istPositivMS(-3)) {
         pln("BA Mindestens eine Zahl ist positiv!");
      } else {
         pln("BB Keine der beiden Zahlen ist positiv!");
      } // if
      pln("--------------------------------------------");
      // ------------------------------------------------------------------
      // Die nicht-schwache Und-Operation && wertet eventuell nur ihren
      // ersten Parameter aus:
      if (istPositivMS(-3) && istPositivMS(17)) {
         pln("CA Beide Zahlen sind positiv!");
      } else {
         pln("CB Mindestens eine Zahl ist nicht positiv!");
      } // if
      pln("--------------------------------------------");
      // ------------------------------------------------------------------
      // Die schwache Und-Opertion & wertet immer beide Parameter aus:
      if (istPositivMS(-3) &  istPositivMS(17)) {
         pln("DA Beide Zahlen sind positiv!");
      } else {
         pln("DB Mindestens eine Zahl ist nicht positiv!");
      } // if
      pln("--------------------------------------------");
      pln("Operatoren02: Das war's erstmal!");
      // ------------------------------------------------------------------
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Operatoren02
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren02

   istPositivMS: Untersucht wird die Zahl 17
AA Mindestens eine Zahl ist positiv!
--------------------------------------------
   istPositivMS: Untersucht wird die Zahl 17
   istPositivMS: Untersucht wird die Zahl -3
BA Mindestens eine Zahl ist positiv!
--------------------------------------------
   istPositivMS: Untersucht wird die Zahl -3
CB Mindestens eine Zahl ist nicht positiv!
--------------------------------------------
   istPositivMS: Untersucht wird die Zahl -3
   istPositivMS: Untersucht wird die Zahl 17
DB Mindestens eine Zahl ist nicht positiv!
--------------------------------------------
Operatoren02: Das war's erstmal!
------------------------------------------------------------------------ */