// Datei Operatoren03.java
/* ------------------------------------------------------------------------
Demonstriert den Unterschied zwischen den schwachen logischen Operatoren
Und und Oder (&  und |)     und den nicht-schwachen logischen Operatoren
Und und Oder (&& und ||) mit Hilfe einer Division durch 0.

Def.: Ein Ausdruck A ist undefiniert, wenn der Ausfuehrer seinen Wert
      nicht berechnen kann (weil er dabei in eine Endlosschleife oder in
      eine Endlosrekursion geraet oder weil er die Berechnung mit einer
      Ausnahme abbrechen muss).

Beispiel: Seien n1 und n2 zwei int-Variablen. Falls n2 den Wert 0 hat,
sind die Ausdruecke (n1/n2) und (n1/n2 > 5) undefiniert.

Def.: Sei op eine zweistellige Operation und seien A1 und A2 zwei Ausdruecke,
      die (typenmaessig) als aktuelle Parameter fuer op geeignet sind.
      Die Operation op ist nicht-schwach, wenn der Ausdruck (A1 op A2) in
      mindestens einem Fall definiert ist, obwohl mind. einer der Parameter
      A1 oder A2 undefiniert ist. Sonst ist op schwach.

Beispiel: Die Oder-Operation || ist nicht-schwach, weil ein Ausdruck wie
true || A2 den definierten Wert true hat, auch wenn A2 undefiniert ist.

Beispiel: Die  Und-Operation && ist nicht-schwach, weil ein Ausdruck wie
false && A2 den definierten Wert false hat, auch wenn A2 undefiniert ist.
------------------------------------------------------------------------ */
class Operatoren03 {
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      int n1 = 17;
      int n2 =  0;
      // ------------------------------------------------------------------
      // Die nicht-schwache Oder-Operation || liefert eventuell ein
      // definiertes Ergebnis, obwohl ihr zweiter Parameter undefiniert
      // ist (d.h. eine Ausnahme wirft):
      if (n1 > 5 || n1/n2 > 5) {
         pln("AA Der Ausdruck n1/n2 wurde nicht ausgewertet!");
      } else {
         pln("AB Der Ausdruck n1/n2 wurde nicht ausgewertet!");
      } // if
      // ------------------------------------------------------------------
      // Die nicht-schwache Oder-Operation && liefert eventuell ein
      // definiertes Ergebnis, obwohl ihr zweiter Parameter undefiniert
      // ist (d.h. eine Ausnahme wirft):
      if (n1 < 5 && n1/n2 < 5) {
         pln("BA Der Ausdruck n1/n2 wurde nicht ausgewertet!");
      } else {
         pln("BB Der Ausdruck n1/n2 wurde nicht ausgewertet!");
      } // if
      // ------------------------------------------------------------------
      // Die schwache Oder-Operation | liefert ein undefiniertes Ergebnis
      // (d.h. wirft eine Ausnahme) wenn einer ihrer beiden Parameter
      // (z.B. der zweite) undefiniert ist (d.h. eine Ausnahme wirft):
      try {
         if (n1 > 5 | n1/n2 > 5) {
            pln("CA Der Ausdruck n1/n2 wurde nicht ausgewertet!");
         } else {
            pln("CB Der Ausdruck n1/n2 wurde nicht ausgewertet!");
         }
      } catch (ArithmeticException ae) {
         pln("CC Der Ausdruck n1/n2 wurde ausgewertet!");
      } // try/catch
      // ------------------------------------------------------------------
      // Die schwache Und-Operation & liefert ein undefiniertes Ergebnis
      // (d.h. wirft eine Ausnahme) wenn einer ihrer beiden Parameter
      // (z.B. der zweite) undefiniert ist (d.h. eine Ausnahme wirft):
      try {
         if (n1 < 5 & n1/n2 < 5) {
            pln("DA Der Ausdruck n1/n2 wurde nicht ausgewertet!");
         } else {
            pln("DB Der Ausdruck n1/n2 wurde nicht ausgewertet!");
         }
      } catch (ArithmeticException ae) {
         pln("DC Der Ausdruck n1/n2 wurde ausgewertet!");
      } // try/catch
      // ------------------------------------------------------------------
      pln("----------------------------------------------");
      pln("Operatoren03: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Operatoren03
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren03

AA Der Ausdruck n1/n2 wurde nicht ausgewertet!
BB Der Ausdruck n1/n2 wurde nicht ausgewertet!
CC Der Ausdruck n1/n2 wurde ausgewertet!
DC Der Ausdruck n1/n2 wurde ausgewertet!
----------------------------------------------
Operatoren03: Das war's erstmal!
------------------------------------------------------------------------ */