// Datei Operatoren04.java
/* ------------------------------------------------------------------------
Dieses Programm versucht, die Wirkung der Divisions-Operation (Operator /)
und der Rest-Operation (oder: Mod-Operation, Modulo-Operation, Operator %)
anhand einer Tabelle mit Beispielen deutlich zu machen, insbesondere die
Faelle, in denen mindestens einer der beiden Operanden negativ ist.
------------------------------------------------------------------------ */
class Operatoren04 {
   // ---------------------------------------------------------------------
   // Konstanten fuer die Grenzen des Dividenden und fuer den Divisor:
   static final int A_VON = 15;
   static final int A_BIS = 21;
   static final int B     =  3;
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      // Gibt eine Tabelle aus, die die Wirkung der Operationen
      // Division (/) und Rest (%) anhand von Beispielen deutlich
      // machen soll:

      printTabellenUeberschrift();

      // Die einzelnen Zeilen der Tabelle ausgeben:
      for (int a=A_VON; a<=A_BIS; a++) {
         printEineTabellenZeile(a, B);
      } // for

      printTabellenAbschlussZeile();

      pln("Operatoren04: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   static void printTabellenUeberschrift() {
      // Gibt die Ueberschrift der Tabelle aus:

      pln("+-------+-------------+-------------+-------------+-------------+");
      pln("|  a  b |  a/b   a%b  | -a/b  -a%b  |  a/-b  a%-b | -a/-b -a%-b |");
      pln("+-------+-------------+-------------+-------------+-------------+");
   } // printTabellenUeberschrift
   // ---------------------------------------------------------------------
   static void printEineTabellenZeile(int a, int b) {
      // Gibt eine Zeile mit den Zahlen a, b, a/b, a%b etc. und ein
      // paar senkrechten Strichen | dazwischen aus:

      p("|"  ); p( a  );  p(" ");    p(    b); p(" ");
      p("|  "); p( a/ b); p("    "); p( a% b); p("   ");
      p("|  "); p(-a/ b); p("    "); p(-a% b); p("   ");
      p("|  "); p( a/-b); p("    "); p( a%-b); p("   ");
      p("|  "); p(-a/-b); p("    "); p(-a%-b); p("   ");
      p("|"  );
      pln();
   } // printEineTabellenZeile
   // ---------------------------------------------------------------------
   static void printTabellenAbschlussZeile() {
      // Die Abschlusszeile der Tabelle ausgeben:
      pln("+-------+-------------+-------------+-------------+-------------+");
   } // printTabellenAbschlussZeile
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }

   static void p  (int    n)  {
      // Bewirkt, dass n mit einem Vorzeichen davor ausgegeben wird
      // (einem Minuszeichen "-", falls n negativ ist und einem
      // Blank " " falls n groesser gleich 0 ist):
      System.out.print(n<0 ? ("" + n) : (" " + n));
   } // p
   // ---------------------------------------------------------------------
} // class Operatoren04
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren04

+-------+-------------+-------------+-------------+-------------+
|  a  b |  a/b   a%b  | -a/b  -a%b  |  a/-b  a%-b | -a/-b -a%-b |
+-------+-------------+-------------+-------------+-------------+
| 15  3 |   5     0   |  -5     0   |  -5     0   |   5     0   |
| 16  3 |   5     1   |  -5    -1   |  -5     1   |   5    -1   |
| 17  3 |   5     2   |  -5    -2   |  -5     2   |   5    -2   |
| 18  3 |   6     0   |  -6     0   |  -6     0   |   6     0   |
| 19  3 |   6     1   |  -6    -1   |  -6     1   |   6    -1   |
| 20  3 |   6     2   |  -6    -2   |  -6     2   |   6    -2   |
| 21  3 |   7     0   |  -7     0   |  -7     0   |   7     0   |
+-------+-------------+-------------+-------------+-------------+
Operatoren04: Das war's erstmal!

Die dritte Zeile dieser Tabelle sollte man etwa so lesen:

Spalte "a b"        :  a hat den Wert 17 und b hat den Wert 3
Spalte " a/b   a%b" :  17 durch  3 ist  5 Rest  2
Spalte "-a/b  -a%b" : -17 durch  3 ist -5 Rest -2
Spalte " a/-b  a%-b":  17 durch -3 ist -5 Rest  2
Spalte "-a/-b -a%-b": -17 durch -3 ist  5 Rest -2
------------------------------------------------------------------------ */