// Datei Operatoren05.java
/* ------------------------------------------------------------------------
Der dreistellige Operator ...?...:... ("der Ausdrucks-if-then-else-Befehl")
wird in mehreren Beispielen vorgefuehrt.
------------------------------------------------------------------------ */
class Operatoren05 {
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      int a = 17;
      int b = 25;
      // ------------------------------------------------------------------
      // Die groessere von zwei Zahlen ausgeben (wenig elegante Loesung
      // mit if-Anweisung):
      if (a > b) {
         pln("A  a: " + a);
      } else {
         pln("A  b: " + b);
      } // if
      // ------------------------------------------------------------------
      // Die groessere von zwei Zahlen ausgeben (elegantere Loesung
      // mit dem Operator ... ? ... : ...):
      pln((a > b) ? ("B  a: " + a) : ("B  b: " + b));
      // ------------------------------------------------------------------
      // Eine Variable c mit dem groesseren von zwei Werten initialisieren:
      int c = (a > b) ? a : b;           // Die Klammern muessen nicht sein
      pln("C  c: " + c + ", a: " + a + ", b: " + b);
      // ------------------------------------------------------------------
      // Eine Variable d unterschiedlich initialisieren, je nachdem ob
      // eine andere Variable m einen geraden Wert enthaelt oder nicht:
      int m = 5;
      int d = (m % 2 == 0) ? (3*a + 5) : (7+b);
      pln("D  d: " + d + ", 3*a+5: " + (3*a+5) + ", 7+b: " + (7+b));
      // ------------------------------------------------------------------
      // Eine Variable e mit dem Vorzeichen ('-' bzw. '+') einer anderen
      // Variablen n initialisieren:
      int  n = -17;
      char e = n < 0 ? '-' : '+';
      pln("E  e: " + e + ",  n: " + n);
      // ------------------------------------------------------------------
      // Eine Variable f mit dem "Vorzeichen" (-1 bzw. +1) einer anderen
      // Variablen o initialisieren:
      int o = -17;
      int f = n < 0 ? -1 : +1;
      pln("F  f: " + f + ", o: " + o);
      // ------------------------------------------------------------------
      // Zwischen Singular und Plural unterscheiden:
      p("G  ");
      for (int anzahl=0; anzahl<=3; anzahl++) {
         p(anzahl + (anzahl==1 ? " Haus" : " Haeuser") + ", ");
      } // for
      pln("...");
      // ------------------------------------------------------------------
      pln("-----------------------------------------------");
      pln("Operatoren05: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Operatoren05
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren05

A  b: 25
B  b: 25
C  c: 25, a: 17, b: 25
D  d: 32, 3*a+5: 56, 7+b: 32
E  e: -,  n: -17
F  f: -1, o: -17
G  0 Haeuser, 1 Haus, 2 Haeuser, 3 Haeuser, ...
-----------------------------------------------
Operatoren05: Das war's erstmal!
------------------------------------------------------------------------ */