// Datei Operatoren06.java
/* ------------------------------------------------------------------------
Der einfache Zuweisungsoperator = und die zusammengesetzten Zuweisungs-
operatoren *=, &= und += werden angewendet.
------------------------------------------------------------------------ */
class Operatoren06 {
   // ---------------------------------------------------------------------
   static void beispielA() {
      // Zeigt, dass der Zuweisungsoperator = rechtsassoziativ ist und
      // dass man eine Kettenzuweisung rechtsassoziativ klammern darf,
      // aber nicht linksassoziativ.

      // Zwei Versionen (1 und 2) von drei Variablen (a, b und c):
      int a1, b1, c1; // Version 1
      int a2, b2, c2; // Version 2

         a1 =   b1  =  c1   = 4;           // Kettenzuweisung, ungeklammert
         a2 = ( b2  = (c2   = 4 ));        // Rechtsassoziativ   geklammert
//    (( a2 =   b2) =  c2 ) = 4;           //  Linksassoziativ   geklammert

      pln("AA a1: " + a1 + ", b1: " + b1 + ", c1: " + c1);
      pln("AB a2: " + a2 + ", b2: " + b2 + ", c2: " + c2);
   } // beispielA
   // ---------------------------------------------------------------------
   static void beispielB() {
      // Zeigt die Wirkung des zusammengesetzten Zuweisungsoperators *=

      // Drei Versionen (1, 2 und 3) von zwei Variablen (s und d):
      short  s1 = 2; double d1 = 3.5; // Version 1
      short  s2 = 2; double d2 = 3.5; // Version 2
      short  s3 = 2; double d3 = 3.5; // Version 3

      s1 *= 4 + d1;                        // Eine Zuweisung Z
      s2  = (short) (s2 * (4 + d2));       // Aequivalent zu Z

//    s3  =         (s3 * (4 + d3));       // Nicht erlaubt.
      s3  = (short) (s3 *  4 + d3 );       // Nicht aequivalent zu Z!

      pln("B  s1: " + s1 + ", s2: " + s2 + ", s3: " + s3);
   } // beispielB
   // ---------------------------------------------------------------------
   static void beispielC() {
      // Zeigt die Wirkung des zusammengesetzten Zuweisungsoperators &=
      // (angewendet auf boolean-Werte)

      // Drei Versionen (1, 2 und 3) von zwei Variablen (b und c):
      boolean b1 = false, c1 = true; // Version 1
      boolean b2 = false, c2 = true; // Version 2
      boolean b3 = false, c3 = true; // Version 3

      b1 &= false | c1;                    // Eine Zuweisung Z
      b2  = (boolean) (b2 & (false | c2)); // Aequivalent zu Z

      b3  =           (b3 &  false | c3);  // Nicht aequivalent zu Z!

      pln("C  b1: " + b1 + ", b2: " + b2 + ", b3: " + b3);

   } // beispielC
   // ---------------------------------------------------------------------
   static void beispielD() {
      // Zeigt die Wirkung des zusammengesetzten Zuweisungsoperators &=
      // (angewendet auf int-Werte)

      // Drei Versionen (1, 2 und 3) von zwei Variablen (b und c):
      int b1 = 15, c1 = 22; // Version 1
      int b2 = 15, c2 = 22; // Version 2
      int b3 = 15, c3 = 22; // Version 3

      b1 &= 19 | c1;                        // Eine Zuweisung Z
      b2  = (int) (b2 & (19 | c2));         // Aequivalent zu Z

      b3  =       (b3 &  19 | c3 );         // Nicht aequivalent zu Z!

      pln("D  b1: " + b1 + ", b2: " + b2 + ", b3: " + b3);

      // Ein paar int-Werte (die bei der Ausfuehrung dieses Unterprogramms
      // als Zwischenergebnisse berechnet werden)
      // in dezimaler und binaerer Darstellung:

      // b         dez: 15, bin: ...01111
      // c         dez: 22, bin: ...10110
      // K1        dez: 19, bin: ...10011
      // K2=19|c   dez: 23, bin: ...10111
      // K3=b &23  dez:  7, bin: ...00111
      // K4=b &19  dez:  3, bin: ...00011
      // K5= 3|c   dez: 23, bin: ...10111

   } // beispielD
   // ---------------------------------------------------------------------
   static void beispielE() {
      // Zeigt die Wirkung des zusammengesetzten Zuweisungsoperators +=
      // auf String-Operanden.

      String se = "Wieviel? ";
      se += 123;
      se += "! Das reicht!";

      pln("E  se: " + se);
   } // beispielE
   // ---------------------------------------------------------------------
   static void beispielF() {
      // Zeigt die Wirkung des zusammengesetzten Zuweisungsoperators +=
      // Wenn der erste (linke) Operand vom Typ String ist, darf der
      // zweite (rechte) Operand zu einem beliebigen Typ gehoeren und
      // wird automatisch in einen String umgewandelt und konkateniert.

      // Ein paar Variablen ganz verschiedener Typen:
      StringBuffer stringBuffer01 = new StringBuffer("Hallo02! ");
      Exception    exception01    = new Exception   ("Hallo03! ");
      Integer      integer01      = new Integer     (123);
      short        short01        = 45;

      // Die Werte der verschiedenen Variablen werden der Reihe nach
      // in Strings umgewandelt und mit dem String sf konkateniert:
      String sf = "Hallo01! ";
      sf += stringBuffer01;
      sf += exception01;
      sf += integer01;
      sf += short01;

      pln("F  sf: " + sf);
   } // beispielF
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      beispielA();
      beispielB();
      beispielC();
      beispielD();
      beispielE();
      beispielF();
      pln("------------------------------------------------------------");
      pln("Operatoren06: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Operatoren06
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren06:

AA a1: 4, b1: 4, c1: 4
AB a2: 4, b2: 4, c2: 4
B  s1: 15, s2: 15, s3: 11
C  b1: false, b2: false, b3: true
D  b1: 7, b2: 7, b3: 23
E  se: Wieviel? 123! Das reicht!
F  sf: Hallo01! Hallo02! java.lang.Exception: Hallo03! 12345
------------------------------------------------------------
Operatoren06: Das war's erstmal!
---------------------------------------------------------------------------
Fehlermeldungen eines Compilers (javac von Sun), wenn die entsprechenden
Zeilen nicht auskommentiert sind:

D:\JavaQuellen\Operatoren06.java:19: unexpected type
required: variable
found   : value
    (( a2 =   b2) =  c2 ) = 4;           //  Linksassoziativ   geklammert
          ^
D:\JavaQuellen\Operatoren06.java:36: possible loss of precision
found   : double
required: short
    s3  =         (s3 * (4 + d3));       // Nicht erlaubt.
                      ^
------------------------------------------------------------------------ */