// Datei Operatoren07.java
/* ------------------------------------------------------------------------
Der Operator instanceof wird angewendet.

Hinweis: Indem man den Operator instanceof verwendet macht man ein
Programm im allgemeinen schwer erweiterbar. In einem richtig objekt-
orientierten Programm sollte dieser Operator hoechstens in seltenen
Sonderfaellen vorkommen. Das Unterpgrogramm gibKlassenNamenAus ist
ein kleines Beispiel dafuer, wie man manchmal den Operator instanceof
vermeiden kann.
------------------------------------------------------------------------ */
class Operatoren07A {
   public String toString() {return "Ein Operatoren07A-Objekt!";}
} // class Operatoren07A
// ------------------------------------------------------------------------
class Operatoren07AA extends Operatoren07A {
   public String toString() {return "Ein Operatoren07AA-Objekt!";}
} // class Operatoren07AA
// ------------------------------------------------------------------------
class Operatoren07AB extends Operatoren07A {
   public String toString() {return "Ein Operatoren07AB-Objekt!";}
} // class Operatoren07AB
// ------------------------------------------------------------------------
class Operatoren07 {
   // ---------------------------------------------------------------------
   static void istString(Object ob, String name) {
      // Prueft, ob das Objekt ob zur Klasse String gehoert und
      // gibt eine entsprechende Meldung aus.

      if (ob instanceof String) {
         pln(name + " ist  ein String-Objekt!");
      } else {
         pln(name + " ist kein String-Objekt!");
      }
   } // istString
   // ---------------------------------------------------------------------
   static void istOperatoren07AB(Object ob, String name) {
      // Prueft, ob das Objekt ob zur Klasse Operatoren07AB gehoert und
      // gibt eine entsprechende Meldung aus.

      if (ob instanceof Operatoren07AB) {
         pln(name + " ist  ein Operatoren07AB-Objekt!");
      } else {
         pln(name + " ist kein Operatoren07AB-Objekt!");
      }
   } // istOperatoren07AB
   // ---------------------------------------------------------------------
   static void gibKlassenNamenAus(Object ob, String name) {
      // Gibt den Namen der Klasse, zu der ob gehoert, im Rahmen einer
      // kleinen Meldung aus. Benuetzt dazu die Reflektions-Schnittstelle
      // von Java und nicht den Operator instanceof.

      Class kob = ob.getClass();

      pln(name + " gehoert zur Klasse " + kob.getName());
   } // gibKlassenNamenAus
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {

      // Objekte verschiedener Klassen werden vereinbart:
      Object        ob01 = new String("Hallo!");
      Object        ob02 = new Operatoren07A();
      Operatoren07A ob03 = new Operatoren07AA();
      Operatoren07A ob04 = new Operatoren07AB();

      pln("----------------------------------------");
      // Die Klassen der Objekte werden "geprueft" und evtl. ausgegeben:
      istString         (ob01, "ob01");
      istString         (ob02, "ob02");
      istOperatoren07AB (ob03, "ob03");
      istOperatoren07AB (ob04, "ob04");
      pln("----------------------------------------");
      // Die Klassen der Objekte werden mit einer anderen Methode
      // ausgegeben:
      gibKlassenNamenAus(ob01, "ob01");
      gibKlassenNamenAus(ob02, "ob02");
      gibKlassenNamenAus(ob03, "ob03");
      gibKlassenNamenAus(ob04, "ob04");
      pln("----------------------------------------");
      pln("Operatoren07: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Operatoren07
/* ------------------------------------------------------------------------
Ausgabe des Programms Operatoren07:

----------------------------------------
ob01 ist  ein String-Objekt!
ob02 ist kein String-Objekt!
ob03 ist kein Operatoren07AB-Objekt!
ob04 ist  ein Operatoren07AB-Objekt!
----------------------------------------
ob01 gehoert zur Klasse java.lang.String
ob02 gehoert zur Klasse Operatoren07A
ob03 gehoert zur Klasse Operatoren07AA
ob04 gehoert zur Klasse Operatoren07AB
----------------------------------------
Operatoren07: Das war's erstmal!
------------------------------------------------------------------------ */