// Datei P01Haupt.java
/* ------------------------------------------------------------------------
Demonstriert, dass eine Nebenklasse eines Programms nur und erst dann
erzeugt wird, wenn sie zum ersten Mal gebraucht (d.h. benutzt) wird.

Achtung: Diese Datei enthaelt die Vereinbarungen von zwei Klassen
(P01Haupt und P01Neben, durch "***"-Zeilen getrennt).

Beim Erzeugen der Klasse P01Haupt initialisiert der Ausfuehrer die Variable
P01Haupt.erzeugungsZeitpunkt mit der momentanen Zeit (in Millisekunden).
Beim Erzeugen der Klasse P01Neben initialisiert der Ausfuehrer die Variable
P01Neben.erzeugungsZeitpunkt mit der momentanen Zeit (in Millisekunden).

In der main-Methode wird ein String eingelesen. Nur wenn der Benutzer
"e" eingibt (und erst nachdem er die Eingabe abgeschlossen hat) wird
die Klasse P01Neben benutzt und deshalb erzeugt. Falls der Benutzer
etwas anderes eingibt (z.B. "q" wie "quit"), wird die Klasse P01Neben
nicht benutzt und deshalb auch nicht erzeugt.

Die Methode System.currentTimeMillis liefert die Anzahl der Millisekunden,
die seit dem 1. Januar 1970 vergangen sind.
------------------------------------------------------------------------ */
// ************************************************************************
class P01Haupt {
   // Die Hauptklasse des Programms P01Haupt
   static long erzeugungsZeitpunkt = System.currentTimeMillis();
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      gibAus01("P01Haupt", P01Haupt.erzeugungsZeitpunkt);

      printf("Die Klasse P01Neben erzeugen (e) oder nicht (q)? ");
      String eingabe = EM.liesString();

      // Nur wenn der Benutzer "e" eingegeben hat, wird die
      // Klasse P01Neben benutzt und deshalb auch erzeugt:
      if (eingabe.equals("e")) {
         // Jetzt wird die Nebenklasse P01Neben benutzt:
         gibAus01("P01Neben", P01Neben.erzeugungsZeitpunkt);

         // Zeitdifferenz ausgeben: Wieviele Millis nach der
         // Klasse P01Haupt wurde die Klasse P01Neben erzeugt?
         gibAus02(P01Neben.erzeugungsZeitpunkt -
                  P01Haupt.erzeugungsZeitpunkt);
         return;
      } // if
      printf("Die Klasse P01Neben wurde diesmal NICHT erzeugt!\n");
   } // main
   // -----------------------------------------------------------
   static private void gibAus01(String klasse, long zeitPunkt) {
      printf("Die Klasse %s wurde erzeugt um %5d Millis\n",
         klasse, zeitPunkt % 100000);
   } // gibAus01
   // -----------------------------------------------------------
   static private void gibAus02(long zeitDifferenz) {
      printf("Zeitdifferenz:                       %5d Millis\n",
         zeitDifferenz % 100000);
   } // gibAus02
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // -----------------------------------------------------------
} // class P01Haupt
// ************************************************************************
class P01Neben {
   // Eine Nebenklasse des Programms P01Haupt
   static long erzeugungsZeitpunkt = System.currentTimeMillis();
} // class P01Neben
// ************************************************************************
/* ------------------------------------------------------------------------
Ein Dialog des Programms P01Haupt mit einem reaktionsstarken Benutzer:

Die Klasse P01Haupt wurde erzeugt um 41390 Millis
Die Klasse P01Neben erzeugen (e) oder nicht (q)? e
Die Klasse P01Neben wurde erzeugt um 41509 Millis
Zeitdifferenz:                         119 Millis
---------------------------------------------------------------------------
Ein Dialog des Programms P01Haupt mit einem etwas traegeren Benutzer:

Die Klasse P01Haupt wurde erzeugt um 53859 Millis
Die Klasse P01Neben erzeugen (e) oder nicht (q)? e
Die Klasse P01Neben wurde erzeugt um 58890 Millis
Zeitdifferenz:                        5031 Millis
---------------------------------------------------------------------------
Noch ein Dialog mit dem Programm P01Haupt:

Die Klasse P01Haupt wurde erzeugt um 63546 Millis
Die Klasse P01Neben erzeugen (e) oder nicht (q)? q
Die Klasse P01Neben wurde diesmal NICHT erzeugt!
------------------------------------------------------------------------ */