// Datei P02Haupt.java
/* ------------------------------------------------------------------------
Demonstriert, dass Nebenklassen eines Programms nur und erst dann erzeugt
werden, wenn sie zum ersten Mal gebraucht werden.

Achtung: Diese Datei enthaelt die Vereinbarungen von drei Klassen
(P02Haupt, P02NebenA und P02NebenB, durch "***"-Zeilen getrennt).

In der main-Methode wird der Benutzer wiederholt gefragt, ob
die Nebenklasse P02NebenA (Eingabe: a) oder
die Nebenklasse P02NebenB (Eingabe: b) benutzt werden soll (indem ein
Objekt der betreffenden Nebenklasse erzeugt wird).

Erst, wenn der Benutzer zum ersten Mal ein a bzw. ein b eingibt, wird die
betreffende Nebenklasse erzeugt.
Wenn der Benutzer nie ein a bzw. nie ein b eingibt, wird die betreffende
Nebenklasse auch nie erzeugt.
------------------------------------------------------------------------ */
// ************************************************************************
class P02Haupt {
   // Die Hauptklasse des Programms P02Haupt
   // ---------------------------------------------------------------------
   static long    erzeugungsZeitpunkt    = System.currentTimeMillis();
   static boolean P02NebenA_WurdeErzeugt = false;
   static boolean P02NebenB_WurdeErzeugt = false;
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Zum Ausfuehren von main werden eventuell die Klassen P02NebenA
      // und/oder P02NebenB benoetig (je nach Eingaben des Benutzers).

      final String minusZeile =
         "----------------------------------------------------";

      printf("Die Klasse P02Haupt  wurde erzeugt!\n");

      while (true) {
         printf(minusZeile + " a, b oder q? ");
         String eingabe = EM.liesString();

         // Eingabe q: Diese Schleife beende.
         // Eingabe a: Ein Objekt der Nebenklasse P02NebenA erzeugen
         // Eingabe b: Ein Objekt der Nebenklasse P02NebenB erzeugen

         if        (eingabe.equals("q")) {
            break;
         } else if (eingabe.equals("a")) {
            new P02NebenA();
         } else if (eingabe.equals("b")) {
            new P02NebenB();
         } // if
      } // while

      // Welche Nebenklassen wurden diesmal benutzt (und deshalb erzeugt)?
      String nichtA = (P02NebenA_WurdeErzeugt ? " " : " nicht ");
      String nichtB = (P02NebenB_WurdeErzeugt ? " " : " nicht ");
      printf("Die Klasse P02NebenA wurde diesmal" + nichtA  + "erzeugt\n");
      printf("Die Klasse P02NebenB wurde diesmal" + nichtB  + "erzeugt\n");
      printf(minusZeile);
   } // main
   // ---------------------------------------------------------------------
   static void gibAus(char AoderB, long delta) {
      // Gibt eine zweizeilig Meldung aus:
      printf("Die Klasse P02Neben" + AoderB + " wurde erzeugt nach ");
      printf("%5d", delta);
      printf(" Millis\n");
      printf("Ein P02Neben" + AoderB + "-Objekt wurde erzeugt nach ");
      printf("%5d", System.currentTimeMillis() - erzeugungsZeitpunkt);
      printf(" Millis\n");
   } // gibAus
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class P02Haupt
// ************************************************************************
class P02NebenA {
   // Eine Nebenklasse des Programms P02Haupt:

   // Wieviele Millisekunden nach der Klasse P02Haupt wurde diese Klasse
   // erzeugt?
   static private long delta =
      System.currentTimeMillis() - P02Haupt.erzeugungsZeitpunkt;

   public P02NebenA() {
      P02Haupt.gibAus('A', delta);
      P02Haupt.P02NebenA_WurdeErzeugt = true;
   } // Konstruktor P02NebenA
   // ---------------------------------------------------------------------
} // class P02NebenA
// ************************************************************************
class P02NebenB {
   // Eine Nebenklasse des Programms P02Haupt:

   // Wieviele Millisekunden nach der Klasse P02Haupt wurde diese Klasse
   // erzeugt?
   static private long delta =
      System.currentTimeMillis() - P02Haupt.erzeugungsZeitpunkt;

   public P02NebenB() {
      P02Haupt.gibAus('B', delta);
      P02Haupt.P02NebenB_WurdeErzeugt = true;
   } // Konstruktor P02NebenB
   // ---------------------------------------------------------------------
} // class P02NebenB
// ************************************************************************
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm P02Haupt:

Die Klasse P02Haupt  wurde erzeugt!
---------------------------------------------------- a, b oder q? a
Die Klasse P02NebenA wurde erzeugt nach  2594 Millis
Ein P02NebenA-Objekt wurde erzeugt nach  2594 Millis
---------------------------------------------------- a, b oder q? a
Die Klasse P02NebenA wurde erzeugt nach  2594 Millis
Ein P02NebenA-Objekt wurde erzeugt nach  5281 Millis
---------------------------------------------------- a, b oder q? b
Die Klasse P02NebenB wurde erzeugt nach  7953 Millis
Ein P02NebenB-Objekt wurde erzeugt nach  7953 Millis
---------------------------------------------------- a, b oder q? q
Die Klasse P02NebenA wurde diesmal erzeugt
Die Klasse P02NebenB wurde diesmal erzeugt
----------------------------------------------------
---------------------------------------------------------------------------
Noch ein Dialog mit dem Programm P02Haupt:

Die Klasse P02Haupt  wurde erzeugt!
---------------------------------------------------- a, b oder q? b
Die Klasse P02NebenB wurde erzeugt nach  1250 Millis
Ein P02NebenB-Objekt wurde erzeugt nach  1250 Millis
---------------------------------------------------- a, b oder q? b
Die Klasse P02NebenB wurde erzeugt nach  1250 Millis
Ein P02NebenB-Objekt wurde erzeugt nach  3484 Millis
---------------------------------------------------- a, b oder q? q
Die Klasse P02NebenA wurde diesmal nicht erzeugt
Die Klasse P02NebenB wurde diesmal erzeugt
----------------------------------------------------
---------------------------------------------------------------------------
Ein besonders kurzer Dialog mit dem Programm P02Haupt:

Die Klasse P02Haupt  wurde erzeugt!
---------------------------------------------------- a, b oder q? q
Die Klasse P02NebenA wurde diesmal nicht erzeugt
Die Klasse P02NebenB wurde diesmal nicht erzeugt
----------------------------------------------------
------------------------------------------------------------------------ */