// Datei Punkt2D.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Punkt auf einer zwei-
dimensionalen Ebene.
---------------------------------------------------------------------------
Die Klassen Punkt3Da und Punkt3Db bauen (auf verschiedene Weise) auf
dieser Klasse Punkt2D auf.
------------------------------------------------------------------------ */
class Punkt2D {
   // Die Koordinaten dieses Punktes:
   protected double x, y;

   public Punkt2D(double x, double y) {
      this.x = x;
      this.y = y;
   } // Konstruktor Punkt2D

   public double urAbstand()  {
      // Liefert den Abstand dieses Punktes vom Punkt (0, 0)
      return Math.sqrt(x*x + y*y);
   } // urAbstand

   public void urSpiegeln() {
      // Spiegelt diesen Punkt am Punkt (0, 0)
      x = -x; y = -y;
   } // urSpiegeln

   public String text() {
      // Liefert die Koordinaten dieses Punktes,
      // z.B. "(2.0, 3.5)"
      return new String("("  + x +  ", "  + y +  ")");
   } // text

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      return new String("Punkt: "  + text());
   } // toString

} // class Punkt2D