// Datei Punkt3D_Erb.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Punkt auf einer
dreidimensionalen Ebene.
---------------------------------------------------------------------------
Dieser Klasse Punkt3D_Erb beerbt die Klasse Punkt2D (siehe auch die
Klasse Punkt3D_Ins, die die Klasse Punkt2D instanziiert).
------------------------------------------------------------------------ */
class Punkt3D_Erb extends Punkt2D {
   // Die z-Koordinate dieses Punktes (die x- und y-Koordinate
   // werden von Punkt2D geerbt):
   protected double z;

   public Punkt3D_Erb(double x, double y, double z) {
      // Konstruktor
      // Wiederverwendung des Konstruktors Punkt2D (alias super) muss
      // sein, ist aber ziemlich klar:
      super(x, y);
      this.z = z;
   } // Konstruktor Punkt3D_Erb

   public double urAbstand()  {
      // Liefert den Abstand dieses Punktes vom Punkt (0, 0, 0)
      // Wiederverwendung von super.urAbstand waere moeglich,
      // aber ohne Wiederverwendung ist diese Methode klarer:
      return Math.sqrt(x*x + y*y + z*z);
   } // urAbstand

   public void urSpiegeln() {
      // Spiegelt diesen Punkt am Punkt (0, 0, 0)
      // Wiederverwendung von super.urSpiegeln ist moeglich
      // und ziemlich klar:
      super.urSpiegeln();
      z = -z;
   } // urSpiegeln

   public String text() {
      // Liefert die Koordinaten dieses Punktes,
      // z.B. "(2.0, 3.5, 1.8)"
      // Wiederverwendung von super.text waere moeglich,
      // aber ohne Wiederverwendung ist diese Methode klarer:
      return new String("(" + x + ", " + y + ", " + z + ")");
   } // text

   /* ---------------------------------------------------------------------
   Anmerkung:
   Weil diese Klasse Punkt3D_Erb von ihrer Oberklasse Punkt2D eine "gut
   funktionierende" toString-Methode geerbt hat, brauchen wir hier keine
   toString-Methode zu vereinbaren. Das ist sehr gut!
   Die geerbte toString-Methode ruft die text-Methode dieser Klasse auf
   (und nicht etwa die text-Methode, die in Punkt2D vereinbart wurde)!
   --------------------------------------------------------------------- */

} // class Punkt3D_Erb