// Datei Punkt3D_Ins.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse repraesentiert einen Punkt auf einer
dreidimensionalen Ebene.
---------------------------------------------------------------------------
In dieser Klasse Punkt3D_Ins wird die Klasse Punkt2D instanziiert, d.h.
jedes Punkt3D_Ins-Objekt enthaelt (unter anderem) eine Punkt2D-Objekt
(siehe auch die Klasse Punkt3D_Erb, die von der Klasse Punkt2D erbt).
------------------------------------------------------------------------ */
class Punkt3D_Ins {

   private Punkt2D p2D; // Vorbereitung fr das Instanziieren

   // Die z-Koordinate dieses 3D-Punktes (die x- und y-Koordinate
   // stecken in dem Objekt p2D):
   protected double z;

   public Punkt3D_Ins(double x, double y, double z) {
      // Konstruktor
      // Wiederverwendung des Konstruktors Punkt2D muss
      // sein, ist aber ziemlich klar:
      p2D = new Punkt2D(x, y); // Hier wird instanziiert!
      this.z = z;
   } // Konstruktor Punkt3D_Ins

   public double urAbstand()  {
      // Liefert den Abstand dieses Punktes vom Punkt (0, 0, 0)
      // Wiederverwendung von p2D.urAbstand muss sein, ist aber
      // nicht besonders leicht verstndlich:
      double urAb2D = p2D.urAbstand();
      return Math.sqrt(urAb2D*urAb2D + z*z);
   } // urAbstand

   public void urSpiegeln() {
      // Spiegelt diesen Punkt am Punkt (0, 0, 0)
      // Wiederverwendung von p2D.urSpiegeln muss sein, ist aber
      // ziemlich klar:
      p2D.urSpiegeln();
      z = -z;
   } // urSpiegeln

   public String text() {
      // Liefert die Koordinaten dieses Punktes,
      // z.B. "(2.0, 3.5, 1.8)"
      // Wiederverwendung von p2D.text muss sein, ist aber
      // nicht besonders leicht verstaendlich:

      // Die schliessende Klammer am Ende von p2D.text() wird
      // durch den String ", " ersetzt, das Ergebnis heisst t2D:
      String t2D = p2D.text().replace(")", ", ");
      return new String(t2D + z + ")");
   } // text

   /* ---------------------------------------------------------------------
   Anmerkung:
   Die folgende Vereinbarung einer toString-Methode wurde vom Programmierer
   mit einem Editor aus der Klasse Punkt2D hierherkopiert. Das Erstellen
   und Verwalten solcher Kopien durch den Programmierer ist im Allgemeinen
   fehleranfaellig und nicht empfehlenswert.
   --------------------------------------------------------------------- */

   public String toString() {
      // Liefert eine String-Repraesentation dieses Objekts:
      // Wiederverwendung von p2D.toString waere moeglich, aber aehnlich
      // unschoen wie bei p2D.text, ohne Wiederverwendung klarer:
      return new String("Punkt: "  + text());
   } // toString

} // class Punkt3D_Ins