// Datei Reflekt04.java
/* ------------------------------------------------------------------------
Klassen, Attribute, Methoden und Konstruktoren koennen in Java durch
Objekte der Klassen Class, Field, Method bzw. Constructor reflektiert
(d.h. dargestellt oder repraesentiert) werden.

Hier wird eine simple Klasse Rek1 vereinbart. Dann wird mit
Reflektions-Objekten auf ihre Attribute zugegriffen und ihre Methoden
werden aufgerufen.
------------------------------------------------------------------------ */
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
// ------------------------------------------------------------------------

// ------------------------------------------------------------------------
class Reflekt04 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) throws ClassNotFoundException {

      String     strob = "Hallo!";           // Ein "normales" Objekt

      int    []   ri1   = new int    [0];
      String []   rt1   = new String [0];    // t wie Texte

      byte   [][] rb2   = new byte   [0][0];
      char   [][] rc2   = new char   [0][0];
      short  [][] rs2   = new short  [0][0];
      int    [][] ri2   = new int    [0][0];
      long   [][] rl2   = new long   [0][0];
      float  [][] rf2   = new float  [0][0];
      double [][] rd2   = new double [0][0];
      boolean[][] rw2   = new boolean[0][0]; // w wie Wahrheitswerte

      String[][]  rt2   = new String [0][0]; // t wie Texte


      pln("Reflekt04: Jetzt geht es los!");
      pln("+--------------------------------------+------------------------+");
      pln("| Class-Objekte                        | Ausgabe der Objekte    |");
      pln("+--------------------------------------+------------------------+");
      pln("A String     .class                    : " + String     .class    );
      pln("B int    []  .class                    : " + int   []   .class);
      pln("C String []  .class                    : " + String[]   .class);
      pln();
      pln("D byte   [][].class                    : " + byte   [][].class);
      pln("E char   [][].class                    : " + char   [][].class);
      pln("F short  [][].class                    : " + short  [][].class);
      pln("G int    [][].class                    : " + int    [][].class);
      pln("H long   [][].class                    : " + long   [][].class);
      pln("I float  [][].class                    : " + float  [][].class);
      pln("J double [][].class                    : " + double [][].class);
      pln("K boolean[][].class                    : " + boolean[][].class);
      pln();
      pln("L String [][].class                    : " + String [][].class);
      pln("---------------------------------------------------------------");
      pln("M strob.getClass()                     : " + strob.getClass()  );
      pln("N \"ABC\".getClass()                     : " + "ABC".getClass());
      pln();
      pln("O ri1  .getClass()                     : " + ri1.getClass());
      pln("P rt1  .getClass()                     : " + rt1.getClass());
      pln();
      pln("Q rb2  .getClass()                     : " + rb2.getClass());
      pln("R rc2  .getClass()                     : " + rc2.getClass());
      pln("S rs2  .getClass()                     : " + rs2.getClass());
      pln("T ri2  .getClass()                     : " + ri2.getClass());
      pln("U rl2  .getClass()                     : " + rl2.getClass());
      pln("V rf2  .getClass()                     : " + rf2.getClass());
      pln("W rd2  .getClass()                     : " + rd2.getClass());
      pln("X rw2  .getClass()                     : " + rw2.getClass());
      pln();
      pln("Y rt2  .getClass()                     : " + rt2.getClass());
      pln("---------------------------------------------------------------");
      pln("Z Class.forName(\"java.lang.String\"     : " + Class.forName("java.lang.String"));
      pln();
      pln("A Class.forName(\"[I\")                  : " + Class.forName("[I"));
      pln("B Class.forName(\"[Ljava.lang.String; \"): " + Class.forName("[Ljava.lang.String;"));
      pln();
      pln("C Class.forName(\"[[B\")                 : " + Class.forName("[[B"));
      pln("D Class.forName(\"[[C\")                 : " + Class.forName("[[C"));
      pln("E Class.forName(\"[[S\")                 : " + Class.forName("[[S"));
      pln("F Class.forName(\"[[I\")                 : " + Class.forName("[[I"));
      pln("G Class.forName(\"[[J\")                 : " + Class.forName("[[J"));
      pln("H Class.forName(\"[[F\")                 : " + Class.forName("[[F"));
      pln("I Class.forName(\"[[D\")                 : " + Class.forName("[[D"));
      pln("J Class.forName(\"[[Z\")                 : " + Class.forName("[[Z"));
      pln();
      pln("K Class.forName(\"[[Ljava.lang.String;\"): " + Class.forName("[[Ljava.lang.String;"));
      pln("---------------------------------------------------------------");
      pln("L Byte     .class                      : " + Byte     .class);
      pln("M Character.class                      : " + Character.class);
      pln("N Short    .class                      : " + Short    .class);
      pln("O Integer  .class                      : " + Integer  .class);
      pln("P Long     .class                      : " + Long     .class);
      pln("Q Float    .class                      : " + Float    .class);
      pln("R Double   .class                      : " + Double   .class);
      pln("S Boolean  .class                      : " + Boolean  .class);
      pln("---------------------------------------------------------------");
      pln("T Byte     .TYPE                       : " + Byte     .TYPE);
      pln("U Character.TYPE                       : " + Character.TYPE);
      pln("V Short    .TYPE                       : " + Short    .TYPE);
      pln("W Integer  .TYPE                       : " + Integer  .TYPE);
      pln("X Long     .TYPE                       : " + Long     .TYPE);
      pln("Y Float    .TYPE                       : " + Float    .TYPE);
      pln("Z Double   .TYPE                       : " + Double   .TYPE);
      pln("A Boolean  .TYPE                       : " + Boolean  .TYPE);
      pln("---------------------------------------------------------------");
   } // main
      static class MyArrayList1<K> extends ArrayList<K> {};
      static class MyArrayList2<String> extends ArrayList<String> {};
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Reflekt04
/* ------------------------------------------------------------------------
Ausgabe des Programms Reflekt04:

Reflekt04: Jetzt geht es los!
+--------------------------------------+------------------------+
| Class-Objekte                        | Ausgabe der Objekte    |
+--------------------------------------+------------------------+
A String     .class                    : class java.lang.String
B int    []  .class                    : class [I
C String []  .class                    : class [Ljava.lang.String;

D byte   [][].class                    : class [[B
E char   [][].class                    : class [[C
F short  [][].class                    : class [[S
G int    [][].class                    : class [[I
H long   [][].class                    : class [[J
I float  [][].class                    : class [[F
J double [][].class                    : class [[D
K boolean[][].class                    : class [[Z

L String [][].class                    : class [[Ljava.lang.String;
---------------------------------------------------------------
M strob.getClass()                     : class java.lang.String
N "ABC".getClass()                     : class java.lang.String

O ri1  .getClass()                     : class [I
P rt1  .getClass()                     : class [Ljava.lang.String;

Q rb2  .getClass()                     : class [[B
R rc2  .getClass()                     : class [[C
S rs2  .getClass()                     : class [[S
T ri2  .getClass()                     : class [[I
U rl2  .getClass()                     : class [[J
V rf2  .getClass()                     : class [[F
W rd2  .getClass()                     : class [[D
X rw2  .getClass()                     : class [[Z

Y rt2  .getClass()                     : class [[Ljava.lang.String;
---------------------------------------------------------------
Z Class.forName("java.lang.String"     : class java.lang.String

A Class.forName("[I")                  : class [I
B Class.forName("[Ljava.lang.String; "): class [Ljava.lang.String;

C Class.forName("[[B")                 : class [[B
D Class.forName("[[C")                 : class [[C
E Class.forName("[[S")                 : class [[S
F Class.forName("[[I")                 : class [[I
G Class.forName("[[J")                 : class [[J
H Class.forName("[[F")                 : class [[F
I Class.forName("[[D")                 : class [[D
J Class.forName("[[Z")                 : class [[Z

K Class.forName("[[Ljava.lang.String;"): class [[Ljava.lang.String;
---------------------------------------------------------------
L Byte     .class                      : class java.lang.Byte
M Character.class                      : class java.lang.Character
N Short    .class                      : class java.lang.Short
O Integer  .class                      : class java.lang.Integer
P Long     .class                      : class java.lang.Long
Q Float    .class                      : class java.lang.Float
R Double   .class                      : class java.lang.Double
S Boolean  .class                      : class java.lang.Boolean
---------------------------------------------------------------
T Byte     .TYPE                       : byte
U Character.TYPE                       : char
V Short    .TYPE                       : short
W Integer  .TYPE                       : int
X Long     .TYPE                       : long
Y Float    .TYPE                       : float
Z Double   .TYPE                       : double
A Boolean  .TYPE                       : boolean
---------------------------------------------------------------
------------------------------------------------------------------------ */