// Datei Reflekt05.java
/* ------------------------------------------------------------------------
Klassen, Attribute, Methoden und Konstruktoren koennen in Java durch
Objekte der Klassen Class, Field, Method bzw. Constructor reflektiert
(d.h. dargestellt oder repraesentiert) werden.

Hier wird eine simple Klasse Rek1 vereinbart. Dann wird mit
Reflektions-Objekten auf ihre Attribute zugegriffen und ihre Methoden
werden aufgerufen.
------------------------------------------------------------------------ */
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.lang.reflect.*;
import java.util.ArrayList;
import java.util.Vector;
import java.util.Arrays;
// ------------------------------------------------------------------------
class Reflekt05 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) throws ClassNotFoundException, NoSuchMethodException {

      ArrayList<String>  aliS = new ArrayList<String>();
      ArrayList<Integer> alsI = new ArrayList<Integer>();

//    Class<ArrayList<String>>   calS1 = aliS.getClass();
//    Class<ArrayList<Integer>>  calI1 = alsI.getClass();

//    Class<ArrayList>           calS2 = aliS.getClass();
//    Class<ArrayList>           calI2 = alsI.getClass();

      Class<? extends ArrayList> calS3 = aliS.getClass();
      Class<? extends ArrayList> calI3 = alsI.getClass();

      Class                      calS4 = aliS.getClass();
      Class                      calI4 = alsI.getClass();

      pln("---------------------------------------------------------------");
      pln("calS3.getConstructor(new Class[0]):                     " +
           calS3.getConstructor(new Class[0]));
      pln("calI3.getConstructor(new Class[0]):                     " +
           calI3.getConstructor(new Class[0]));
      pln("calS3.getConstructor(new Class[0]).toGenericString():   " +
           calS3.getConstructor(new Class[0]).toGenericString());
      pln("calI3.getConstructor(new Class[0]).toGenericString():   " +
           calI3.getConstructor(new Class[0]).toGenericString());
      pln("---------------------------------------------------------------");
      Constructor<? extends ArrayList> kaliS  = calS3.getConstructor(new Class[0]);
//    Constructor<? extends Vector>    kaliS2 = kaliS; // Typfehler
      pln("---------------------------------------------------------------");
      pln("calS3.getConstructors()[0]:                             " +
           calS3.getConstructors()[0]);
      pln("calI3.getConstructors()[0]:                             " +
           calI3.getConstructors()[0]);
      pln("calS3.getConstructors()[0].toGenericString():           " +
           calS3.getConstructors()[0].toGenericString());
      pln("calI3.getConstructors()[0].toGenericString():           " +
           calI3.getConstructors()[0].toGenericString());
      pln("---------------------------------------------------------------");
      pln("calS3.getConstructor(new Class[0]).getParameterTypes(): " +
          Arrays.toString(calS3.getConstructor(new Class[0]).getParameterTypes()));
      pln("calI3.getConstructor(new Class[0]).getParameterTypes(): " +
          Arrays.toString(calI3.getConstructor(new Class[0]).getParameterTypes()));
      pln("calS3.getConstructors()[0]        .getParameterTypes(): " +
          Arrays.toString(calS3.getConstructors()[0]        .getParameterTypes()));
      pln("calI3.getConstructors()[0]        .getParameterTypes(): " +
          Arrays.toString(calI3.getConstructors()[0]        .getParameterTypes()));
      pln("calS4.getConstructors()[0]        .getParameterTypes(): " +
          Arrays.toString(calS4.getConstructors()[0]        .getParameterTypes()));
      pln("calI4.getConstructors()[0]        .getParameterTypes(): " +
          Arrays.toString(calI4.getConstructors()[0]        .getParameterTypes()));
      pln("---------------------------------------------------------------");
      pln("aliS.getClass() == alsI.getClass():                     " +
          (aliS.getClass() == alsI.getClass()));
      pln("---------------------------------------------------------------");
      pln("  ArrayList<String> aliS = new ArrayList<String>();");
      pln("---------------------------------------------------------------");
      pln("A ArrayList.class:                                      " +
             ArrayList.class );
      pln("B aliS.getClass():                                      " +
              aliS.getClass() );
      pln("C Arrays.toString(aliS.getClass().getTypeParameters()): " +
             Arrays.toString(aliS.getClass().getTypeParameters()) );
      pln("D ArrayList.class.getGenericSuperclass():               " +
             ArrayList.class.getGenericSuperclass()  );
      pln("E aliS.getClass().getGenericSuperclass():               " +
             aliS.getClass().getGenericSuperclass());
      pln("F ArrayList.class.getSuperclass():                      " +
             ArrayList.class.getSuperclass()  );
      pln("G aliS.getClass().getSuperclass():                      " +
             aliS.getClass().getSuperclass()  );
      pln("---------------------------------------------------------------");
      pln("H MyArrayList1.class.getGenericSuperclass():            " +
             MyArrayList1.class.getGenericSuperclass()  );
      pln("I MyArrayList2.class.getGenericSuperclass():            " +
             MyArrayList2.class.getGenericSuperclass() );
      pln("---------------------------------------------------------------");

      Class             kob1 = MyArrayList1.class;
      Class             kob2 = MyArrayList2.class;
      ParameterizedType tob1 = (ParameterizedType) MyArrayList1.class.getGenericSuperclass();
      ParameterizedType tob2 = (ParameterizedType) MyArrayList2.class.getGenericSuperclass();

      pln("J tob1:                                                 " + tob1 );
      pln("K tob2:                                                 " + tob2 );
      pln("L tob1.getClass()                                       " +
             tob1.getClass() );
      pln("M tob2.getClass()                                       " +
             tob2.getClass() );
      pln("N tob1.getActualTypeArguments()[0]                      " +
             tob1.getActualTypeArguments()[0] );
      pln("O tob2.getActualTypeArguments()[0]                      " +
             tob2.getActualTypeArguments()[0] );
      pln("P kob1.getTypeParameters()[0]                           " +
             kob1.getTypeParameters()[0] );
      pln("Q kob2.getTypeParameters()[0]                           " +
             kob2.getTypeParameters()[0] );


//    pln((MyArrayList2.class.getGenericSuperclass()).getActualTypeArguments());
//    pln((MyArrayList2.class.getGenericSuperclass()).getRawType());

//    pln(aliS.getClass().getActualTypeArguments());

      pln("-----------------------------");
      pln("Reflekt05: Das war's erstmal!");
      pln("---------------------------------------------------------------");
   } // main
      static class MyArrayList1<K>      extends ArrayList<K> {};
      static class MyArrayList2<String> extends ArrayList<String> {};
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Reflekt05
/* ------------------------------------------------------------------------
Fehlermeldungen des Compilers:

D:\Java\Reflekt05.java:26: incompatible types
found   : java.lang.Class<capture of ? extends java.util.ArrayList>
required: java.lang.Class<java.util.ArrayList<java.lang.String>>
    Class<ArrayList<String>>   calS1 = aliS.getClass();
                                                    ^
D:\Java\Reflekt05.java:27: incompatible types
found   : java.lang.Class<capture of ? extends java.util.ArrayList>
required: java.lang.Class<java.util.ArrayList<java.lang.Integer>>
    Class<ArrayList<Integer>>  calI1 = alsI.getClass();
                                                    ^
D:\Java\Reflekt05.java:29: incompatible types
found   : java.lang.Class<capture of ? extends java.util.ArrayList>
required: java.lang.Class<java.util.ArrayList>
    Class<ArrayList>           calS2 = aliS.getClass();
                                                    ^
D:\Java\Reflekt05.java:30: incompatible types
found   : java.lang.Class<capture of ? extends java.util.ArrayList>
required: java.lang.Class<java.util.ArrayList>
    Class<ArrayList>           calI2 = alsI.getClass();
                                                    ^
D:\Java\Reflekt05.java:49: incompatible types
found   : java.lang.reflect.Constructor<capture of ? extends java.util.ArrayList>
required: java.lang.reflect.Constructor<? extends java.util.Vector>
    Constructor<? extends Vector>    kaliS2 = kaliS; // Typfehler
                                              ^
D:\Java\Reflekt05.java:120: cannot find symbol
symbol  : method getActualTypeArguments()
location: interface java.lang.reflect.Type
    pln((MyArrayList2.class.getGenericSuperclass()).getActualTypeArguments());
        ^
D:\Java\Reflekt05.java:121: cannot find symbol
symbol  : method getRawType()
location: interface java.lang.reflect.Type
    pln((MyArrayList2.class.getGenericSuperclass()).getRawType());
        ^
D:\Java\Reflekt05.java:123: cannot find symbol
symbol  : method getActualTypeArguments()
location: class java.lang.Class<capture of ? extends java.util.ArrayList>
    pln(aliS.getClass().getActualTypeArguments());
                     ^
---------------------------------------------------------------------------
Ausgabe des Programms Reflekt05:

---------------------------------------------------------------
calS3.getConstructor(new Class[0]):                     public java.util.ArrayList()
calI3.getConstructor(new Class[0]):                     public java.util.ArrayList()
calS3.getConstructor(new Class[0]).toGenericString():   public java.util.ArrayList()
calI3.getConstructor(new Class[0]).toGenericString():   public java.util.ArrayList()
---------------------------------------------------------------
---------------------------------------------------------------
calS3.getConstructors()[0]:                             public java.util.ArrayList()
calI3.getConstructors()[0]:                             public java.util.ArrayList()
calS3.getConstructors()[0].toGenericString():           public java.util.ArrayList()
calI3.getConstructors()[0].toGenericString():           public java.util.ArrayList()
---------------------------------------------------------------
calS3.getConstructor(new Class[0]).getParameterTypes(): []
calI3.getConstructor(new Class[0]).getParameterTypes(): []
calS3.getConstructors()[0]        .getParameterTypes(): []
calI3.getConstructors()[0]        .getParameterTypes(): []
calS4.getConstructors()[0]        .getParameterTypes(): []
calI4.getConstructors()[0]        .getParameterTypes(): []
---------------------------------------------------------------
aliS.getClass() == alsI.getClass():                     true
---------------------------------------------------------------
  ArrayList<String> aliS = new ArrayList<String>();
---------------------------------------------------------------
A ArrayList.class:                                      class java.util.ArrayList
B aliS.getClass():                                      class java.util.ArrayList
C Arrays.toString(aliS.getClass().getTypeParameters()): [E]
D ArrayList.class.getGenericSuperclass():               java.util.AbstractList<E>
E aliS.getClass().getGenericSuperclass():               java.util.AbstractList<E>
F ArrayList.class.getSuperclass():                      class java.util.AbstractList
G aliS.getClass().getSuperclass():                      class java.util.AbstractList
---------------------------------------------------------------
H MyArrayList1.class.getGenericSuperclass():            java.util.ArrayList<K>
I MyArrayList2.class.getGenericSuperclass():            java.util.ArrayList<String>
---------------------------------------------------------------
J tob1:                                                 java.util.ArrayList<K>
K tob2:                                                 java.util.ArrayList<String>
L tob1.getClass()                                       class sun.reflect.generics.reflectiveObjects.ParameterizedTypeImpl
M tob2.getClass()                                       class sun.reflect.generics.reflectiveObjects.ParameterizedTypeImpl
N tob1.getActualTypeArguments()[0]                      K
O tob2.getActualTypeArguments()[0]                      String
P kob1.getTypeParameters()[0]                           K
Q kob2.getTypeParameters()[0]                           String
-----------------------------
Reflekt05: Das war's erstmal!
---------------------------------------------------------------
------------------------------------------------------------------------ */