// Datei Reihungen02.java
/* ------------------------------------------------------------------------
Reihungsvariablen der Reihungstypen long[] und String[] werden auf
verschiedene Weise vereinbart und initialisiert.

Die Buchstaben    A,   B, ... etc. im folgenden Kommentar entsprechen den
Variablen-Namen lrA, lrB, ... etc.
bzw.            srA, srB, ... etc.

A Erzeugt wird nur eine Reihungsvariable mit dem Wert null, keine Reihung.
B Erzeugt wird eine Reihungsvariable, die auf eine Reihung mit 8 Kompo-
  nenten zeigt. Die Komponenten der Reihung werden nur implizit initiali-
  siert (d.h. mit den Standardwerten 0 bzw. null).
C Erzeugt wird eine Reihungsvariable, die auf eine Reihung zeigt.
  Die Komponenten der Reihung werden explizit initialisiert (d.h. mit
  Werten, die der Programmierer ausdruecklich festgelegt hat).
D Erzeugt wird eine Reihungsvariable, die auf eine leere Reihung zeigt
  (um den Unterschied zu A deutlich zu machen)
E Genau gleiche Wirkung wie bei C, aber mit einer anderen Notation
  (die nur selten wirklich noetig ist).
F Genau gleiche Wirkung wie bei D, aber mit einer anderen Notation.
------------------------------------------------------------------------ */
import java.util.Arrays;

class Reihungen02 {
   static public void main(String[] sonja) {
      long  [] lrA = null;
      long  [] lrB = new long[8];
      long  [] lrC =              {+15, -37, +22, +33, +44};
      long  [] lrD = {};
      long  [] lrE = new long[]   {+15, -37, +22, +33, +44};
      long  [] lrF = new long[0];

      String[] srA = null;
      String[] srB = new String[8];
      String[] srC =              {"Hallo!", "Wie geht's?", "Gut!"};
      String[] srD = {};
      String[] srE = new String[] {"Hallo!", "Wie geht's?", "Gut!"};
      String[] srF = new String[0];

      pln("Reihungen02: Jetz geht es los!");
      pln("----------------------------------------------------");
      pln("lrA " + Arrays.toString(lrA));
      pln("lrB " + Arrays.toString(lrB));
      pln("lrC " + Arrays.toString(lrC));
      pln("lrD " + Arrays.toString(lrD));
      pln("lrE " + Arrays.toString(lrE));
      pln("lrF " + Arrays.toString(lrF));
      pln("----------------------------------------------------");
      pln("srA " + Arrays.toString(srA));
      pln("srB " + Arrays.toString(srB));
      pln("srC " + Arrays.toString(srC));
      pln("srD " + Arrays.toString(srD));
      pln("srE " + Arrays.toString(srE));
      pln("srF " + Arrays.toString(srF));
      pln("----------------------------------------------------");
      pln("Reihungen02: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Reihungen02
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen02:

Reihungen02: Jetz geht es los!
----------------------------------------------------
lrA null
lrB [0, 0, 0, 0, 0, 0, 0, 0]
lrC [15, -37, 22, 33, 44]
lrD []
lrE [15, -37, 22, 33, 44]
lrF []
----------------------------------------------------
srA null
srB [null, null, null, null, null, null, null, null]
srC [Hallo!, Wie geht's?, Gut!]
srD []
srE [Hallo!, Wie geht's?, Gut!]
srF []
----------------------------------------------------
Reihungen02: Das war's erstmal!
------------------------------------------------------------------------ */