// Datei Reihungen03.java
/* ------------------------------------------------------------------------
Demonstriert, dass Reihungsvariablen Referenzvariablen sind.

Die zwei Reihungsvariblen srA und srB werden so vereinbart, dass sie
gleiche (Referenz-) Werte haben und somit auf ein und dieselbe Reihung
zeigen. Dagegen zeigt die Variable srC auf eine Kopie dieser Reihung.
Aenderungen an der Reihung srA sind auch Aenderungen an srB und
Aenderungen an der Reihung srB sind auch Aenderungen an srA
(denn die Reihungen srA und srB sind identisch, nicht nur gleich).
Die Aenderungen an srA und srB haben aber keine Auswirkungen auf die
Reihung srC und Aenderungen an srC haben keine Auswirkungen auf srA
oder srB.

Siehe auch das Beispielprogramm Reihungen05.
------------------------------------------------------------------------ */
import java.util.Arrays;

class Reihungen03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("Reihungen03: Jetzt geht es los!");

      // Drei Reihungsvariablen, aber nur zwei Reihungen werden erzeugt
      // (srA und srB zeigen auf dieselbe Reihung):
      short[] srA = {11, 22, 33};
      short[] srB = srA;
      short[] srC = (short[]) srA.clone();

      // Die Zielwerte der drei Reihungsvariablen werden ausgegeben:
      pln("-------------------------------");
      pln("srA vorher : " + Arrays.toString(srA));
      pln("srB vorher : " + Arrays.toString(srB));
      pln("srC vorher : " + Arrays.toString(srC));
      pln("-------------------------------");

      // Die Zielwerte der drei Reihungsvariablen (die eigentlichen
      // Reihungen) werden veraendert:
      srA[2] = -3; // Die Reihung srA wird ein bisschen veraendert!
      srB[1] = -2; // Die Reihung srB wird ein bisschen veraendert!
      srC[0] = -1; // Die Reihung srC wird ein bisschen veraendert!

      // Die Zielwerte der drei Reihungsvariablen werden erneut ausgegeben:
      pln("srA nachher: " + Arrays.toString(srA));
      pln("srB nachher: " + Arrays.toString(srB));
      pln("srC nachher: " + Arrays.toString(srC));
      pln("-------------------------------");
      pln("Reihungen03: Das War's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Reihungen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen03:

Reihungen03: Jetzt geht es los!
-------------------------------
srA vorher : [11, 22, 33]
srB vorher : [11, 22, 33]
srC vorher : [11, 22, 33]
-------------------------------
srA nachher: [11, -2, -3]
srB nachher: [11, -2, -3]
srC nachher: [-1, 22, 33]
-------------------------------
Reihungen03: Das War's erstmal!
------------------------------------------------------------------------ */