// Datei Reihungen04.java
/* ------------------------------------------------------------------------
Die Erzeugung einer Reihungsvariablen vom Typ String[] ist ein Vorgang,
der eigentlich aus 3 Schritten besteht.
Der Programmierer kann dem Ausfuehrer befehlen, diese Schritte einzeln
auszfuehren oder alle 3 Schritte auf einmal anordnen.
------------------------------------------------------------------------ */
import java.util.Arrays;

class Reihungen04 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // ------------------------------------------------------------------
      // Schritt 1:
      // Eine Variable vom Typ String[] wird vereinbart, aber noch nicht
      // mit einem Anfangswert versehen. Diese Referenzvariable zeigt
      // somit erstmal noch nicht auf eine Reihung:
      String[] sr07;
      // ----------------------------------------
      // Schritt 2:
      // Mit dem new-Befehl wird eine neue Reihung erzeugt, die
      // 3 String-Variablen enthaelt. Der Variablen sr07 wird ein
      // Referenzwert zugewiesen, der auf diese neue Reihung zeigt.
      sr07 = new String[3];
      // ----------------------------------------
      // Schritt 3:
      // Die Komponenten der Reihung sr07 sind Variablen des (Referenz-)
      // Typs String, die vom Ausfuehrer automatisch mit dem Wert null
      // initialisiert wurden. Mit dem new-Befehl werden jetzt neue
      // String-Objekte erzeugt. Referenzwerte, die auf die neuen
      // Objekte zeigen, werden den Reihungskomponenten zugewiesen.
      sr07[0] = new String("Hallo!");
      sr07[1] = new String("Wie geht's?");
      sr07[2] = new String("Gut!");
      // ------------------------------------------------------------------
      // Alle 3 Schritte koennen auch auf einmal angeordnet werden:
      String[] sr08 = {"Hallo!", "Wie geht's?", "Gut!"};
      // ------------------------------------------------------------------
      // Die Reihungen sr07 und sr08 werden ausgegeben um zu zeigen,
      // dass sie gleich sind:

      pln("----------------------------------------------");
      p  ("A sr07: "); printObjectReihungS(sr07);
      p  ("B sr08: "); printObjectReihungS(sr08);
      pln("----------------------------------------------");
      p  ("C sr07: "); printObjectReihungA(sr07);
      p  ("D sr08: "); printObjectReihungA(sr08);
      pln("----------------------------------------------");
      pln("E sr07: " + Arrays.toString(sr07));
      pln("F sr08: " + Arrays.toString(sr08));
      pln("-----------------------------------");
      pln("Reihungen04: Das war's erstmal!");
      // ------------------------------------------------------------------
   } // main
   // ---------------------------------------------------------------------
   static void printObjectReihungS(Object[] objectR) {
      // Gibt die Reihung objectR in lesbarer Form zur Standardausgabe aus.
      // Sichere und einfache Version ohne Indizes.
      p(objectR.length + " Komponenten: ");
      for (Object komp: objectR) {
         p(komp + " ");
      }
      pln();
   } // printObjectReihungS
   // ---------------------------------------------------------------------
   static void printObjectReihungA(Object[] objectR) {
      // Gibt die Reihung objectR in lesbarer Form zur Standardausgabe aus:
      // Alte Version mit Indizes.
      p(objectR.length + " Komponenten: ");
      for (int i=0; i<objectR.length; i++) {
         p(objectR[i] + " ");
      }
      pln();
   } // printObjectReihungA
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Reihungen04
/* ------------------------------------------------------------------------
Die Ausgabe des Programms Reihungen04:

----------------------------------------------
A sr07: 3 Komponenten: Hallo! Wie geht's? Gut!
B sr08: 3 Komponenten: Hallo! Wie geht's? Gut!
----------------------------------------------
C sr07: 3 Komponenten: Hallo! Wie geht's? Gut!
D sr08: 3 Komponenten: Hallo! Wie geht's? Gut!
----------------------------------------------
E sr07: [Hallo!, Wie geht's?, Gut!]
F sr08: [Hallo!, Wie geht's?, Gut!]
-----------------------------------
Reihungen04: Das war's erstmal!
------------------------------------------------------------------------ */