// Datei Reihungen10.java
/* ------------------------------------------------------------------------
Reihungen von Reihungen werden vereinbart und bearbeitet.

Eine Reihung (1. Stufe) kann Reihungen (2. Stufe) als Komponenten enthalten
(und die Reihungen 2. Stufe koennen Reihungen 3. Stufe als Komponenten
enthalten und die Reihungen 3. Stufe koennen ... etc.).

Bei einer solchen Reihung von Reihungen bezeichnet man die Komponenten
der tiefsten Stufe (die keine Reihungen mehr sind) als die elementaren
Komponenten (engl. elements) der Reihung der 1. Stufe.

Die Variable irrA wird als Reihung von Reihungen von int-Variablen
vereinbart (siehe unten). Somit hat die Reihung irrA Komponenten vom
Typ int[] (Reihung von int) und Elemente vom Typ int.
Das Gleiche gilt fuer die Variable irrB.
------------------------------------------------------------------------ */
import java.util.Random;

class Reihungen10 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // ------------------------------------------------------------------
      // In der Variablen irrA kann man 7 Tage lang jede Stunde des
      // Tages einen Messwert (insgesamt also 7 * 24 Messwerte) speichern:
      int[][] irrA = new int[7][24];
      // Die Reihung irrA enthaelt 7 Komponenten vom Typ int[].
      // Jede dieser 7 Reihungen enthaelt 24 Komponenten vom Typ int. Somit
      // enthaelt irrA insgesamt (7*24 gleich) 168 elementare Komponenten
      // vom Typ int.
      // ------------------------------------------------------------------
      // In der Variablen irrB kann man 12 Monate lang jeden Tag des
      // Monats einen Messwert (insgesamt also 365 Messwerte) speichern:
      int[][] irrB = new int[][] {
         new int[31], new int[28], new int[31], // Jan, Feb, Mar
         new int[30], new int[31], new int[30], // Apr, Mai, Jun
         new int[31], new int[31], new int[30], // Jul, Aug, Sep
         new int[31], new int[30], new int[31], // Okt, Nov, Dez
      };
      // Die Reihung irrB enthaelt 12 Komponenten vom Typ int[].
      // Diese 12 Reihungen haben unterschiedliche Laengen (zwischen 28
      // und 31) und enthalten zusammen 365 Komponenten vom Typ int. Somit
      // enthaelt irrB insgesamt 365 elementare Komponenten vom Typ int.
      // ------------------------------------------------------------------
      int[][] irrC = { {3, 5, 2}, {1, 8}, {4, 6, 9, 7}};
      // Die Reihung irrC enthaelt 3 Komponenten vom Typ int[].
      // Diese 3 Reihungen haben unterschiedliche Laengen (zwischen 2
      // und 4) und enthalten zusammen 9 Komponenten vom Typ int. Somit
      // enthaelt irrC zusammen 9 elementare Komponenten vom Typ int.
      // ------------------------------------------------------------------

      // Die elementaren Komponenten der Reihungen irrA und irrB werden
      // mit Zufallszahlen gefuellt. Alle drei Reihungen (irrA bis irrC)
      // werden, gefolgt von einer kleinen Statistik, ausgegeben:
      pln("-------------------------------------------------------------");
      fuelleIRR     (irrA);
      druckeIRR_S   (irrA, "irrA");
      statistikIRR_S(irrA);
      pln("-------------------------------------------------------------");
      fuelleIRR     (irrB);
      druckeIRR_S   (irrB, "irrB");
      statistikIRR_S(irrB);
      pln("-------------------------------------------------------------");
      druckeIRR_S   (irrC, "irrC");
      statistikIRR_S(irrC);
      pln("-------------------------------------------------------------");
      pln("Reihungen10: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   static void fuelleIRR(int[][] irr) {
      // Fuellt alle Elemente der Reihung irr mit Zufallszahlen:

      for (int i=0; i<irr.length; i++) {
         for (int j=0; j<irr[i].length; j++) {
            irr[i][j] = zufallsZahl();
         } // for j
      } // for i
   } // fuelleIRR
   // ---------------------------------------------------------------------
   static void druckeIRR_S(int[][] irr, String name) {
      // Gibt den name und alle Komponenten der Reihung irr "in lesbarer
      // Form" zur Standardausgabe aus (mit einer sicheren und einfachen
      // for-Schleife):

      pln("Reihung " + name + ": " + irr.length + " Zeilen:");
      for (int[] ir: irr) {
         p(ir.length + " Spalten:" );
         for (int i: ir) {
            p(i + " ");
         } // for i
         pln();
      } // for ir
   } // druckeIRR_S
   // ---------------------------------------------------------------------
   static void druckeIRR_A(int[][] irr, String name) {
      // Gibt den name und alle Komponenten der Reihung irr "in lesbarer
      // Form" zur Standardausgabe aus (mit einer alten for-Schleife mit
      // Index):

      pln("Reihung " + name + ": " + irr.length + " Zeilen:");
      for (int i=0; i<irr.length; i++) {
         p(irr[i].length + " Spalten: ");
         for (int j=0; j<irr[i].length; j++) {
            p(irr[i][j] + " ");
         } // for j
         pln();
      } // for i
   } // druckeIRR_A
   // ---------------------------------------------------------------------
   static void statistikIRR_S(int[][] irr) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von irr und gibt sie aus (mit einer sicheren und
      // einfachen for-Schleife):

      int anzahl = 0;
      int summe  = 0;

      for (int[] ir: irr) {
         anzahl += ir.length;
         for (int i: ir) {
            summe += i;
         } // for i
      } // for ir

      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRR_S
   // ---------------------------------------------------------------------
   static void statistikIRR_A(int[][] irr) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von irr und gibt sie aus (mit einer alten
      // for-Schleife mit Index):

      int anzahl = 0;
      int summe  = 0;

      for (int i=0; i<irr.length; i++) {
         anzahl += irr[i].length;
         for (int j=0; j<irr[i].length; j++) {
            summe += irr[i][j];
         } // for j
      } // for i
      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRR_A
   // ---------------------------------------------------------------------
   // Wenn man beim Erzeugen eines Random-Objekts eine Zahl angibt
   // (z.B. 23), dann liefert das Objekt bei jedem Programmstart die
   // gleiche Folge von Zufallszahlen ("reproduzierbare Zufallszahlen").
   // Wenn man keine Zahl angibt, liefert das Objekt jedesmal eine andere
   // Folge von Zufallszahlen ("nicht-reproduzierbare Zufallszahlen").
   //
   // Beim Testen eines Programms mit Zufallszahlen verwendet man in aller
   // Regel reproduzierbare Zufallszahlen, damit man eventuell auftretende
   // Fehler reproduzieren kann. Beim Programmieren von Gluecksspielen
   // werden nicht-reproduzierbare Zufallszahlen bevorzugt.
   static Random quelle = new Random(23); // Reproduzierbare Zufallszahlen
// static Random quelle = new Random();   // Nicht-reproduzierbare Zufalls-
                                          // zahlen
   static int zufallsZahl() {
      // Liefert bei jedem Aufruf einen zufaellig gewaehlten Wert
      // zwischen 0 und 9.
      return quelle.nextInt(10);
   } // zufallsZiffer
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // Reihungen10
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen10:

-------------------------------------------------------------
Reihung irrA: 7 Zeilen:
24 Spalten: 7 8 3 7 8 3 0 0 1 5 4 7 9 0 1 6 4 0 2 7 2 7 4 5
24 Spalten: 4 4 1 0 3 9 2 2 0 7 9 2 1 6 9 4 3 6 8 1 0 7 1 8
24 Spalten: 8 2 8 5 0 2 0 2 6 4 9 6 1 2 2 4 7 1 5 8 7 7 6 5
24 Spalten: 0 2 7 1 9 6 4 7 7 4 5 6 3 4 8 6 9 7 1 5 9 7 1 7
24 Spalten: 7 5 3 1 6 2 6 4 7 2 1 5 6 4 5 6 5 5 7 1 7 8 6 8
24 Spalten: 1 6 9 6 8 6 2 5 7 9 8 4 6 3 6 6 0 3 1 1 1 2 1 8
24 Spalten: 5 6 3 5 2 3 6 5 2 8 5 0 1 3 9 8 8 8 2 0 5 4 3 7
Anzahl Zahlen: 168, Summe: 763
-------------------------------------------------------------
Reihung irrB: 12 Zeilen:
31 Spalten: 0 5 2 8 4 8 9 6 8 2 8 6 1 7 9 4 1 8 7 2 7 5 5 4 4 7 5 9 8 7 4
28 Spalten: 4 6 3 5 1 7 4 5 8 9 8 3 6 2 0 2 0 3 8 9 9 2 7 3 1 6 1 1
31 Spalten: 7 3 2 3 8 2 0 0 6 5 6 2 6 7 1 3 1 1 3 3 4 5 6 4 1 3 9 7 9 7 4
30 Spalten: 7 3 2 3 1 7 1 3 9 1 8 5 5 0 2 2 4 2 1 7 4 1 5 3 0 6 9 8 2 2
31 Spalten: 9 3 9 0 2 7 9 9 6 4 6 4 4 7 9 9 2 5 9 0 8 2 0 8 4 8 1 4 8 6 0
30 Spalten: 0 7 2 2 6 3 0 3 3 7 7 3 2 2 3 5 8 0 3 4 3 0 9 9 9 1 8 9 9 2
31 Spalten: 2 1 9 0 0 1 9 1 1 9 2 7 9 6 8 6 3 8 0 9 4 5 7 1 1 0 1 7 3 6 1
31 Spalten: 1 6 8 6 4 6 1 3 3 4 2 8 7 5 7 2 3 0 2 3 8 3 6 3 0 0 2 3 6 8 9
30 Spalten: 0 5 1 2 5 4 1 9 5 9 5 4 7 7 2 3 6 7 8 2 9 0 8 9 3 5 7 9 5 8
31 Spalten: 5 0 7 3 7 5 1 3 2 9 4 1 9 6 8 6 7 4 7 2 1 5 2 7 8 3 5 2 4 2 5
30 Spalten: 1 1 9 4 6 2 3 7 3 1 8 2 2 0 7 0 1 6 0 3 7 5 3 6 7 3 4 6 4 4
31 Spalten: 6 6 8 2 2 1 4 8 0 9 5 6 8 5 6 9 3 8 6 7 3 0 4 2 8 5 9 2 0 1 7
Anzahl Zahlen: 365, Summe: 1641
-------------------------------------------------------------
Reihung irrC: 3 Zeilen:
3 Spalten: 3 5 2
2 Spalten: 1 8
4 Spalten: 4 6 9 7
Anzahl Zahlen: 9, Summe: 45
-------------------------------------------------------------
------------------------------------------------------------------------ */