// Datei Reihungen11.java
/* ------------------------------------------------------------------------
Reihungen von Reihungenen von Reihungenen von int-Variablen
(dreistufige Reihungen) werden auf verschiedene Weisen vereinbart,
initialisiert und ausgegeben.

Insbesondere soll dieses Programm deutlich machen, dass eine Reihung von
Reihungen nur Referenzen auf ihre Komponenten-Reihungen enthaelt, und
eine Reihung von Reihungenen von Reihungenen nur Referenzen auf solche
Reihungen von Reihungen enthaelt.

In den Ausgaben dieses Programms werden null-Werte verschiedener Typen
unterschieden, je nachdem, wodurch man sie ersetzen koennte:
durch eine Referenz auf eine Variable des Typs int[]   oder
durch eine Referenz auf eine Variable des Typs int[][] oder
durch eine Referenz auf eine Variable des Typs int[][][].
------------------------------------------------------------------------ */
class Reihungen11 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // ------------------------------------------------------------------
      // Vier dreistufige Reihungsvariablen werden vereinbart und teil-
      // weise initialisiert.
      // Die elementaren Komponenten dieser Reihungen (soweit vorhanden)
      // werden vom Ausfuehrer automatisch mit 0 initialisiert.
      int[][][] irrrA = null;
      int[][][] irrrB = new int[3][][];
      int[][][] irrrC = new int[3][2][];
      int[][][] irrrD = new int[3][2][4];
      // ------------------------------------------------------------------
      // Eine dreistufige Reihungsvariable namens irrrE wird vereinbart und
      // so initialisiert, dass sie 12 elementare Komponenten enthaelt.
      // Jeder elementaren Komponenten wird ein int-Wert zwischen 1 und 12
      // zugewiesen:

      int[][][] irrrE = new int[3][][];;

      irrrE           = new int[3][][];

      irrrE[0]        = new int[2][];
      irrrE[1]        = new int[2][4];

      irrrE[0][0]     = new int[4];

      irrrE[0][0][0] =  1;
      irrrE[0][0][1] =  2;
      irrrE[0][0][2] =  3;
      irrrE[0][0][3] =  4;

      irrrE[1][0][0] =  5;
      irrrE[1][0][1] =  6;
      irrrE[1][0][2] =  7;
      irrrE[1][0][3] =  8;

      irrrE[1][1][0] =  9;
      irrrE[1][1][1] = 10;
      irrrE[1][1][2] = 11;
      irrrE[1][1][3] = 12;
      // ------------------------------------------------------------------
      // Eine dreistufige Reihungsvariable namens irrrF wird so vereinbart
      // und initialisiert, dass sie "genau so aussieht" wie die zuvor
      // vereinbarte Variable irrrE:

      int[][][] irrrF = {
          {                             // irrrF[0]      length: 2
              { 1,  2,  3,  4},         // irrrF[0][0]   length: 4
              null                      // irrrF[0][1]   length: -
          },
          {                             // irrrF[1]      length: 2
              { 5,  6,  7,  8},         // irrrF[1][0]   length: 4
              { 9, 10, 11, 12}          // irrrF[1][1]   length: 4
          },
          null                          // irrrF[2]      length: -
       };
      // ------------------------------------------------------------------
      // Eine dreistufige Reihungsvariable namens irrrG wird vereinbart und
      // so initialisiert, dass keine Komponente den Wert null hat.
      // Die Laengen der Komponenten, die Reihungen sind, wurden
      // "moeglichst unterschiedlich und chaotisch" gewaehlt. Die Reihung
      // irrrG hat insgesamt ((3 + 5 + 2) + (2 + 4 + 3 + 2)) geich 21
      // elementare Komponenten, die mit den int-Werten zwischen 101
      // und 121 initialisiert werden:

      int[][][] irrrG = {               //               length: 2
         {                              // irrrG[0]      length: 3
            {101, 102, 103},            // irrrG[0][0]   length: 3
            {104, 105, 106, 107, 108},  // irrrG[0][1]   length: 5
            {109, 110},                 // irrrG[0][2]   length: 2
         },
         {                              // irrrG[0]      length: 4
            {111, 112},                 // irrrG[0][0]   length: 2
            {113, 114, 115, 116},       // irrrG[0][1]   length: 4
            {117, 118, 119},            // irrrG[0][2]   length: 3
            {120, 121},                 // irrrG[0][3]   length: 2
         }
      };
      // ------------------------------------------------------------------
      // 7 einstufige, 2 zweistufige und eine dreistufige Reihungsvariable
      // werden vereinbart. Die dreistufige Reihung irrrH "sieht genau so
      // aus" wie die zuvor vereinbarte Reihung irrrG:

      int[]     ir00  = {101, 102, 103};            // length: 3
      int[]     ir01  = {104, 105, 106, 107, 108};  // length: 5
      int[]     ir02  = {109, 110};                 // length: 2

      int[]     ir10  = {111, 112};                 // length: 2
      int[]     ir11  = {113, 114, 115, 116};       // length: 4
      int[]     ir12  = {117, 118, 119};            // length: 3
      int[]     ir13  = {120, 121};                 // length: 2

      int[][]   irr0  = {ir00, ir01, ir02};         // length: 3
      int[][]   irr1  = {ir10, ir11, ir12, ir13};   // length: 4

      int[][][] irrrH = {irr0, irr1};               // length: 2
      // ------------------------------------------------------------------
         druckeIRRR_S(irrrA, "irrrA");
         druckeIRRR_S(irrrB, "irrrB");
         druckeIRRR_S(irrrC, "irrrC");
         druckeIRRR_S(irrrD, "irrrD");
         druckeIRRR_S(irrrE, "irrrE");
         druckeIRRR_S(irrrF, "irrrF");
         druckeIRRR_S(irrrG, "irrrG");
         druckeIRRR_S(irrrH, "irrrH");
      statistikIRRR_S(irrrH);
      pln("-------------------------------");
      pln("Reihungen11: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   static void druckeIRRR_S(int[][][] irrr, String name) {
      // Versucht, die Reihung irrr "in lesbarer Form" zur Standardausgabe
      // auszugeben (mit sicheren und einfachen for-Schleifen).

      // Falls irrr nicht auf eine Reihung zeigt:
      if (irrr == null) {
         pln(name + ": null (Typ: int[][][])"); pln();
         return;
      }

      // Falls irrr auf eine Reihung zeigt:
      pln(name + ".length: " + irrr.length);
      int a = 0;
      for (int[][] irr: irrr) {

         // Falls irrr[i] nicht auf eine Reihung zeigt:
         if (irr == null) {
            pln("  \"  [" + a++ + "]: null (Typ: int[][])");
            continue;
         }

         // Falls irr auf eine Reihung zeigt:
         pln("  \"  [" + a++ + "].length: " + irr.length);
         int b = 0;
         for (int[] ir: irr) {

            // Falls ir nicht auf eine Reihung zeigt:
            if (ir == null) {
               pln("  \"   \" [" + b++ +"]: null (Typ: int[])");
               continue;
            }

            // Falls ir auf eine Reihung zeigt:
            pln("  \"   \" [" + b++ +"].length: " + ir.length);
            int c = 0;
            for (int i: ir) {
               pln("  \"   \"  \" [" + c++ + "]: " + i + " ");
            } // for i

         } // for ir
      } // for irr
      pln();
   } // druckeIRRR_S
   // ---------------------------------------------------------------------
   static void druckeIRRR_A(int[][][] irrr, String name) {
      // Versucht, die Reihung irrr "in lesbarer Form" zur Standardausgabe
      // auszugeben (mit alten for-Schleifen mit Index).

      // Falls irrr nicht auf eine Reihung zeigt:
      if (irrr == null) {
         pln(name + ": null (Typ: int[][][])"); pln();
         return;
      }

      // Falls irrr auf eine Reihung zeigt:
      pln(name + ".length: " + irrr.length);
      for (int i=0; i<irrr.length; i++) {

         // Falls irrr[i] nicht auf eine Reihung zeigt:
         if (irrr[i] == null) {
            pln("  \"  [" + i + "]: null (Typ: int[][])");
            continue;
         }

         // Falls irrr[i] auf eine Reihung zeigt:
         pln("  \"  [" + i + "].length: " + irrr[i].length);
         for (int j=0; j<irrr[i].length; j++) {

            // Falls irrr[i][j] nicht auf eine Reihung zeigt:
            if (irrr[i][j] == null) {
               pln("  \"   \" [" + j +"]: null (Typ: int[])");
               continue;
            }

            // Falls irrr[i][j] auf eine Reihung zeigt:
            pln("  \"   \" [" + j +"].length: " + irrr[i][j].length);
            for (int k=0; k<irrr[i][j].length; k++) {
               pln("  \"   \"  \" [" + k + "]: " + irrr[i][j][k] + " ");
            } // for k

         } // for j
      } // for i
      pln();
   } // druckeIRRR_A
   // ---------------------------------------------------------------------
   static void statistikIRRR_S(int[][][] irrr) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von irrr und gibt sie aus (mit sicheren und
      // einfachen for-Schleifen):

      int anzahl = 0;
      int summe  = 0;

      for (int[][] irr: irrr) {
         for (int[] ir: irr) {
            anzahl += ir.length;
            for (int i: ir) {
               summe += i;
            } // for i
         } // for ir
      } // for irr
      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRRR_S
   // ---------------------------------------------------------------------
   static void statistikIRRR_A(int[][][] irrr) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von irrr und gibt sie aus (mit alten for-Schleifen
      // mit Index):

      int anzahl = 0;
      int summe  = 0;

      for (int i=0; i<irrr.length; i++) {
         for (int j=0; j<irrr[i].length; j++) {
            anzahl += irrr[i][j].length;
            for (int k=0; k<irrr[i][j].length; k++) {
               summe += irrr[i][j][k];
            } // for k
         } // for j
      } // for i
      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRRR_A
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // Reihungen11
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen11:

Mit alten for-Schleifen:          Mit sicheren for-Schleifen:

irrrA: null (Typ: int[][][])      irrrA: null (Typ: int[][][])

irrrB.length: 3                   irrrB.length: 3
  "  [0]: null (Typ: int[][])       "  [0]: null (Typ: int[][])
  "  [1]: null (Typ: int[][])       "  [1]: null (Typ: int[][])
  "  [2]: null (Typ: int[][])       "  [2]: null (Typ: int[][])

irrrC.length: 3                   irrrC.length: 3
  "  [0].length: 2                  "  [0].length: 2
  "   " [0]: null (Typ: int[])      "   " [0]: null (Typ: int[])
  "   " [1]: null (Typ: int[])      "   " [1]: null (Typ: int[])
  "  [1].length: 2                  "  [1].length: 2
  "   " [0]: null (Typ: int[])      "   " [0]: null (Typ: int[])
  "   " [1]: null (Typ: int[])      "   " [1]: null (Typ: int[])
  "  [2].length: 2                  "  [2].length: 2
  "   " [0]: null (Typ: int[])      "   " [0]: null (Typ: int[])
  "   " [1]: null (Typ: int[])      "   " [1]: null (Typ: int[])

irrrD.length: 3                   irrrD.length: 3
  "  [0].length: 2                  "  [0].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0
  "  [1].length: 2                  "  [1].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0
  "  [2].length: 2                  "  [2].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 0                   "   "  " [0]: 0
  "   "  " [1]: 0                   "   "  " [1]: 0
  "   "  " [2]: 0                   "   "  " [2]: 0
  "   "  " [3]: 0                   "   "  " [3]: 0

irrrE.length: 3                   irrrE.length: 3
  "  [0].length: 2                  "  [0].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 1                   "   "  " [0]: 1
  "   "  " [1]: 2                   "   "  " [1]: 2
  "   "  " [2]: 3                   "   "  " [2]: 3
  "   "  " [3]: 4                   "   "  " [3]: 4
  "   " [1]: null (Typ: int[])      "   " [1]: null (Typ: int[])
  "  [1].length: 2                  "  [1].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 5                   "   "  " [0]: 5
  "   "  " [1]: 6                   "   "  " [1]: 6
  "   "  " [2]: 7                   "   "  " [2]: 7
  "   "  " [3]: 8                   "   "  " [3]: 8
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 9                   "   "  " [0]: 9
  "   "  " [1]: 10                  "   "  " [1]: 10
  "   "  " [2]: 11                  "   "  " [2]: 11
  "   "  " [3]: 12                  "   "  " [3]: 12
  "  [2]: null (Typ: int[][])       "  [2]: null (Typ: int[][])

irrrF.length: 3                   irrrF.length: 3
  "  [0].length: 2                  "  [0].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 1                   "   "  " [0]: 1
  "   "  " [1]: 2                   "   "  " [1]: 2
  "   "  " [2]: 3                   "   "  " [2]: 3
  "   "  " [3]: 4                   "   "  " [3]: 4
  "   " [1]: null (Typ: int[])      "   " [1]: null (Typ: int[])
  "  [1].length: 2                  "  [1].length: 2
  "   " [0].length: 4               "   " [0].length: 4
  "   "  " [0]: 5                   "   "  " [0]: 5
  "   "  " [1]: 6                   "   "  " [1]: 6
  "   "  " [2]: 7                   "   "  " [2]: 7
  "   "  " [3]: 8                   "   "  " [3]: 8
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 9                   "   "  " [0]: 9
  "   "  " [1]: 10                  "   "  " [1]: 10
  "   "  " [2]: 11                  "   "  " [2]: 11
  "   "  " [3]: 12                  "   "  " [3]: 12
  "  [2]: null (Typ: int[][])       "  [2]: null (Typ: int[][])

irrrG.length: 2                   irrrG.length: 2
  "  [0].length: 3                  "  [0].length: 3
  "   " [0].length: 3               "   " [0].length: 3
  "   "  " [0]: 101                 "   "  " [0]: 101
  "   "  " [1]: 102                 "   "  " [1]: 102
  "   "  " [2]: 103                 "   "  " [2]: 103
  "   " [1].length: 5               "   " [1].length: 5
  "   "  " [0]: 104                 "   "  " [0]: 104
  "   "  " [1]: 105                 "   "  " [1]: 105
  "   "  " [2]: 106                 "   "  " [2]: 106
  "   "  " [3]: 107                 "   "  " [3]: 107
  "   "  " [4]: 108                 "   "  " [4]: 108
  "   " [2].length: 2               "   " [2].length: 2
  "   "  " [0]: 109                 "   "  " [0]: 109
  "   "  " [1]: 110                 "   "  " [1]: 110
  "  [1].length: 4                  "  [1].length: 4
  "   " [0].length: 2               "   " [0].length: 2
  "   "  " [0]: 111                 "   "  " [0]: 111
  "   "  " [1]: 112                 "   "  " [1]: 112
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 113                 "   "  " [0]: 113
  "   "  " [1]: 114                 "   "  " [1]: 114
  "   "  " [2]: 115                 "   "  " [2]: 115
  "   "  " [3]: 116                 "   "  " [3]: 116
  "   " [2].length: 3               "   " [2].length: 3
  "   "  " [0]: 117                 "   "  " [0]: 117
  "   "  " [1]: 118                 "   "  " [1]: 118
  "   "  " [2]: 119                 "   "  " [2]: 119
  "   " [3].length: 2               "   " [3].length: 2
  "   "  " [0]: 120                 "   "  " [0]: 120
  "   "  " [1]: 121                 "   "  " [1]: 121

irrrH.length: 2                   irrrH.length: 2
  "  [0].length: 3                  "  [0].length: 3
  "   " [0].length: 3               "   " [0].length: 3
  "   "  " [0]: 101                 "   "  " [0]: 101
  "   "  " [1]: 102                 "   "  " [1]: 102
  "   "  " [2]: 103                 "   "  " [2]: 103
  "   " [1].length: 5               "   " [1].length: 5
  "   "  " [0]: 104                 "   "  " [0]: 104
  "   "  " [1]: 105                 "   "  " [1]: 105
  "   "  " [2]: 106                 "   "  " [2]: 106
  "   "  " [3]: 107                 "   "  " [3]: 107
  "   "  " [4]: 108                 "   "  " [4]: 108
  "   " [2].length: 2               "   " [2].length: 2
  "   "  " [0]: 109                 "   "  " [0]: 109
  "   "  " [1]: 110                 "   "  " [1]: 110
  "  [1].length: 4                  "  [1].length: 4
  "   " [0].length: 2               "   " [0].length: 2
  "   "  " [0]: 111                 "   "  " [0]: 111
  "   "  " [1]: 112                 "   "  " [1]: 112
  "   " [1].length: 4               "   " [1].length: 4
  "   "  " [0]: 113                 "   "  " [0]: 113
  "   "  " [1]: 114                 "   "  " [1]: 114
  "   "  " [2]: 115                 "   "  " [2]: 115
  "   "  " [3]: 116                 "   "  " [3]: 116
  "   " [2].length: 3               "   " [2].length: 3
  "   "  " [0]: 117                 "   "  " [0]: 117
  "   "  " [1]: 118                 "   "  " [1]: 118
  "   "  " [2]: 119                 "   "  " [2]: 119
  "   " [3].length: 2               "   " [3].length: 2
  "   "  " [0]: 120                 "   "  " [0]: 120
  "   "  " [1]: 121                 "   "  " [1]: 121

Anzahl Zahlen: 21, Summe: 2331    Anzahl Zahlen: 21, Summe: 2331
-------------------------------   -------------------------------
Reihungen11: Das war's erstmal!   Reihungen11: Das war's erstmal!
------------------------------------------------------------------------ */