// Datei Reihungen12.java
/* ------------------------------------------------------------------------
Eine Reihungsvariablen namens ir2K vom Typ int[][] wird vereinbart und
so initialisiert, dass sie 4 elementare Komponenten enthaelt, deren Summe
gleich 16 ist. Dann wird eine der elementaren Komponente um 2 erhoeht.
Dananch ist die Summe aller elementaren Komponenten gleich 20 und nicht
gleich 18! Warum?

Moeglicherweise hilft es beim Suchen nach einer Erklaerung, wenn man
die Variable ir2K als Boje darstellt und die wesentlichen Befehle des
Programms selbst "mit Papier und Bleistift" ausfuehrt.
------------------------------------------------------------------------ */
class Reihungen12 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Eine einstufige Reihung ir1K und eine zweistufige Reihung ir2K
      // werden vereinbart:
      int[]   ir1K = {3, 5};
      int[][] ir2K = {ir1K, ir1K};

      // Die Reihung ir2K und eine kleine Statistik werden ausgegeben:
      pln("--------------------------------");
      druckeIRR_A(ir2K, "ir2K vorher");
      statistikIRR_S(ir2K);
      pln("--------------------------------");

      // Eine elementare Komponente der Reihung ir2K wird um 2 erhoeht:
      ir2K[1][1] = ir2K[1][1] + 2;

      // Die Reihung ir2K und eine kleine Statistik werden
      // noch einmal ausgegeben:
      druckeIRR_A(ir2K, "ir2K nachher");
      statistikIRR_S(ir2K);
      pln("--------------------------------");
      pln("Reihungen12: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   static void druckeIRR_S(int[][] ir2, String name) {
      // Gibt den name und alle Komponenten der Reihung ir2 "in lesbarer
      // Form" zur Standardausgabe aus (mit sicheren und einfachen for-
      // Schleifen):

      pln("Reihung " + name + ": " + ir2.length + " Zeilen:");
      for (int [] ir: ir2) {
         p(ir.length + " Spalten: ");
         for (int i: ir) {
            p(i + " ");
         } // for i
         pln();
      } // for ir
   } // druckeIRR_S
   // ---------------------------------------------------------------------
   static void druckeIRR_A(int[][] ir2, String name) {
      // Gibt den name und alle Komponenten der Reihung ir2 "in lesbarer
      // Form" zur Standardausgabe aus (mit alten for-Schleifen mit
      // Index):

      pln("Reihung " + name + ": " + ir2.length + " Zeilen:");
      for (int i=0; i<ir2.length; i++) {
         p("Zeile " + i + ": " + ir2[i].length + " Spalten: ");
         for (int j=0; j<ir2[i].length; j++) {
            p(ir2[i][j] + " ");
         } // for j
         pln();
      } // for i
   } // druckeIRR_A
   // ---------------------------------------------------------------------
   static void statistikIRR_S(int[][] ir2) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von ir2 und gibt sie aus (mit sicheren und
      // einfachen for-Schleifen):

      int anzahl = 0;
      int summe  = 0;

      for (int[] ir: ir2) {
         anzahl += ir.length;
         for (int i: ir) {
            summe += i;
         } // for i
      } // for ir
      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRR_S
   // ---------------------------------------------------------------------
   static void statistikIRR_A(int[][] ir2) {
      // Berechnet die Anzahl und die Summe aller elementaren
      // Komponenten von ir2 und gibt sie aus (mit alten for-
      // Schleifen mit Index):

      int anzahl = 0;
      int summe  = 0;

      for (int i=0; i<ir2.length; i++) {
         anzahl += ir2[i].length;
         for (int j=0; j<ir2[i].length; j++) {
            summe += ir2[i][j];
         } // for j
      } // for i
      pln("Anzahl Zahlen: " + anzahl + ", Summe: " + summe);
   } // statistikIRR_A
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // Reihungen12
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen12:

Mit alten for-Schleifen:             Mit sicheren for-Schleifen:

--------------------------------     --------------------------------
Reihung ir2K vorher: 2 Zeilen:       Reihung ir2K vorher: 2 Zeilen:
Zeile 0: 2 Spalten: 3 5              2 Spalten: 3 5
Zeile 1: 2 Spalten: 3 5              2 Spalten: 3 5
Anzahl Zahlen: 4, Summe: 16          Anzahl Zahlen: 4, Summe: 16
--------------------------------     --------------------------------
Reihung ir2K nachher: 2 Zeilen:      Reihung ir2K nachher: 2 Zeilen:
Zeile 0: 2 Spalten: 3 7              2 Spalten: 3 7
Zeile 1: 2 Spalten: 3 7              2 Spalten: 3 7
Anzahl Zahlen: 4, Summe: 20          Anzahl Zahlen: 4, Summe: 20
--------------------------------     --------------------------------
Reihungen12: Das war's erstmal!      Reihungen12: Das war's erstmal!
------------------------------------------------------------------------ */
