// Datei Reihungen14.java
/* ------------------------------------------------------------------------
Der Modul (oder: die Klasse) java.util.Arrays enthaelt eine Reihe von
nuetzlichen Methoden zur Bearbeitung von Reihungen: fill, binarySearch,
equals, sort und asList. Diese Methoden werden hier auf Reihungen des Typs
String[] angewendet, d.h. auf Reihungen mit Komponenten eines Referenztyps.
------------------------------------------------------------------------ */
// Die folgende import-Anweisung fuehrt den Namen "Arrays" als Abkuerzung
// fuer den vollen Namen "java.util.Arrays" ein. Laesst man die import-
// Anweisung weg, muss man immer den vollen Namen der Klasse angeben, mit
// der import-Anweisung genuegt die Abkuerzung.

import java.util.Arrays;

class Reihungen14 {
   static public void main(String[] sonja) {

      // Vier String-Reihungen als "Rohmaterial":
      String[] sr01 = new String[1000];
      String[] sr02 = new String[1000];
      String[] sr03 = new String[1000];
      String[] sr04 = {"CC", "AA", "EE", "BB", "DD"};

      // Die Reihungen sr01 und sr02 werden mit dem String "XXX" gefuellt:
      Arrays.fill(sr01, "XXX");
      Arrays.fill(sr02, "XXX");

      // Die Reihung sr03 wird zur Haelfte mit dem String "ABC" und
      //                       zur Haelfte mit dem String "DEF" gefuellt:
      Arrays.fill(sr03,   0, 499, "ABC");
      Arrays.fill(sr03, 500, 999, "DEF");

      // Ein Funktionsaufruf wie Arrays.equals(sr01, sr02) bewirkt, dass
      // die Zielwerte der Variablen sr01 und sr02 (die Reihungen sr01
      // und sr02) verglichen werden, nicht die Werte der Variablen (d.h.
      // nicht die Referenzen der Reihungen).

      // Ein Funktionsaufruf wie sr01.equals(sr02) bewirkt, dass die
      // Werte der Variablen sr01 und sr02 verglichen werden, nicht die
      // Reihungen selbst (d.h. nicht die Zielwerte der Variablen sr01
      // und sr02).
      pln("-------------------------------------------------------------");
      pln("A Arrays.equals(sr01, sr02): " + Arrays.equals(sr01, sr02)    );
      pln("B sr01.equals(sr02):         " + (sr01.equals(sr02) )         );
      pln("-------------------------------------------------------------");
      pln("C Arrays.equals(sr02, sr03): " + Arrays.equals(sr02, sr03)    );
      pln("D sr02.equals(sr03):         " + (sr01.equals(sr03) )         );

      // Mit der Prozedur Arrays.sort kann man eine Reihung aufsteigend
      // sortieren:
      pln("-------------------------------------------------------------");
      // Eine Reihung von Objekten kann man mit der Methode
      // Arrays.asList in ein List-Objekt umwandeln und dieses List-
      // Objekt weiter bearbeiten, z.B. sortieren und ausgeben, etwa so:
      // List-Objekt ausgeben, z.B. so:
      pln("E " + Arrays.asList(sr04));
      pln("F Arrays.sort(sr04);"); Arrays.sort(sr04);
      pln("G " + Arrays.asList(sr04));

      // Die Funktionen Arrays.binarySearch funktionieren nur dann richtig,
      // wenn man sie auf eine aufsteigend sortierte Reihung anwendet.

      // Ein Funktionsaufruf wie Arrays.binarySearch(sr01, "DD") liefert
      // den Index, an dem der String "DD" in der Reihung sr01 steht.

      // Ein Funktionsaufruf wie Arrays.binarySearch(sr01, "DA") liefert
      // einen negativen Wert, weil "DA" nicht in sr01 vorkommt. Genauer:
      // Das Ergebnis ist (- EinfuegeIndex - 1), wobei EinfuegeIndex die
      // Stelle in der Reihung sr01 bezeichnet, an der der Wert "DA" einge-
      // fuegt werden muesste, damit die Sortierung erhalten bleibt.
      pln("-------------------------------------------------------------");
      pln("H Arrays.binarySearch(sr04, \"DD\"): " +
             Arrays.binarySearch(sr04,  "DD"));
      pln("I Arrays.binarySearch(sr04, \"DA\"): " +
             Arrays.binarySearch(sr04,  "DA"));
      pln("-------------------------------------------------------------");
      pln("Reihungen14: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // Reihungen14
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen14:

-------------------------------------------------------------
A Arrays.equals(sr01, sr02): true
B sr01.equals(sr02):         false
-------------------------------------------------------------
C Arrays.equals(sr02, sr03): false
D sr02.equals(sr03):         false
-------------------------------------------------------------
E [CC, AA, EE, BB, DD]
F Arrays.sort(sr04);
G [AA, BB, CC, DD, EE]
-------------------------------------------------------------
H Arrays.binarySearch(sr04, "DD"): 3
I Arrays.binarySearch(sr04, "DA"): -4
-------------------------------------------------------------
Reihungen14: Das war's erstmal!
------------------------------------------------------------------------ */
