// Datei Return02.java
/* ------------------------------------------------------------------------
In einer Funktion kann nach return ein beliebig (einfacher oder)
komplizierter Ausdruck stehen. Durch einen komplizierten Ausdruck kann
man haeufig eine noch kompliziertere if-Anweisung ersetzen.
------------------------------------------------------------------------ */
class Return02 {
   // -----------------------------------------------------------
   // Eine Funktion mit einer komplizierten if-Anweisung im
   // Rumpf:
   static boolean istZifferA(char c) {
      if ('0' <= c && c <= '9') {
         return true;
      } else {
         return false;
      }
   } // istZifferA
   // -----------------------------------------------------------
   // Eine Funktion mit einem komplizierten Ausdruck nach
   // return (eleganter als die vorige Funktion):
   static boolean istZifferB(char c) {
      return '0' <= c && c <= '9';
   } // istZifferB
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      pln("A " + istZifferA('?'));
      pln("B " + istZifferB('?'));
      pln("C " + istZifferA('5'));
      pln("D " + istZifferB('5'));
      pln("----------------------------");
      pln("Return02: Das war's erstmal!");
   } // main
   // -----------------------------------------------------------
} // class Return02
/* ------------------------------------------------------------------------
Ausgabe des Programms Return02:

A false
B false
C true
D true
----------------------------
Return02: Das war's erstmal!
------------------------------------------------------------------------ */