// Datei Return03.java
/* ------------------------------------------------------------------------
Zwei Funktionen mit falschen return-Anweisungen und
eine richtige Funktion ohne return-Anweisungen:
------------------------------------------------------------------------ */
class Return03 {
/*
   // -----------------------------------------------------------
   // Eine Funktion in der noch eine return-Anweisung fehlt:
   static boolean istGrossbuchstabe(char c) {
      if ('A' <= c && c <= 'Z') {
         return true;
      }
   } // istGrossbuchstabe
   // -----------------------------------------------------------
   // Eine Funktion mit 2 falschen return-Anweisungen:
   static int liefereWas(int n) {
      if (n < 0) {
         return;
      }
      return "Hallo!";
   } // liefereWas
   // -----------------------------------------------------------
*/
   // Ein ausgefallener und konstruierter Sonderfall: Eine
   // korrekte Funktion ohne return-Anweisung (sie wird immer
   // durch das Werfen einer Ausnahme beendet):
   static String funktion02() {
      throw new ArithmeticException();
   } // funktion02
   // -----------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // -----------------------------------------------------------
   static public void main(String[] sonja) {
      try {
         funktion02();
      } catch (ArithmeticException aus) {
         pln("Es trat folgende Ausnahme auf: " + aus);
      }
      pln("----------------------------");
      pln("Return03: Das war's erstmal!");
   } // main
   // -----------------------------------------------------------
} // class Return03
/* ------------------------------------------------------------------------
Ausgabe des Programms Return03:

Es trat folgende Ausnahme auf: java.lang.ArithmeticException
----------------------------
Return03: Das war's erstmal!
---------------------------------------------------------------------------
Fehlermeldungen des Compilers (jikes von IBM)  wenn die Funktionen
istGrossbuchstabe und liefereWas nicht auskommentiert sind:

    10.    static boolean istGrossbuchstabe(char c) {
                  ^-----------------------^
*** Semantic Error: The method "boolean istGrossbuchstabe(char c);"
must contain a return statement with an expression compatible with
type "boolean".


    19.          return;
                 ^-----^
*** Semantic Error: A return statement with no expression may only
appear in void method or a constructor.


    21.       return "Hallo!";
                     ^------^
*** Semantic Error: The type of this return expression, "java.lang.String",
does not match the return type of the method, "int".
------------------------------------------------------------------------ */