// Datei ReturnAnweisungen.java
/* ------------------------------------------------------------------------
Verschiedene return-Anweisungen in Funktionen und Prozeduren.
------------------------------------------------------------------------ */
class ReturnAnweisungen {
   // ---------------------------------------------------------------------
   static void analysiereZahl(int n) {
      // Diese Prozedur (void-Methode) enthaelt 2 return-Anweisungen und
      // wird ohne return-Anweisung beendet, falls n zwischen 0 und 100
      // liegt.

      p("Die Zahl " + n + " ");
      if (n < 0) {
         pln("ist negativ!");
         return;                        // 1. return-Anweisung
      }
      if (100 < n) {
         pln("ist groesser als 100!");
         return;                        // 2. return-Anweisung
      }
      pln("liegt zwischen 0 und 100!"); // Ende ohne return-Anweisung
   } // analysiereZahl
   // ---------------------------------------------------------------------
   static boolean istGrossbuchstabe1(char c) {
      // Wenn die zweite return-Anweisung auskommentiert wird, lehnt der
      // Ausfuehrer diese Funktion ab (Fehlermeldung siehe unten):
      if ('A' <= c && c <= 'Z') {
         return true;
      }
      return false;
   } // istGrossbuchstabe1
   // ---------------------------------------------------------------------
   static boolean istGrossbuchstabe2(char c) {
      // Diese Funktion leistet das Gleiche wie die Funktion
      // istGrossbuchstabe1, kommt aber mit einer return-Anweisung aus.
      return 'A' <= c && c <= 'Z';
   } // istGrossbuchstabe2
   // ---------------------------------------------------------------------
   static boolean istEinZeichen(char c) {
      // Sogar diese Funktion wird vom Ausfuehrer abgelehnt, wenn die
      // zweite return-Anweisung auskommentiert wird (obwohl ein Mensch
      // klar erkennen kann, dass die Funktion immer mit der ersten
      // return-Anweisung beendet wird).
      if (true) {
         return true;
      }
      return true;
   } // istEinZeichen
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      analysiereZahl(-17);
      analysiereZahl(123);
      analysiereZahl(+17);
   } // main
} // ReturnAnweisungen
/* ------------------------------------------------------------------------
Ausgabe des Programms ReturnAnweisungen

Die Zahl -17 ist negativ!
Die Zahl 123 ist groesser als 100!
Die Zahl 17 liegt zwischen 0 und 100!
---------------------------------------------------------------------------
Fehlermeldungen des jikes-Compilers, wenn die Zeilen 30 und 47 aus-
kommentiert werden:

Found 2 semantic errors compiling "D:/JavaQuellen/ReturnAnweisungen.java":

    24.    static boolean istGrossbuchstabe1(char c) {
                  <------------------------>
*** Error: The method "boolean istGrossbuchstabe1(char c);" must contain
a return statement with an expression compatible with type "boolean".


    39.    static boolean istEinZeichen(char c) {
                  <------------------->
*** Error: The method "boolean istEinZeichen(char c);" must contain
a return statement with an expression compatible with type "boolean".
------------------------------------------------------------------------ */