// Datei RodentListenerTst.java
/* ------------------------------------------------------------------------
Ein kleiner Test der abstrakten Klasse RodentListener und ihrer konkreten
Unterklassen RodentPlainListener, RodentMotionListener und RodentWheelList-
ener. Der Sinn dieser Klassen wird am Anfang der Datei RodentListener.java
(im Unterverzeichnis myja/awt/event) erlaeutert.

Wenn man dieses Programm startet, erscheint ein Fenster (JFrame-Objekt).
Wenn darin Mausereignisse der Arten

mouseEntered
mouseDragged
mouseWheelMoved

eintreten, wird eine Meldung zur Standardausgabe ausgegeben.
------------------------------------------------------------------------ */
import java.awt      .Component;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelListener;
import myja.awt.event.RodentListener;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;

import javax.swing.JFrame;
// ------------------------------------------------------------------------
class RodentListenerTst {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("RodentListener: Jetzt geht es los!%n");
      // ------------------------------------------------------------------
      MouseListener ml01 = new MouseAdapter() {
         public void mouseEntered(MouseEvent me) {
            printf("mouseEntered!%n");
         } // mouseEntered
      };
      // ------------------------------------------------------------------
      MouseMotionListener mml01 = new MouseMotionAdapter() {
         public void mouseDragged(MouseEvent me) {
            printf("mouseDragged!%n");
         } // mouseDragged
      };
      // ------------------------------------------------------------------
      MouseWheelListener mwl01 = new MouseWheelListener() {
         public void mouseWheelMoved(MouseWheelEvent mwe) {
            printf("mouseWHeelMoved!%n");
         }
      };
      // ------------------------------------------------------------------
      RodentListener r01 = RodentListener.makeRL(ml01);
      RodentListener r02 = RodentListener.makeRL(mml01);
      RodentListener r03 = RodentListener.makeRL(mwl01);

      JFrame mr = new JFrame("Rahmen fuer Mausereignisse!");
      mr.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      mr.setBounds(40, 30, 400, 300);

      r01.addThisListener(mr);
      r02.addThisListener(mr);
      r03.addThisListener(mr);

      mr.setVisible(true);

      printf("RodentListener: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // RodentListenerTst
// ------------------------------------------------------------------------
