// Datei Sammlungen01.java
/* ------------------------------------------------------------------------
Die Methoden addAll, containsAll, removeAll und retainsAll aus der
Schnittstelle Collection<K> werden auf Sammlungen c1, c2, ... angewendet.

In diesem Programm sind alle Sammlungsobjekte vom Typ ArrayList<String>.
------------------------------------------------------------------------ */
import java.util.Collection;
import java.util.ArrayList;
import java.util.Arrays;

class Sammlungen01 {
   static public void main(String[] sonja) {

      // Reihungen von String-Objekten, mit denen spaeter Sammlungen
      // initialisiert werden sollen:
      String[] sr01 = {"aa", "bb", "cc"};
      String[] sr02 = {"aa", "dd", "ee"};
      String[] sr03 = {"dd", "aa"};
      String[] sr04 = {"aa", "bb", "cc", "ff", "gg"};

      // Sammlungen (collection objects) werden erzeugt und mit
      // Hilfe von Reihungen initialisiert:
      Collection<String> c1 = new ArrayList<String>(Arrays.asList(sr01));
      Collection<String> c2 = new ArrayList<String>(Arrays.asList(sr02));
      Collection<String> c3 = new ArrayList<String>(Arrays.asList(sr03));
      Collection<String> c4 = new ArrayList<String>(Arrays.asList(sr04));

      // Die Sammlungen werden ausgegeben und bearbeitet. Die
      // Ergebnisse der Bearbeitung werden ebenfalls ausgegeben:
      pln("Sammlungen01: Jetzt geht es los!");
      pln("----------------------------------------------------");
      pln("A c1:                       " + c1);
      pln("B c2:                       " + c2);
      pln("C c3:                       " + c3);
      pln("D c4:                       " + c4);
      pln("----------------------------------------------------");
      pln("E c1.containsAll(c2):       " + c1.containsAll(c2));
      pln("F c2.containsAll(c3):       " + c2.containsAll(c3));
      pln("----------------------------------------------------");
      c1.addAll(c2);
      pln("G c1 nach c1.addAll   (c2): " + c1);

      c1.removeAll(c2);
      pln("H c1 nach c1.removeAll(c2): " + c1);

      c1.addAll(c2);
      pln("I c1 nach c1.addAll   (c2): " + c1);

      c1.retainAll(c4);
      pln("J c1 nach c1.retainAll(c4): " + c1);
      pln("----------------------------------------------------");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // Sammlungen01
/* ------------------------------------------------------------------------
Ausgabe des Programms Sammlungen01:

Sammlungen01: Jetzt geht es los!
----------------------------------------------------
A c1:                       [aa, bb, cc]
B c2:                       [aa, dd, ee]
C c3:                       [dd, aa]
D c4:                       [aa, bb, cc, ff, gg]
----------------------------------------------------
E c1.containsAll(c2):       false
F c2.containsAll(c3):       true
----------------------------------------------------
G c1 nach c1.addAll   (c2): [aa, bb, cc, aa, dd, ee]
H c1 nach c1.removeAll(c2): [bb, cc]
I c1 nach c1.addAll   (c2): [bb, cc, aa, dd, ee]
J c1 nach c1.retainAll(c4): [bb, cc, aa]
----------------------------------------------------
------------------------------------------------------------------------ */