// Datei Sammlungen03.java
/* ------------------------------------------------------------------------
Eine Sammlungklasse (collection class) ist eine Klasse, die die
Schnittstelle Collection implentiert. Ab Java 1.5 sind die Schnittstelle
Collection und alle Sammlungsklassen generisch (mit einem Typparameter
K, der fuer den Typ der Komponenten der Sammlung steht).

Wenn man eine Sammlung eines bestimmten Sammlungstyps ST1<K> hat, kann
man daraus (mithilfe eines geeigneten Konstruktors) eine Sammlung eines
anderen Sammlungstyps ST2<K> machen.
------------------------------------------------------------------------ */
import java.util.Collection;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.TreeSet;
import java.util.Vector;
import java.util.Arrays; // fuer asList

class Sammlungen03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {

      // Eine Reihung von Objekten (zum Initialisieren von c1):
      String[] sr = {"aa", "bb", "cc", "bb", "aa"};

      // Aus Sammlungen verschiedener Typen werden Sammlungen anderer
      // Typen erzeugt (in Form einer "Rundreise" von ArrayList ueber
      // LinkedList, Vector, TreeSet, LinkedHashSet zurueck zu ArrayList):
      Collection<String> cs1, cs2, cs3, cs4, cs5, cs6;
      cs1 = new     ArrayList<String>(Arrays.asList(sr)); //     ArrayList
      cs2 = new    LinkedList<String>(cs1); // ArrayList     --> LinkedList
      cs3 = new        Vector<String>(cs2); // LinkedList    --> Vector
      cs4 = new       TreeSet<String>(cs3); // Vector        --> TreeSet
      cs5 = new LinkedHashSet<String>(cs4); // TreeSet       --> LinkedHashSet
      cs6 = new     ArrayList<String>(cs5); // LinkedHashSet --> ArrayList
      // Achtung: Eine Menge (engl. set) darf keine Doppelgaenger enthalten.
      // Beim Uebergang von der Vector-Sammlung cs3 zur TreeSet-Sammlung cs4
      // gehen deshalb die Doppelgaenger "aa" und "bb" verloren.

      printf("Sammlungen03: Jetzt geht es los!%n");
      printf("-----------------------------------------------------------%n");
      printf("A Ein     ArrayList<String>-Objekt c1: %s%n", cs1);
      printf("B Ein    LinkedList<String>-Objekt c2: %s%n", cs2);
      printf("C Ein        Vector<String>-Objekt c3: %s%n", cs3);
      printf("D Ein       TreeSet<String>-Objekt c4: %s%n", cs4);
      printf("E Ein LinkedHashSet<String>-Objekt c5: %s%n", cs5);
      printf("F Ein     ArrayList<String>-Objekt c6: %s%n", cs6);
      printf("-----------------------------------------------------------%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // Sammlungen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Sammlungen03:

Sammlungen03: Jetzt geht es los!
-----------------------------------------------------------
A Ein     ArrayList<String>-Objekt c1: [aa, bb, cc, bb, aa]
B Ein    LinkedList<String>-Objekt c2: [aa, bb, cc, bb, aa]
C Ein        Vector<String>-Objekt c3: [aa, bb, cc, bb, aa]
D Ein       TreeSet<String>-Objekt c4: [aa, bb, cc]
E Ein LinkedHashSet<String>-Objekt c5: [aa, bb, cc]
F Ein     ArrayList<String>-Objekt c6: [aa, bb, cc]
-----------------------------------------------------------
------------------------------------------------------------------------ */