// Datei Sammlungen05.java
/* ------------------------------------------------------------------------
Die Methode subList wird in verschiedenen Zusammenhaengen auf Sammlungen
des Typs List<String> angewendet. Insbesondere werden die All-Methoden
removeAll und addAll in Kombination mit sublist angewendet.
------------------------------------------------------------------------ */
import java.util.Collection;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;

class Sammlungen05 {
   // ---------------------------------------------------------------------
   // Reihungen von String-Objekten, mit denen spaeter Sammlungen
   // initialisiert werden sollen:
   static String[] sr01 = {"aa", "bb", "cc", "dd"};
   static String[] sr02 = {"dd", "ee"};

   // Mit Hilfe der Reihungen werden unveraenderbare Sammlungen erzeugt:
   static List<String> s1 = new ArrayList<String>(Arrays.asList(sr01));
   static List<String> s2 = new ArrayList<String>(Arrays.asList(sr02));
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Auf die unveraenderbare Sammlung s1 werden nacheinander
      // verschiedene Methoden angewendet. Nach jeder Anwendung wird
      // ausgegeben, ob eine (und welche) Ausnahme ausgeloest wurde oder
      // ob keine Ausnahme ausgeloest wurde.

      pln("Sammlungen05: Jetzt geht es los!");

      pln("--------------------------------------------------------------");
      pln("A s1                            : " + s1);
      pln("B s2                            : " + s2);
      pln("--------------------------------------------------------------");
      pln("C s1.subList(1, 1)              : " + s1.subList(1, 1));
      pln("D s1.subList(1, 2)              : " + s1.subList(1, 2));
      pln("E s1.subList(1, 3)              : " + s1.subList(1, 3));
      pln("F s1.subList(2, 4)              : " + s1.subList(2, 4));
      pln("G s1.subList(0, s1.size())      : " + s1.subList(0, s1.size()));
      pln("--------------------------------------------------------------");
      pln("H s1 nach");
      p  ("I s1.removeAll(s2.subList(0, 2)): ");
             s1.removeAll(s2.subList(0, 2));
      pln(s1);
      p  ("J s1.addAll   (s2.subList(0, 2)): ");
             s1.addAll   (s2.subList(0, 2));
      pln(s1);
      pln("--------------------------------------------------------------");
      pln("K s1 nach");
      p  ("L s1.addAll   (s1.subList(0, 2)): ");
             s1.addAll   (s1.subList(0, 2));
      pln(s1);
      pln("--------------------------------------------------------------");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // Sammlungen05
/* ------------------------------------------------------------------------
Ausgabe des Programms Sammlungen05:

Sammlungen05: Jetzt geht es los!
--------------------------------------------------------------
A s1                            : [aa, bb, cc, dd]
B s2                            : [dd, ee]
--------------------------------------------------------------
C s1.subList(1, 1)              : []
D s1.subList(1, 2)              : [bb]
E s1.subList(1, 3)              : [bb, cc]
F s1.subList(2, 4)              : [cc, dd]
G s1.subList(0, s1.size())      : [aa, bb, cc, dd]
--------------------------------------------------------------
H s1 nach
I s1.removeAll(s2.subList(0, 2)): [aa, bb, cc]
J s1.addAll   (s2.subList(0, 2)): [aa, bb, cc, dd, ee]
--------------------------------------------------------------
K s1 nach
L s1.addAll   (s1.subList(0, 2)): [aa, bb, cc, dd, ee, aa, bb]
--------------------------------------------------------------
------------------------------------------------------------------------ */