// Datei Scanner02.java
/* ------------------------------------------------------------------------
Mit Hilfe eines Scanner-Objekts kann man unter anderem Ganzzahlen der
Typen byte, short, int oder long einlesen. Dabei muss man aber auf
"Mehrdeutigkeiten" wie die folgenden achten:

+---------------------+-------------------------------------------+
|      Die Eingabe    | kann eingelesen werden als Wert der Typen |
+---------------------+-------------------------------------------+
|-9223372036854775809 | float                                     |
|-9223372036854775808 | float, long                               |
|         -2147483649 | float, long                               |
|         -2147483648 | float, long, int                          |
|              -32769 | float, long, int                          |
|              -32768 | float, long, int, short                   |
|                -129 | float, long, int, short                   |
|                -128 | float, long, int, short, byte             |
|                   0 | float, long, int, short, byte             |
|                 127 | float, long, int, short, byte             |
|                 128 | float, long, int, short                   |
|               32767 | float, long, int, short                   |
|               32768 | float, long, int                          |
|          2147483647 | float, long, int                          |
|          2147483648 | float, long                               |
| 9223372036854775807 | float, long                               |
| 9223372036854775808 | float                                     |
+---------------------+-------------------------------------------+----- */
import java.util.Scanner;

class Scanner02 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("Scanner02: Jetzt geht es los!%n");
      printf("-----------------------------%n");

      Scanner scin = new Scanner(System.in);

      // Die folgende Schleife enthaelt eine Folge von if-Anweisungen:
      // if (scin.hasNextByte)  ...
      // if (scin.hasNextShort) ...
      // if (scin.hasNextInt)   ...
      // ...
      // Die Reihenfolge dieser if-Anweisungen ist ganz wesentlich
      // fuer das Funktionieren dieses Programms!

      while (true) {
         printf("Eine Ganzzahl (q zum Beenden): ");
         if        (scin.hasNextByte()) {
            int b = scin.nextByte();
            printf("Das war ein byte-Wert        : %d%n", b);
         } else if (scin.hasNextShort()) {
            short s = scin.nextShort();
            printf("Das war ein short-Wert       : %d%n", s);
         } else if (scin.hasNextInt()) {
            int i = scin.nextInt();
            printf("Das war ein int-Wert         : %d%n", i);
         } else if (scin.hasNextLong()) {
            long l = scin.nextLong();
            printf("Das war ein long-Wert        : %d%n", l);
         } else if (scin.hasNextFloat()) {
            float f = scin.nextFloat();
            printf("Das war ein float-Wert       : %.2g%n", f);
         } else if (scin.hasNext()) {
            String s = scin.next();
            printf("Das war ein String           : %s%n", s);
            if (s.equals("q")) break;
         }
      }

      printf("-----------------------------%n");
      printf("Scanner02: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Scanner02
/* ------------------------------------------------------------------------
Ein Dialog mit diesem Programm:

Scanner02: Jetzt geht es los!
-----------------------------
Eine Ganzzahl (q zum Beenden): -9223372036854775809
Das war ein float-Wert       : -9.2e+18
Eine Ganzzahl (q zum Beenden): -9223372036854775808
Das war ein long-Wert        : -9223372036854775808
Eine Ganzzahl (q zum Beenden): -2147483649
Das war ein long-Wert        : -2147483649
Eine Ganzzahl (q zum Beenden): -2147483648
Das war ein int-Wert         : -2147483648
Eine Ganzzahl (q zum Beenden): -32769
Das war ein int-Wert         : -32769
Eine Ganzzahl (q zum Beenden): -32768
Das war ein short-Wert       : -32768
Eine Ganzzahl (q zum Beenden): -129
Das war ein short-Wert       : -129
Eine Ganzzahl (q zum Beenden): -128
Das war ein byte-Wert        : -128
Eine Ganzzahl (q zum Beenden): 0
Das war ein byte-Wert        : 0
Eine Ganzzahl (q zum Beenden): 127
Das war ein byte-Wert        : 127
Eine Ganzzahl (q zum Beenden): 128
Das war ein short-Wert       : 128
Eine Ganzzahl (q zum Beenden): 32767
Das war ein short-Wert       : 32767
Eine Ganzzahl (q zum Beenden): 32768
Das war ein int-Wert         : 32768
Eine Ganzzahl (q zum Beenden): 2147483647
Das war ein int-Wert         : 2147483647
Eine Ganzzahl (q zum Beenden): 2147483648
Das war ein long-Wert        : 2147483648
Eine Ganzzahl (q zum Beenden): 9223372036854775807
Das war ein long-Wert        : 9223372036854775807
Eine Ganzzahl (q zum Beenden): 9223372036854775808
Das war ein float-Wert       : 9.2e+18
Eine Ganzzahl (q zum Beenden): q
Das war ein String           : q
-----------------------------
Scanner02: Das war's erstmal!
------------------------------------------------------------------------ */
