// Datei Scanner03.java
/* ------------------------------------------------------------------------
Mit einem Scanner-Objekt kann man Daten nicht nur von der Standardeingabe
(System.in), sondern aus einem beliebigen Readable-Objekt oder aus einem
String-Objekt lesen.

Ausserdem kann man Ganzzahlen nicht nur 10-er-Zahlen (Dezimalzahlen),
sondern auch 2-er-Zahlen, 3-er-, 4-er-, ..., 36-er-Zahlen einlesen.

Als Zeichen zur Darstellung von Zahlen wollte man nur die 10 Dezimalziffern
und die 26 Buchstaben verwenden (denn mit deren Reihenfolge sinde viele
Menschen vertraut). Deshalt ist die groesste zulaessige Basis gleich 36.
------------------------------------------------------------------------ */
import java.util.Scanner;

class Scanner03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("Scanner03: Jetzt geht es los!%n");
      printf("-----------------------------%n");
      printf("Character.MIN_RADIX: %2d%n", Character.MIN_RADIX);
      printf("Character.MAX_RADIX: %2d%n", Character.MAX_RADIX);
      printf("-----------------------------%n");

      // Jeder Eingabestring enthaelt eine Basis (als 10-er-Zahl notiert)
      // und eine Zahl im System mit dieser Basis.
      // Als Zusaetze snd erlaubt:
      // ein Vorzeichen Minus '-' vor der ersten Ziffer und
      // Trennzeichen zwischen 3-er-Gruppen von Ziffern (in DE: '.')
      String[] eingabe = {
         " 2         101",
         " 2 -11.111.111",
         " 5          40",
         " 5      -1.100",
         "10         789",
         "10     -12.345",
         "16         100",
         "16      -1.000",
         "20           j",
         "20         -J0",
         "36           z",
         "36         -20",

      };

      // Ein paar Ueberschriften ausgeben:
      printf("%-15s   %-10s%n", "Eingabe-", "Als"        );
      printf("%-15s   %-10s%n", "String:",  "10-er-Zahl:");
      printf("%n");

      // Jeden Eingeabestring mit einem Scanner-Objekt als int-Wert
      // "einlesen" und diesen Wert als 10-er-Zahl wieder ausgeben:
      for (String ein : eingabe) {
         Scanner sc    = new Scanner(ein);
         int     basis = sc.nextInt();
         int     zahl  = sc.nextInt(basis);
         printf("\"%15s\"  %,10d%n", ein, zahl);
      }

      printf("-----------------------------%n");
      printf("Scanner03: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Scanner03
/* ------------------------------------------------------------------------
Ausgabe:

Scanner03: Jetzt geht es los!
-----------------------------
Character.MIN_RADIX:  2
Character.MAX_RADIX: 36
-----------------------------
Eingabe-          Als
String:           10-er-Zahl:

"  2         101"           5
"  2 -11.111.111"        -255
"  5          40"          20
"  5      -1.100"        -150
" 10         789"         789
" 10     -12.345"     -12.345
" 16         100"         256
" 16      -1.000"      -4.096
" 20           j"          19
" 20         -J0"        -380
" 36           z"          35
" 36         -20"         -72
-----------------------------
Scanner03: Das war's erstmal!
------------------------------------------------------------------------ */
