// Datei Schleifen02.java
/* ------------------------------------------------------------------------
Ein Unterprogramm gibAus bearbeitet alle Komponenten einer Reihung mit
einer garantiert haltenden for-Schleife.
------------------------------------------------------------------------ */
class Schleifen02 {
   // ---------------------------------------------------------------------
   static void gibAus(int[] ir) {
      // Gibt alle Komponenten der Reihung ir lesbar aus.
      p("Eine int-Reihung mit " + ir.length + " Komponenten: ");
      // Der Java-Ausfuehrer garantiert: Die folgende for-Schleife
      // ist ("aufgrund ihrer Form") keine Endlosschleife:
      for (int komp: ir) { // Jede Komponente der Reihung ir wird
         p(komp + " ");    // bearbeitet (hier: ausgegeben).
      }
      pln();
   } // gibAus
   // ---------------------------------------------------------------------
   static int summe(int[] ir) {
      // Liefert die Summe aller Komponenten der Reihung ir.
      int erg = 0;
      for (int komp: ir) { // Jede Komponente der Reihung ir wird
         erg += komp;      // bearbeitet (hier: zu erg addiert)
      }
      return erg;
   } // summe
   // ---------------------------------------------------------------------
   static public void main(String[] susi) {
      pln("Schleifen02: Jetzt geht es los!");
      pln("-------------------------------");

      int[] ir01 = {30, 10, 20};
      int[] ir02 = {1, 2, 3, 4, 5};

      gibAus(ir01);
      gibAus(ir02);
      pln("summe(ir01): " + summe(ir01));
      pln("summe(ir02): " + summe(ir02));

      pln("-------------------------------");
      pln("Schleifen02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Schleifen02
/* ------------------------------------------------------------------------
Ausgabe des Programms Schleifen02:

Schleifen02: Jetzt geht es los!
-------------------------------
Eine int-Reihung mit 3 Komponenten: 30 10 20
Eine int-Reihung mit 5 Komponenten: 1 2 3 4 5
summe(ir01): 60
summe(ir02): 15
-------------------------------
Schleifen02: Das war's erstmal!
------------------------------------------------------------------------ */