// Datei Schleifen03.java
/* ------------------------------------------------------------------------
Demonstriert geschachtelte for-Schleifen. Ein Schachbrett (mit den
Feldbezeichnungen A1 bis H8 darin) wird in vier verschiedenen
"Orientierungen" ausgegeben. Jede Orientierung ist gegenueber der
vorhergehenden um 90 Grad im Uhrzeigersinn gedreht.

Dann werden zwei Bretter in gleicher Orientierung nebeninander ausgegeben.
Zum Schluss werden zwei Bretter in verschiedenen Orientierungen neben-
einander ausgegeben.

Im Initialisierungsteil einer for-Schleife darf man nicht nur *eine*
Variable vereinbaren, sondern im Prinzip *beliebig viele*, allerdings
muessen all diese Variablen zum selben Typ gehoeren. In der Methode
zweiBretter 12 wird von dieser Moeglichkeit Gebrauch gemacht.
------------------------------------------------------------------------ */
class Schleifen03 {
   // ---------------------------------------------------------------------
   static void schachBrett01() {
      pln("Ein Schachbrett in Orientierung 1:");
      for (char b='A'; b<='H'; b++) {
         for (char z='1'; z<='8'; z++) { //  +-  Geschach-
            p(b + (z + " "));            // -+   telte
         }                               //  +-  Schleife
         pln();
      }
   } // schachBrett01
   // ---------------------------------------------------------------------
   static void schachBrett02() {
      pln("Ein Schachbrett in Orientierung 2:");
      for (char z='1'; z<='8'; z++) {
         for (char b='H'; b>='A'; b--) {
            p(b + (z + " "));
         }
         pln();
      }
   } // schachBrett02
   // ---------------------------------------------------------------------
   static void schachBrett03() {
      pln("Ein Schachbrett in Orientierung 3:");
      for (char b='H'; b>='A'; b--) {
         for (char z='8'; z>='1'; z--) {
            p(b + (z + " "));
         }
         pln();
      }
   } // schachBrett03
   // ---------------------------------------------------------------------
   static void schachBrett04() {
      pln("Ein Schachbrett in Orientierung 4:");
      for (char z='8'; z>='1'; z--) {
         for (char b='A'; b<='H'; b++) {
            p(b + (z + " "));
         }
         pln();
      }
   } // schachBrett04
   // ---------------------------------------------------------------------
   static void zweiBretter11() {
      pln("Zwei Schachbretter in Orientierung 1:");
      for (char b='A'; b<='H'; b++) {
         for (char z='1'; z<='8'; z++) { // Eine Zeile von Brett1 ausgeben
            p(b + (z + " "));
         }

         p("  ");                        // Zum Trennen der beiden Bretter

         for (char z='1'; z<='8'; z++) { // Eine Zeile von Brett2 ausgeben
            p(b + (z + " "));
         }

         pln();
      }
   } // schachBrett11
   // ---------------------------------------------------------------------
   static void zweiBretter12() {
      pln("Zwei Schachbretter in Orientierung 1 und 2:");
      for (char b1='A', z2='1'; b1<='H'; b1++, z2++) {
         for (char z1='1'; z1<='8'; z1++) { // Eine Zeile von Brett1 ausgeben
            p(b1 + (z1 + " "));
         }

         p("  ");                           // Zum Trennen der beiden Bretter

         for (char b2='H'; b2>='A'; b2--) { // Eine Zeile von Brett2 ausgeben
            p(b2 + (z2 + " "));
         }

         pln();
      }
   } // schachBrett12
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("Schleifen03: Jetzt geht es los!");
      pln("-----------------------------------------");
      schachBrett01();
      pln("-----------------------------------------");
      schachBrett02();
      pln("-----------------------------------------");
      schachBrett03();
      pln("-----------------------------------------");
      schachBrett04();
      pln("-------------------------------------------------");
      zweiBretter11();
      pln("-------------------------------------------------");
      zweiBretter12();
      pln("-------------------------------------------------");
      pln("Schleifen03: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
} // class Schleifen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Schleifen03:

Schleifen03: Jetzt geht es los!
-----------------------------------------
Ein Schachbrett in Orientierung 1:
A1 A2 A3 A4 A5 A6 A7 A8
B1 B2 B3 B4 B5 B6 B7 B8
C1 C2 C3 C4 C5 C6 C7 C8
D1 D2 D3 D4 D5 D6 D7 D8
E1 E2 E3 E4 E5 E6 E7 E8
F1 F2 F3 F4 F5 F6 F7 F8
G1 G2 G3 G4 G5 G6 G7 G8
H1 H2 H3 H4 H5 H6 H7 H8
-----------------------------------------
Ein Schachbrett in Orientierung 2:
H1 G1 F1 E1 D1 C1 B1 A1
H2 G2 F2 E2 D2 C2 B2 A2
H3 G3 F3 E3 D3 C3 B3 A3
H4 G4 F4 E4 D4 C4 B4 A4
H5 G5 F5 E5 D5 C5 B5 A5
H6 G6 F6 E6 D6 C6 B6 A6
H7 G7 F7 E7 D7 C7 B7 A7
H8 G8 F8 E8 D8 C8 B8 A8
-----------------------------------------
Ein Schachbrett in Orientierung 3:
H8 H7 H6 H5 H4 H3 H2 H1
G8 G7 G6 G5 G4 G3 G2 G1
F8 F7 F6 F5 F4 F3 F2 F1
E8 E7 E6 E5 E4 E3 E2 E1
D8 D7 D6 D5 D4 D3 D2 D1
C8 C7 C6 C5 C4 C3 C2 C1
B8 B7 B6 B5 B4 B3 B2 B1
A8 A7 A6 A5 A4 A3 A2 A1
-----------------------------------------
Ein Schachbrett in Orientierung 4:
A8 B8 C8 D8 E8 F8 G8 H8
A7 B7 C7 D7 E7 F7 G7 H7
A6 B6 C6 D6 E6 F6 G6 H6
A5 B5 C5 D5 E5 F5 G5 H5
A4 B4 C4 D4 E4 F4 G4 H4
A3 B3 C3 D3 E3 F3 G3 H3
A2 B2 C2 D2 E2 F2 G2 H2
A1 B1 C1 D1 E1 F1 G1 H1
-------------------------------------------------
Zwei Schachbretter in Orientierung 1:
A1 A2 A3 A4 A5 A6 A7 A8   A1 A2 A3 A4 A5 A6 A7 A8
B1 B2 B3 B4 B5 B6 B7 B8   B1 B2 B3 B4 B5 B6 B7 B8
C1 C2 C3 C4 C5 C6 C7 C8   C1 C2 C3 C4 C5 C6 C7 C8
D1 D2 D3 D4 D5 D6 D7 D8   D1 D2 D3 D4 D5 D6 D7 D8
E1 E2 E3 E4 E5 E6 E7 E8   E1 E2 E3 E4 E5 E6 E7 E8
F1 F2 F3 F4 F5 F6 F7 F8   F1 F2 F3 F4 F5 F6 F7 F8
G1 G2 G3 G4 G5 G6 G7 G8   G1 G2 G3 G4 G5 G6 G7 G8
H1 H2 H3 H4 H5 H6 H7 H8   H1 H2 H3 H4 H5 H6 H7 H8
-------------------------------------------------
Zwei Schachbretter in Orientierung 1 und 2:
A1 A2 A3 A4 A5 A6 A7 A8   H1 G1 F1 E1 D1 C1 B1 A1
B1 B2 B3 B4 B5 B6 B7 B8   H2 G2 F2 E2 D2 C2 B2 A2
C1 C2 C3 C4 C5 C6 C7 C8   H3 G3 F3 E3 D3 C3 B3 A3
D1 D2 D3 D4 D5 D6 D7 D8   H4 G4 F4 E4 D4 C4 B4 A4
E1 E2 E3 E4 E5 E6 E7 E8   H5 G5 F5 E5 D5 C5 B5 A5
F1 F2 F3 F4 F5 F6 F7 F8   H6 G6 F6 E6 D6 C6 B6 A6
G1 G2 G3 G4 G5 G6 G7 G8   H7 G7 F7 E7 D7 C7 B7 A7
H1 H2 H3 H4 H5 H6 H7 H8   H8 G8 F8 E8 D8 C8 B8 A8
-------------------------------------------------
Schleifen03: Das war's erstmal!
------------------------------------------------------------------------ */
