// Datei SeitenFormat.java
/* ------------------------------------------------------------------------
Jedes Objekt dieser Klasse enthaelt die Breite und die Laenge einer Seite.
Die Objekte sind veraenderbar.
------------------------------------------------------------------------ */
class SeitenFormat implements Veraenderbar {
   private double breite;
   private double laenge;

   public SeitenFormat(double breite, double laenge) {
      this.breite = breite;
      this.laenge = laenge;
   } // Konstruktor SeitenFormat

   // Die 4 Methoden der Schnittstelle Veraenderbar (verdopple,
   // verdreifache, halbiere und aendere) werden hier implementiert:
   public void verdopple()    {breite *= 2.0; laenge *= 2.0;}
   public void verdreifache() {breite *= 3.0; laenge *= 3.0;}

   public void halbiere()     {breite /= 2.0; laenge /= 2.0;}
   // ---------------------------------------------------------------------
   public void aendere(int prozent) {
      if (prozent < 0) {
         prozent = -prozent;
         printf("-------------------------------------------%n");
         printf("Negativer Param. -" + prozent + " fuer Methode%n");
         printf("aendere in Klasse SeitenFormat ist verboten%n");
         printf("und wurde durch  +" + prozent + " ersetzt!%n");
         printf("-------------------------------------------%n");
      } // if

      breite = (breite * prozent) / 100;
      laenge = (laenge * prozent) / 100;
   } // aendere
   // ---------------------------------------------------------------------
   // Eine zusaetzliche ("freiwillig programmierte") Methode:
   public String toString() {
      return "SeitenFormat " + breite + " mal " + laenge + " mm";
   } // toString
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class SeitenFormat