// Datei Serial05.java
/* ------------------------------------------------------------------------
Eine Reihung ist ein Objekt und kann somit mit einem einzigen writeObject-
Befehl in einen Strom des Typs ObjectOutputStream geschrieben bzw. mit
einem einzigen readObject-Befehl aus einem Strom des Typs ObjectInputStream
gelesen werden.
------------------------------------------------------------------------ */
import java.io  .IOException;
import java.io  .FileNotFoundException;
import java.io  .File;
import java.io  .FileInputStream;
import java.io  .FileOutputStream;
import java.io  .ObjectInputStream;
import java.io  .ObjectOutputStream;
import java.io  .Serializable;
import java.lang.ClassNotFoundException; // Zur Dokumentation
// ------------------------------------------------------------------------
// Eine Reihung von Artikel-Objekten wird ("serialisiert" und) in einen
// Objekt-Ausgabestrom geschrieben und spaeter aus einem Objekt-Eingabe-
// Strom wieder eingelesen.
class Artikel implements Serializable {
   // Jedes Objekt dieser Klasse beschreibt einen Artikel (seine
   // bezeichnung und die anzahl, in der er momentan vorhanden ist)
   String bezeichnung;
   int    anzahl;

   public String toString() {
      return "Bez.: " + bezeichnung + ", Anz.: " + anzahl;
   } // toString

   Artikel(String bezeichnung, int anzahl) {
      this.bezeichnung = bezeichnung;
      this.anzahl      = anzahl;
   } // Konstruktor Artikel
} // Artikel
// ------------------------------------------------------------------------
class Serial05 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) throws
      FileNotFoundException,
      IOException,
      ClassNotFoundException
   {
      // Eine Reihung von Artikel-Objekten:
      Artikel[] tabVorher = {
         new Artikel("Knoepfe", 65),
         new Artikel("Socken ", 17),
         new Artikel("Hemden ", 24)
      };
      // ------------------------------------------------------------------
      // Die Reihung tabVorher augeben:
      pln("-----------------------");
      pln("Die Reihung tabVorher: ");
      for (Artikel a: tabVorher) pln(a);

      String pfad  = "Serial05.tmp";
      File   dat01 = new File(pfad);

      // Zwei Ausgabestroeme und eine Datei erzeugen und zusmmenfuegen:
      FileOutputStream    fos = new FileOutputStream  (dat01);
      ObjectOutputStream  oos = new ObjectOutputStream(fos);
      // Datenfluss: Datei Serial05.tmp <-- fos <-- oos <-- Programm

      // Die Reihung tabVorher in die Datei schreiben:
      oos.writeObject(tabVorher);

      oos.close();
      // ------------------------------------------------------------------
      // Zwei Eingabestroeme erzeugen und mit der Datei verbinden:
      FileInputStream   fis = new FileInputStream  (dat01);
      ObjectInputStream ois = new ObjectInputStream(fis);
      // Datenfluss: Datei Serial05.tmp --> fis --> ois --> Programm

      // Eine Reihung aus der Datei in die Variable tabNachher lesen:
      Artikel[] tabNachher = (Artikel[]) ois.readObject();

      // Die Reihung tabNachher augeben:
      pln("-----------------------");
      pln("Die Reihung tabNachher:");
      for (Artikel a: tabNachher) pln(a);

      ois.close();
      dat01.delete(); // Die Datei dat01 loeschen

      pln("-----------------------");
      pln("Serial05: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
} // class Serial05
/* ------------------------------------------------------------------------
Ausgabe des Progrmms Serial05 zur Standardausgabe (Bildschirm):

-----------------------
Die Reihung tabVorher:
Bez.: Knoepfe, Anz.: 65
Bez.: Socken , Anz.: 17
Bez.: Hemden , Anz.: 24
-----------------------
Die Reihung tabNachher:
Bez.: Knoepfe, Anz.: 65
Bez.: Socken , Anz.: 17
Bez.: Hemden , Anz.: 24
-----------------------
Serial05: Das war's erstmal!
===========================================================================
Inhalt der Datei Serial05 (in hexadezimaler Darstellung):

000000  AC ED 00 05  75 72 00 0A  5B 4C 41 72  74 69 6B 65  ..ur..[LArtike
000010  6C 3B 57 39  A4 BD 1D EE  14 11 02 00  00 78 70 00  l;W9......xp.
000020  00 00 03 73  72 00 07 41  72 74 69 6B  65 6C C6 B3  ...sr..ArtikelƳ
000030  E8 98 56 25  8F 4D 02 00  02 49 00 06  61 6E 7A 61  V%.M...I..anza
000040  68 6C 4C 00  0B 62 65 7A  65 69 63 68  6E 75 6E 67  hlL..bezeichnung
000050  74 00 12 4C  6A 61 76 61  2F 6C 61 6E  67 2F 53 74  t..Ljava/lang/St
000060  72 69 6E 67  3B 78 70 00  00 00 41 74  00 07 4B 6E  ring;xp...At..Kn
000070  6F 65 70 66  65 73 71 00  7E 00 02 00  00 00 11 74  oepfesq.~......t
000080  00 07 53 6F  63 6B 65 6E  20 73 71 00  7E 00 02 00  ..Socken sq.~...
000090  00 00 18 74  00 07 48 65  6D 64 65 6E  20           ...t..Hemden
------------------------------------------------------------------------ */