// Datei Sieb01.java
/* ------------------------------------------------------------------------
Dieses Programm ermittelt Primzahlen (Sieb des Eratosthenes)
------------------------------------------------------------------------ */
import java.util.BitSet;

class Sieb01 {
   // ---------------------------------------------------------------------
   static BitSet hatTeiler;
   // ---------------------------------------------------------------------
   static public void siebe(int n) {
      hatTeiler = new BitSet(n);
      hatTeiler.set(0);
      hatTeiler.set(1);
      int prim = 1; // 1 vor der kleinsten Primzahl

      while (true) {
         prim = hatTeiler.nextClearBit(prim+1);
//       while (hatTeiler.get(++prim) && prim < n-1) ;
         if (prim >= n-1) break;
//       printf("%10d", prim);

         int ind;
         for (int faktor = 2; (ind = faktor*prim) < n; faktor++) {
            hatTeiler.set(ind);
         }
      }

      int size = hatTeiler.size();
      int card = hatTeiler.cardinality();

      printf("hatTeiler.size()       : %10d%n", size);
      printf("hatTeiler.cardinality(): %10d%n", card);
      printf("Differenz              : %10d%n", size-card);
      printf("%n");
   } // siebe
   // ---------------------------------------------------------------------
   static public void gibAusDieGroessten(int size, int anz) {

      int ind = size;
      if (ind < 3) {
         printf("gatTeiler.size() ( %d) ist zu klein!%n", hatTeiler.size());
         return;
      }
      while (anz-- > 0) {
         while (hatTeiler.get(--ind) && ind>0);
         if (ind == 0) break;
         printf("Nr: %2d: %11d%n", anz+1, ind);
      }
   }

   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("Sieb01: Jetzt geht es los!%n");
      printf("--------------------------%n");
      final int BIS = 4096 * 4096;
      siebe             (BIS);
      gibAusDieGroessten(BIS, 10);

/*
      for (int max=100; max < 200; max++) {
         printf("---------------------------------------");
         siebe(max);
      }
*/
      printf("--------------------------%n");
      printf("Sieb01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Sieb01
/* ------------------------------------------------------------------------
Ausgabe des Programms Sieb01:

Sieb01: Jetzt geht es los!
--------------------------
hatTeiler.size()       :   16777216
hatTeiler.cardinality():   15699345
Differenz              :    1077871

Nr: 10:    16777213
Nr:  9:    16777199
Nr:  8:    16777183
Nr:  7:    16777153
Nr:  6:    16777141
Nr:  5:    16777139
Nr:  4:    16777127
Nr:  3:    16777121
Nr:  2:    16777099
Nr:  1:    16777049
--------------------------
Sieb01: Das war's erstmal!
------------------------------------------------------------------------ */
