// Datei Stapel01.java
/* ------------------------------------------------------------------------
Informationen darueber, welche Methoden er schon begonnen, aber noch nicht
fertig ausgefuehrt hat, verwaltet der Ausfuehrer auf einem sogenannten
Stapel (engl. stack). Wenn er mit der Ausfuehrung einer Methode beginnt,
legt er bestimmte Informationen ueber die Methode auf den Stapel. Wenn
er die Ausfuehrung der Methode beendet, entfernt er diese Informationen
wieder vom Stapel.

Dieses Programm verwaltet und "zeigt" ein stark vereinfachtes Modell des
"richtigen Stapels", den der Ausfuehrer benutzt. Hier werden nur die Namen
der Methoden auf den Modellstapel gelegt (mit dem Befehl push) bzw. vom
Modellstapel entfernt (mit dem Befehl pop).
------------------------------------------------------------------------ */
import java.util.Stack;

class Stapel01 {
   // Der Modellstapel stapel ist anfangs leer:
   static Stack<String> stapel = new Stack<String>();
   // -----------------------------------------------------------
   static public void main(String [] sonja) {
      pln("Stapel01: Jetzt geht es los!");
      pln("----------------------------");
      stapel.push("main"); // "main" wird auf den stapel gelegt
      pln (stapel);
      metB();
      pln (stapel);
      metA();
      pln (stapel);
      stapel.pop();        // "main" wird vom stapel entfernt
      pln("----------------------------");
      pln("Stapel01: Das war's erstmal!");
   } // main
   // -----------------------------------------------------------
   static void metA() {
      stapel.push("metA"); // "metA" wird auf den stapel gelegt
      pln (stapel);
      metB();
      pln (stapel);
      metB();
      pln (stapel);
      stapel.pop();        // "metA" wird vom stapel entfernt
   } // metA
   // -----------------------------------------------------------
   static void metB() {
      stapel.push("metB"); // "metB" wird auf den stapel gelegt
      pln(stapel);
      stapel.pop();        // "metB" wird vom stapel entfernt
   } // metB
   // -----------------------------------------------------------
   static int nr = 1;
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {
      System.out.println("Stapelzustand " + nr++ + ": " + ob);
   } // pln
   static void pln(String s) {
      System.out.println(s);
   } // pln
   // ---------------------------------------------------------------------
} // Stapel01
/* ------------------------------------------------------------------------
Ausgabe des Programms Stapel01:

Stapel01: Jetzt geht es los!
----------------------------
Stapelzustand 1: [main]
Stapelzustand 2: [main, metB]
Stapelzustand 3: [main]
Stapelzustand 4: [main, metA]
Stapelzustand 5: [main, metA, metB]
Stapelzustand 6: [main, metA]
Stapelzustand 7: [main, metA, metB]
Stapelzustand 8: [main, metA]
Stapelzustand 9: [main]
----------------------------
Stapel01: Das war's erstmal!
------------------------------------------------------------------------ */