// Datei String02.java
/* ------------------------------------------------------------------------
Zeigt
wie man String-Objekte vereinbaren und initialisieren kann,
wie man die Laenge eines Strings ermittelt (mit length)
wie man auf einzelne Zeichen eines Strings zugreift (mit charAt)
wie man auf Teilstrings eines Strings zugreift (mit substring)
wie man prueft, ob ein String einen bestimmten Teilstring enthaelt
    (mit startsWith, endsWith und contains)
wie man ermittelt, wo in einem String (bei welchem Index) ein
    bestimmtes Zeichen oder ein bestimmter Teilstring steht bzw.
    beginnt (mit indexOf und lastIndexOf)
wie man veraenderte Kopien eines Strings erzeugt (mit replace,
    toUpperCase und toLowerCase).
------------------------------------------------------------------------ */
class String02 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      // ------------------------------------------------------------------
      // Ein paar String-Objekte auf verschiedene Weise vereinbaren
      // (weitere Moeglichkeiten findet man im Programm String02)
      String s11;                      // Ausfuehrer initialisiert mit null
      String s12 = "Hallo Sonja!";
      String s13 = new String(" Wie geht's?");
      String s14 = new String(s12 + s13 + " Gut!");
      String s15 = new String("Catamantaloedis");

      pln("--------------------------------------------------------------");
      // Die Laenge eines Strings ermitteln (mit der Methode length):
      pln("A s12                          : "   + s12);
      pln("B s12.length()                 : "   + s12.length());
      pln("--------------------------------------------------------------");
      // Auf einzelne Zeichen eines Strings zugreifen (mit der
      // Methode charAt):
      pln("C s12.charAt(0)                : "   + s12.charAt(0));
      pln("D s12.charAt(11)               : "   + s12.charAt(11));
      pln("E s12.charAt(s12.length()-1)   : "   + s12.charAt(s12.length()-1));

      // Die Anzahl der Grossbuchstaben in einem String ermitteln
      // (mit der Methode charAt):
      int anzGrossBuchstaben = 0;
      for (int i=0; i<s12.length(); i++) {
         char c = s12.charAt(i);
         if ('A' <= c && c <= 'Z') anzGrossBuchstaben++;
      } // for i

      pln("F Anzahl Grossbuchstaben in s12: "   + anzGrossBuchstaben);
      pln("--------------------------------------------------------------");
      // Auf Teilstrings eines Strings zugreifen (mit der Methode
      // substring). Gibt man 2 Indizes als Parameter an (z. B.
      // substring(6, 11) ) dann ist der Teilstring vom Index 6
      // (einschliesslich) bis zum Index 11 (ausschliesslich!) gemeint.
      pln("G s12.substring(6):            : "   + s12.substring(6));
      pln("H s12.substring(6, 11):        : "   + s12.substring(6, 11));
      pln("I s12.substring(0, 7):         : "   + s12.substring(0, 7));

      for (int bis=7; bis<=s12.length(); bis+=2) {
         pln("J " + s12.substring(0, bis));
      }
      pln("--------------------------------------------------------------");
      // Pruefen, ob ein String mit einem bestimmten Teilstring beginnt
      // bzw. endet (mit den Methoden startsWith und endsWith):
      pln("K s14                          : "   + s14);
      pln("L s14.startsWith(\"Hall\")       : " + s14.startsWith("Hall"));
      pln("M s14.startsWith(\"hall\")       : " + s14.startsWith("hall"));
      pln("N s14.startsWith(s12)          : "   + s14.startsWith(s12));
      pln("O s14.endsWith(\"Gut!\")         : " + s14.endsWith("Gut!"));
      pln("P s14.endsWith(\"Gut\")          : " + s14.endsWith("Gut"));
      pln("--------------------------------------------------------------");
      // Pruefen, ob ein String einen bestimmten Teilstring enthaelt
      // (mit der Methode contains):
      pln("Q s14.contains(\"Sonja\")        : " + s14.contains("Sonja"));
      pln("R s14.contains(\"wie\")          : " + s14.contains("wie"));
      pln("--------------------------------------------------------------");
      // Ermitteln, wo in einem String (bei welchem Index) ein bestimmtes
      // Zeichen steht (mit den Methoden indexOf und lastIndexOf):
      pln("S s15                          : "   + s15);
      pln("T s15.    indexOf('a')         : "   + s15.    indexOf('a')    );
      pln("U s15.lastIndexOf('a')         : "   + s15.lastIndexOf('a')    );
      pln("V s15.    indexOf('a',  2)     : "   + s15.    indexOf('a',  2));
      pln("W s15.lastIndexOf('a',  4)     : "   + s15.lastIndexOf('a',  4));
      pln("X s15.    indexOf('x')         : "   + s15.    indexOf('x')    );
      pln("Y s15.lastIndexOf('x')         : "   + s15.lastIndexOf('x')    );
      pln("--------------------------------------------------------------");
      // Ermitteln, wo in einem String (bei welchem Index) ein bestimmter
      // Teilstring beginnt (mit den Methoden indexOf und lastIndexOf):
      pln("Z s15.    indexOf(\"ta\")        : " + s15.    indexOf("ta")   );
      pln("a s15.lastIndexOf(\"ta\")        : " + s15.lastIndexOf("ta")   );
      pln("b s15.    indexOf(\"ta\", 3)     : " + s15.    indexOf("ta", 3));
      pln("c s15.lastIndexOf(\"ta\", 6)     : " + s15.lastIndexOf("ta", 6));
      pln("d s15.    indexOf(\"xy\")        : " + s15.    indexOf("xy")   );
      pln("e s15.lastIndexOf(\"xy\")        : " + s15.lastIndexOf("xy")   );
      pln("------------------------------------------------");
      // Veraenderte Kopien eines Strings erzeugen (mit den Methoden
      // replace, toUpperCase und toLowerCase):
      pln("f s15.replace('a', 'i')        : "   + s15.replace('a', 'i'));
      pln("g s15.replace('a', 'o')        : "   + s15.replace('a', 'o'));
      pln("h s15.toUpperCase()            : "   + s15.toUpperCase());
      pln("i s15.toLowerCase()            : "   + s15.toLowerCase());
      pln("------------------------------------------------");
      pln("String02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class String02
/* ------------------------------------------------------------------------
Ausgabe des Programms String02:

--------------------------------------------------------------
A s12                          : Hallo Sonja!
B s12.length()                 : 12
--------------------------------------------------------------
C s12.charAt(0)                : H
D s12.charAt(11)               : !
E s12.charAt(s12.length()-1)   : !
F Anzahl Grossbuchstaben in s12: 2
--------------------------------------------------------------
G s12.substring(6):            : Sonja!
H s12.substring(6, 11):        : Sonja
I s12.substring(0, 7):         : Hallo S
J Hallo S
J Hallo Son
J Hallo Sonja
--------------------------------------------------------------
K s14                          : Hallo Sonja! Wie geht's? Gut!
L s14.startsWith("Hall")       : true
M s14.startsWith("hall")       : false
N s14.startsWith(s12)          : true
O s14.endsWith("Gut!")         : true
P s14.endsWith("Gut")          : false
--------------------------------------------------------------
Q s14.contains("Sonja")        : true
R s14.contains("wie")          : false
--------------------------------------------------------------
S s15                          : Catamantaloedis
T s15.    indexOf('a')         : 1
U s15.lastIndexOf('a')         : 8
V s15.    indexOf('a',  2)     : 3
W s15.lastIndexOf('a',  4)     : 3
X s15.    indexOf('x')         : -1
Y s15.lastIndexOf('x')         : -1
--------------------------------------------------------------
Z s15.    indexOf("ta")        : 2
a s15.lastIndexOf("ta")        : 7
b s15.    indexOf("ta", 3)     : 7
c s15.lastIndexOf("ta", 6)     : 2
d s15.    indexOf("xy")        : -1
e s15.lastIndexOf("xy")        : -1
------------------------------------------------
f s15.replace('a', 'i')        : Citimintiloedis
g s15.replace('a', 'o')        : Cotomontoloedis
h s15.toUpperCase()            : CATAMANTALOEDIS
i s15.toLowerCase()            : catamantaloedis
------------------------------------------------
String02: Das war's erstmal!
------------------------------------------------------------------------ */