// Datei String04.java
/* ------------------------------------------------------------------------
Zeigt, wie man String-Objekte miteinander vergleichen kann. Einige
der Ergebnisse sind moeglicherweise ueberraschend und merkwuerdig.

Die Operationen == und != (Gleich und Ungleich) vergleichen immer
die Werte ihrer Operanden (und nicht ihre Zielwerte!).

Die Objektmethode equals eines String-Objekts vergleicht die
Zielwerte ihrer Parameter (nicht die Werte!).

Die Objektmethode equalsIgnoreCase eines String-Objekts vergleicht die
Zielwerte ihrer Parameter (nicht die Werte!), ohne grosse und kleine
Buchstaben zu unterscheiden.

Die Objektmethode compareTo eines String-Objekts vergleicht die
Zielwerte ihrer Parameter (nicht die Werte!). Sie liefert als Ergebnis
keinen boolean-Wert, sondern einen int-Wert. Ein Ausdruck wie
s1.compareTo(s2) hat einen negativen Wert, den Wert 0 bzw. einen
positiven Wert je nachdem ob s1 kleiner, gleich oder groesser ist als s2.

Wenn man zwei String-Variablen ohne new und mit demselben Literal
initialisiert (z. B. mit dem Literal "Hallo!", wie die Variablen s31
und s32 in diesem Programm), bekommen sie automatisch gleiche Werte
und zeigen damit auf dasselbe String-Objekt.

Wenn man eine String-Variable mit new initialisiert, bekommt sie
garantiert einen anderen Wert als alle anderen (String-) Variablen
(auch wenn sie den gleichen Zielwert hat wie andere String-Variablen).
------------------------------------------------------------------------ */
class String04 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      String s31 =            "Hallo!";  // ohne new initialisiert
      String s32 =            "Hallo!";  // ohne new initialisiert
      String s33 = new String("Hallo!"); // mit  new initialisiert
      String s34 = new String("Hallo!"); // mit  new initialisiert
      String s35 = new String("HALLO!"); // mit  new initialisiert
      String s36 = new String("hallo!"); // mit  new initialisiert
      String s37 = null;
      String s38 = s31.substring(0, 5);

      pln("----------------------------------------");
      pln("A  s31 : " + s31 + " (ohne new initialisiert)");
      pln("B  s32 : " + s32 + " (ohne new initialisiert)");
      pln("C  s33 : " + s33 + " ( mit new initialisiert)");
      pln("D  s34 : " + s34 + " ( mit new initialisiert)");
      pln("E  s35 : " + s35 + " ( mit new initialisiert)");
      pln("F  s36 : " + s36 + " ( mit new initialisiert)");
      pln("G  s37 : " + s37                              );
      pln("----------------------------------------");
      pln("H (s31 == s32)                : " + (s31 == s32));
      pln("I (s32 == s33)                : " + (s32 == s33));
      pln("J (s33 == s34)                : " + (s33 == s34));
      pln("K (s34 == s35)                : " + (s34 == s35));
      pln("L (s35 == s36)                : " + (s35 == s36));
      pln("M (s36 == s37)                : " + (s36 == s37));
      pln("N (s37 == s36)                : " + (s37 == s36));
      pln("----------------------------------------");
      pln("O  s31.equals(s32)            : " +  s31.equals(s32));
      pln("P  s32.equals(s33)            : " +  s32.equals(s33));
      pln("Q  s33.equals(s34)            : " +  s33.equals(s34));
      pln("R  s34.equals(s35)            : " +  s34.equals(s35));
      pln("S  s35.equals(s36)            : " +  s35.equals(s36));
      pln("T  s36.equals(s37)            : " +  s36.equals(s37));
//    pln("U  s37.equals(s36)            : " +  s37.equals(s36));
      pln("----------------------------------------");
      pln("V (s31.equalsIgnoreCase(s32)) : " +  s31.equalsIgnoreCase(s32));
      pln("W (s32.equalsIgnoreCase(s33)) : " +  s32.equalsIgnoreCase(s33));
      pln("X (s33.equalsIgnoreCase(s34)) : " +  s33.equalsIgnoreCase(s34));
      pln("Y (s34.equalsIgnoreCase(s35)) : " +  s34.equalsIgnoreCase(s35));
      pln("Z (s35.equalsIgnoreCase(s36)) : " +  s35.equalsIgnoreCase(s36));
      pln("a (s36.equalsIgnoreCase(s37)) : " +  s36.equalsIgnoreCase(s37));
//    pln("b (s37.equalsIgnoreCase(s36)) : " +  s37.equalsIgnoreCase(s36));
      pln("----------------------------------------");
      pln("c (s31.compareTo(\"H\"))        : " +  s31.compareTo("H"));
      pln("d (s31.compareTo(\"Ha\"))       : " +  s31.compareTo("Ha"));
      pln("e (s31.compareTo(\"Hal\"))      : " +  s31.compareTo("Hal"));
      pln("f (s31.compareTo(\"Hall\"))     : " +  s31.compareTo("Hall"));
      pln("g (s31.compareTo(\"Hallo\"))    : " +  s31.compareTo("Hallo"));
      pln("h (s31.compareTo(\"Hallo!\"))   : " +  s31.compareTo("Hallo!"));
      pln("i (s31.compareTo(\"Hallo!a\"))  : " +  s31.compareTo("Hallo!a"));
      pln("j (s31.compareTo(\"Hallo!ab\")) : " +  s31.compareTo("Hallo!ab"));
      pln("k (s31.compareTo(\"Hallo!abc\")): " +  s31.compareTo("Hallo!abc"));
      pln("----------------------------------------");
      pln("l (s31.compareTo(\"Halll\"))    : " +  s31.compareTo("Halll"));
      pln("m (s31.compareTo(\"Hallm\"))    : " +  s31.compareTo("Hallm"));
      pln("n (s31.compareTo(\"Halln\"))    : " +  s31.compareTo("Halln"));
      pln("o (s31.compareTo(\"Hallo\"))    : " +  s31.compareTo("Hallo"));
      pln("p (s31.compareTo(\"Hallp\"))    : " +  s31.compareTo("Hallp"));
      pln("q (s31.compareTo(\"Hallq\"))    : " +  s31.compareTo("Hallq"));
      pln("r (s31.compareTo(\"Hallr\"))    : " +  s31.compareTo("Hallr"));
      pln("----------------------------------------");
      pln("s (s31 == s31.substring(0, 6)): " + (s31 == s31.substring(0, 6)));
      pln("t (s38 == s31.substring(0, 5)): " + (s38 == s31.substring(0, 5)));
      pln("----------------------------------------");
//    pln("u (s31.compareTo(s37)         : " + s31.compareTo(s37));
//    pln("v (s37.compareTo(s31)         : " + s37.compareTo(s31));

      pln("String04: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class String04
/* ------------------------------------------------------------------------
Ausgabe des Programms String04:

----------------------------------------
A  s31 : Hallo! (ohne new initialisiert)
B  s32 : Hallo! (ohne new initialisiert)
C  s33 : Hallo! ( mit new initialisiert)
D  s34 : Hallo! ( mit new initialisiert)
E  s35 : HALLO! ( mit new initialisiert)
F  s36 : hallo! ( mit new initialisiert)
G  s37 : null
----------------------------------------
H (s31 == s32)                : true
I (s32 == s33)                : false
J (s33 == s34)                : false
K (s34 == s35)                : false
L (s35 == s36)                : false
M (s36 == s37)                : false
N (s37 == s36)                : false
----------------------------------------
O  s31.equals(s32)            : true
P  s32.equals(s33)            : true
Q  s33.equals(s34)            : true
R  s34.equals(s35)            : false
S  s35.equals(s36)            : false
T  s36.equals(s37)            : false
----------------------------------------
V (s31.equalsIgnoreCase(s32)) : true
W (s32.equalsIgnoreCase(s33)) : true
X (s33.equalsIgnoreCase(s34)) : true
Y (s34.equalsIgnoreCase(s35)) : true
Z (s35.equalsIgnoreCase(s36)) : true
a (s36.equalsIgnoreCase(s37)) : false
----------------------------------------
c (s31.compareTo("H"))        : 5
d (s31.compareTo("Ha"))       : 4
e (s31.compareTo("Hal"))      : 3
f (s31.compareTo("Hall"))     : 2
g (s31.compareTo("Hallo"))    : 1
h (s31.compareTo("Hallo!"))   : 0
i (s31.compareTo("Hallo!a"))  : -1
j (s31.compareTo("Hallo!ab")) : -2
k (s31.compareTo("Hallo!abc")): -3
----------------------------------------
l (s31.compareTo("Halll"))    : 3
m (s31.compareTo("Hallm"))    : 2
n (s31.compareTo("Halln"))    : 1
o (s31.compareTo("Hallo"))    : 1
p (s31.compareTo("Hallp"))    : -1
q (s31.compareTo("Hallq"))    : -2
r (s31.compareTo("Hallr"))    : -3
----------------------------------------
s (s31 == s31.substring(0, 6)): true
t (s38 == s31.substring(0, 5)): false
----------------------------------------
String04: Das war's erstmal!
---------------------------------------------------------------------------
Fehlermeldungen waehrend der Ausfuehrung des Programms, wenn die ent-
sprchenden Zeilen keine Kommentare sind:

Exception in thread "main" java.lang.NullPointerException
   at String04.main(String04.java:67)

Exception in thread "main" java.lang.NullPointerException
   at String04.main(String04.java:75)

Exception in thread "main" java.lang.NullPointerException
   at java.lang.String.compareTo(String.java:998)
   at String04.main(String04.java:98)

Exception in thread "main" java.lang.NullPointerException
   at String04.main(String04.java:99)
------------------------------------------------------------------------ */