// Datei String05.java
/* ------------------------------------------------------------------------
Der Unicode umfasst etwa 60 Tausend 16-Bit-Codezahlen fuer haeufig ver-
wendete Zeichen und etwa eine Million 32-Bit-Codezahlen fuer seltener
verwendete Zeichen. In einem Java-Programm werden die 16-Bit-Codezahlen
durch *einen* und die 32-Bit-Codezahlen durch *zwei* char-Werte darge-
stellt.

Ist s ein String-Objekt so bezeichnet
s.length()                      die Anzahl der char-Werte und
s.codePointCount(0, s.length()) die Anzahl der Unicode-Zeichen,
die der String s enthaelt. Falls der String Zeichen mit 32-Bit-Code-
zahlen enthaelt, stimmen die beiden Anzahlen nicht ueberein, wie dieses
Programm zeigen soll.

Zwei char-Werte, die gemeinsam *ein* Zeichen (mit einer 32-Bit-Codezahl)
darstellen, werden auch als Surrogat-Paar bezeichnet. Der erste Wert
eines solchen Paares muss aus dem Bereich D800 bis DBFF und der zweite
aus dem Bereich DC00 bis DFFF stammen. Jeder dieser Bereiche umfasst
1024 Werte, insgesamt gibt es also 1024 * 1024 Surrogat-Paare.
------------------------------------------------------------------------ */
class String05 {
   // ---------------------------------------------------------------------
   static public void gibLaengeUndAnzahlZeichenAus(String s, String name) {
      // Gibt die Anzahl der char-Werte und die Anzahl der Zeichen
      // im String s und den String s selbst aus:
      pln(name + ".length()                    : " +
                 s.length());
      pln(name + ".codePointCount(0, s.length(): " +
                 s.codePointCount(0, s.length()));
      pln(name + "                             : " +
                 s);
   } // gibLaengeUndAnzahlZeichenAus
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {

      // Der String s41 enthaelt drei haeufig verwendete Zeichen, die durch
      // je einen char-Wert dargestellt werden:
      String s41 = "\u0041\u0042\u0043"; // ABC

      // Der String s42 enthaelt ein selten verwendetes chinesisches
      // Zeichen, welches durch *zwei* char-Werte dargestellt wird, und
      // ein haeufig verwendetes Zeichen, welches durch *einen* char-Wert
      // dargestellt wird (insgesamt also zwei Zeichen):
      String s42 = "\uD840\uDC01\u0043"; // ?C

      pln("-------------------------------------");
      gibLaengeUndAnzahlZeichenAus(s41, "s41");
      pln("-------------------------------------");
      gibLaengeUndAnzahlZeichenAus(s42, "s42");
      pln("-------------------------------------");

      pln("String05: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Ein Unterprogramm mit kurzem Namen:
   static void pln(String s) {System.out.println(s);}
   // ---------------------------------------------------------------------
} // class String05
/* ------------------------------------------------------------------------
Ausgabe des Programms String05:

-------------------------------------
s41.length()                    : 3
s41.codePointCount(0, s.length(): 3
s41                             : ABC
-------------------------------------
s42.length()                    : 3
s42.codePointCount(0, s.length(): 2
s42                             : ?C
-------------------------------------
String05: Das war's erstmal!
------------------------------------------------------------------------ */