// Datei StringBuffer02.java
/* ------------------------------------------------------------------------
Zeigt, wie man StringBuffer-Objekte vereinbaren und initialisieren kann,
wie man Werte verschiedener Typen an ein StringBuffer-Objekt anhaengt (mit
append), wie man Werte verschiedener Typen in ein StringBuffer-Objekt ein-
fuegt (mit insert), wie man Teile eines StringBuffer-Objekts ersetzt (mit
replace), wie man die momentane Kapazitaet und die momentane Laenge eines
StringBuffer-Objekts feststellt, wie man auf einzelne Zeichen eines String-
Buffer-Objekts zugreift (mit charAt und setCharAt), wie man einen Teil-
string aus einem StringBuffer-Objekt holt (mit substring), wie man einzelne
Zeichen und Teilstrings aus einem StringBuffer-Objekt entfernt (mit
deleteCharAt und delete) und wie man ein StringBuffer-Objekt in ein String-
Objekt umwandelt (mit toString).
------------------------------------------------------------------------ */
class StringBuffer02 {
   // ---------------------------------------------------------------------
   static public void main(String[] sigfried) {

      // Eine Hilfsvariable zum initialisieren eines StringBuffer-Objekts:
      String st01 = "Hans! ";

      // Variablen vom Typ StringBuffer vereinbaren und initialisieren:
      StringBuffer sb01 = new StringBuffer("Hallo ");
      StringBuffer sb02 = new StringBuffer(st01);

      // Mit append Werte der Typen StringBuffer und String an einen
      // StringBuffer anhaengen:
      pln("--------------------------------------------------------------");
      pln("A sb01            : " + sb01);
      sb01.append(sb02);            // einen StringBuffer-Wert anhaengen
      pln("B sb01            : " + sb01);
      sb01.append("Wie geht's? ");  // einen       String-Wert anhaengen
      pln("C sb01            : " + sb01);

      // Alle Methoden namens append sind Funktionen, die ein
      // StringBuffer-Objekt als Ergebnis liefern:
      StringBuffer sb03 = sb01.append("Danke, es geht so!");
      pln("D sb03            : " + sb03);

      // Mit append Werte der Typen int, String, double und boolean an
      // einen StringBuffer anhaengen:
      pln("--------------------------------------------------------------");
      StringBuffer sb04    = new StringBuffer("Ein paar Werte: ");
      String       trenner = ", ";
      sb04.append(17 + 4);          // einen     int-Wert anhaengen
      sb04.append(trenner);         // einen  String-Wert anhaengen
      sb04.append(12.34 * 2);       // einen  double-Wert anhaengen
      sb04.append(trenner);         // einen  String-Wert anhaengen
      sb04.append(sb01 == sb03);    // einen boolean-Wert anhaengen
      pln("E sb04            : " + sb04);

      // Mit insert Werte verschiedener Typen in einen StringBuffer
      // einfuegen:
      pln("--------------------------------------------------------------");
      StringBuffer sb05 = new StringBuffer("Nur  Euro pro Stueck");
      sb05.insert(4, 15);                  // einen     int-Wert einfuegen
      pln("F sb05            : " + sb05);
      sb05.insert(12, "76 Cents ");        // einen  String-Wert einfuegen
      pln("G sb05            : " + sb05);

      // Mit replace Teile eines StringBuffers ersetzen:
      sb05.replace( 4,  6, "10");       // Von Index  4 bis  5 (!) ersetzen
      sb05.replace(25, 31, "kg");       // Von Index 25 bis 30 (!) ersetzen
      pln("H sb05            : " + sb05);

      // Die Kapazitaet und die tatsaechliche Laenge feststellen:
      pln("--------------------------------------------------------------");
      StringBuffer sb06 = new StringBuffer("Hallo!");
      pln("I sb06            : " + sb06);
      pln("J sb06.capacity() : " + sb06.capacity());
      pln("K sb06.length  () : " + sb06.length  ());

      // Mit charAt und setCharAt auf einzelne Zeichen zugreifen:
      pln("--------------------------------------------------------------");
      final int LI = sb06.length()-1;              // Letzter Index von sb06
      pln("L sb06.charAt(0)  : " + sb06.charAt(0));
      pln("M sb06.charAt(1)  : " + sb06.charAt(1));
      pln("N sb06.charAt(LI) : " + sb06.charAt(LI));
      sb06.setCharAt(1, 'e');                // 'a' wird durch 'e' ersetzt
      pln("O sb06            : " + sb06);
      p  ("P Rueckwaerts     : ");
      for (int i=sb06.length()-1; i>=0; i--) p(sb06.charAt(i));
      pln("");

      // Einen Teilstring aus einem StringBuffer holen:
      pln("--------------------------------------------------------------");
      StringBuffer sb07 = new StringBuffer("Kraut");
      String       st02 = sb07.substring(1, 4);  // inklusiv 1, exklusiv 4
      pln("Q sb07            : " + sb07);
      pln("R st02            : " + st02);

      // Einzelne Zeichen und ganze Teilstrings loeschen:
      pln("--------------------------------------------------------------");
      StringBuffer sb08 = new StringBuffer("Nichte Berta-Luise");
      pln("S sb08            : " + sb08);
      sb08.delete(11, sb08.length());   // Einen ganzen Teilstring loeschen
      sb08.deleteCharAt(5);             // Ein einzelnes Zeichen   loeschen
      pln("T sb08            : " + sb08);

      // Ein StringBuffer-Objekt in ein String-Objekt umwandeln:
      String sb09 = sb08.toString() + "ram-August";
      pln("U sb09            : " + sb09);

      pln("--------------------------------------------------------------");
      pln("StringBuffer02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Drei Unterprogramme mit kurzen Namen:
   static void pln(String s) {System.out.println(s);}
   static void p  (String s) {System.out.print  (s);}
   static void p  (char c)   {System.out.print  (c);}
   // ---------------------------------------------------------------------
} // class StringBuffer02
/* ------------------------------------------------------------------------
Ausgabe des Programms StingBuffer01:

--------------------------------------------------------------
A sb01            : Hallo
B sb01            : Hallo Hans!
C sb01            : Hallo Hans! Wie geht's?
D sb03            : Hallo Hans! Wie geht's? Danke, es geht so!
--------------------------------------------------------------
E sb04            : Ein paar Werte: 21, 24.68, true
--------------------------------------------------------------
F sb05            : Nur 15 Euro pro Stueck
G sb05            : Nur 15 Euro 76 Cents pro Stueck
H sb05            : Nur 10 Euro 76 Cents pro kg
--------------------------------------------------------------
I sb06            : Hallo!
J sb06.capacity() : 22
K sb06.length  () : 6
--------------------------------------------------------------
L sb06.charAt(0)  : H
M sb06.charAt(1)  : a
N sb06.charAt(LI) : !
O sb06            : Hello!
P Rueckwaerts     : !olleH
--------------------------------------------------------------
Q sb07            : Kraut
R st02            : rau
--------------------------------------------------------------
S sb08            : Nichte Berta-Luise
T sb08            : Nicht Bert
U sb09            : Nicht Bertram-August
--------------------------------------------------------------
StringBuffer02: Das war's erstmal!
------------------------------------------------------------------------ */