// Datei StringBuffer04.java
/* ------------------------------------------------------------------------
Enthaelt und testet die Methode alleTeiler.
------------------------------------------------------------------------ */
class StringBuffer04 {
   // -----------------------------------------------------------
   static StringBuffer alleTeiler(int n) {
      // Liefert ein StringBuffer-Objekt, welches alle positiven
      // Teiler von n (durch Kommas separiert) enthaelt. Falls n
      // gleich -1, 0 oder +1 ist, wird nur 1 als Teiler gelie-
      // fert. Fuer alle anderen Zahlen n ist 1 der kleinste und
      // (der Betrag von) n der groesste Teiler. Beispiele:
      // alleTeiler( 12) ist gleich "1, 2, 3, 4, 6, 12"
      // alleTeiler(-12) ist gleich "1, 2, 3, 4, 6, 12"
      // alleTeiler( 17) ist gleich "1, 17"
      // alleTeiler( -1) ist gleich "1"
      // alleTeiler( +1) ist gleich "1"
      // alleTeiler(  0) ist gleich "1"

      // Das Ergebnis-Objekt muss auf jeden Fall "1" enthalten:
      StringBuffer erg = new StringBuffer("1");

      // Drei Sonderfaelle "aus dem Weg rauemen":
      if (-1 <= n && n <= +1) return erg;

      // Falls n negativ ist:
      if (n < 0) n = -n;

      // Alle positiven Teiler von n ermitteln und
      // an erg anhaengen:
      for (int teiler=2; teiler<=n; teiler++) {
         if (n % teiler == 0) {
            erg.append(", ");
            erg.append(teiler);
         }
      } // for

      return erg;
   } // alleTeiler
   // -----------------------------------------------------------
   static public void main(String[] sigfried) {
      // Die Methode alleTeiler wird ein bisschen getestet:
      pln("A alleTeiler(  12): " + alleTeiler(  12));
      pln("B alleTeiler( -12): " + alleTeiler( -12));
      pln("C alleTeiler(  17): " + alleTeiler(  17));
      pln("D alleTeiler( -64): " + alleTeiler( -64));
      pln("E alleTeiler(  -1): " + alleTeiler(  -1));
      pln("F alleTeiler(  +1): " + alleTeiler(  +1));
      pln("G alleTeiler(   0): " + alleTeiler(   0));
      pln("H alleTeiler(5765): " + alleTeiler(5765));
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class StringBuffer04
/* ------------------------------------------------------------------------
Ausgabe des Programms StringBuffer04:

A alleTeiler(  12): 1, 2, 3, 4, 6, 12
B alleTeiler( -12): 1, 2, 3, 4, 6, 12
C alleTeiler(  17): 1, 17
D alleTeiler( -64): 1, 2, 4, 8, 16, 32, 64
E alleTeiler(  -1): 1
F alleTeiler(  +1): 1
G alleTeiler(   0): 1
H alleTeiler(5765): 1, 5, 1153, 5765
------------------------------------------------------------------------ */