// Datei Stroeme10.java
/* ------------------------------------------------------------------------
Verschiedene Datenquellen/Datensenken werden beschrieben bzw. erzeugt
(eine Datei, Reihungen der Typen byte[] uns char[], ein String).
Verschiedene Stromobjekte werden direkt mit diesen Quellen/Senken
verbunden.
------------------------------------------------------------------------ */
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.ByteArrayOutputStream;
import java.io.CharArrayWriter;
import java.io.StringWriter;

import java.io.FileInputStream;
import java.io.FileReader;
import java.io.ByteArrayInputStream;
import java.io.CharArrayReader;
import java.io.StringReader;

import java.io.File;

class Stroeme10 {
   static public void main(String[] salome) throws java.io.IOException {
      // ------------------------------------------------------------------
      // Verschiedene Datensenken und Datenquellen:
      String                s01  = "D:/meineDateien/BspJaSp/Stroeme10.tmp";
      File                  f01  = new File(s01);

      byte[]                br01 = new byte[100];
      char[]                cr01 = new char[250];
      String                st01 = "Hallo! Wie geht's? Gut!";
      // ------------------------------------------------------------------
      // Verschiedene Ausgabestroeme direkt mit Datensenken
      // bzw.         Eingabestroeme direkt mit Datenquellen verbinden:
      FileOutputStream      as01 = new FileOutputStream     (s01);
      FileOutputStream      as02 = new FileOutputStream     (f01);
      FileWriter            as03 = new FileWriter           (s01);
      FileWriter            as04 = new FileWriter           (f01);

      ByteArrayOutputStream as05 = new ByteArrayOutputStream(   );
      CharArrayWriter       as06 = new CharArrayWriter      (   );
      StringWriter          as07 = new StringWriter         (   );

      FileInputStream       es01 = new FileInputStream      (s01);
      FileInputStream       es02 = new FileInputStream      (f01);
      FileReader            es03 = new FileReader           (s01);
      FileReader            es04 = new FileReader           (f01);

      ByteArrayInputStream  es05 = new ByteArrayInputStream (br01);
      CharArrayReader       es06 = new CharArrayReader      (cr01);
      StringReader          es07 = new StringReader         (st01);
      // ------------------------------------------------------------------
      // In die Ausgabestroeme as05 und as06 werden ein paar Daten
      // geschrieben. Die Eingabestroeme es05 und es06 wrden durch
      // neue Objekte ersetzt. Aus denen werden Daten gelesen und
      // zur Standardausgabe ausgegeben.
      // Die meisten der oben vereinbarten Stromobjekte bleiben
      // unbenutzt.
      pln("Stroeme10: Jetzt geht es los!");
      pln("-----------------------------");
      for (byte b=64;  b<=90;  b++) as05.write(b);
      es05 = new ByteArrayInputStream(as05.toByteArray());
      for (int i=es05.available(); i>0; i--) p("" + (char) es05.read());
      pln();
      pln("-----------------------------");
      for (char c='@'; c<='Z'; c++) as06.write(c);
      es06 = new CharArrayReader(as06.toCharArray());
      while (es06.ready())                  p("" +  (char) es06.read());
      pln();
      pln("-----------------------------");
      pln("Stroeme10: Das war's erstmal!");
      // ------------------------------------------------------------------
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
} // class Stroeme10
/* ------------------------------------------------------------------------
Ausgabe des Programms Stroeme10 zur Standardausgabe (Bildschirm):

Stroeme10: Jetzt geht es los!
-----------------------------
@ABCDEFGHIJKLMNOPQRSTUVWXYZ
-----------------------------
@ABCDEFGHIJKLMNOPQRSTUVWXYZ
-----------------------------
Stroeme10: Das war's erstmal!
------------------------------------------------------------------------ */