// Datei Switch01.java
/* ------------------------------------------------------------------------
Eine geschachtelte if-Anweisung und eine switch-Anweisung die genau das
Gleiche leisten (aber die switch-Anweisung ist eleganter).
------------------------------------------------------------------------ */
class Switch01 {
   // ---------------------------------------------------------------------
   static void pIf(char zeichen) {
      // Prueft, ob zeichen eine Klammer enthaelt und gibt
      // eine entsprechende Meldung aus.
      String txt = "'" + zeichen + "': ";

      if (zeichen == '(') {
         pln(txt + "rund,  oeffnend");
      } else if (zeichen == '[') {
         pln(txt + "eckig, oeffnend");
      } else if (zeichen == ')') {
         pln(txt + "rund,  schliessend");
      } else if (zeichen == ']') {
         pln(txt + "eckig, schliessend");
      } else {
         pln(txt + "keine Klammer!");
      } // if
   } // pIf
   // ---------------------------------------------------------------------
   static void pSwitch(char zeichen) {
      // Prueft, ob zeichen eine Klammer enthaelt und gibt
      // eine entsprechende Meldung aus.
      String txt = "'" + zeichen + "': ";

      switch (zeichen) {
         case '(': pln(txt + "rund,  oeffnend");    break;
         case '[': pln(txt + "eckig, oeffnend");    break;
         case ')': pln(txt + "rund,  schliessend"); break;
         case ']': pln(txt + "eckig, schliessend"); break;
         default:  pln(txt + "keine Klammer!");     break;

         // Zusaetzliche Testbefehle, vom Warter eingefuegt:
         case 'x': pln("zeichen x, Fehler!");       break;
         case 'y': pln("zeichen y, Fehler!");       break;
      } // switch
   } // pSwitch
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Methoden pIf und pSwitch werden mit verschiedenen
      // Parametern aufgerufen.
      pln("-----------------------------------------");
      p("A  "); pIf('[');
      p("B  "); pIf(']');
      p("C  "); pIf('(');
      p("D  "); pIf(')');
      p("E  "); pIf('X');
      pln("-----------------------------------------");
      p("F  "); pSwitch('[');
      p("G  "); pSwitch(']');
      p("H  "); pSwitch('(');
      p("I  "); pSwitch(')');
      p("J  "); pSwitch('X');
      pln("-----------------------------------------");
      pln("Switch01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Switch01
/* ------------------------------------------------------------------------
Ausgabe des Programms Switch01:

-----------------------------------------
A  '[': eckig, oeffnend
B  ']': eckig, schliessend
C  '(': rund,  oeffnend
D  ')': rund,  schliessend
E  'X': keine Klammer!
-----------------------------------------
F  '[': eckig, oeffnend
G  ']': eckig, schliessend
H  '(': rund,  oeffnend
I  ')': rund,  schliessend
J  'X': keine Klammer!
-----------------------------------------
Switch01: Das war's erstmal!
------------------------------------------------------------------------ */