// Datei Switch02.java
/* ------------------------------------------------------------------------
Switch-Anweisungen mit mehreren Fallmarken am Anfang der einzelnen Faelle.

Innerhalb einer Funktion kann mit die einzelnen Faelle einer switch-An-
weisung auch mit return-Anweisungen beenden statt mit break-Anweisungen.
------------------------------------------------------------------------ */
class Switch02 {
   // ---------------------------------------------------------------------
   // In der folgenden Prozedur muessen die einzelnen Faelle der switch-
   // Anweisung durch break-Anweisungen beendet werden:

   static void procSwitch(char zeichen) {
      // Prueft, ob zeichen eine oeffnende oder schliessende Klammer
      // enthaelt und gibt eine ensprechende Meldung aus.
      // Falls zeichen keine Klammer enthaelt, passiert einfach nichts
      // (weil die switch-Anweisung keinen default-Fall hat).
      String txt = "'" + zeichen + "': ";

      switch (zeichen) {
         case '(':
         case '[':
         case '{': pln(txt + "oeffnend");      break;
         case ')':
         case ']':
         case '}': pln(txt + "schliessend");   break;
      } // switch

   } // procSwitch
   // ---------------------------------------------------------------------
   // In der folgenden Funktion werden die einzelnen Faelle der switch-
   // Anweisung durch return-Anweisungen beendet:

   static String funcSwitch(char zeichen) {
      // Prueft, ob zeichen eine oeffnende oder schliessende Klammer
      // enthaelt und liefert einen entsprechenden Meldungs-String.
      // Achtung: Eine Funktion muss in jedem Fall mit einer retunr-
      // Anweisung beendet werden. Darum hat die switch-Anweisung
      // hier auch einen default-Fall!
      String txt = "'" + zeichen + "': ";

      switch (zeichen) {
         case '(':
         case '[':
         case '{': return txt + "oeffnend";
         case ')':
         case ']':
         case '}': return txt + "schliessend";
         default:  return txt + "keine Klammer!";
      } // switch

   } // funcSwitch
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Methoden procSwitch und funcSwitch werden mit verschiedenen
      // Parametern aufgerufen.
      pln("-----------------------------------------");
      p("A  ");     procSwitch('(');
      p("B  ");     procSwitch('[');
      p("C  ");     procSwitch('{');
      p("D  ");     procSwitch('}');
      p("E  ");     procSwitch(']');
      p("F  ");     procSwitch(')');
      p("G  ");     procSwitch('X'); pln("Wieso nix?");
      pln("-----------------------------------------");
      p("H  "); pln(funcSwitch('('));
      p("I  "); pln(funcSwitch('['));
      p("J  "); pln(funcSwitch('{'));
      p("K  "); pln(funcSwitch('}'));
      p("L  "); pln(funcSwitch(']'));
      p("M  "); pln(funcSwitch(')'));
      p("N  "); pln(funcSwitch('X'));
      pln("-----------------------------------------");
      pln("Switch02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Switch02
/* ------------------------------------------------------------------------
Ausgabe des Programms Switch02:

-----------------------------------------
A  '(': oeffnend
B  '[': oeffnend
C  '{': oeffnend
D  '}': schliessend
E  ']': schliessend
F  ')': schliessend
G  Wieso nix?
-----------------------------------------
H  '(': oeffnend
I  '[': oeffnend
J  '{': oeffnend
K  '}': schliessend
L  ']': schliessend
M  ')': schliessend
N  'X': keine Klammer!
-----------------------------------------
Switch02: Das war's erstmal!
------------------------------------------------------------------------ */