// Datei Switch03.java
/* ------------------------------------------------------------------------
Eine geschachtelte if-Anweisung und eine switch-Anweisung die genau das
Gleiche leisten. Hier ist nicht so klar, welche Loesung eleganter ist.
------------------------------------------------------------------------ */
class Switch03 {
   // ---------------------------------------------------------------------
   static void pSwitch(int zahl) {
      // Prueft, ob zahl zwischen 1 und 10 liegt und ob zahl gerade
      // oder ungerade ist. Gibt eine entsprechende Meldung aus.
      String txt = "Die Zahl " + zahl + " ";

      switch (zahl) {
         case 2: case 4: case 6: case 8: case 10:
            pln(txt + "ist gerade!");
            break;
         case 1: case 3: case 5: case 7: case 9:
            pln(txt + "ist ungerade!");
            break;
         default:
            pln(txt + "liegt nicht zwischen 1 und 10!");
            break;
      } // switch

   } // procSwitch
   // ---------------------------------------------------------------------
   static void pIf(int zahl) {
      // Prueft, ob zahl zwischen 1 und 10 liegt und ob zahl gerade
      // oder ungerade ist. Gibt eine entsprechende Meldung aus.
      //
      // Das Prozentzeichen % bezeichnet die Rest-Operation. Beispiele:
      // 7 % 2 ist gleich 1 (denn 7 durch 2 ist 3 Rest 1)
      // 8 % 2 ist gleich 0 (denn 8 durch 2 ist 4 Rest 0)
      //
      //  if (zahl % 2 == 0)  ... bedeutet also soviel wie:
      // wenn zahl gerade ist ...

      String txt = "Die Zahl " + zahl + " ";

      if (zahl < 1 || 10 < zahl) {
         pln(txt + "liegt nicht zwischen 1 und 10!");
      } else if (zahl % 2 == 0) {
         pln(txt + "ist gerade!");
      } else {
         pln(txt + "ist ungerade!");
      }
   } // pIf
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Methoden pIf und pSwitch werden mit verschiedenen
      // Parametern aufgerufen.
      pln("-------------------------------------------");
      p("A "); pSwitch(8);
      p("B "); pSwitch(2);
      p("C "); pSwitch(9);
      p("D "); pSwitch(1);
      p("E "); pSwitch(0);
      pln("-------------------------------------------");
      p("F "); pIf(8);
      p("G "); pIf(2);
      p("H "); pIf(9);
      p("I "); pIf(1);
      p("J "); pIf(0);
      pln("-------------------------------------------");
      pln("Switch03: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   // ---------------------------------------------------------------------
} // class Switch03
/* ------------------------------------------------------------------------
Ausgabe des Programms Switch03:

-------------------------------------------
A Die Zahl 8 ist gerade!
B Die Zahl 2 ist gerade!
C Die Zahl 9 ist ungerade!
D Die Zahl 1 ist ungerade!
E Die Zahl 0 liegt nicht zwischen 1 und 10!
-------------------------------------------
F Die Zahl 8 ist gerade!
G Die Zahl 2 ist gerade!
H Die Zahl 9 ist ungerade!
I Die Zahl 1 ist ungerade!
J Die Zahl 0 liegt nicht zwischen 1 und 10!
-------------------------------------------
Switch03: Das war's erstmal!
------------------------------------------------------------------------ */