// Datei TypUmwandlungen02.java
/* ------------------------------------------------------------------------
Mit Cast-Befehlen werden Werte numerischer Typen umgewandelt. Dabei tritt
jeweils ein Verlust der Groessenordnung auf.

Erlaeuterungen zu den Ausgabezeilen:
Zeile A: Nach   dem groessten byte-Wert ( 127, Byte.MAX_VALUE) kommt
         wieder der kleinste  byte-Wert (-128, Byte.MIN_VALUE)
Zeile B: Vor    dem kleinsten byte-Wert (-128, Byte.MIN_VALUE) kommt
         wieder der groesste  byte-Wert ( 127, Byte.MIN_VALUE)
Zeile C:  127 + 1 ist gleich -128, -128 + 28 ist gleich -100.
Zeile D: -128 - 1 ist gleich  127,  127 - 27 ist gleich  100.
Zeile E: 'A' + 1 ist der Code von 'B', 'B' + 1 ist der Code fuer 'C' etc.
Zeile F: Es gibt 65536 char-Werte. Also ist 'A' + 65536 gleich 'A' ("einmal
         rum") und 'A' + 65537 ist gleich 'B' ("ein mal rum plus 1")
Zeile G: Der int-Wert -1 besteht aus 32 1-er-Bits. Beim Umwandeln in einen
         char-Wert bleiben davon 16 1-er-Bits ueberig. Ein char-Wert mit
         16 1-er-Bits ist gleich Character.MAX_VALUE gleich 65535. Wenn
         man diese Zahl wieder in einen int-Wert umwandelt und ausgibt
         erscheint 65535 auf dem Bildschirm.
Zeile H: Die Zeichen '0', '1' und 'a' haben die Codes 48 bzw. 49 bzw. 97.
Zeile I: Nach   dem groessten short-Wert ( 32767, Short.MAX_VALUE) kommt
         wieder der kleinste  short-Wert (-32768, Short.MIN_VALUE)
Zeile J: Vor    dem kleinsten short-Wert (-32768, Short.MIN_VALUE) kommt
         wieder der groesste  short-Wert ( 32767, Short.MIN_VALUE)
Zeile K:  32767 + 1 ist gleich -32768, -32768 + 68 ist gleich -32700.
Zeile L: -32768 - 1 ist gleich  32767,  32767 - 67 ist gleich  32700.
------------------------------------------------------------------------ */
class TypUmwandlungen02 {
   // ---------------------------------------------------------------------
   static public void main(String[] siegfried) {
      pln("--------------------------------------------------");
      pln("A (byte)   128          : " + (byte)   128         );
      pln("B (byte)  -129          : " + (byte)  -129         );
      pln("C (byte) ( 127 + 29)    : " + (byte) ( 127 + 29)   );
      pln("D (byte) (-128 - 28)    : " + (byte) (-128 - 28)   );
      pln("--------------------------------------------------");
      pln("E (char) ('A' + 1)      : " + (char) ('A' + 1)     );
      pln("F (char) ('A' + 65537)  : " + (char) ('A' + 65537) );
      pln("G (int)  (char) -1      : " + (int)  (char) -1     );
      pln("H (char) ('0' + '1')    : " + (char) ('0' + '1')   );
      pln("--------------------------------------------------");
      pln("I (short)   32768       : " + (short)   32768      );
      pln("J (short)  -32769       : " + (short)  -32769      );
      pln("K (short) ( 32767 + 69) : " + (short) ( 32767 + 69));
      pln("L (short) (-32768 - 68) : " + (short) (-32768 - 68));
      pln("--------------------------------------------------");
      pln("TypUmwandlungen02: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class TypUmwandlungen02
/* ------------------------------------------------------------------------
Ausgabe des Programms TypUmwandlungen02:

--------------------------------------------------
A (byte)   128          : -128
B (byte)  -129          : 127
C (byte) ( 127 + 29)    : -100
D (byte) (-128 - 28)    : 100
--------------------------------------------------
E (char) ('A' + 1)      : B
F (char) ('A' + 65537)  : B
G (int)  (char) -1      : 65535
H (char) ('0' + '1')    : a
--------------------------------------------------
I (short)   32768       : -32768
J (short)  -32769       : 32767
K (short) ( 32767 + 69) : -32700
L (short) (-32768 - 68) : 32700
--------------------------------------------------
TypUmwandlungen02: Das war's erstmal!
------------------------------------------------------------------------ */