// Datei Typen02.java
/* ------------------------------------------------------------------------
Eine Zuweisung zwischen zwei primitiven Variablen (z.B. p01 = p02); und
eine Zuweisung zwischen zwei Referenzvariablen    (z.B. r01 = r02); ver-
aendert jeweils den Wert der Variablen auf der linken Seite der Zuweisung.
Das hat aber bei primitiven Variablen eine ganze andere Wirkung als bei
einer Referenzvariablen.
------------------------------------------------------------------------ */
class Typen02 {
   // ---------------------------------------------------------------------
   static int          p01 = 17;
   static int          p02 = 25;
   static StringBuffer r01 = new StringBuffer("Hallo!");
   static StringBuffer r02 = new StringBuffer("Wie geht's?");
   static StringBuffer r03;
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      pln("------------------");
      pln("A p01: " + p01);
      pln("B p02: " + p02);
      pln("C r01: " + r01);
      pln("D r02: " + r02);
      pln("E r03: " + r03);
      pln("------------------");

      p01 = p02;                   // p01 und p02 haben gleiche Werte
      r01 = r02;                   // r01 und r02 haben gleiche Werte und
                                   // damit ein und denselben Zielwert!
      pln("F p01: " + p01);
      pln("G p02: " + p02);
      pln("H r01: " + r01);
      pln("I r02: " + r02);
      pln("------------------");

      p02 = p02 + 1;               // p02 wird  veraendert
      r02.replace(0, 5, "G");      // r02 wird  veranedert

      pln("J p01: " + p01);        // p01 ist unveraendert
      pln("K p02: " + p02);        // p02 ist   veraendert
      pln("L r01: " + r01);        // r01 ist   veraendert
      pln("M r02: " + r02);        // r02 ist   veraendert
      pln("------------------");

      // Jetzt wird der StringBuffer r02 kopiert, nicht nur die Referenz,
      // die auf ihn zeigt. Danach haben r01 und r02 zwei gleiche
      // Zielwerte, und nicht mehr (ein und) denselben Zielwert:
      r01 = new StringBuffer(r02.toString());
      r02.replace(0, 1, "Wie g");  // r02 wird  veraendert

      pln("N r01: " + r01);        // r01 ist unveraendert
      pln("O r02: " + r02);        // r02 ist   veraendert
      pln("---------------------------");
      pln("Typen02: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Typen02
/* ------------------------------------------------------------------------
Ausgabe des Programms Typen02:

------------------
A p01: 17
B p02: 25
C r01: Hallo!
D r02: Wie geht's?
E r03: null
------------------
F p01: 25
G p02: 25
H r01: Wie geht's?
I r02: Wie geht's?
------------------
J p01: 25
K p02: 26
L r01: Geht's?
M r02: Geht's?
------------------
N r01: Geht's?
O r02: Wie geht's?
---------------------------
Typen02: Das war's erstmal!
------------------------------------------------------------------------ */