// Datei Typen03.java
/* ------------------------------------------------------------------------
Seien a und b zwei Referenzvariablen des selben Typs (z.B. des Typs
StringBuffer). Vergleicht man a und b mit den Operatoren == (gleich)
und != (ungleich), dann werden die *Werte* der Variablen verglichen
und nicht etwa die *Zielwerte* (wie es naheliegt zu erwarten).

Daraus folgt: Der Ausdruck (a == b) hat genau dann den Wert true,
wenn a und b gleiche Werte und somit denselben Zielwert haben.
------------------------------------------------------------------------ */
class Typen03 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Referenzvariablen a und b haben gleiche Zielwerte ("Hallo!"),
      // aber verschiedene Werte:
      StringBuffer a = new StringBuffer("Hallo!");
      StringBuffer b = new StringBuffer("Hallo!");

      pln("Typen03: Jetzt geht es los!");
      pln("---------------------------------------------");
      pln("A                     StringBuffer a : " + a);
      pln("B                     StringBuffer b : " + b);
      pln("---------------------------------------------");
      pln("C                         a.equals(b): " +
                                     a.equals(b) );
      pln("D (a.toString()).equals(b.toString()): " +
             (a.toString()).equals(b.toString()) );
      pln("---------------------------------------------");
      pln("E                            (a == b): " + (a == b));
      pln("F                            (a != b): " + (a != b));
      pln("G                            (a == a): " + (a == a));
      pln("H                            (a != a): " + (a != a));
      pln("---------------------------------------------");
      pln("I Nach der Zuweisung a=b; gilt:");
      a = b;
      pln("J                            (a == b): " + (a == b));
      pln("K                            (a != b): " + (a != b));
      pln("---------------------------------------------");
      pln("Typen03: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Typen03
/* ------------------------------------------------------------------------
Ausgabe des Programms Typen03:

Typen03: Jetzt geht es los!
---------------------------------------------
A                     StringBuffer a : Hallo!
B                     StringBuffer b : Hallo!
---------------------------------------------
C                         a.equals(b): false
D (a.toString()).equals(b.toString()): true
---------------------------------------------
E                            (a == b): false
F                            (a != b): true
G                            (a == a): true
H                            (a != a): false
---------------------------------------------
I Nach der Zuweisung a=b; gilt:
J                            (a == b): true
K                            (a != b): false
---------------------------------------------
Typen03: Das war's erstmal!
------------------------------------------------------------------------ */