// Datei Typen04.java
/* ------------------------------------------------------------------------
Seien a und b zwei Referenzvariablen des selben Typs (z.B. des Typs
String).
Vergleicht man a und b mit den Operatoren == (gleich) und != (ungleich),
dann werden die *Werte* der Variablen verglichen und nicht etwa die
*Zielwerte*.

Daraus folgt: Der Ausdruck (a == b) hat genau dann den Wert true,
wenn a und b gleiche Werte und somit denselben Zielwert haben.

Bei String-Variablen kommt noch hinzu, dass man sie auf zwei Weisen
initialisieren kann, mit new (wie unten die Variablen a und b) und
ohne new (wie unten die Variablen c und d).

Initialisiert man eine String-Variable wie b mit new, dann wird
ein neuer Zielwert erzeugt ("an einer anderen Stelle im Speicher
als alle bisher erzeugten Zielwerte") und die Variable b bekommt
garantiert einen anderen Wert als alle schon existierenden
Variablen. Deshalb hat z.B. c einen anderen Wert als b und einen
anderen Wert als a.

Initialisiert man eine String-Variable wie d ohne new, dann prueft
der Ausfuehrer, ob er den Zielwert schon fuer eine aehnliche Variable
(wie c) erzeugt hat. In diesem Beispiel bekommt d den gleichen Wert
wie c und somit haben c und d denselben Zielwert. Dieser Zielwert
steht aber an einer anderen Stelle im Speicher als die Zielwerte der
Variablen a und b.

Je nach Situation ist die eine oder die andere Art der Initialisierung
einer String-Variablen effizienter. Die Vereinbarung ohne new (wie bei
c und d) erfordert eventuell aufwendige Pruefungen, ob schon ein gleicher
Zielwert existiert. Aber wenn die Pruefung positiv ausfaellt, spart man
Speicherplatz. Bei der Initialisierung mit new (wie bei a und b) werden
keine aufwendigen Pruefungen durchgefuehrt, aber eventuell wird fuer
gleiche Zielwerte mehrmals Speicher verbraucht.
------------------------------------------------------------------------ */
class Typen04 {
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Die Referenzvariablen a und b haben gleiche Zielwerte ("Hallo!"),
      // aber verschiedene Werte:
      String a = new String("Hallo!");
      String b = new String("Hallo!");
      String c = "Hallo!";
      String d = "Hallo!";

      pln("------------------------------");
      pln("A  a:        " + a);
      pln("B  b:        " + b);
      pln("C  c:        " + b);
      pln("D  d:        " + b);
      pln("------------------------------");
      pln("E  (a == b): " + (a == b));
      pln("F  (c == d): " + (c == d));
      pln("G  (b == c): " + (b == c));
      pln("------------------------------");
      pln("Typen04: Das war's erstmal!");

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Typen04
/* ------------------------------------------------------------------------
Ausgabe des Programms Typen04:

------------------------------
A  a:        Hallo!
B  b:        Hallo!
C  c:        Hallo!
D  d:        Hallo!
------------------------------
E  (a == b): false
F  (c == d): true
G  (b == c): false
------------------------------
Typen04: Das war's erstmal!
------------------------------------------------------------------------ */