// Datei Typen07.java
/* ------------------------------------------------------------------------
Hundertausend * Hundertausend ist gleich 10 Milliarden.
Wenn man diese Rechnung mit int-Werten durchfuehrt, kommt nur etwa
1.4 Milliarden heraus. Warum?

Insgesamt gibt es etwa 4.3 Milliarden int-Werte, die "kreisfoermig ange-
ordnet sind", d.h. nach Integer.MAX_VALUE kommt wieder Integer.MIN_VALUE.

4.3 + 4.3 + 1.4 = 10 [Milliarden]
---------------------------------------------------------------------------
2 Milliarden + 2 Milliarden ist gleich 4 Milliarden.
Wenn man diese Rechnung mit int-Werten durchfuehrt, kommt nur etwa
-0.3 Milliarden heraus. Warum?

4.3 - 0.3 = 4.0 [Milliarden]
------------------------------------------------------------------------ */
class Typen07 {
   // ---------------------------------------------------------------------
   static public void main(String[] siegfried) {

      final int HT = 100 * 1000;             // Hundertausend
      final int M2 = 2 * 1000 * 1000 * 1000; // 2 Milliarden

      System.out.println("HT * HT ist gleich " + (HT * HT));
      System.out.println("M2 + M2 ist gleich " + (M2 + M2));
      System.out.println("-----------------------------");
      System.out.println("Typen07: Das war's erstmal");

   } // main
   // ---------------------------------------------------------------------
} // class Typen07
/* ------------------------------------------------------------------------
Ausgabe des Programms Typen07:

HT * HT ist gleich 1410065408
M2 + M2 ist gleich -294967296
-----------------------------
Typen07: Das war's erstmal
------------------------------------------------------------------------ */