// Datei Typen09.java
/* ------------------------------------------------------------------------
Der Java-Ausfuehrer kann nicht mit Werten der drei kurzen Ganzzahltypen
byte, char und short rechnen. Wenn man ihm trozdem befiehlt, z.B. zwei
short-Werte zu addieren, wandelt er die Werte erst in int-Werte um und
addiert die int-Werte. Das Ergebnis der Addition ist ein int-Wert (und
nicht etwa ein short-Wert). Will man das Ergebnis in einer short-Variablen
speichern, muss man es mit einem Cast-Befehl in einen short-Wert umwandeln
lassen.

Erlaeuterungen zu den Ausgabezeilen:

Zeile A: Keine Erlaeuterung.
Zeile B: 17 * 3 ist natuerlich gleich 51, aber der char-Wert 51 ist der
         Code fuer das Zeichen '3' und wird ensprechend als 3 ausgegeben.
Zeile C: 17 * 3 ist natuerlich gleich 51, aber int-51 und nicht char-51.
         Der int-Wert 51 wird als 51 ausgegeben (und nicht als 3).
Zeile D: 17 / 3 ist natuerlich gleich 5, und nicht etwa gleich
         5.66666666..., wie viele Taschenrechner behaupten.
Zeile E: 127 ist der groesste byte-Wert (Byte.MAX_VALUE). Wenn man
         versucht, den um 1 zu erhoehen, ist das Ergebnis nicht etwa gleich
         128, sondern der kleinste byte-Wert -128 (Byte.MIN_VALUE).
Zeile F: Wenn man die Zeile E verstanden und notgedrungen akzeptiert hat,
         ist diese Zeile eine logische Folge: -128 plus 1 ist gleich -127.
Zeile G: Entsprechend wie F: -127 plus 1 ist gleich -126.
Zeile H: Die Zahlen  48,  49,  50,  ... etc. sind die Codes fuer
         die Zeichen '0', '1', '2', ... etc. Wenn man diese Zahlen als
         char-Werte ausgibt, erscheinen die entsprechenden Zeichen auf
         dem Bildschirm.
Zeile I: Die Literale '0', '1', '2', ... etc. sind nur "alternative Namen"
         fuer die Zahlen 48, 49, 50, ... etc. Wenn man das Zeichen '0'
         meint, sollte man mit Ruecksicht auf die Kollegen lieber
         '0' schreiben statt 48. Wenn man einen Zeitraum von zwei Tagen
         in Stunden beschreiben will, sollte mann besser 48 schreiben
         und nicht '0'. Dem Ausfuehrer ist weitgehend gleichgueltig,
         ob man '0' oder 48 schreibt.
Zeile J: Wenn man die Zahlen   48, 49, 50, ... etc. als int-Werte ausgibt,
         erscheinen die Zahlen 48, 49, 50, ... etc. auf dem Bildschirm
         (und nicht etwa die Zeichen '0', '1', '2' ... etc.).

Anmerkung 1: Die Behauptung, der Java-Ausfuehrer koenne nicht mit Werten
der kurzen Ganzzahltypen byte, char und short rechnen ist nicht ganz
richtig. Der Ausfuehrer kann Variablen dieser Typen um 1 erhoehen bzw.
vermindern, wenn man es ihm mit den Operatoren ++ bzw. -- befiehlt.

Anmerkung 2: Wenn man die Zahl 48 mit dem Befehl System.out.print als
Wert des Typs char ausgibt, erscheint auf dem Bildschirm das Zeichen 0.
Wenn man die Zahl 48 als byte-, short-, int- oder long-Wert ausgibt,
erscheinen auf dem Bildschirm die zwei Zeichen 48. Das char-Literal '0'
ist nur "ein Name fuer die Zahl 48". Entsprechend sind die char-Literale
'1', '2', '3', ... Namen fuer die Zahlen
49,  50,  51,  ... und wenn man diese Zahlen als char-Werte ausgibt,
erscheinen auf dem Bildschirm die Zeichen 1, 2, 3, ... (siehe unten die
Ausgabe der Zeilen I und J).
------------------------------------------------------------------------ */
class Typen09 {
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      pln("---------------------------");
      // ------------------------------------------------------------------
      // Zwei byte-Werte addieren:
      byte  byte01   = 17;
      byte  byte02   =  3;
//    byte  byteErg  =         byte01 + byte02; // Compiler-Fehler!
      byte  byteErg  = (byte) (byte01 + byte02);
      pln("A  byteErg  17 + 3: " + byteErg);
      // ------------------------------------------------------------------
      // Zwei char-Werte multiplizieren:
      char  char01   = 17;
      char  char02   =  3;
//    char  charErg  =         char01 * char02; // Compiler-Fehler!
      char  charErg  = (char) (char01 * char02);
      pln("B  charErg  17 * 3: " + charErg);
      pln("C  char01*char02  17 * 3: " + (char01*char02));
      // ------------------------------------------------------------------
      // Zwei short-Werte diviedieren:
      short short01  = 17;
      short short02  =  3;
//    short shortErg =          short01 / short02; // Compiler-Fehler!
      short shortErg = (short) (short01 / short02);
      pln("D shortErg  17 / 3: " + shortErg);
      // ------------------------------------------------------------------
            byte01   = 127;
            byteErg  = (byte) (byte01 + 1);
      pln("E  byteErg 127 + 1:" + byteErg);
      // ------------------------------------------------------------------
            byteErg  = (byte) (byte01 + 2);
      pln("F  byteErg 127 + 2:" + byteErg);
      // ------------------------------------------------------------------
            byteErg  = (byte) (byte01 + 3);
      pln("G  byteErg 127 + 3:" + byteErg);
      // ------------------------------------------------------------------
      // Die Inkrement-Operatoren ++ und die Dekrement-Operatoren -- kann
      // der Ausfuehrer auch auf Variablen der kurzen Ganzzahltypen byte,
      // char und short anwenden:

      p  ("H  ");
      for (byte byte03=0; byte03<=6; byte03++) {
         p(byte03 + "  ");
      }
      pln();
      // --------------------------------------------------
      p  ("I  ");
      for (char char03='0'; char03<='6'; char03++) {
         p(char03 + "  ");
      }
      pln();
      // --------------------------------------------------
      p  ("J  ");
      for (short  short03='0';  short03<='6';  short03++) {
         p(short03 + " ");
      }
      pln();
      // ------------------------------------------------------------------
      pln("---------------------------");
      pln("Typen09: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class Typen09
/* ------------------------------------------------------------------------
Fehlermeldungen eines Compilers (jikes von IBM), wenn die betreffenden
Zeilen nicht auskommentiert sind:

    64.     byte  byteErg  =         byte01 + byte02; // Compiler-Fehler!
                  ^--------------------------------^
*** Semantic Error: The type of the right sub-expression, "int", is not
assignable to the variable, of type "byte".


    71.     char  charErg  =         char01 * char02; // Compiler-Fehler!
                  ^--------------------------------^
*** Semantic Error: The type of the right sub-expression, "int", is not
assignable to the variable, of type "char".


    79.     short shortErg =          short01 / short02; // Compiler-Fehler!
                  ^-----------------------------------^
*** Semantic Error: The type of the right sub-expression, "int", is not
assignable to the variable, of type "short".
---------------------------------------------------------------------------
Ausgabe des Programms Typen09:

A  byteErg  17 + 3: 20
B  charErg  17 * 3: 3
C  char01*char02  17 * 3: 51
D shortErg  17 / 3: 5
E  byteErg 127 + 1:-128
F  byteErg 127 + 2:-127
G  byteErg 127 + 3:-126
H  0  1  2  3  4  5  6
I  0  1  2  3  4  5  6
J  48 49 50 51 52 53 54
Typen09: Das war's erstmal!
------------------------------------------------------------------------ */