// Datei Typen10.java
/* ------------------------------------------------------------------------
Der Java-Ausfuehrer kann nicht zwei Werte verschiedener Typen addieren.
Wenn man es ihm trotzdem befiehlt, wandelt er den Wert des "kuerzeren"
Typs in einen Wert des "laengeren" Typs um und addiert dann die beiden
Werte des "laengeren" Typs. Entprechendes gilt auch fuer anderen Rechen-
Operationen Subtraktion (-), Multiplikation (*), Division (/) und die
Rest-Operation (%).

Werte der kurzen Ganzzahltypen byte, char und short werden vom Ausfuehrer
vor jeder Rechnung in int-Werte umgewandelt.

Dieses Programm macht die Typumwandlungen, die der Ausfuehrer automatisch
ausfuehrt, sichtbar (mit einem kleinen Trick).
---------------------------------------------------------------------------
Trick: Fuer jeden der 7 numerischen Typen byte, char, short, int, long,
float und double wird eine Funktion mit einem Parameter dieses Typs verein-
bart. Die Namen der 7 Funktionen sind gleich (naemlich toString)!. Ein
Funktionsaufruf wie toString(a+b) veranlasst den Ausfuehrer, den Typ des
Ausdrucks a+b zu ermitteln und die entsprechende Funktion namens toString
auszufuehren.
Von dem Funktionsnamen toString in diesem Programm sagt man auch, er sei
ueberladen, weil er nicht nur eine Funktion bezeichnet, sondern mehrere.
------------------------------------------------------------------------ */
class Typen10 {
   // ---------------------------------------------------------------------
   // Fuer jeden der 7 numerischen Typen eine Funktion, die einen Wert
   // des Typs in einen String umwandelt, der auch den Namen des Typs
   // enthaelt:
   static String toString(byte   b) {return b + "   (vom Typ byte)"  ;}
   static String toString(char   c) {return c + "   (vom Typ char)"  ;}
   static String toString(short  s) {return s + "   (vom Typ short)" ;}
   static String toString(int    i) {return i + "   (vom Typ int)"   ;}
   static String toString(long   l) {return l + "   (vom Typ long)"  ;}
   static String toString(float  f) {return f +   " (vom Typ float)" ;}
   static String toString(double d) {return d +   " (vom Typ double)";}
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      // ------------------------------------------------------------------
      // Von jedem der 7 numerischen Typ wird eine Variable vereinbart
      // und mit dem (hier nicht wichtigen) Wert 17 initialisiert:

      byte     byte17 = 17;
      char     char17 = 17;
      short   short17 = 17;
      int       int17 = 17;
      long     long17 = 17;
      float   float17 = 17;
      double double17 = 17;

      // Jede Variable wird zu jeder addiert. Die 49 Additionsergebnisse
      // (hier nicht wichtig, alle sind gleich 34) werden zusammen mit
      // einem Hinweis auf ihren Typ (hier wichtig!) ausgegeben:
      pln("--------------------------------------------------------");
      pln("  byte17 +   byte17 ist " + toString(  byte17 +   byte17));
      pln("  byte17 +   char17 ist " + toString(  byte17 +   char17));
      pln("  byte17 +  short17 ist " + toString(  byte17 +  short17));
      pln("  byte17 +    int17 ist " + toString(  byte17 +    int17));
      pln("  byte17 +   long17 ist " + toString(  byte17 +   long17));
      pln("  byte17 +  float17 ist " + toString(  byte17 +  float17));
      pln("  byte17 + double17 ist " + toString(  byte17 + double17));
      pln("--------------------------------------------------------");
      pln("  char17 +   byte17 ist " + toString(  char17 +   byte17));
      pln("  char17 +   char17 ist " + toString(  char17 +   char17));
      pln("  char17 +  short17 ist " + toString(  char17 +  short17));
      pln("  char17 +    int17 ist " + toString(  char17 +    int17));
      pln("  char17 +   long17 ist " + toString(  char17 +   long17));
      pln("  char17 +  float17 ist " + toString(  char17 +  float17));
      pln("  char17 + double17 ist " + toString(  char17 + double17));
      pln("--------------------------------------------------------");
      pln(" short17 +   byte17 ist " + toString( short17 +   byte17));
      pln(" short17 +   char17 ist " + toString( short17 +   char17));
      pln(" short17 +  short17 ist " + toString( short17 +  short17));
      pln(" short17 +    int17 ist " + toString( short17 +    int17));
      pln(" short17 +   long17 ist " + toString( short17 +   long17));
      pln(" short17 +  float17 ist " + toString( short17 +  float17));
      pln(" short17 + double17 ist " + toString( short17 + double17));
      pln("--------------------------------------------------------");
      pln("   int17 +   byte17 ist " + toString(   int17 +   byte17));
      pln("   int17 +   char17 ist " + toString(   int17 +   char17));
      pln("   int17 +  short17 ist " + toString(   int17 +  short17));
      pln("   int17 +    int17 ist " + toString(   int17 +    int17));
      pln("   int17 +   long17 ist " + toString(   int17 +   long17));
      pln("   int17 +  float17 ist " + toString(   int17 +  float17));
      pln("   int17 + double17 ist " + toString(   int17 + double17));
      pln("--------------------------------------------------------");
      pln("  long17 +   byte17 ist " + toString(  long17 +   byte17));
      pln("  long17 +   char17 ist " + toString(  long17 +   char17));
      pln("  long17 +  short17 ist " + toString(  long17 +  short17));
      pln("  long17 +    int17 ist " + toString(  long17 +    int17));
      pln("  long17 +   long17 ist " + toString(  long17 +   long17));
      pln("  long17 +  float17 ist " + toString(  long17 +  float17));
      pln("  long17 + double17 ist " + toString(  long17 + double17));
      pln("--------------------------------------------------------");
      pln(" float17 +   byte17 ist " + toString( float17 +   byte17));
      pln(" float17 +   char17 ist " + toString( float17 +   char17));
      pln(" float17 +  short17 ist " + toString( float17 +  short17));
      pln(" float17 +    int17 ist " + toString( float17 +    int17));
      pln(" float17 +   long17 ist " + toString( float17 +   long17));
      pln(" float17 +  float17 ist " + toString( float17 +  float17));
      pln(" float17 + double17 ist " + toString( float17 + double17));
      pln("--------------------------------------------------------");
      pln("double17 +   byte17 ist " + toString(double17 +   byte17));
      pln("double17 +   char17 ist " + toString(double17 +   char17));
      pln("double17 +  short17 ist " + toString(double17 +  short17));
      pln("double17 +    int17 ist " + toString(double17 +    int17));
      pln("double17 +   long17 ist " + toString(double17 +   long17));
      pln("double17 +  float17 ist " + toString(double17 +  float17));
      pln("double17 + double17 ist " + toString(double17 + double17));
      pln("--------------------------------------------------------");
      pln("Typen10: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Typen10
/* ------------------------------------------------------------------------
Ausgabe des Programms Typen01:

--------------------------------------------------------
  byte17 +   byte17 ist 34   (vom Typ int)
  byte17 +   char17 ist 34   (vom Typ int)
  byte17 +  short17 ist 34   (vom Typ int)
  byte17 +    int17 ist 34   (vom Typ int)
  byte17 +   long17 ist 34   (vom Typ long)
  byte17 +  float17 ist 34.0 (vom Typ float)
  byte17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
  char17 +   byte17 ist 34   (vom Typ int)
  char17 +   char17 ist 34   (vom Typ int)
  char17 +  short17 ist 34   (vom Typ int)
  char17 +    int17 ist 34   (vom Typ int)
  char17 +   long17 ist 34   (vom Typ long)
  char17 +  float17 ist 34.0 (vom Typ float)
  char17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
 short17 +   byte17 ist 34   (vom Typ int)
 short17 +   char17 ist 34   (vom Typ int)
 short17 +  short17 ist 34   (vom Typ int)
 short17 +    int17 ist 34   (vom Typ int)
 short17 +   long17 ist 34   (vom Typ long)
 short17 +  float17 ist 34.0 (vom Typ float)
 short17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
   int17 +   byte17 ist 34   (vom Typ int)
   int17 +   char17 ist 34   (vom Typ int)
   int17 +  short17 ist 34   (vom Typ int)
   int17 +    int17 ist 34   (vom Typ int)
   int17 +   long17 ist 34   (vom Typ long)
   int17 +  float17 ist 34.0 (vom Typ float)
   int17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
  long17 +   byte17 ist 34   (vom Typ long)
  long17 +   char17 ist 34   (vom Typ long)
  long17 +  short17 ist 34   (vom Typ long)
  long17 +    int17 ist 34   (vom Typ long)
  long17 +   long17 ist 34   (vom Typ long)
  long17 +  float17 ist 34.0 (vom Typ float)
  long17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
 float17 +   byte17 ist 34.0 (vom Typ float)
 float17 +   char17 ist 34.0 (vom Typ float)
 float17 +  short17 ist 34.0 (vom Typ float)
 float17 +    int17 ist 34.0 (vom Typ float)
 float17 +   long17 ist 34.0 (vom Typ float)
 float17 +  float17 ist 34.0 (vom Typ float)
 float17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
double17 +   byte17 ist 34.0 (vom Typ double)
double17 +   char17 ist 34.0 (vom Typ double)
double17 +  short17 ist 34.0 (vom Typ double)
double17 +    int17 ist 34.0 (vom Typ double)
double17 +   long17 ist 34.0 (vom Typ double)
double17 +  float17 ist 34.0 (vom Typ double)
double17 + double17 ist 34.0 (vom Typ double)
--------------------------------------------------------
Typen10: Das war's erstmal!
------------------------------------------------------------------------ */