// Datei Typen11.java
/* ------------------------------------------------------------------------
Welcher Typ (wie Object, Vector, Vector<Object>, Vector<Double> etc.)
ist ein Untertyp von welchem anderen solchen Typ?

java.util.Vector ist eine generische Klasse.
Vector          ist ein roher Typ
Vector<Object>  ist ein parametrisierter Vector-Typ
Vector<Double>  ist ein parametrisierter Vector-Typ

VectorR         ist ein Untertyp des rohen Typs Vector
VectorP<K>      ist ein Untertyp von Vector<K>
VectorObject    ist ein Untertyp von Vector<Object>
VectorDouble    ist ein Untertyp von Vector<Double>
------------------------------------------------------------------------ */
import java.util.Vector;

class VectorR      extends Vector         {};
class VectorP<K>   extends Vector<K>      {};
class VectorObject extends Vector<Object> {};
class VectorDouble extends Vector<Double> {};
// ------------------------------------------------------------------------
class Typen11 {

   Object          v11 = new Vector         ();
   Object          v12 = new VectorR        ();
   Object          v13 = new VectorP        ();
   Object          v14 = new VectorP<Object>();
   Object          v15 = new VectorP<Double>();
   Object          v16 = new VectorObject   ();
   Object          v17 = new VectorDouble   ();

   Vector          v21 = new Vector         ();
   Vector          v22 = new VectorR        ();
   Vector          v23 = new VectorP        ();
   Vector          v24 = new VectorP<Object>();
   Vector          v25 = new VectorP<Double>();
   Vector          v26 = new VectorObject   ();
   Vector          v27 = new VectorDouble   ();

// VectorR         v31 = new Vector         (); // Fehler
   VectorR         v32 = new VectorR        ();
// VectorR         v33 = new VectorP        (); // Fehler
// VectorR         v34 = new VectorP<Object>(); // Fehler
// VectorR         v35 = new VectorP<Double>(); // Fehler
// VectorR         v36 = new VectorObject   (); // Fehler
// VectorR         v37 = new VectorDouble   (); // Fehler

// VectorP         v41 = new Vector         (); // Fehler
// VectorP         v42 = new VectorR        (); // Fehler
   VectorP         v43 = new VectorP        ();
   VectorP         v44 = new VectorP<Object>();
   VectorP         v45 = new VectorP<Double>();
// VectorP         v46 = new VectorObject   (); // Fehler
// VectorP         v47 = new VectorDouble   (); // Fehler

// VectorP<Object> v51 = new Vector         (); // Fehler
// VectorP<Object> v52 = new VectorR        (); // Fehler
// VectorP<Object> v53 = new VectorP        (); // Warnung
   VectorP<Object> v54 = new VectorP<Object>();
// VectorP<Object> v55 = new VectorP<Double>(); // Fehler
// VectorP<Object> v56 = new VectorObject   (); // Fehler
// VectorP<Object> v57 = new VectorDouble   (); // Fehler

// VectorP<Double> v61 = new Vector         (); // Fehler
// VectorP<Double> v62 = new VectorR        (); // Fehler
// VectorP<Double> v63 = new VectorP        (); // Warnung
// VectorP<Double> v64 = new VectorP<Object>(); // Fehler
   VectorP<Double> v65 = new VectorP<Double>();
// VectorP<Double> v66 = new VectorObject   (); // Fehler
// VectorP<Double> v67 = new VectorDouble   (); // Fehler

// VectorObject    v71 = new Vector         (); // Fehler
// VectorObject    v72 = new VectorR        (); // Fehler
// VectorObject    v73 = new VectorP        (); // Fehler
// VectorObject    v74 = new VectorP<Object>(); // Fehler
// VectorObject    v75 = new VectorP<Double>(); // Fehler
   VectorObject    v76 = new VectorObject   ();
// VectorObject    v77 = new VectorDouble   (); // Fehler

// VectorDouble    v81 = new Vector         (); // Fehler
// VectorDouble    v82 = new VectorR        (); // Fehler
// VectorDouble    v83 = new VectorP        (); // Fehler
// VectorDouble    v84 = new VectorP<Object>(); // Fehler
// VectorDouble    v85 = new VectorP<Double>(); // Fehler
// VectorDouble    v86 = new VectorObject   (); // Fehler
   VectorDouble    v87 = new VectorDouble   ();

} // class Typen11
/* ------------------------------------------------------------------------
Warnungen und Fehlermeldungen des Compilers javac von Sun, wenn die
betreffenden Zeilen nicht auskommentiert sind:

D:\meineDateien\BspJaSp\Typen11.java:41: incompatible types
found   : java.util.Vector
required: VectorR
 VectorR         v31 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:43: incompatible types
found   : VectorP
required: VectorR
 VectorR         v33 = new VectorP        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:44: incompatible types
found   : VectorP<java.lang.Object>
required: VectorR
 VectorR         v34 = new VectorP<Object>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:45: incompatible types
found   : VectorP<java.lang.Double>
required: VectorR
 VectorR         v35 = new VectorP<Double>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:46: incompatible types
found   : VectorObject
required: VectorR
 VectorR         v36 = new VectorObject   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:47: incompatible types
found   : VectorDouble
required: VectorR
 VectorR         v37 = new VectorDouble   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:49: incompatible types
found   : java.util.Vector
required: VectorP
 VectorP         v41 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:50: incompatible types
found   : VectorR
required: VectorP
 VectorP         v42 = new VectorR        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:54: incompatible types
found   : VectorObject
required: VectorP
 VectorP         v46 = new VectorObject   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:55: incompatible types
found   : VectorDouble
required: VectorP
 VectorP         v47 = new VectorDouble   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:57: incompatible types
found   : java.util.Vector
required: VectorP<java.lang.Object>
 VectorP<Object> v51 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:58: incompatible types
found   : VectorR
required: VectorP<java.lang.Object>
 VectorP<Object> v52 = new VectorR        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:59: warning: [unchecked] unchecked conversion
found   : VectorP
required: VectorP<java.lang.Object>
 VectorP<Object> v53 = new VectorP        (); // Warnung
                       ^
D:\meineDateien\BspJaSp\Typen11.java:61: incompatible types
found   : VectorP<java.lang.Double>
required: VectorP<java.lang.Object>
 VectorP<Object> v55 = new VectorP<Double>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:62: incompatible types
found   : VectorObject
required: VectorP<java.lang.Object>
 VectorP<Object> v56 = new VectorObject   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:63: incompatible types
found   : VectorDouble
required: VectorP<java.lang.Object>
 VectorP<Object> v57 = new VectorDouble   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:65: incompatible types
found   : java.util.Vector
required: VectorP<java.lang.Double>
 VectorP<Double> v61 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:66: incompatible types
found   : VectorR
required: VectorP<java.lang.Double>
 VectorP<Double> v62 = new VectorR        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:67: warning: [unchecked] unchecked conversion
found   : VectorP
required: VectorP<java.lang.Double>
 VectorP<Double> v63 = new VectorP        (); // Warnung
                       ^
D:\meineDateien\BspJaSp\Typen11.java:68: incompatible types
found   : VectorP<java.lang.Object>
required: VectorP<java.lang.Double>
 VectorP<Double> v64 = new VectorP<Object>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:70: incompatible types
found   : VectorObject
required: VectorP<java.lang.Double>
 VectorP<Double> v66 = new VectorObject   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:71: incompatible types
found   : VectorDouble
required: VectorP<java.lang.Double>
 VectorP<Double> v67 = new VectorDouble   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:73: incompatible types
found   : java.util.Vector
required: VectorObject
 VectorObject    v71 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:74: incompatible types
found   : VectorR
required: VectorObject
 VectorObject    v72 = new VectorR        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:75: incompatible types
found   : VectorP
required: VectorObject
 VectorObject    v73 = new VectorP        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:76: incompatible types
found   : VectorP<java.lang.Object>
required: VectorObject
 VectorObject    v74 = new VectorP<Object>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:77: incompatible types
found   : VectorP<java.lang.Double>
required: VectorObject
 VectorObject    v75 = new VectorP<Double>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:79: incompatible types
found   : VectorDouble
required: VectorObject
 VectorObject    v77 = new VectorDouble   (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:81: incompatible types
found   : java.util.Vector
required: VectorDouble
 VectorDouble    v81 = new Vector         (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:82: incompatible types
found   : VectorR
required: VectorDouble
 VectorDouble    v82 = new VectorR        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:83: incompatible types
found   : VectorP
required: VectorDouble
 VectorDouble    v83 = new VectorP        (); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:84: incompatible types
found   : VectorP<java.lang.Object>
required: VectorDouble
 VectorDouble    v84 = new VectorP<Object>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:85: incompatible types
found   : VectorP<java.lang.Double>
required: VectorDouble
 VectorDouble    v85 = new VectorP<Double>(); // Fehler
                       ^
D:\meineDateien\BspJaSp\Typen11.java:86: incompatible types
found   : VectorObject
required: VectorDouble
 VectorDouble    v86 = new VectorObject   (); // Fehler
                       ^
32 errors
2 warnings
------------------------------------------------------------------------ */
