// Datei Ueberladen01.java
/* ------------------------------------------------------------------------
Def.: Signatur einer Methode:
   Name der Methode, Typ des 1. Param, Typ des 2. Param, ...
Def.: Profil   einer Methode:
   Rueckgabetyp, Signatur

Beispiel: Die Methode  static String quadrat(String name, int n) {...}
hat die Signatur  quadrat String int
und das Profil    String quadrat String int

Innerhalb einer Klasse darf man mehrere Methoden mit gleichen Namen ver-
einbaren, wenn die Methoden sich durch ihre Signaturen unterscheiden.
Ein Name ist ueberladen (overloaded), wenn er mehrere Methoden (mit unter-
schiedlichen Signaturen) bezeichnet.

Innerhalb einer Klasse darf man nicht mehrere Methoden mit gleicher Sig-
natur vereinbaren (auch dann nicht, wenn die Methoden unterschiedliche
Rueckgabetypen haben, d.h. sich durch ihre Profile unterscheiden, oder
die eine eine Objektmedthode und die andere eine Klassenmethode ist).
------------------------------------------------------------------------ */
class Ueberladen01 {
   static String quadrat(String name, int n) {
      return name + " zum Quadrat ist gleich " + n*n;
   } // quadrat
   // ---------------------------------------------------------------------
   static String quadrat(int n, String name) {
      return name + " squared is equals " + n*n;
   } // quadrat
   // ---------------------------------------------------------------------
// static int quadrat(int n, String name) {
//    return n*n;
// } // quadrat
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      int otto = 5;

      // Anhand der Typen der aktuellen Parameter kann der Ausfuehrer
      // entscheiden, welche der beiden quadrat-Funktionen gemeint ist:
      pln(quadrat("otto", otto ));
      pln(quadrat( otto, "otto"));

   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Ueberladen01
/* ------------------------------------------------------------------------
Fehlermeldung des Compilers javac von Sun, wenn die entsprechenden Zeilen
keine Kommentare sind:

D:\Quellen\Ueberladen01.java:31: quadrat(int,java.lang.String)
is already defined in Ueberladen01
   static int quadrat(int n, String name) {
              ^
---------------------------------------------------------------------------
Ausgabe des Programms Ueberladen01:

otto zum Quadrat ist gleich 25
otto squared is equals 25
------------------------------------------------------------------------ */