// Datei VergroesserbarAnwendung01.java
/* ------------------------------------------------------------------------
Demonstriert eine Amwendung der Schnittstelle Vergroesserbar.

Def.: Eine Vergroesserbar-Klasse ist eine Klasse, die die Schnittstelle
      Vergroesserbar implementiert.

Def.: Ein Vergroesserbar-Objekt ist ein Objekt einer Vergroesserbar-Klasse.

Eine Vergroesserbar-Variable darf auf ein beliebiges Vergroesserbar-Objekt
zeigen (oder den Wert null haben).
------------------------------------------------------------------------ */
class VergroesserbarAnwendung01 {

   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Ein paar Vergroesserbar-Variablen werden vereinbart,
      // ausgegeben, bearbeitet und erneut ausgegeben.

      // Vier Vergroesserbar-Variablen (Variablen mit dem vereinbarten
      // Typ Vergroesserbar) mit unterschiedlichen momentanen Typen
      // werden vereinbart:
      Vergroesserbar v01 = new GanzZahl01(17);
      Vergroesserbar v02 = new SeitenFormat(210.0, 297.0); // DIN A4
      Vergroesserbar v03 = new WalFisch(95); // 95 t, ein ausge-
                                             // wachsener Blauwal
      Vergroesserbar v04 = null;

      pln("-----------------------------------------");
      // Die vier Variablen werden ausgegeben:
      pln("A v01: " + v01);
      pln("B v02: " + v02);
      pln("C v03: " + v03);
      pln("D v04: " + v04);
      pln("-----------------------------------------");
      // Die vier Variablen werden bearbeitet:
      v01.verdreifache();          // 3 mal 17     ist 51
      v02.verdopple();             // 2 mal DIN A4 ist DIN A3
      v03.verdopple();             // Blauwale werden maximal 100 t schwer!
      v04 = new BruchZahl01(4.25F);

      // Die vier Variablen werden erneut ausgegeben:
      pln("E v01: " + v01);
      pln("F v02: " + v02);
      pln("G v03: " + v03);
      pln("H v04: " + v04);
      pln("-----------------------------------------");
      pln("VergroesserbarAnwendung01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // VergroesserbarAnwendung01
/* ------------------------------------------------------------------------
Ausgabe des Programms VergroesserbarAnwendung01:

-----------------------------------------
A v01: GanzZahl01  mit Groesse 17
B v02: SeitenFormat 210.0 mal 297.0 mm
C v03: WalFisch, Gewicht 95 t
D v04: null
-----------------------------------------
E v01: GanzZahl01  mit Groesse 51
F v02: SeitenFormat 420.0 mal 594.0 mm
G v03: WalFisch, Gewicht 100 t
H v04: BruchZahl01 mit Groesse 4.25
-----------------------------------------
VergroesserbarAnwendung01: Das war's erstmal!
------------------------------------------------------------------------ */