// Datei YoyoTst.java
/* ------------------------------------------------------------------------
Der sogenannte Yoyo-Effekt kann in Vererbungsbaeumen auftreten und das
Verstehen eines objektorientierten Programms erheblich erschweren.

Frage: Was bewirkt der Methodenaufruf ob.m01(); in der main-Methode
der Klasse YoyoTst (siehe unten Zeile 47)?

Um diese Frage zu beantworten muss der Leser mehrmals (wie ein Yoyo)
"rauf und runter durch den Vererbungsbaum steigen".
------------------------------------------------------------------------ */
class Yoyo01 {
   void m01() {printf("m01 in Yoyo01, ganz oben\n" ); m02();}
   void m02() {printf("m02 in Yoyo01, ganz oben\n" );       }
   void m03() {printf("m03 in Yoyo01, ganz oben\n" ); m04();}
   void m04() {printf("m04 in Yoyo01, ganz oben\n" );       }
   void m05() {printf("m05 in Yoyo01, ganz oben\n" ); m06();}
   void m06() {printf("m06 in Yoyo01, ganz oben\n" );       }

   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
} // class Yoyo01
// ----------------------------------------------
class Yoyo02 extends Yoyo01 {
   void m02() {printf("m02 in Yoyo02, halb oben\n" );       }
   void m03() {printf("m03 in Yoyo02, halb oben\n" ); m04();}
   void m04() {printf("m04 in Yoyo02, halb oben\n" );       }
   void m06() {printf("m06 in Yoyo02, halb oben\n" );       }
} // class Yoyo02
// ----------------------------------------------
class Yoyo03 extends Yoyo02 {
   void m02() {printf("m02 in Yoyo03, halb unten\n");       }
   void m04() {printf("m04 in Yoyo03, halb unten\n");       }
   void m06() {printf("m06 in Yoyo03, halb unten\n");       }
} // class Yoyo03
// ----------------------------------------------
class Yoyo04 extends Yoyo03 {
   void m02() {printf("m02 in Yoyo04, ganz unten\n"); m03();}
   void m04() {printf("m04 in Yoyo04, ganz unten\n"); m05();}
} // class Yoyo04
// ----------------------------------------------
class YoyoTst {
   static public void main(String [] sonja) {
      // Die Methode m01 in einem Yoyo04-Objekt wird aufgerufen.

      Yoyo04 ob = new Yoyo04();
      ob.m01();      // Was bewirkt dieser Methoden-Aufruf?

   } // main
} // YoyoTst
/* ------------------------------------------------------------------------
Ausgabe des Programms YoyoTst:

m01 in Yoyo01, ganz oben
m02 in Yoyo04, ganz unten
m03 in Yoyo02, halb oben
m04 in Yoyo04, ganz unten
m05 in Yoyo01, ganz oben
m06 in Yoyo03, halb unten
------------------------------------------------------------------------ */