// Datei Zufall02.java
/* ------------------------------------------------------------------------
Dieses Programm gibt kurze Folgen von reproduzierbaren Zufallszahlen und
von nicht-reproduzierbaren Zufallszahlen aus.

Die Methode reproduzierbareFolge hat einen long-Parameter und gibt
eine reproduzierbare Folge von Zufallszahlen (vom Typ double) aus.
"Reproduzierbar" heisst: Wenn man die Methode mehrmals mit gleichem
Parameter aufruft (z.B. mit dem Parameter 123) wird immer die selbe
Folge von Zahlen ausgegeben.

Die Methode nichtReproduzierbareFolge() hat keinen Parameter und
gibt eine nicht-reproduzierbare Folge von Zufallszahlen (vom Typ
double) aus.

Diese beiden Methoden erzeugen Zufallszahlen mit der Methode nextDouble
eines Random-Objektes r und werden mehrmals aufgerufen (siehe die mit
"// <---" gekennzeichneten Zeilen).
------------------------------------------------------------------------ */
import java.util.Random;

class Zufall02 {
   // ---------------------------------------------------------------------
   static void reproduzierbareFolge(long keim) {
      // Gibt 5 reproduzierbare Zufallszahlen aus. Welche Zahlen
      // ausgegeben werden, haengt vom keim ab ("gleicher keim,
      // gleiche Zahlen, ungleiche Keime, andere Zahlen").
      // Die Zahlen sind vom Typ double und aus dem Intervall von 0.0
      // (einschliesslich) bis 1.0 (ausschliesslich). Die Zahlen sind
      // gleichverteilt ("jede hat die gleiche Chance gewaehlt zu
      // werden").

      Random r = new Random(keim); // Ein Zufallsgenerator mit Keim

      printf("      reproduzierbar: ");
      for (int i=1; i<=5; i++) {
         double z = r.nextDouble();                                 // <---
         printf("%5.3f ", z);
      }
      printf("%n");
   } // reproduzierbareFolge
   // ---------------------------------------------------------------------
   static void nichtReproduzierbareFolge() {
      // Gibt 5 nicht-reproduzierbare Zufallszahlen aus.
      // Die Zahlen sind vom Typ double und aus dem Intervall von 0.0
      // (einschliesslich) bis 1.0 (ausschliesslich). Die Zahlen sind
      // gleichverteilt ("jede hat die gleiche Chance gewaehlt zu
      // werden").

      Random r = new Random();      // Ein Zufallsgenerator ohne Keim

      printf("nicht-reproduzierbar: ");
      for (int i=1; i<=5; i++) {
         double z = r.nextDouble();                                 // <---
         printf("%5.3f ", z);
      }
      printf("%n");
   } // nichtReproduzierbareFolge
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Zufall02: Jetzt geht es los!%n");
      printf("---------------------------------------------------%n");
      reproduzierbareFolge(123);
      reproduzierbareFolge(123);
      reproduzierbareFolge(123);
      printf("---------------------------------------------------%n");
      reproduzierbareFolge(756);
      reproduzierbareFolge(756);
      printf("---------------------------------------------------%n");
      nichtReproduzierbareFolge();
      nichtReproduzierbareFolge();
      nichtReproduzierbareFolge();
      printf("---------------------------------------------------%n");
      printf("Zufall02: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Zufall02
/* ------------------------------------------------------------------------
Zwei verschiedene Ausgaben des Programms Zufall02:

Zufall02: Jetzt geht es los!
---------------------------------------------------
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
---------------------------------------------------
      reproduzierbar: 0,689 0,587 0,537 0,657 0,856
      reproduzierbar: 0,689 0,587 0,537 0,657 0,856
---------------------------------------------------
nicht-reproduzierbar: 0,489 0,418 0,383 0,356 0,376
nicht-reproduzierbar: 0,351 0,166 0,386 0,440 0,195
nicht-reproduzierbar: 0,228 0,868 0,743 0,890 0,650
---------------------------------------------------
Zufall02: Das war's erstmal!

Zufall02: Jetzt geht es los!
---------------------------------------------------
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
      reproduzierbar: 0,723 0,991 0,253 0,609 0,806
---------------------------------------------------
      reproduzierbar: 0,689 0,587 0,537 0,657 0,856
      reproduzierbar: 0,689 0,587 0,537 0,657 0,856
---------------------------------------------------
nicht-reproduzierbar: 0,228 0,824 0,076 0,658 0,360
nicht-reproduzierbar: 0,075 0,366 0,127 0,905 0,263
nicht-reproduzierbar: 0,555 0,450 0,243 0,233 0,194
---------------------------------------------------
Zufall02: Das war's erstmal!
------------------------------------------------------------------------ */
