// Datei Zufall04.java
/* ------------------------------------------------------------------------
Die Methode unbeschraenkteIntZZ gibt unbeschraenkte Zufallszahlen des
Typs int aus ("jeder int-Wert hat eine Chance").

Die Methode beschraenkteIntZZ gibt beschraenkte Zufallszahlen des
Typs int aus (die aus einem Intervall 0 bis grenze stammen).

Diese beiden Methoden erzeugen Zufallszahlen mit der Methode nextInt
und werden mehrmals aufgerufen (siehe die mit "// <---" gekennzeich-
neten Zeilen).

Beide Methoden benutzen gemeinsam einen globalen Zufallsgenerator.
In der main-Methode wird der Keim dieses Generators mehrmals gesetzt.
Alle ausgegebenen Zufallszahlen sind reproduzierbar.
------------------------------------------------------------------------ */
import java.util.Random;

class Zufall04 {
   // ---------------------------------------------------------------------
   static Random r = new Random(); // Ein Zufallsgenerator fuer alle
                                   // Methoden

   static void unbeschraenkteIntZZ() {
      // Gibt 3 unbeschraenkte Zufallszahlen des Typs int aus
      // ("jeder int-Wert hat eine Chance")

      printf("unbeschraenkt: ");
      for (int i=1; i<=3; i++) {
         int z = r.nextInt();                                       // <---
         printf("%12d ", z);
      }
      printf("%n");
   } // unbeschraenkteIntZZ
   // ---------------------------------------------------------------------
   static void beschraenkteIntZZ(int grenze) {
      // Gibt 6 beschraenkte Zufallszahlen des Typs int aus dem Intervall
      // 0 (einschliesslich) bis grenze (ausschliesslich) aus.

//      printf("B Zufall04(0..%d): ", grenze);
      printf("beschraenkt(0..%d): ", grenze);
      for (int i=1; i<=6; i++) {
         int z = r.nextInt(grenze);                                 // <---
         printf("%4d ", z);
      }
      printf("%n");
   } // beschraenkteIntZZ
   // ---------------------------------------------------------------------
   static public void main(String [] sonja) {
      printf("Zufall04: Jetzt geht es los!%n");
      printf("------------------------------------------------------%n");
      r.setSeed(123);    unbeschraenkteIntZZ();
      r.setSeed(123);    unbeschraenkteIntZZ();
      r.setSeed(123);    unbeschraenkteIntZZ();
      printf("------------------------------------------------------%n");
      r.setSeed(654321); unbeschraenkteIntZZ();
                         unbeschraenkteIntZZ();
      printf("------------------------------------------------------%n");
      beschraenkteIntZZ(500);
      beschraenkteIntZZ(500);
      beschraenkteIntZZ(250);
      printf("------------------------------------------------------%n");
      printf("Zufall04: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Zufall04
/* ------------------------------------------------------------------------
Die Ausgabe des Programms Zufall04:

Zufall04: Jetzt geht es los!
------------------------------------------------------
unbeschraenkt:  -1188957731   1018954901    -39088943
unbeschraenkt:  -1188957731   1018954901    -39088943
unbeschraenkt:  -1188957731   1018954901    -39088943
------------------------------------------------------
unbeschraenkt:    129127415  -1818575409    770026255
unbeschraenkt:   -777264696    602399285  -1540052466
------------------------------------------------------
beschraenkt(0..500):  163  301   82    1   21  366
beschraenkt(0..500):  479  254  154  428  302   28
beschraenkt(0..250):  100  194   86   16   65   53
------------------------------------------------------
Zufall04: Das war's erstmal!
------------------------------------------------------------------------ */
