// Datei K10Tst.java
/* ------------------------------------------------------------------------
Dieses Programm soll deutlich machen, welche der 16 Elemente der Klasse
p00.p10.K10 in den 4 Klassen p00.p10.K11,
                             p00.p10.K12,
                             p00.p20.K21,
                             p00.p20.K22 erreichbar sind.
---------------------------------------------------------------------------
Compilieren und starten (unter Windows, mit den Programmen javac und java
der Firma Sun. Unter Linux geht es ganz entsprechend)

Hier wird angenommen, dass die Quelldateien wie folgt in Unterverzeich-
nissen eines Verzeichnisses d:\Quellen stehen:

// Die Quelldatei:                gehoert zum Paket:
d:\Quellen\p00\p10\K10.java    // package p00.p10;
d:\Quellen\p00\p10\K11.java    // package p00.p10;
d:\Quellen\p00\p10\K12.java    // package p00.p10;
d:\Quellen\p00\p20\K21.java    // package p00.p20;
d:\Quellen\p00\p20\K22.java    // package p00.p20;
d:\Quellen\p00\K10Tst.java     // package p00;

Kommandos sind einzugeben in ein Dos-Eingabeaufforderungsfenster. Dabei
muss d:\Quellen das aktuelle Arbeitsverzeichnis sein (unten soll
d:\Quellen>  vor den Kommandos das Promptzeichen darstellen).

Es werden 2 Moeglichkeiten beschrieben, die 6 Quelldateien mit dem
Compiler javac zu compilieren und das Programm K10Tst (d.h. die
Bytecode-Datei K10Tst.class) mit dem Interpreter java ausfuehren zu
lassen. Es sind jeweils nur 2 Kommandos notwendig. In allen Kommandos
kann (und sollte) man (auch unter Windows) Schraegstriche / anstelle
von Rueckwaertsschraegstrichen \ verwenden.
-----------------------------------
Moeglichkeit 1: Die .class-Dateien werden in denselben Verzeichnissen
abgelegt, in denen die .java-Dateien stehen:

d:\Quellen> javac -cp . p00/K10Tst.java
d:\Quellen> java  -cp . p00/K10Tst
-----------------------------------
Moeglichkeit 2: Die .class-Dateien werden in Unterverzeichnissen eines
separaten Klassenverzeichnisses c:\Klassen abgelegt. Das Klassenver-
zeichnis c:\Klassen muss vorher angelegt werden.

d:\Quellen> javac -cp . -d c:/Klassen p00/K10Tst.java
d:\Quellen> java  -cp c:/Klassen      p00/K10Tst
------------------------------------------------------------------------ */
package p00;

public class K10Tst {
   // ---------------------------------------------------------------------
   static void printReihung(String[] sr, String name) {
      p(name + ": ");
      for (int i=0; i<sr.length; i++) {
         p(sr[i] + " ");
      }
      pln();
   } // printReihung
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // 4 Objekte (der Klassen K11, K12, K21 und K22) werden erzeugt:
      p00.p10.K11 ob11 = new p00.p10.K11();
      p00.p10.K12 ob12 = new p00.p10.K12();
      p00.p20.K21 ob21 = new p00.p20.K21();
      p00.p20.K22 ob22 = new p00.p20.K22();

      // Ein paar Erlaeuterungen und von jedem Objekt obXY die beiden
      // Reihungen oeXY und keXY werden ausgegeben:
      pln();
      pln("K10Tst: Jetzt geht es los!");
      pln("---------------------------------------");
      pln("Abkuerzungen:");
      pln("oe: Objektelemente, ke: Klassenelemente");
      pln("OA: Objektattribut, KA: Klassenattribut");
      pln("OM: Objektmethode,  KM: Klassenmethode ");
      pln("-----------------------------------------------------------------------");
      printReihung(ob11.oe11, "oe11");
      printReihung(ob11.ke11, "ke11");
      pln();
      printReihung(ob12.oe12, "oe12");
      printReihung(ob12.ke12, "ke12");
      pln();
      printReihung(ob21.oe21, "oe21");
      printReihung(ob21.ke21, "ke21");
      pln();
      printReihung(ob22.oe22, "oe22");
      printReihung(ob22.ke22, "ke22");
      pln("-----------------------------------------------------------------------");
      pln("K10Tst: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // K10Tst
/* ------------------------------------------------------------------------
Ausgabe des Programms K10Tst:

---------------------------------------
Abkuerzungen:
oe: Objektelemente, ke: Klassenelemente
OA: Objektattribut, KA: Klassenattribut
OM: Objektmethode,  KM: Klassenmethode
-----------------------------------------------------------------------
oe11: publicOA publicOM protectedOA protectedOM paketweitOA paketweitOM
ke11: publicKA publicKM protectedKA protectedKM paketweitKA paketweitKM

oe12: publicOA publicOM protectedOA protectedOM paketweitOA paketweitOM
ke12: publicKA publicKM protectedKA protectedKM paketweitKA paketweitKM

oe21: publicOA publicOM protectedOA protectedOM
ke21: publicKA publicKM protectedKA protectedKM

oe22: publicOA publicOM
ke22: publicKA publicKM
-----------------------------------------------------------------------
------------------------------------------------------------------------ */